#include <QtGui>
#include "mainwindow.h" 
#include "append.h"
#include "default.h"
#include "catalog.h"
#include "convert.h"
#include "document.h"
#include "viewcatalogimpl.h"
#include "bottomwindow.h"
#include "helpwindow.h"
 const int WRITE_FIRST_CATALOG_BUFFER_SIZE= 1000; 

 //acuracyCompareTimeValue()
//-------------------------------------------
AppendImpl::~AppendImpl(){
    values.clear();
    if(help !=0) {delete help; help = 0;}
}
AppendImpl::AppendImpl(QWidget *parent,FDocument* dc,TypeUsing tp)
      : QDialog(0),doc(dc),type(tp)

{
    QFont f = parent->font();
    setFont( parent->font() );
    setWindowIcon(QIcon(":/images/icon.png"));
    setupUi(this); 
    setModal (true);
	if (type != Wizard) parentWindow = (CatTable* )parent;
	else parentWindow = 0;
    textLabel->setText("");
	if (type == Wizard)  {textLabel->hide();groupBoxCatalogIns->hide();}
    values.append(doc->GetListAddCatalog());
    firstStart = true;
    SetDocumentToDialog();
    help = 0;
    actionName = projectActionList().split ('@').at(4);
    setWindowTitle(actionName);
    texted = MainWindow::self->bottomWindow->messageTab;
    correctioned = MainWindow::self->bottomWindow->correctionTab;
    if (type == Tool)  {
      toolButtonProject->hide();
      MainWindow::self->bottomWindow->OpenMessagesProtocolPage();
      texted->insertPlainText(prefixMessage() + actionName + " ***\n");
    }
    connect(buttonOk, SIGNAL(clicked()), this, SLOT(accept()));
    connect(buttonCancel, SIGNAL(clicked()), this, SLOT(close()));
    connect(buttonHelp, SIGNAL(clicked()), this, SLOT(helpButton()));
    connect(pushButtonStart, SIGNAL(clicked()), this, SLOT(start()));

    connect( toolButtonIns, SIGNAL( clicked() ), this, SLOT( ins() ) );
    connect( toolButtonDel, SIGNAL( clicked() ), this, SLOT( del() ) );
    connect( toolButtonBrowse, SIGNAL( clicked() ), this, SLOT( browse() ) );
    connect( toolButtonDown, SIGNAL( clicked() ), this, SLOT( down() ) );
    connect( toolButtonUp, SIGNAL( clicked() ), this, SLOT( up() ) );
    connect(toolButtonReset,     SIGNAL(clicked()),   this, SLOT(reset()));
    connect(toolButtonProject,   SIGNAL(clicked()),   this, SLOT(project()));
    connect(toolButtonDefault,   SIGNAL(clicked()),   this, SLOT(defaults()));
    connect( listWidget, SIGNAL( itemClicked (QListWidgetItem *) ), this, SLOT(RowClicked(QListWidgetItem *) ) );
    buttonOk->setEnabled(FALSE);
	
	openUserToolFileDirectory = MainWindow::self->openUserFileDirectory;

}
//------------------------------------------------------------------------------------------
void AppendImpl::closeEvent(QCloseEvent *event)
{
// like as reject
 if (!firstStart) {
 foreach (PropertyValue* val, values) val->SetResetvalueToValue();
 }
    texted->insertPlainText(cancelMessage() + "\n");
    correctioned->insertPlainText(corrmess + "\n");
    correctioned->insertPlainText(cancelMessage() + "\n");
    correctioned->ensureCursorVisible ();
		MainWindow::self->addPos   =  pos();
		MainWindow::self->addSize  =  size();
    MainWindow::self->RestoreStatusbarMessage();
    event->accept();

}
void AppendImpl::reject()
{
return;
}
//------------------------------------------------------------------------------------------
void AppendImpl::SetProjectCatalogInfo(QString &name) {
    QString tmp =  doc->GetProjectCatalogName()->GetValue();
    SetCatalogInfo(name,labelNameIn,labelRecordIn,labelDateInStart,labelDateInFinish);
}
//------------------------------------------------------------------------------------------
void AppendImpl::accept()
{

 GetDocumentFromDialog();
 parentWindow->GetFstream()->close();
 QDir dp(MainWindow::self->tempDirectory);
 dp.remove(MainWindow::self->GetOpenBinaryFileName());
 dp.rename (TempCatalogName,MainWindow::self->GetOpenBinaryFileName());
 parentWindow->RestoreIndex();
 foreach (PropertyValue* val, values) val->SetValueToResetvalue();
 MainWindow::self->modifiedCatalog = true;
 MainWindow::self->modifiedProtocol = true;
    if (type == Tool) {
      texted->ensureCursorVisible ();
      correctioned->ensureCursorVisible ();
   }
		MainWindow::self->addPos   =  pos();
		MainWindow::self->addSize  =  size();
   MainWindow::self->RestoreStatusbarMessage();
   done( Accepted );
}
//------------------------------------------------------------------------------------------
bool AppendImpl::GetRecordCatalogIndex(QString &file,DoubleIntMultiMap  &index){
   int numRec = 0; RECORD record; double datetime = 0;
   fstream in(file.toAscii(),ios::binary | ios::in);
   if (!(in)) {error(QString("cannot open input file"),file);return false;}
   in.seekg(sizeof(RECORD),ios::beg);
   while(in.read((char*)&record,sizeof(RECORD ))){
	    if(in.fail()){;error(QString("An reading error has occurred"),file);return false;}
	    datetime =  DateTime(record);
	    index.insert(make_pair(datetime,numRec));
            numRec++;
    }
return true;
}
//------------------------------------------------------------------------------------------
bool AppendImpl::execute(){
bool ret = applay();
 QDir dp(MainWindow::self->tempDirectory);
 dp.remove(MainWindow::self->GetOpenBinaryFileName());
 dp.rename (TempCatalogName,MainWindow::self->GetOpenBinaryFileName());
 parentWindow->RestoreIndex();

done( Accepted );
return ret;
}
//------------------------------------------------------------------------------------------
void AppendImpl::GetMessageInfo(){
QString filemes = "";
message = "";
Catalog cat;
           filemes += "List of add-in catalogs:\n";
            QStringList::Iterator it = listAddCatalog.begin();
			int numrec = 0;
	    while( it != listAddCatalog.end() ) {
			numrec++;
            filemes += QString("%1: %2").arg(numrec).arg(cat.GetOneLineCatalogInfoMessage(*it));
            it++;
            }

      QString incatmes = "";
      if (type == Tool)    incatmes += cat.GetCatalogInfoMessage(MainWindow::self->GetCurrentCatalogName());
      if (type == Execute) {
		  incatmes += "Current catalog ";
		  incatmes += cat.GetCatalogShortInfoMessage(MainWindow::self->GetOpenBinaryFileName());
	  }
     message +=  incatmes;
     message +=  filemes;

}
bool AppendImpl::NextOk(){
if(listAddCatalog.empty()) {
error(QString("Files to add section:\nPush button \"Browse\" to browse catalogs for add action"),"");
return false;
}

GetMessageInfo();

 if (type == Tool || type == Wizard) {
       QString tmp = QString("Do you want to execute %1?\n\n").arg(actionName);
       int ret = QMessageBox::warning(this,windowTitle (),tmp + message,
                 QMessageBox::Yes | QMessageBox::Default,
                 QMessageBox::No | QMessageBox::Escape);
      if (ret == QMessageBox::No) return false;
  }
return true;
}
//------------------------------------------------------------------------------------------
void AppendImpl::FinishOk()
{
	message = "";
	texted->insertPlainText(prefixMessage() + actionName + " ***\n\n");	
	GetMessageInfo();
	GetDocumentFromDialog();
	foreach (PropertyValue* val, values) val->SetValueToResetvalue();
	texted->insertPlainText(message);
	texted->insertPlainText(postfixActionMessage() + ": " + actionName + " ***\n\n");
}
//------------------------------------------------------------------------------------------
bool AppendImpl::applay(){
if(listAddCatalog.empty()) {
error(QString("Files to add section:\nPush button \"Browse\" to browse catalogs for add action"),"");
return false;
} 
GetMessageInfo();
 if (type == Tool || type == Wizard) {
       QString tmp = QString("Do you want to execute %1?\n\n").arg(actionName);
       int ret = QMessageBox::warning(this,windowTitle (),tmp + message,
                 QMessageBox::Yes | QMessageBox::Default,
                 QMessageBox::No | QMessageBox::Escape);
      if (ret == QMessageBox::No) return false;
  }
repaint();
QApplication::setOverrideCursor(Qt::WaitCursor);
if (firstStart == true) {
 QString filename = MainWindow::self->GetOpenBinaryFileName();
 filename.replace( openBinaryCatalogfileName(), openTempMergeBinaryCatalogfileName());
 SaveCatalogName = filename;
 
 if ( !parentWindow->writeFile(filename) ) { QApplication::restoreOverrideCursor(); return false;}
 filename = MainWindow::self->GetOpenBinaryFileName();
 filename.replace( openBinaryCatalogfileName(), openSecondBinaryCatalogfileName());
 TempCatalogName = filename;
 if ( !parentWindow->writeFile(filename) ) { QApplication::restoreOverrideCursor(); return false;}
} else {
Catalog cat;
if(!cat.CopyFile(SaveCatalogName,TempCatalogName)) { QApplication::restoreOverrideCursor(); return false;}
}

firstStart = false;
GetDocumentFromDialog();
Catalog cat; 
 correctioned->insertPlainText(prefixMessage()  + actionName + " ***\n");
 QStringList::iterator i;
     for (i = listAddCatalog.begin(); i != listAddCatalog.end(); ++i) {
    QString catInfo = "";
    catInfo += "\nCatalog in process Catalog in process ";
    catInfo += cat.GetCatalogShortInfoMessage(MainWindow::self->GetOpenBinaryFileName());
    SecondCatalogName = *i ;
    correctioned->insertPlainText(catInfo);
    corrmess = "";
      if(!AddSecondCatalog()) { QApplication::restoreOverrideCursor(); return false;}
    correctioned->insertPlainText(corrmess + "\n");
     }
buttonOk->setEnabled(TRUE);
QApplication::restoreOverrideCursor();
//--------------------------------------------------------------

   RECORD record;
   RECORD record1;
   int numrec;
   if (cat.GetCatalogInfo(TempCatalogName,numrec,record,record1)) {
   QString tmp = QString("Result: Time: ( %1 ) - ( %2 ) Records: %3").arg(cat.getQStringTime(record)).
                 arg(cat.getQStringTime(record1)).arg(numrec);

   textLabel->setText(tmp);
   textLabel->repaint ();
   }
//--------------------------------------------------------------
  texted->insertPlainText(message);
  QString outInfo = "\nOutput catalog " + cat.GetCatalogShortInfoMessage(MainWindow::self->GetOpenBinaryFileName());

  texted->insertPlainText(outInfo);
  texted->insertPlainText(postfixActionMessage() + ": " + actionName + " ***\n");

  correctioned->insertPlainText(outInfo);
  correctioned->insertPlainText(postfixActionMessage() + ": " + actionName + " ***\n");

return true;
}
void AppendImpl::start(){
if (!applay()) return;
}
//------------------------------------------------------------------------------------------
bool AppendImpl::AddSecondCatalog() {
Catalog cat;
if (!cat.GetTwoCatalogMode(TempCatalogName,SecondCatalogName)) return false;
char buf[sizeof(RECORD)]="";
int numberNewRecord = 0;
int numberRecordFirst = cat.numberRecordFirst;
int numberRecordSecond = cat.numberRecordSecond;
Catalog::TwoCatMode mode = cat.mode;
QList<double> keys = cat.modeKeys;

   QString outFileName = MainWindow::self->GetOpenBinaryFileName();

   ofstream outfile(outFileName.toAscii(), ios::binary | ios::out);
   if (!(outfile)) {QApplication::restoreOverrideCursor();
                    error(QString("cannot open output file"),outFileName);return false;}

   fstream inFirst(TempCatalogName.toAscii(),ios::binary | ios::in);
   if (!(inFirst)) {QApplication::restoreOverrideCursor();
                      error(QString("cannot open input file"),TempCatalogName);return false;}

   fstream inSecond(SecondCatalogName.toAscii(),ios::binary | ios::in);
   if (!(inSecond)) {QApplication::restoreOverrideCursor();
                      error(QString("cannot open input file"),SecondCatalogName);return false;}

   inFirst.seekg(sizeof(int),ios::beg);
   quint32 magic;
   inFirst.read((char*)&magic,sizeof(quint32));
   inFirst.seekg(sizeof(RECORD),ios::beg);
   inSecond.seekg(sizeof(RECORD),ios::beg);

   outfile.write(buf,sizeof(RECORD));
   outfile.seekp(sizeof(int),ios::beg);
   outfile.write((char*)&magic,sizeof(quint32));
   outfile.seekp(sizeof(RECORD),ios::beg);

if (mode == Catalog::Substitute) {
	outfile << inSecond.rdbuf();
	outfile.seekp(0,ios::beg);
	numberNewRecord = numberRecordSecond;
	outfile.write((char*)&numberNewRecord,sizeof(int));
	//corrmess += "**** mode == Catalog::Substitute ***\n";
	
	
    corrmess += 
	          cat.GetOneLineCatalogInfoMessage(SecondCatalogName) +
			  "              and replaces the entire catalog in progress.";

}
if (mode == Catalog::Prepend) {
	outfile << inSecond.rdbuf();
	outfile << inFirst.rdbuf();
	outfile.seekp(0,ios::beg);
	numberNewRecord = numberRecordFirst + numberRecordSecond;
	outfile.write((char*)&numberNewRecord,sizeof(int));
	//corrmess += "**** mode == Catalog::Prepend ***\n";
		
	corrmess += cat.GetOneLineCatalogInfoMessage(SecondCatalogName) +
			  "              and prepends the catalog in progress.";	
			  
}
if (mode == Catalog::Append) {
	outfile << inFirst.rdbuf();
	outfile << inSecond.rdbuf();
	outfile.seekp(0,ios::beg);
	numberNewRecord = numberRecordFirst + numberRecordSecond;
	outfile.write((char*)&numberNewRecord,sizeof(int));
	//corrmess += "**** mode == Catalog::Append ***\n";
		
	corrmess += cat.GetOneLineCatalogInfoMessage(SecondCatalogName) +
			  "              and appends the catalog in progress.";
}
if (mode == Catalog::Replace) {
// cat.mapTwoCatRec.size() == 4           +     -     -     + 
	DoubleIntMultiMap  index;
	if (!GetRecordCatalogIndex(TempCatalogName,index)) return false;

	ItrMultiMap pos1 = index.lower_bound(keys.at(1) - acuracyCompareTimeValue());
	if (pos1 == index.end()) {error(QString("Task: \"Substitute\".\nCannot find second catalog start time in first catalog"),""); return false;}
	int num1 = (*pos1).second;
    pos1--;
	double pos1Time = (*pos1).first;
	QString replDate = cat.getQStringTime(pos1Time);

	ItrMultiMap pos2 = index.upper_bound(keys.at(2) + acuracyCompareTimeValue());
	if (pos2 == index.end()) {error(QString("Task: \"Substitute\".\nCannot find second catalog end time in first catalog"),""); return false;}
	int num2 = (*pos2).second;

// Note: first record of catalog is service record contains record numbers and
// magic number	
// real number (N) in binary catalog corresponding number num1 is N = num1 + 1
// program WriteBeginingCatalog(inFirst,outfile,num1) writes first num1 -1 records of
// inFirst fstreem

	if(!WriteBeginingCatalog(inFirst,outfile,num1)) return false;

    outfile << inSecond.rdbuf();

	inFirst.seekg((num2+1)*sizeof(RECORD),ios::beg);

// Note: first record of catalog is service record contains record numbers and
// magic number
// writes last num2 records of 	inFirst fstreem
	
	outfile << inFirst.rdbuf();
	 
	numberNewRecord = num1 + numberRecordSecond + (numberRecordFirst - num2);	
	outfile.seekp(0,ios::beg);
	
	outfile.write((char*)&numberNewRecord,sizeof(int));
	index.clear();	
 
	
//	corrmess += "**** mode == Catalog::Replace ***\n";
	
//	QMessageBox::information(0,"",QString("mode == Catalog::Replace 0\n %1").arg(num2-num1));

	

//	QMessageBox::information(this,mainWindowCaption(),"mode == Catalog::Replace 1");
	QString temp = cat.GetOneLineCatalogInfoMessage(SecondCatalogName);
	if (num2-num1 == 0){
	corrmess += QString("%1                 and inserts all of them into the catalog in progress after %2").
	arg(temp).
	arg(replDate);		
	}
	else {
	corrmess += QString("%1                 replaces %2  records of the catalog in progress after %3").
	arg(temp).
	arg(num2-num1).
	arg(replDate);		
	}

	//QMessageBox::information(this,mainWindowCaption(),"mode == Catalog::Replace 2");
}
if (mode == Catalog::ReplacePrepend) {
// cat.mapTwoCatRec.size() == 3     -     -     +	 
// cat.mapTwoCatRec.size() == 4     -     +     -      + 
	DoubleIntMultiMap  index;
	if (!GetRecordCatalogIndex(TempCatalogName,index)) return false;

	outfile << inSecond.rdbuf();
	double searchKey = 0.0;
	if( (int)cat.mapTwoCatRec.size() == 3 )	searchKey = keys.at(1);
	if( (int)cat.mapTwoCatRec.size() == 4 )	searchKey = keys.at(2);
	
	ItrMultiMap pos2 = index.upper_bound(searchKey + acuracyCompareTimeValue());
	if (pos2 == index.end()) {error(QString("Task: \"Substitute\".\nCannot find second catalog end time in first catalog"),""); return false;}
	int num2 = (*pos2).second;
	double pos2Time = (*pos2).first;
	inFirst.seekg((num2+1)*sizeof(RECORD),ios::beg);
	outfile << inFirst.rdbuf();
	numberNewRecord = numberRecordSecond + (numberRecordFirst - num2);	
	outfile.seekp(0,ios::beg);
	
	outfile.write((char*)&numberNewRecord,sizeof(int));
	index.clear();	
	pos2--;
	QString replDate = cat.getQStringTime(pos2Time);
	//corrmess += "**** mode == ReplacePrepend ***\n";
	
	corrmess += QString("%1                 replaces the first %2 records of the catalog in progress,\n              and prepends the rest of it from %3 on").
	arg(cat.GetOneLineCatalogInfoMessage(SecondCatalogName)).
	arg(num2).
	arg(replDate);	
}

if ( mode == Catalog::ReplaceAppend ) {
// cat.mapTwoCatRec.size() == 3     +     -     -
// cat.mapTwoCatRec.size() == 4     +     -     +     -
	DoubleIntMultiMap  index;
	if (!GetRecordCatalogIndex(TempCatalogName,index)) return false;

	ItrMultiMap pos1 = index.lower_bound(keys.at(1) - acuracyCompareTimeValue());
	
	if (pos1 == index.end()) {error(QString("Task: \"Substitute\".\nCannot find second catalog start time in first catalog"),""); return false;}
	int num1 = (*pos1).second;
	pos1--;
	double pos1Time = (*pos1).first;
	QString replDate = cat.getQStringTime(pos1Time);
	if(!WriteBeginingCatalog(inFirst,outfile,num1)) return false;
	
    outfile << inSecond.rdbuf();
	numberNewRecord = num1  + numberRecordSecond;	
	outfile.seekp(0,ios::beg);
	
	outfile.write((char*)&numberNewRecord,sizeof(int));
	index.clear();	

	
	//corrmess += "**** mode == Catalog::ReplaceAppend ***\n";
	
	corrmess += QString("%1                 appends the catalog in progress after  %2\n              replacing its  %3 last  records.").
	arg(cat.GetOneLineCatalogInfoMessage(SecondCatalogName)).
	arg(replDate).
	arg(numberRecordFirst - num1);	
	
//	QMessageBox::information(this,mainWindowCaption(),QString("repstart %1 repnum %2 numberNewRecord %3")
//	.arg(num1).arg(numberRecordFirst - num1).arg(numberNewRecord));	
	
}

if ( mode == Catalog::None ) {
	corrmess += "Task: \"Substitute\".\nCannot define the substitute mode.\nIt's bug. Send mail to program provider.";
	QMessageBox::information(this,mainWindowCaption(),
		"Task: \"Substitute\".\nCannot define the substitute mode.\nIt's bug. Send mail to program provider.");
	return false;
}

cat.mapTwoCatRec.clear();
outfile.close(); inFirst.close(); inSecond.close();
if(!cat.CopyFile(outFileName,TempCatalogName)) return false;

return true;
}
//------------------------------------------------------------------------------
// Note real number (N) in binary catalog corresponding number num is N = num + 1
// program WriteBeginingCatalog(inFirst,outfile,num) writes first num -1 records of
// in fstreem
// Note: first record of catalog is service record contains record numbers and
// magic number	
bool AppendImpl::WriteBeginingCatalog(fstream &in,ofstream &out,int num){
    char buf[WRITE_FIRST_CATALOG_BUFFER_SIZE*sizeof(RECORD)] = "";
    int numBigBuffer =  num/WRITE_FIRST_CATALOG_BUFFER_SIZE;
    int numRest = num - numBigBuffer*WRITE_FIRST_CATALOG_BUFFER_SIZE;
    for(int i = 0; i < numBigBuffer; i++) {
    in.read(buf,WRITE_FIRST_CATALOG_BUFFER_SIZE*sizeof(RECORD));
    if(in.fail()){QApplication::restoreOverrideCursor();error(QString("An reading buffer error has occurred (buf #%1 * %2)").arg(i+1).arg(WRITE_FIRST_CATALOG_BUFFER_SIZE),"");return false;}
    out.write(buf,WRITE_FIRST_CATALOG_BUFFER_SIZE*sizeof(RECORD));
    if(out.fail()){QApplication::restoreOverrideCursor();error(QString("An writing error has occurred (buf #%1 * %2)").arg(i+1).arg(WRITE_FIRST_CATALOG_BUFFER_SIZE),"");return  false;}
    }
    if (numRest > 0) {
    in.read(buf,numRest*sizeof(RECORD));
    if(in.fail()){QApplication::restoreOverrideCursor();error(QString("An reading buffer error has occurred (buf #%1 * %2)").arg(numBigBuffer+1).arg(numRest),"");return false;}
    out.write(buf,numRest*sizeof(RECORD));
    if(out.fail()){QApplication::restoreOverrideCursor();error(QString("An writing error has occurred (buf #%1 * %2)").arg(numBigBuffer+1).arg(numRest),"");return false;}
    }
	return true;
}
//------------------------------------------------------------------------------------------
void AppendImpl::helpButton()
{
     QString home = searchHelpPath() + "/edcat-tool-substitute.html";
    if(help !=0) {delete help; help =0;}
    help = new HelpWindow(home,this);
    if ( QApplication::desktop()->width() > 400
         && QApplication::desktop()->height() > 500 )
         help->show();
    else
        help->showMaximized();
}
//------------------------------------------------------------------------------------------
 void AppendImpl::GetDocumentFromDialog(){

   doc->GetListAddCatalog()->SetListToValue(listAddCatalog);
}
//--------------------------------------------------------------------------------------------
 void AppendImpl::SetDocumentToDialog()
{
if (type == Tool) {
    QString tmp =  MainWindow::self->GetCurrentCatalogName();
    SetCatalogInfo(tmp,labelNameIn,labelRecordIn,labelDateInStart,labelDateInFinish);
}

    listAddCatalog.clear();
    listWidget->clear();
    QStringList tmp = doc->GetListAddCatalog()->GetStringList();
    if(!tmp.empty()) listAddCatalog = SetListWidgetAddeFiles(tmp);


}
//--------------------------------------------------------------------------------------------
void AppendImpl::browse(){
          QStringList FileNames = QFileDialog::getOpenFileNames(this,"Select one or more add-in files.",
                            openUserToolFileDirectory,
                            MainWindow::self->GetFileFilters());
QStringList tmp = SetListWidgetAddeFiles(FileNames);
 if ( tmp.count() == 0 ) return;
 listAddCatalog = tmp;
}
QStringList AppendImpl::SetListWidgetAddeFiles(QStringList &FileNames) {
if (!FileNames.empty()) {
            listWidget->clear();
            QStringList errFiles;
	    QStringList::Iterator it = FileNames.begin();
	    while( it != FileNames.end() ) {
	       QString fileName = *it ;
               Catalog cat;
               if (cat.CheckStandardBinaryFormat(fileName)) {
                 QString tmp =   MainWindow::self->strippedName(fileName);
                 listWidget->addItem(new QListWidgetItem(tmp));
               } else errFiles.push_back(fileName);
            ++it;
	    }
            if(!errFiles.empty ()) {
              QStringList::iterator i;
              for (i = errFiles.begin(); i != errFiles.end(); ++i) {
                int find = FileNames.indexOf(*i);
                FileNames.removeAt (find);
              }
            }
    if(FileNames.empty()) return QStringList();
    SetCatalogInfo((QString &)FileNames.at(0),labelNameAdd,labelRecordAdd,labelDateAddStart,labelDateAddFinish);
    listWidget->setCurrentRow (0);
	it = FileNames.begin();
	openUserToolFileDirectory = QFileInfo(*it).absolutePath ();

    return QStringList(FileNames);
    } else return QStringList();
}
//------------------------------------------------------------------------------------------
void AppendImpl::SetCatalogInfo(QString &file,QLabel *fileName,QLabel *rec,QLabel *dateStart,QLabel *dateFinish){
   Catalog cat;
   RECORD record;
   RECORD record1;
   int numrec;
   if (cat.GetCatalogInfo(file,numrec,record,record1)) {
   QString name = "unnamed";
   if(file != "")   name = MainWindow::self->strippedName(file);
/// !!!!
   fileName->setText(QString("Catalog: \"%1\"").arg(name));
   rec->setText(QString("Records: %1").arg(numrec));
   dateStart->setText ("First record: " + cat.getQStringTime(record));
   dateFinish->setText("Last  record: " + cat.getQStringTime(record1));

   }

}
//------------------------------------------------------------------------------------------
void AppendImpl::reset(){

foreach (PropertyValue* val, values) val->SetResetvalueToValue();
SetDocumentToDialog();
}
//------------------------------------------------------------------------------------------
void AppendImpl::project(){

foreach (PropertyValue* val, values) val->SetInitial();
SetDocumentToDialog();
}
//------------------------------------------------------------------------------------------
void AppendImpl::defaults(){
foreach (PropertyValue* val, values) {
val->SetDefault();
}
SetDocumentToDialog();

labelNameAdd->setText("Catalog:");
labelRecordAdd->setText("Records:");
labelDateAddStart->setText("Start Date:");
labelDateAddFinish->setText("Finish Date:");

}
//------------------------------------------------------------------------------------------
void AppendImpl::RowClicked(QListWidgetItem * item){
int row =    item->listWidget ()->currentRow ();
SetCatalogInfo((QString &)listAddCatalog.at(row),labelNameAdd,labelRecordAdd,labelDateAddStart,labelDateAddFinish);

}
//----------------------------------------------------------------------------------
void AppendImpl::ins(){
	  QString fileName =
		QFileDialog::getOpenFileName(this,"Open an existing catalog file",
                openUserToolFileDirectory,
                MainWindow::self->GetFileFilters());
	  if (!fileName.isEmpty()) {
          Catalog cat;
               if (cat.CheckStandardBinaryFormat(fileName)) {
                 QString tmp =   MainWindow::self->strippedName(fileName);
                 listWidget->addItem(new QListWidgetItem(tmp));
                 listAddCatalog.push_back(fileName);
			     openUserToolFileDirectory = QFileInfo(fileName).absolutePath ();
           }     else return; 
        }

}
//------------------------------------------------------------------------------------------
void AppendImpl::del(){
if (listWidget->count () < 1) return;
int row = listWidget->currentRow();
int curRow = row;
if (row == listWidget->count () -1 )  curRow = row -1;
listWidget->takeItem (row);
listAddCatalog.takeAt (row);
listWidget->setCurrentRow(curRow);

SetCatalogInfo((QString &)listAddCatalog.at(curRow),labelNameAdd,labelRecordAdd,labelDateAddStart,labelDateAddFinish);

}
//------------------------------------------------------------------------------------------
void AppendImpl::down(){
if (listWidget->count () < 2) return;
int row = listWidget->currentRow() ;
QListWidgetItem * item = listWidget->currentItem ();
listWidget->takeItem ( row );
listWidget->insertItem(row+1,item);
listWidget->setCurrentRow(row+1);

QString tmp = listAddCatalog.at(row);
listAddCatalog.takeAt (row);
listAddCatalog.insert ( row+1, tmp);

}
//------------------------------------------------------------------------------------------
void AppendImpl::up(){
if (listWidget->count () < 2) return;
int row = listWidget->currentRow() ;
QListWidgetItem * item = listWidget->currentItem ();
listWidget->takeItem ( row );
listWidget->insertItem(row-1,item);
listWidget->setCurrentRow(row-1);

QString tmp = listAddCatalog.at(row);
listAddCatalog.takeAt (row);
listAddCatalog.insert ( row-1, tmp);
}
//------------------------------------------------------------------------------------------
