#ifndef _APPEND_DIALOG_H
#define _APPEND_DIALOG_H
#include "ui_appendbase.h"
#include <fstream>
#include <iostream>
using namespace std;
class QTextEdit;
class CatTable;
class FDocument;
class PropertyValue;
class HelpWindow;
class AppendImpl : public QDialog, private Ui::AppendBase
{
    typedef multimap<double,int> DoubleIntMultiMap;
    typedef DoubleIntMultiMap::iterator ItrMultiMap;
    Q_OBJECT
public:
    enum TypeUsing
    {
        Tool,
        Wizard,
        Execute
    };

    AppendImpl(QWidget *parent,FDocument* dc,TypeUsing type);
    ~AppendImpl();
    bool NextOk();
    void FinishOk();
    bool execute();
    bool applay();
    QStringList &GetListAddCatalog(){ return listAddCatalog;}
    QStringList SetListWidgetAddeFiles(QStringList &FileNames);
    void SetProjectCatalogInfo(QString &name);
    bool AddSecondCatalog();
    bool GetRecordCatalogIndex(QString &file,DoubleIntMultiMap  &index);
    bool WriteBeginingCatalog(fstream &inFirst,ofstream &outfile,int num1);
protected:
    void closeEvent(QCloseEvent *event); 
public slots:
protected slots:
    void accept();
    void reject();
    void helpButton();
    void ins();
    void del();
    void browse();
    void down();
    void up();
    void reset();
    void project();
    void defaults();
    void start();
    void RowClicked(QListWidgetItem * item);
private:
    FDocument* doc;
    TypeUsing type;
    CatTable* parentWindow;
    void SetDocumentToDialog();
    void GetDocumentFromDialog();
    void SetCatalogInfo(QString &file,QLabel *fileName,QLabel *rec,QLabel *dateStart,QLabel *dateFinish);
    void GetMessageInfo();
    QString  startTimeFirst;
    QString  endTimeFirst;
    QString  startTimeSecond;
    QString  endTimeSecond;
    QString  cataloNameFirst;
    QString  cataloNameSecond;
    int catSizeFirst;
    int catSizeSecond;
    double dtSecondStart;
    double dtSecondEnd;
    double dtFirstStart;
    double dtFirstEnd;
    QStringList listAddCatalog;
    QList<PropertyValue* > values;
    bool firstStart;
    QString SecondCatalogName;
    QString TempCatalogName;
    QString SaveCatalogName;
    
    QTextEdit* texted;
    QString message;
    QTextEdit* correctioned;
    QString    corrmess;
    QString    actionName;
    HelpWindow* help;
    QString openUserToolFileDirectory;
};
#endif 
