#ifndef BOTTOM_WINDOW_H
#define BOTTOM_WINDOW_H
//----------------------
#include <QItemDelegate>
#include <QModelIndex>
#include <QObject>
#include <QSize>
#include <QPointer>
#include <QStandardItemModel>
#include <QList>
//--------------------------
#include <QDockWidget>
#include <QTableView>
#include <QTabWidget>
#include <QDialog>
#include <QTextEdit>
#include <vector>
using namespace std;
class ErrorModel;
class BottomWindow;
class ComTable : public QTableView
{
    Q_OBJECT
typedef vector<QString> ErrorVector;
typedef ErrorVector::iterator ItrVector;

public:
   enum TypeError
    {
        ParamAll,
        ParamFirst,
        SortAll,
        SortFirst
    };
    TypeError GetTypeError() {return type;}
    ComTable( int numRow,int numCol,QWidget* parent = 0);
    ~ComTable();   
    ErrorVector *errorvec;
    bool   InitCommentTable(ErrorVector *errorvector,TypeError type);
	void ClearComTable();
public slots:    
   void clickedRowCol(QModelIndex  ); 
//   void clickedVerticalHeader(int );
private:
    void ResizeHorizontalHeader(QHeaderView *hd);
    void ResizeRowsCols();
    ErrorModel *model;    
    int NumRows;
    int NumCols;
    BottomWindow* parentWindow;
    int lastCheckedRow;
    TypeError type;
};
//---------------------------------------------------------------------------------
class MessageTab : public QTextEdit
{
    Q_OBJECT

public:
    MessageTab(QWidget *parent = 0);
private:
BottomWindow* parentWindow;
};
class CorrectionTab : public QTextEdit
{
    Q_OBJECT

public:
    CorrectionTab(QWidget *parent = 0);
private:
BottomWindow* parentWindow;
};
//---------------------------------------------------------------------------------
class BottomWindow : public QDialog
{
    Q_OBJECT

public:
    BottomWindow  (QWidget * parent);
    ~BottomWindow ();
    QTabWidget *tabWidget;
    ComTable* comtable;
    MessageTab* messageTab;
    CorrectionTab* correctionTab;
    void OpenMessagesProtocolPage();
    void OpenProblemsProtocolPage();
    void OpenCorrectionsProtocolPage();
	void CleanAllEntries();
protected slots:

};
//---------------------------------------------------------------------------------
class ErrorModel : public QStandardItemModel
{
    Q_OBJECT

public:
ErrorModel(int rows, int columns, QObject * parent = 0);
//IProperty * findProperty(const QModelIndex & index);
//QList<IProperty *> ipList;
void SetRow(int row,int col,QString temp);
//QStringList GetTableData(int row);

private:
void SetHorizontalHeader();
QTableView* parentTable;
int NumRows;
int NumCols;
};
//---------------------------------------------------------------------------------
class ErrorDelegate : public QItemDelegate
{
    Q_OBJECT

public:
    ErrorDelegate(){};

   // QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option,
//                          const QModelIndex &index) const;

   // void setEditorData(QWidget *editor, const QModelIndex &index) const;
   // void setModelData(QWidget *editor, QAbstractItemModel *model,
   //                   const QModelIndex &index) const;
   // void paint(QPainter *painter, const QStyleOptionViewItem &option,
   //                    const QModelIndex &index) const;
private slots:
   // void setValue( const QString  &v );
   // void emitCommitData();
private:
  //  QPointer<QLineEdit> lin;
};
#endif
