#include <QtGui>
#include <math.h> 
#include "mainwindow.h" 
#include "doubleimpl.h"
#include "catalimpl.h"
#include "default.h"
#include "viewcatalogimpl.h"
#include "bottomwindow.h"
#include "editline.h"
#include "convert.h"
#include "helpwindow.h"
static const  QString  _ENTER_CATALOG_NAME_ = "Browse catalog file name:>";
CatalBaseImpl::~CatalBaseImpl(){
if (findFunction !=0)   delete findFunction;   findFunction = 0;
if(!listMergeCatalog.empty()) listMergeCatalog.clear();
comboBoxes.clear(); transFunc.clear();
if (!indexMagnitude.empty()) indexMagnitude.clear();
if (!indexDoubleModeActionFirst.empty()) indexDoubleModeActionFirst.clear();
if (!indexDoubleModeActionSecond.empty()) indexDoubleModeActionSecond.clear();
values.clear();
if(!propDocLine.empty()) {
foreach (LineDocProperty* prop, propDocLine) {delete prop;prop = 0;}
propDocLine.clear();
}
if(!EditLineValues.empty()) {
for_each(EditLineValues.begin(),EditLineValues.end(),delAndNullify);
EditLineValues.erase(remove(EditLineValues.begin(),EditLineValues.end(),
static_cast<PropertyValue*>(0)),EditLineValues.end());
}
if(help !=0) {delete help; help =0;}
//----------------------------------------------------
    if (in != 0) in->close();delete in; in = 0;
    if (inSecond != 0) { inSecond->close();delete inSecond;inSecond = 0; }
	if (!indexDouble->empty()) indexDouble->clear(); delete indexDouble;
//----------------------------------------------------
}
CatalBaseImpl::CatalBaseImpl( QWidget *parent,FDocument* dc,CatalogAction act,TypeUsing tp)
    : QDialog(0),doc(dc),catAct(act),type(tp)
{
     QFont f = parent->font();
     setFont( parent->font() );
     setWindowIcon(QIcon(":/images/icon.png"));
     Ui_CatalBase::setupUi(this);

//----------------------------------------------------------------------------------
actionName = "";
if( catAct == MergeCatalog)   {
         actionName = projectActionList().split ('@').at(3);
         groupBoxCatalogAdd->setTitle("Add-in catalog:");
         mode = Merge;
         tabWidget->removeTab(1);
         //tabWidget->setCurrentIndex(1);

    }
if( catAct == CompareCatalog) {
         actionName = projectCompareTitle();
         groupBoxCatalogAdd->setTitle("Reference catalog:");
         tabWidget->removeTab(0);
        // tabWidget->setCurrentIndex(1);
}
     openUserToolFileDirectory = MainWindow::self->openUserFileDirectory;
     setWindowTitle(actionName);

//---------------------------------------------------------------------------------
	 in = 0;
     inSecond=0;
	 indexDouble = new DoubleIntMultiMap;
     ptrFindFunction = 0;
     findFunction = 0;
     help =0;
     maxCorrectionPageDouble = MainWindow::self->GetSetDocument()->GetMaxCorrectionLines()->GetValue().toInt()/4;
     setModal (true);
	 
	 if (type != Wizard) 
		 parentWindow = (CatTable* )parent;
	 else parentWindow = 0;
     textLabel->setText("");
	 if (type == Wizard)  { 
		 textLabel->hide();
		 groupBoxCatalogIns->hide();
		 groupBoxCatalogInsC->hide();
		// if( catAct == CompareCatalog) QMessageBox::critical(0,"","type == Wizard");

	 }
     numberOfDoubles = 0;
     firstStart = true;
//--------- Fill Lists Functions and Priority Magnitudes -----------------------

     comboBoxDeltaFunction->clear();
     QStringList lst = doc->GetDeltaCatMagnitudeFunction()->GetStringList();
     for (int i = 0; i < lst.size(); i++) comboBoxDeltaFunction->addItem(lst.at(i));

     lst = enumComboBoxMagnitudeList().split ('@');
     comboBoxes.append(comboBoxDeltaM1); comboBoxes.append(comboBoxDeltaM2);
     comboBoxes.append(comboBoxDeltaM3); comboBoxes.append(comboBoxDeltaM4);
     foreach (QComboBox * box, comboBoxes) box->clear();
     for (int i = 0; i < lst.size(); i++) foreach (QComboBox * box, comboBoxes) box->addItem(lst.at(i));

//--------------------------------------------------------------------------------------------------------

     values.append(doc->GetDeltaCatMagnitudeFunction());
     values.append(doc->GetCompareCatalogAction());
     first  = doc->GetDefineDeltaCatFirstMagnitude();   transFunc.append(first);
     second = doc->GetDefineDeltaCatSecondMagnitude();  transFunc.append(second);
     third  = doc->GetDefineDeltaCatThirdMagnitude();   transFunc.append(third);
     fourth = doc->GetDefineDeltaCatFourthMagnitude();  transFunc.append(fourth);

     values.append(first);values.append(second);values.append(third);values.append(fourth);

     values.append(doc->GetDeltaCatTime());
     values.append(doc->GetDeltaCatDepth());
     values.append(doc->GetDeltaCatLatitude());
     values.append(doc->GetDeltaCatLongitude());
     values.append(doc->GetDeltaCatMagnitude());
     if( catAct == MergeCatalog) {
     values.append(doc->GetAssignDuplicateMagnitude());
     values.append(doc->GetSelectedDuplicateMagnitude());
     values.append(doc->GetRemovingDuplicateMagnitude());
     values.append(doc->GetListMergeCatalog());
     values.append(doc->GetSecondCatalogName());
     }
//---------------------------------------------------------------------------------------------------------

    buttonOk->setEnabled(FALSE);
      texted = MainWindow::self->bottomWindow->messageTab;
      correctioned = MainWindow::self->bottomWindow->correctionTab;
    if (type == Tool)  {
      toolButtonProject->hide();
      MainWindow::self->bottomWindow->OpenMessagesProtocolPage();
      texted->insertPlainText(prefixMessage() + actionName + " ***\n\n");
      }
    connect( buttonOk, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( buttonCancel, SIGNAL( clicked() ), this, SLOT( close() ) );
    connect( buttonHelp, SIGNAL( clicked() ), this, SLOT( btHelp() ) );
    connect( pushButtonStart, SIGNAL( clicked() ), this, SLOT( start() ) );
    connect( toolButtonFileName, SIGNAL( clicked() ), this, SLOT( BrowseSecondCatalogName() ) ); 


    connect( toolButtonIns, SIGNAL( clicked() ), this, SLOT( ins() ) );
    connect( toolButtonDel, SIGNAL( clicked() ), this, SLOT( del() ) );
    connect( toolButtonBrowse, SIGNAL( clicked() ), this, SLOT( browse() ) );
    connect( toolButtonDown, SIGNAL( clicked() ), this, SLOT( down() ) );
    connect( toolButtonUp, SIGNAL( clicked() ), this, SLOT( up() ) );
    connect(toolButtonReset,     SIGNAL(clicked()),   this, SLOT(reset()));
    connect(toolButtonProject,   SIGNAL(clicked()),   this, SLOT(project()));
    connect(toolButtonDefault,   SIGNAL(clicked()),   this, SLOT(defaults()));
    connect( progressBar, SIGNAL( valueChanged ( int) ), this, SLOT(ProgressBarChanged(int) ) );
    connect( listWidget, SIGNAL( itemClicked (QListWidgetItem *) ), this, SLOT(RowClicked(QListWidgetItem *) ) );
    InitLineDocProperty();
    SetDocumentToDialog();
	 comboBoxDeltaM1->adjustSize();
	 comboBoxDeltaM2->adjustSize();
	 comboBoxDeltaM3->adjustSize(); 
	 comboBoxDeltaM4->adjustSize();
    textLabel->setText("");
    DuplicateProgress(0);
	 tabWidget->setCurrentIndex(0);

 }
void CatalBaseImpl::InitLineDocProperty(){
     propDocLine.append(new LineDocProperty(spinBoxDeltaTime,      doc->GetDeltaCatTime()));
     propDocLine.append(new LineDocProperty(lineEditDeltaLatitude, doc->GetDeltaCatLatitude()));
     propDocLine.append(new LineDocProperty(lineEditDeltaLongitude,doc->GetDeltaCatLongitude()));
     propDocLine.append(new LineDocProperty(spinBoxDeltaDepth,     doc->GetDeltaCatDepth()));
     propDocLine.append(new LineDocProperty(lineEditDf,            doc->GetDeltaCatMagnitude()));
//---------------------------------------------------------------- 
 PropertyFloatValue* M1_D = new PropertyFloatValue(101,first->valD,"",
 minTransformMagnitudeD(),maxTransformMagnitudeD(),decimalTransformMagnitudeD());
 propDocLine.append(new LineDocProperty(lineEditDeltaM1_D,M1_D));
 EditLineValues.push_back(M1_D);

 PropertyFloatValue* M1_A = new PropertyFloatValue(102,first->valA,"",
 minTransformMagnitudeA(),maxTransformMagnitudeA(),decimalTransformMagnitudeA());
 propDocLine.append(new LineDocProperty(lineEditDeltaM1_A,M1_A));
 EditLineValues.push_back(M1_A);

 PropertyFloatValue* M1_B = new PropertyFloatValue(103,first->valB,"",
 minTransformMagnitudeB(),maxTransformMagnitudeB(),decimalTransformMagnitudeB());
 propDocLine.append(new LineDocProperty(lineEditDeltaM1_B,M1_B));
 EditLineValues.push_back(M1_B);

 PropertyFloatValue* M1_C = new PropertyFloatValue(104,first->valC,"",
 minTransformMagnitudeC(),maxTransformMagnitudeC(),decimalTransformMagnitudeC());
 propDocLine.append(new LineDocProperty(lineEditDeltaM1_C,M1_C));
 EditLineValues.push_back(M1_C);
//----------------------------------------------------------------- 
 PropertyFloatValue* M2_D = new PropertyFloatValue(105,second->valD,"",
 minTransformMagnitudeD(),maxTransformMagnitudeD(),decimalTransformMagnitudeD());
 propDocLine.append(new LineDocProperty(lineEditDeltaM2_D,M2_D));
 EditLineValues.push_back(M2_D);

 PropertyFloatValue* M2_A = new PropertyFloatValue(106,second->valA,"",
 minTransformMagnitudeA(),maxTransformMagnitudeA(),decimalTransformMagnitudeA());
 propDocLine.append(new LineDocProperty(lineEditDeltaM2_A,M2_A));
 EditLineValues.push_back(M2_A);

 PropertyFloatValue* M2_B = new PropertyFloatValue(107,second->valB,"",
 minTransformMagnitudeB(),maxTransformMagnitudeB(),decimalTransformMagnitudeB());
 propDocLine.append(new LineDocProperty(lineEditDeltaM2_B,M2_B));
 EditLineValues.push_back(M2_B);

 PropertyFloatValue* M2_C = new PropertyFloatValue(108,second->valC,"",
 minTransformMagnitudeC(),maxTransformMagnitudeC(),decimalTransformMagnitudeC());
 propDocLine.append(new LineDocProperty(lineEditDeltaM2_C,M2_C));
 EditLineValues.push_back(M2_C);

//-----------------------------------------------------------------
PropertyFloatValue* M3_D = new PropertyFloatValue(109,third->valD,"",
 minTransformMagnitudeD(),maxTransformMagnitudeD(),decimalTransformMagnitudeD());
 propDocLine.append(new LineDocProperty(lineEditDeltaM3_D,M3_D));
 EditLineValues.push_back(M3_D);

 PropertyFloatValue* M3_A = new PropertyFloatValue(110,third->valA,"",
 minTransformMagnitudeA(),maxTransformMagnitudeA(),decimalTransformMagnitudeA());
 propDocLine.append(new LineDocProperty(lineEditDeltaM3_A,M3_A));
 EditLineValues.push_back(M3_A);

 PropertyFloatValue* M3_B = new PropertyFloatValue(111,third->valB,"",
 minTransformMagnitudeB(),maxTransformMagnitudeB(),decimalTransformMagnitudeB());
 propDocLine.append(new LineDocProperty(lineEditDeltaM3_B,M3_B));
 EditLineValues.push_back(M3_B);

 PropertyFloatValue* M3_C = new PropertyFloatValue(112,third->valC,"",
 minTransformMagnitudeC(),maxTransformMagnitudeC(),decimalTransformMagnitudeC());
 propDocLine.append(new LineDocProperty(lineEditDeltaM3_C,M3_C));
 EditLineValues.push_back(M3_C);

//-----------------------------------------------------------------
 PropertyFloatValue* M4_D = new PropertyFloatValue(113,fourth->valD,"",
 minTransformMagnitudeD(),maxTransformMagnitudeD(),decimalTransformMagnitudeD());
 propDocLine.append(new LineDocProperty(lineEditDeltaM4_D,M4_D));
 EditLineValues.push_back(M4_D);

 PropertyFloatValue* M4_A = new PropertyFloatValue(114,fourth->valA,"",
 minTransformMagnitudeA(),maxTransformMagnitudeA(),decimalTransformMagnitudeA());
 propDocLine.append(new LineDocProperty(lineEditDeltaM4_A,M4_A));
 EditLineValues.push_back(M4_A);

 PropertyFloatValue* M4_B = new PropertyFloatValue(115,fourth->valB,"",
 minTransformMagnitudeB(),maxTransformMagnitudeB(),decimalTransformMagnitudeB());
 propDocLine.append(new LineDocProperty(lineEditDeltaM4_B,M4_B));
 EditLineValues.push_back(M4_B);

 PropertyFloatValue* M4_C = new PropertyFloatValue(116,fourth->valC,"",
 minTransformMagnitudeC(),maxTransformMagnitudeC(),decimalTransformMagnitudeC());
 propDocLine.append(new LineDocProperty(lineEditDeltaM4_C,M4_C));
 EditLineValues.push_back(M4_C);

//-----------------------------------------------------------------
/*
     QFont fnOld = font();
     QFont fn = fnOld;
     fn.setBold(true);
     int width =  fontMetrics().width(fontmetricLineEdit());
     foreach (LineDocProperty *docprop, propDocLine) {
     if (docprop->GetProp()->GetKind()  == PropertyValue::Property_Float){
      QLineEdit * lin = (QLineEdit *) docprop->GetEditor();
      lin->setFixedWidth (width);
    }
 }
*/
}
bool CatalBaseImpl::NextOk(){ 
  message = "";
  if ( !GetRemDupFunc() ) return false;
  if (type == Tool || type == Wizard) {
       QString tmp = QString("Do you want to execute %1?\n\n").arg(actionName);
       int ret = QMessageBox::warning(this,windowTitle (),tmp + message,
                 QMessageBox::Yes | QMessageBox::Default,
                 QMessageBox::No | QMessageBox::Escape);
      if (ret == QMessageBox::No) return false;
  }

  return true;
}
void CatalBaseImpl::TimeOutShot(){
progressBar->repaint();
//listWidget->setCurrentRow (currentNumberCatalog++);
//listWidget->repaint();
}
bool CatalBaseImpl::DoubleProccessing() {
//----------------------------------------------------------------------
  if (in != 0) { in->close();  delete in; in = 0;}
  in = new fstream (TempCatalogName.toAscii(),ios::binary | ios::in | ios::out);
  if (!(*in)) {QApplication::restoreOverrideCursor();error(QString("cannot open input file"),TempCatalogName);return false;}
  in->clear();
  
  if (inSecond != 0) { inSecond->close();  delete inSecond; inSecond = 0;}
  inSecond = new fstream (SecondCatalogName.toAscii(),ios::binary | ios::in | ios::out);
  if (!(*inSecond)) {QApplication::restoreOverrideCursor();error(QString("cannot open input file"),SecondCatalogName);return false;}
  inSecond->clear();
  
  if (!indexDouble->empty()) indexDouble->clear();
  RECORD record;
  double datetime = 0;
  in->seekg(sizeof(RECORD),ios::beg);
  inSecond->seekg(sizeof(RECORD),ios::beg);
    int numRec = 0;
      while(in->read((char*)&record,sizeof(RECORD ))) {
	    if(in->fail()){QApplication::restoreOverrideCursor();error(QString("An reading error has occurred"),TempCatalogName);return false;}
	    datetime =  DateTime(record);
	    indexDouble->insert(make_pair(datetime,numRec));
		numRec++;
	}
    numRec = 1;

    while(inSecond->read((char*)&record,sizeof(RECORD ))){
	    if(inSecond->fail()){QApplication::restoreOverrideCursor();error(QString("An reading error has occurred"),SecondCatalogName);return false;}
	    datetime =  DateTime(record);
	    indexDouble->insert(make_pair(datetime,-numRec));
        numRec++;
	 }
//-----------------------------------------------------------------------  
  
  int maxRangeProgress = indexDouble->size()-1;
  progressBar->setRange(0,maxRangeProgress);
  DuplicateProgress(0);
 // QTimer::singleShot(200, this, SLOT(progressBar->repaint()));
  QTimer::singleShot(200, this, SLOT(TimeOutShot()));

  numberOfIndexDouble = 0;
  if (!indexMagnitude.empty()) indexMagnitude.clear();
  if (!indexDoubleModeActionFirst.empty()) indexDoubleModeActionFirst.clear();
  if (!indexDoubleModeActionSecond.empty()) indexDoubleModeActionSecond.clear();
  QString tmp1 = MainWindow::self->strippedName(SecondCatalogName);
  textLabel->setText(QString("Reference catalog Name: ") +tmp1); 

      in->clear(); inSecond->clear();
      pos1        = indexDouble->begin();
      //ItrMultiMap postmp = pos1;postmp++;
      pos2        = indexDouble->begin();pos2++;
//------------------------------------------------------------------
	  while ( pos1 != indexDouble->end() || pos2 != indexDouble->end() ) {
	    returnCode  =   findNextDouble();
//----------------------------------------------------------------------
      if (returnCode == 3)
         if (pos1->second >= 0) EraseSecondRecordOfDouble();
         else EraseFirstRecordOfDouble();
//-------------------------------------------------------------------------
	    QString tmp ="";
	    if (returnCode == 1) {textLabel->setText("An reading error catalog has occurred"); return false;}
	    if (returnCode == 2) {textLabel->setText("An expected eof catalog has occurred"); return false;}

	} 
//while
         // print   indexMagnitude
          /*
          if (!indexMagnitude.empty())  {
           multimap<double,short>::iterator it;
           for (it = indexMagnitude.begin(); it!=indexMagnitude.end();it++)
           qWarning("--- %16.6f %d",it->first,it->second);
          }
           */
          // print   indexMagnitude
/*
         if (!indexDoubleModeAction.empty())  {
           map<double,int>::iterator it;
           for (it = indexDoubleModeAction.begin(); it!=indexDoubleModeAction.end();it++)
           qWarning("--- %16.6f %d",it->first,it->second);
          }
*/
//------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------
  DuplicateProgress(maxRangeProgress);
 // correctioned->insertPlainText(message);
  QString tmp ="";
  if (numberOfDoubles == 0)  
		tmp = "Duplicates have not found.Identification complited" ;
  if (numberOfDoubles > 0)
		tmp = QString("Found %1 duplicates. Identification complited.").arg(numberOfDoubles);
  if (numberOfDoubles > 1) correctioned->insertPlainText(tmp + "\n\nList of duplicates :\n\n");
   else correctioned->insertPlainText(tmp + "\n" );
  correctioned->insertPlainText(corrmess);
//-----------------------------------------------------------------------------------
return true;
}
bool CatalBaseImpl::execute(){
bool ret = applay();
//------------------------------------------------------------------------------------
	if (numberOfDoubles == 0 && mode == Intersection) {
		QMessageBox::warning(this, "Task: Compare Catalogs",
			QString("Intersection mode: Initial catalog  have no  equivalent records in Reference catalog.\nResult is empty. Task will be canceled."));
		MainWindow::self->modifiedCatalog = false;
        return true;	
	} 
	
	if (numberOfDoubles == CatTable::tSelf->GetCatSize() && mode == Difference) {
		QMessageBox::warning(this, "Task: Compare Catalogs",
			QString("Difference mode: All records of Initial catalog have equivalent record in Reference catalog.\nResult is empty. Do you want to canceled task?"));
			MainWindow::self->modifiedCatalog = false;	
			return true;

	} 
	if (numberOfDoubles == 0 && mode == Equivalence) {
		QMessageBox::warning(this, "Task: Compare Catalogs",
			QString("Equivalence mode:  The catalog of groups of equivalent events from Initial catalog and Reference catalog is empty!\n Do you want to canceled task?"));
		MainWindow::self->modifiedCatalog = false;                     
        return true;
	
	} 
	if (numberOfDoubles == CatTable::tSelf->GetCatSize() && mode == Nonequivalence) {
		QMessageBox::warning(this, "Task: Compare Catalogs",
			QString("Nonequivalence mode: All records of Initial catalog have equivalent record in Reference catalog.\nResult is empty.  Do you want to canceled task?"));
		MainWindow::self->modifiedCatalog = false;	
        return true;
	
	} 	
	    parentWindow->GetFstream()->close();
		QDir dp(MainWindow::self->tempDirectory);
		dp.remove(MainWindow::self->GetOpenBinaryFileName());
		dp.rename (TempCatalogName,MainWindow::self->GetOpenBinaryFileName());
		parentWindow->RestoreIndex();
		done( Accepted );
		
	
//------------------------------------------------------------------------------------

return ret;
}
bool CatalBaseImpl::applay() {
  message = "";
  if ( !GetRemDupFunc() ) return false;
  if (type == Tool || type == Wizard) {
       QString tmp = QString("Do you want to execute %1?\n\n").arg(actionName);
       int ret = QMessageBox::warning(0,windowTitle (),tmp + message,
                 QMessageBox::Yes | QMessageBox::Default,
                 QMessageBox::No | QMessageBox::Escape);
      if (ret == QMessageBox::No) return false;
  }
QApplication::setOverrideCursor(Qt::WaitCursor);
if (firstStart == true) {
 Catalog cat;	
 QString initialCatalogName = MainWindow::self->GetOpenBinaryFileName();
 
 QString filename = initialCatalogName;
 filename.replace( openBinaryCatalogfileName(), openTempMergeBinaryCatalogfileName());
 SaveCatalogName = filename;
 if ( !cat.CopyFile(initialCatalogName,SaveCatalogName) ) { QApplication::restoreOverrideCursor(); return false;}

 filename = initialCatalogName;
 filename.replace( openBinaryCatalogfileName(), openSecondBinaryCatalogfileName());
 TempCatalogName = filename;
 if ( !cat.CopyFile(initialCatalogName,TempCatalogName) ) { QApplication::restoreOverrideCursor(); return false;}
} else {
Catalog cat;
if(!cat.CopyFile(SaveCatalogName,TempCatalogName)) { QApplication::restoreOverrideCursor(); return false;}
}

firstStart = false;



  int commonNumberDoubles = 0;

  correctioned->insertPlainText(prefixMessage()  + actionName + " ***\n\n");
  Catalog cat; 
   correctioned->insertPlainText(message);
  if (mode == Merge)  {
   currentNumberCatalog = 0;
   QStringList::Iterator it = listMergeCatalog.begin();
   int numIteration = 0;
   for( it = listMergeCatalog.begin(); it != listMergeCatalog.end();it++ ) {
	numIteration++;
	SecondCatalogName = *it ; 
    QString catInfo = "";
    catInfo += QString("%1. Merging current and add-in catalogs.\n\nCurrent catalog ").arg(numIteration);
    catInfo += cat.GetCatalogShortInfoMessage(TempCatalogName);   
   // catInfo += "Catalog for merging info:\n";
	QString tmp = cat.GetCatalogInfoMessage(SecondCatalogName);
	tmp = tmp.replace(QString("Initial"), QString("Add-in"));
    catInfo += tmp;
    correctioned->insertPlainText(catInfo);
       corrmess = "";
       numberOfDoubles = 0;
	   
       if (!DoubleProccessing()) { 
		   texted->insertPlainText("\nAction canceled\n");
		   correctioned->insertPlainText("\nAction canceled\n");
		   return false;
	   }

       commonNumberDoubles += numberOfDoubles;

//	   	  QMessageBox::warning(this, "DoubleProccessing"," Point 0",
//		           QMessageBox::Yes | QMessageBox::Default,QMessageBox::No | QMessageBox::Escape);

//       if (isTransformMagnitude) parentWindow->MergeTwoCatalogs(CatalBaseImpl::Replace);
//       else  parentWindow->MergeTwoCatalogs(CatalBaseImpl::Ignore);
       WriteCatalogFromTwoCatatalgIndex(Merge);

   }
  } else {

    corrmess = "";
    QString catInfo = "";
    catInfo += "Initial catalog info:\n";
    catInfo += cat.GetCatalogShortInfoMessage(MainWindow::self->GetOpenBinaryFileName());
    QString modeStr = "";
    if (mode == Intersection ) modeStr = "Intersection";
    if (mode == Difference   ) modeStr = "Difference";
    if (mode == Equivalence  ) modeStr = "Equivalence";
    if (mode == Nonequivalence) modeStr = "Nonequivalence";
    catInfo += QString("Comparing mode: \"%1 \"\n").arg(modeStr);
	QString tmp = cat.GetCatalogInfoMessage(SecondCatalogName);
	tmp = tmp.replace(QString("Initial"), QString("Reference"));
    catInfo += tmp;
    correctioned->insertPlainText(catInfo);
    numberOfDoubles = 0;
    if (!DoubleProccessing()) { 
		   texted->insertPlainText("\nAction canceled\n");
		   correctioned->insertPlainText("\nAction canceled\n");
		   return false;
	   }
    commonNumberDoubles += numberOfDoubles;
    if (mode == Intersection && numberOfDoubles > 0) IntersectionTwoCatalogs();
    if (mode == Difference   && numberOfDoubles < CatTable::tSelf->GetCatSize()) DifferenceTwoCatalogs();
    if (mode == Equivalence  && numberOfDoubles > 0) EquivalenceTwoCatalogs();
    if (mode == Nonequivalence && numberOfDoubles < CatTable::tSelf->GetCatSize()) UnequivalenceTwoCatalogs();
  }
  
  QString tmp = "";
  if (commonNumberDoubles == 0) tmp = "Duplicates have not found." ;
  if (commonNumberDoubles > 0)
     tmp = QString("Found %1 duplicates.").arg(commonNumberDoubles);

  tmp +=   " Identification complited.";
  textLabel->setText(tmp); 
  QApplication::restoreOverrideCursor();
  buttonOk->setEnabled(TRUE);
  texted->insertPlainText(message);
  texted->insertPlainText(tmp + "\n");
  texted->insertPlainText("\nOutput catalog " + 
           cat.GetCatalogShortInfoMessage(TempCatalogName));

  texted->insertPlainText(postfixActionMessage() + ": " + actionName + " ***\n\n");
  correctioned->insertPlainText("\nOutput catalog " + 
           cat.GetCatalogShortInfoMessage(TempCatalogName));
           //cat.GetCatalogShortInfoMessage(MainWindow::self->GetOpenBinaryFileName()));

  correctioned->insertPlainText(postfixActionMessage() + ": " + actionName + " ***\n\n");

return true;
}

void CatalBaseImpl::start(){
if (!applay()) return;
}
int CatalBaseImpl::GetValuesFromCatalogsRecord(ItrMultiMap pos,float &lat,float &lon,float &dep,
                    float &mb,float &ms,float &ml,float &mp,RECORD &record) {

    if (pos->second >= 0) {
    int  inpos = pos->second +1;
    in->seekg(inpos * sizeof(RECORD),ios::beg);
    in->read((char * ) &record,sizeof(RECORD ));
    if(in->eof()){
	error(QString("An expected eof of first catalog has occurred"),"");
            QPalette pal = textLabel->palette();
            pal.setColor(QPalette::Foreground, QColor( 255, 0, 0 ));
	    textLabel->setPalette(pal);
	return 2;
    }
    if(in->fail()){
	error(QString("An reading error of first catalog has occurred (rec %1)").arg(inpos),"");
            QPalette pal = textLabel->palette();
            pal.setColor(QPalette::Foreground, QColor( 255, 0, 0 ));
	    textLabel->setPalette(pal);
	return 1;
    }
    cat.GetLatLonDepthMagnitude(record,lat,lon,dep,mb,ms,ml,mp);
    }
    else {
    int  inpos = -pos->second;
    inSecond->seekg(inpos * sizeof(RECORD),ios::beg);
    inSecond->read((char * ) &record,sizeof(RECORD ));
    if(inSecond->eof()){
	error(QString("An expected eof of second catalog  has occurred"),"");
	    QPalette pal = textLabel->palette();
            pal.setColor(QPalette::Foreground, QColor( 255, 0, 0 ));
	    textLabel->setPalette(pal);
	return 2;
    }
    if(inSecond->fail()){
	error(QString("An reading error of second catalog has occurred (rec %1)").arg(inpos),"");
	    QPalette pal = textLabel->palette();
            pal.setColor(QPalette::Foreground, QColor( 255, 0, 0 ));
	    textLabel->setPalette(pal);
	return 1;
    }
    cat.GetLatLonDepthMagnitude(record,lat,lon,dep,mb,ms,ml,mp);
    }
    

 return 0;
}
/*
void CatalBaseImpl::DuplicateAction(ItrMultiMap sel,ItrMultiMap rem)  {
  RECORD selRecord;
  RECORD remRecord;
  if (sel == pos1)  selRecord = record1; else selRecord = record2;
  if (rem == pos1)  remRecord = record1; else remRecord = record2;
double selTime =  DateTime(selRecord);
double remTime =  DateTime(remRecord);
int remMagnitudeIndex = comboBoxRem->currentIndex ();

if (isTransformMagnitude)   {
indexMagnitude.insert(make_pair(selTime,remRecord.m[remMagnitudeIndex]));
}

}
*/
int CatalBaseImpl::findNextDouble(){
    float eps = acuracyCompareFloatValue();
    bool isPositionsFromDiffCatalog = false;
    bool findDouble = false;
    int returnCode = 0;
    while(pos1 != indexDouble->end()) {
//---------------------------------------------------------------------------
    returnCode = GetValuesFromCatalogsRecord(pos1,lat1,lon1,dep1,mb1,ms1,ml1,mp1,record1);
   if (returnCode > 0) return returnCode;
//---------------------------------------------------------------------------
    GetTimeSec(pos1->first,min1, sec1);
    float fsec1 = (float)sec1/100.;
    ItrMultiMap postmp = pos2;

    while(pos2 !=indexDouble->end()) {   
//---------------------------------------------------------------------------
    returnCode = GetValuesFromCatalogsRecord(pos2,lat2,lon2,dep2,mb2,ms2,ml2,mp2,record2);
    if (returnCode > 0) return returnCode;
//---------------------------------------------------------------------------
	GetTimeSec(pos2->first,min2 , sec2);
	float fsec2 = (float)sec2 / 100.;
  //////////////////////////////////////////////////////////////
	float dt = (float)dtime;
	float dlt = fabs(lat2 - lat1);
	float dln = fabs(lon2 - lon1);
	float ddp = fabs(dep2 - dep1);
	float deltaSec = (float)abs(min2  - min1)*60.  + abs(fsec2 - fsec1);
	 if ( deltaSec < dt + 60. ) {  
     if ( (deltaSec < dt || fabs(deltaSec - dt) < eps )&&
		  (dlt < dlat  || fabs(dlt - dlat) < eps) &&
		  (dln < dlon  || fabs(dln - dlon) < eps )&&
		  (ddp < (float)ddep || fabs(ddp - (float)ddep) < eps) )
  //////////////////////////////////////////////////////////////
      {
     // bool val,func; //int delRow;float valFunct1;float valFunct2;
       findFunction->SetValue(mb1,ms1,ml1,mp1,mb2,ms2,ml2,mp2);
       (findFunction->*ptrFindFunction)();
       if ( (pos1->second >= 0 && pos2->second >= 0) || (pos1->second <= -1 && pos2->second <= -1))
             isPositionsFromDiffCatalog = false;
       else  isPositionsFromDiffCatalog = true;
       if ( findFunction->value && isPositionsFromDiffCatalog ){findDouble = true;numberOfDoubles++;break;}       
      }

	  } else {pos2++; break;}
	pos2++;
	numberOfIndexDouble++;	
	if ((numberOfIndexDouble/100)*100 == numberOfIndexDouble ) DuplicateProgress(numberOfIndexDouble);	
	  
    }  //while(pos2 
    if (findDouble == true) break;
    pos1++; postmp = pos1;  if( pos1 != pos2) pos2 = ++postmp;
	numberOfIndexDouble++;	
	if ((numberOfIndexDouble/100)*100 == numberOfIndexDouble ) DuplicateProgress(numberOfIndexDouble);		
}   //while(pos1

    if (findDouble == true) {
      if (numberOfDoubles <= maxCorrectionPageDouble)   SetFindDoubleInfo();
        if (numberOfDoubles == maxCorrectionPageDouble) {
        corrmess += QString("Stop info: number of doubles more than %1 ... \n").arg(maxCorrectionPageDouble);
         }
	   return 3;
    } else {
	return 4;
    }

    return 0;
}

void CatalBaseImpl::SetFindDoubleInfo(){

       Catalog cat;
       QString rec1;
       QString rec2;
if (pos1->second < 0) {
       rec1 = QString("%1 :>  1:  %2 -  %3").arg(numberOfDoubles).arg(pos2->second + 1).arg(cat.getFieldsFromRecord(record1));
       rec2 = QString("%1 :>  2:  %2 -  %3").arg(numberOfDoubles).arg(-pos1->second).arg(cat.getFieldsFromRecord(record2));
} else {
       rec1 = QString("%1 :>  1:  %2 -  %3").arg(numberOfDoubles).arg(pos1->second + 1).arg(cat.getFieldsFromRecord(record1));
       rec2 = QString("%1 :>  2:  %2 -  %3").arg(numberOfDoubles).arg(-pos2->second).arg(cat.getFieldsFromRecord(record2));
}

       corrmess += rec1 + "\n"; corrmess += rec2 + "\n\n";


}

void CatalBaseImpl::btHelp(){

QString home = "";
if( catAct == MergeCatalog)   home = searchHelpPath() + "/edcat-tool-merge.html";
if( catAct == CompareCatalog) home = searchHelpPath() + "/edcat-tool-compare.html";

    if(help !=0) {delete help; help =0;}
    help = new HelpWindow(home,this);
    if ( QApplication::desktop()->width() > 400
         && QApplication::desktop()->height() > 500 )
         help->show();
    else
        help->showMaximized();

}

void CatalBaseImpl::DuplicateProgress(int progress){
    progressBar->setValue(progress);
}


void CatalBaseImpl::EraseFirstRecordOfDouble() {
		ItrMultiMap posNew = pos1; posNew++;
   // if (isTransformMagnitude) DuplicateAction(pos2,pos1);

    if (mode == CatalBaseImpl::Intersection || mode == CatalBaseImpl::Difference)
       indexDoubleModeActionFirst.insert(make_pair(pos2->first,pos2->second));
    if (mode == CatalBaseImpl::Equivalence  || mode == CatalBaseImpl::Nonequivalence)  {
       indexDoubleModeActionFirst.insert(make_pair(pos2->first,pos2->second));
       indexDoubleModeActionSecond.insert(make_pair(pos1->first,pos1->second));
     }

		indexDouble->erase(pos1);
		pos1 = posNew;
		if (pos1 == pos2) pos2++;
}
void CatalBaseImpl::EraseSecondRecordOfDouble() {
		ItrMultiMap posNew = pos2;posNew++;
 //   if (isTransformMagnitude) DuplicateAction(pos1,pos2);

    if (mode == CatalBaseImpl::Intersection || mode == CatalBaseImpl::Difference)
        indexDoubleModeActionFirst.insert(make_pair(pos1->first,pos1->second));
    if (mode == CatalBaseImpl::Equivalence  || mode == CatalBaseImpl::Nonequivalence)  {
       indexDoubleModeActionFirst.insert(make_pair(pos1->first,pos1->second));
       indexDoubleModeActionSecond.insert(make_pair(pos2->first,pos2->second));
     }

		indexDouble->erase(pos2);
		pos2 = posNew;
}
void CatalBaseImpl::FinishOk()
{
if( catAct == MergeCatalog) mode = CatalBaseImpl::Merge;
if( catAct == CompareCatalog) {
    int indexModeAction = comboBoxMode->currentIndex ();
    if(indexModeAction == 0) mode = CatalBaseImpl::Intersection;
    if(indexModeAction == 1) mode = CatalBaseImpl::Difference;
    if(indexModeAction == 2) mode = CatalBaseImpl::Equivalence;
    if(indexModeAction == 3) mode = CatalBaseImpl::Nonequivalence;
}

	message = "";
	texted->insertPlainText(prefixMessage() + actionName + " ***\n\n");
	GetRemDupFunc();
    GetDocumentFromDialog();
    foreach (PropertyValue* val, values) val->SetValueToResetvalue();
	texted->insertPlainText(message);
	texted->insertPlainText(postfixActionMessage() + actionName + " ***\n\n");
}
void CatalBaseImpl::accept()
{
	//if (numberOfDoubles == 0 && mode != Merge) {close(); } 
	
	if (numberOfDoubles == 0 && mode == Intersection) {
		int ret = QMessageBox::warning(this, "Task: Compare Catalogs",
                     QString("Intersection mode: Initial catalog  have no  equivalent records in Reference catalog.\nResult is empty. Do you want to canceled task?"),
                     QMessageBox::Yes | QMessageBox::Default,
                     QMessageBox::No | QMessageBox::Escape);
        if (ret == QMessageBox::No) return;
		MainWindow::self->modifiedCatalog = false;
		close();
        return;	
	} 
	
	if (numberOfDoubles == CatTable::tSelf->GetCatSize() && mode == Difference) {
		int ret = QMessageBox::warning(this, "Task: Compare Catalogs",
                     QString("Difference mode: All records of Initial catalog have equivalent record in Reference catalog.\nResult is empty. Do you want to canceled task?"),
                     QMessageBox::Yes | QMessageBox::Default,
                     QMessageBox::No | QMessageBox::Escape);
        if (ret == QMessageBox::No) return;
		MainWindow::self->modifiedCatalog = false;
		close();
        return;
	
	} 
	if (numberOfDoubles == 0 && mode == Equivalence) {
		int ret = QMessageBox::warning(this, "Task: Compare Catalogs",
                     QString("Equivalence mode:  The catalog of groups of equivalent events from Initial catalog and Reference catalog is empty!\n Do you want to canceled task?"),
                     QMessageBox::Yes | QMessageBox::Default,
                     QMessageBox::No | QMessageBox::Escape);
        if (ret == QMessageBox::No) return;
		MainWindow::self->modifiedCatalog = false;
		close();
        return;
	
	} 
	if (numberOfDoubles == CatTable::tSelf->GetCatSize() && mode == Nonequivalence) {
		int ret = QMessageBox::warning(this, "Task: Compare Catalogs",
                     QString("Nonequivalence mode: All records of Initial catalog have equivalent record in Reference catalog.\nResult is empty.  Do you want to canceled task?"),
                     QMessageBox::Yes | QMessageBox::Default,
                     QMessageBox::No | QMessageBox::Escape);
        if (ret == QMessageBox::No) return;
		MainWindow::self->modifiedCatalog = false;
		close();
        return;
	
	} 
    
    	GetDocumentFromDialog();
		parentWindow->GetFstream()->close();
		QDir dp(MainWindow::self->tempDirectory);
		dp.remove(MainWindow::self->GetOpenBinaryFileName());
		dp.rename (TempCatalogName,MainWindow::self->GetOpenBinaryFileName());
		parentWindow->RestoreIndex();
		foreach (PropertyValue* val, values) val->SetValueToResetvalue();
		MainWindow::self->catalImplPos   =  pos();
		MainWindow::self->catalImplSize  =  size();
		MainWindow::self->modifiedCatalog = true;
		MainWindow::self->modifiedProtocol = true;
/// mode != Merge
/*
		if (numberOfDoubles > 0 && mode != Merge) {
			MainWindow::self->GetCurrentCatalogName() = "";
		    MainWindow::self->setWindowTitle(QString("%1 - %2").arg("unnamed - ").arg(mainWindowCaption())); 
		}
*/
		if (type == Tool) {
			texted->ensureCursorVisible ();
			correctioned->ensureCursorVisible ();
		}
		MainWindow::self->RestoreStatusbarMessage();
		done( Accepted );
	
}
void CatalBaseImpl::reject()
{
return;
}

void CatalBaseImpl::closeEvent(QCloseEvent *event)
{
// like as reject
if (!firstStart) {
 foreach (PropertyValue* val, values) val->SetResetvalueToValue();
}

    MainWindow::self->catalImplPos   =  pos();
    MainWindow::self->catalImplSize  =  size();
    texted->insertPlainText(cancelMessage() + "\n\n");
    correctioned->insertPlainText(corrmess + "\n");
    correctioned->insertPlainText(cancelMessage() + "\n\n");
    correctioned->ensureCursorVisible ();
    MainWindow::self->RestoreStatusbarMessage();
    event->accept();

}
void CatalBaseImpl::BrowseSecondCatalogName(){
	  QString fileName =
	  QFileDialog::getOpenFileName(this,"Open Reference Catalog",
          openUserToolFileDirectory,
          MainWindow::self->GetFileFilters());
	  if (!fileName.isEmpty()) {
   Catalog cat;
   if (!cat.CheckStandardBinaryFormat(fileName)) return;
   QFont fn = font ();
   fn.setBold(false);
   labelSecond->setFont(fn);
   QPalette pl = labelSecond->palette ();
   pl.setColor (QPalette::WindowText, QColor(Qt::black) );
   labelSecond->setPalette ( pl );
   SecondCatalogName = fileName;
   QString tmp = MainWindow::self->strippedName(fileName);
   QString tmp1 = "\"" + tmp + "\"";
   labelSecond->setText(tmp1);
   SetCatalogInfo((QString &)SecondCatalogName,labelNameAddC,labelRecordAddC,labelDateAddStartC,labelDateAddFinishC);
   openUserToolFileDirectory = QFileInfo(fileName).absolutePath ();

 }
}
bool CatalBaseImpl::GetRemDupFunc()
{
 Catalog cat;
 QString filemes = "";
if( catAct == CompareCatalog)
if (labelSecond->text() == _ENTER_CATALOG_NAME_) {
error(QString("Two catalog actions section:\nPush button \"...\" to browse Reference Catalog Name"),"");
return false;
} else {
	QString tmp = cat.GetCatalogInfoMessage(SecondCatalogName);
	tmp = tmp.replace(QString("Initial"), QString("Reference"));
	
	filemes += tmp;

}


if( catAct == MergeCatalog) 
if(listMergeCatalog.empty()) {
error(QString("Files to merge section:\nPush button \"Browse\" to browse catalogs for merge action"),"");
return false;
} else {

            filemes += "List add-ins files:\n";
            QStringList::Iterator it = listMergeCatalog.begin();
			int numrec = 0;
	    while( it != listMergeCatalog.end() ) {
			numrec++;
            filemes += QString("%1: %2").arg(numrec).arg(cat.GetOneLineCatalogInfoMessage(*it));
            it++;
            }
}
      QString incatmes = "";

      if (type == Tool)    incatmes += cat.GetCatalogInfoMessage(MainWindow::self->GetCurrentCatalogName());
      if (type == Execute){
		  incatmes += "Current catalog ";
		  incatmes += cat.GetCatalogShortInfoMessage(MainWindow::self->GetOpenBinaryFileName());
	  }


     dtime = spinBoxDeltaTime->text().toInt();
     dlat  = lineEditDeltaLatitude->text().toFloat();
     dlon  = lineEditDeltaLongitude->text().toFloat();
     ddep  = spinBoxDeltaDepth->text().toInt();
     dmf   = lineEditDf->text().toFloat();
QString delta = "\nProximity limits: ";
delta += "Time: "      + spinBoxDeltaTime->text() + " ; ";
delta += "Latitude: "  + lineEditDeltaLatitude->text() + " ; ";
delta += "Longitude: " + lineEditDeltaLongitude->text() + " ; ";
delta += "Depth: "     + spinBoxDeltaDepth->text() + " ;";




     vector<int> priorityFind;
//-----------------------------------------------

     vector<QString> valFunc;valFunc.resize(4);
     if(checkBoxDeltaM1->isChecked ()) priorityFind.push_back(comboBoxDeltaM1->currentIndex ());
       valFunc[0] = QString("%1@%2@%3@%4").arg(lineEditDeltaM1_D->text())
                                          .arg(lineEditDeltaM1_A->text())
                                          .arg(lineEditDeltaM1_B->text())
                                          .arg(lineEditDeltaM1_C->text());
     

     if(checkBoxDeltaM2->isChecked ()) priorityFind.push_back(comboBoxDeltaM2->currentIndex ());
       valFunc[1] = QString("%1@%2@%3@%4").arg(lineEditDeltaM2_D->text())
                                          .arg(lineEditDeltaM2_A->text())
                                          .arg(lineEditDeltaM2_B->text())
                                          .arg(lineEditDeltaM2_C->text());
     

     if(checkBoxDeltaM3->isChecked ()) priorityFind.push_back(comboBoxDeltaM3->currentIndex ());
       valFunc[2] = QString("%1@%2@%3@%4").arg(lineEditDeltaM3_D->text())
                                          .arg(lineEditDeltaM3_A->text())
                                          .arg(lineEditDeltaM3_B->text())
                                          .arg(lineEditDeltaM3_C->text());
     

     if(checkBoxDeltaM4->isChecked ()) priorityFind.push_back(comboBoxDeltaM4->currentIndex ());
       valFunc[3] = QString("%1@%2@%3@%4").arg(lineEditDeltaM4_D->text())
                                          .arg(lineEditDeltaM4_A->text())
                                          .arg(lineEditDeltaM4_B->text())
                                          .arg(lineEditDeltaM4_C->text());
     


//-----------------------------------------------
     int indexDeltaFunction = comboBoxDeltaFunction->currentIndex ();

     if (findFunction      !=0) { delete findFunction;   findFunction   = 0;}     
     if (indexDeltaFunction == 0 ) findFunction = new FindValue(priorityFind,valFunc,dmf);
     if (indexDeltaFunction == 1 ) findFunction = new FindMaximum(priorityFind,valFunc,dmf);
     if (indexDeltaFunction == 2 ) findFunction = new FindMinimum(priorityFind,valFunc,dmf);
     if (indexDeltaFunction == 3 ) findFunction = new FindAverage(priorityFind,valFunc,dmf);

     ptrFindFunction = & FindDupFunc::FindVal;

    int    size = (int) priorityFind.size();
    QString strmes = "";
	
	
	if(!priorityFind.empty()) delta += "Magnitude function: " + lineEditDf->text() + " ,\nwhere\n";

    if(!priorityFind.empty()){
     strmes += "Magnitude function to define Delta Magnitude equals to\n";
     if (indexDeltaFunction == 0 ) {
        if (size > 1) strmes += " Priority Value";
        }
     if (indexDeltaFunction == 1 )  {
        if (size > 1) strmes += " Maximum";
        }
     if (indexDeltaFunction == 2 ) {
        if (size > 1) strmes += " Minimum";
        }
     if (indexDeltaFunction == 3 ) {
        if (size > 1) strmes += " Average";
        }

     QString mag = "";
     for(int i = 0; i < size;i++) {
         if(priorityFind[i] == 0)mag += " f(m1),";
         if(priorityFind[i] == 1)mag += " f(m2),";
         if(priorityFind[i] == 2)mag += " f(m3),";
         if(priorityFind[i] == 3)mag += " f(m4),";
     }
     mag.replace(mag.lastIndexOf(','),1," ");
     if (size > 1) strmes += " { " + mag + " }\n";
     for(int i = 0; i < size;i++) {
       QStringList p = valFunc[priorityFind[i]].split ('@');
       QString mag = ""; 
       if(priorityFind[i] == 0)mag = "m1";
       if(priorityFind[i] == 1)mag = "m2";
       if(priorityFind[i] == 2)mag = "m3";
       if(priorityFind[i] == 3)mag = "m4";
       QString fun = " f(" + mag + ")" + " = " ;
       strmes += fun + p.at(1) + " * " + mag + " + " + p.at(2) +
               " if " + mag + " greater or equal to " + p.at(0);
       strmes += " else " + fun + p.at(3) + "\n";
    }
 }


//    if(checkBoxDuplicateMagnitude->isChecked ())  isTransformMagnitude = true;
//    else  isTransformMagnitude = false;
     
   QString actmes = "";
   QString dupmes = "";
   if( catAct == MergeCatalog) {
	/*  
   if(isTransformMagnitude) {
   QString magFirst = comboBoxSel->currentText ();
   QString magSecond = comboBoxRem->currentText ();
   dupmes += QString("Duplicate Magnitude:\nReplace current catalog magnitude \"%1\" with second catalog magnitude \"%2\"").
             arg(magFirst).arg(magSecond);
   }
   */
   mode = CatalBaseImpl::Merge;
  }
if( catAct == CompareCatalog) {
    int indexModeAction = comboBoxMode->currentIndex ();
    if(indexModeAction == 0) {mode = CatalBaseImpl::Intersection; actmes = "The mode is \"Intersection\"";}
    if(indexModeAction == 1) {mode = CatalBaseImpl::Difference; actmes = "The mode is \"Difference\"";}
    if(indexModeAction == 2) {mode = CatalBaseImpl::Equivalence; actmes = "The mode is \"Equivalence\"";}
    if(indexModeAction == 3) {mode = CatalBaseImpl::Nonequivalence; actmes = "The mode is \"Nonequivalence\"";}
}

     message +=  incatmes;
     message +=  filemes;
    if( catAct == CompareCatalog)  message += actmes +"\n\n";
     message +=  delta;
     message += strmes + "\n";
     if( catAct == MergeCatalog) message += dupmes + "\n";
     return true;
}


void CatalBaseImpl::GetDocumentFromDialog()
{
   if( catAct == MergeCatalog) {
     doc->GetListMergeCatalog()->SetListToValue(listMergeCatalog);
  }

  if( catAct == CompareCatalog)  doc->GetSecondCatalogName()->SetValue(SecondCatalogName);


     doc->GetDeltaCatTime()->SetValue(spinBoxDeltaTime->text());
     doc->GetDeltaCatLatitude()->SetValue(lineEditDeltaLatitude->text());
     doc->GetDeltaCatLongitude()->SetValue(lineEditDeltaLongitude->text());
     doc->GetDeltaCatDepth()->SetValue(spinBoxDeltaDepth->text());
     doc->GetDeltaCatMagnitude()->SetValue(lineEditDf->text());

     doc->GetCompareCatalogAction()->SetValue(QString("%1").arg(comboBoxMode->currentIndex()));

///----------------------Delta Magnitude Functions  ----------------------------------------
    if(checkBoxDeltaM1->isChecked()) {
    first->valIsOn = true;
    first->valIndexMagnitude = comboBoxDeltaM1->currentIndex();
    first->valA = lineEditDeltaM1_A->text();
    first->valB = lineEditDeltaM1_B->text();
    first->valC = lineEditDeltaM1_C->text();
    first->valD = lineEditDeltaM1_D->text();
    } else {
    first->valIsOn = false;
    first->valIndexMagnitude = first->defIndexMagnitude;
    first->valA = first->defA;
    first->valB = first->defB;
    first->valC = first->defC;
    first->valD = first->defD;
    }
    doc->GetDefineDeltaCatFirstMagnitude()->SetValue(first);

    if(checkBoxDeltaM2->isChecked()) {
    second->valIsOn = true;
    second->valIndexMagnitude = comboBoxDeltaM2->currentIndex();
    second->valA = lineEditDeltaM2_A->text();
    second->valB = lineEditDeltaM2_B->text();
    second->valC = lineEditDeltaM2_C->text();
    second->valD = lineEditDeltaM2_D->text();
    } else {
    second->valIsOn = false;
    second->valIndexMagnitude = second->defIndexMagnitude;
    second->valA = second->defA;
    second->valB = second->defB;
    second->valC = second->defC;
    second->valD = second->defD;
    }
    doc->GetDefineDeltaCatSecondMagnitude()->SetValue(second);

   if(checkBoxDeltaM3->isChecked()) {
    third->valIsOn = true;
    third->valIndexMagnitude = comboBoxDeltaM3->currentIndex();
    third->valA = lineEditDeltaM3_A->text();
    third->valB = lineEditDeltaM3_B->text();
    third->valC = lineEditDeltaM3_C->text();
    third->valD = lineEditDeltaM3_D->text();
    } else {
    third->valIsOn = false;
    third->valIndexMagnitude = third->defIndexMagnitude;
    third->valA = third->defA;
    third->valB = third->defB;
    third->valC = third->defC;
    third->valD = third->defD;
    }
    doc->GetDefineDeltaCatThirdMagnitude()->SetValue(third);

   if(checkBoxDeltaM4->isChecked()) {
    fourth->valIsOn = true;
    fourth->valIndexMagnitude = comboBoxDeltaM4->currentIndex();
    fourth->valA = lineEditDeltaM4_A->text();
    fourth->valB = lineEditDeltaM4_B->text();
    fourth->valC = lineEditDeltaM4_C->text();
    fourth->valD = lineEditDeltaM4_D->text();
    } else {
    fourth->valIsOn = false;
    fourth->valIndexMagnitude = fourth->defIndexMagnitude;
    fourth->valA = fourth->defA;
    fourth->valB = fourth->defB;
    fourth->valC = fourth->defC;
    fourth->valD = fourth->defD;
    }
    doc->GetDefineDeltaCatFourthMagnitude()->SetValue(fourth);

    doc->GetDeltaCatMagnitudeFunction()->SetValue(QString("%1").arg(comboBoxDeltaFunction->currentIndex()));
/*
 if( catAct == MergeCatalog) {
   if(checkBoxDuplicateMagnitude->isChecked()) {
      doc->GetAssignDuplicateMagnitude()->SetValue("1");
      doc->GetSelectedDuplicateMagnitude()->SetValue(QString("%1").arg(comboBoxSel->currentIndex()));
      doc->GetRemovingDuplicateMagnitude()->SetValue(QString("%1").arg(comboBoxRem->currentIndex()));
  }  else{
      doc->GetAssignDuplicateMagnitude()->SetValue("0");
      doc->GetSelectedDuplicateMagnitude()->SetValue(defaultSelectedDuplicateMagnitude());
      doc->GetRemovingDuplicateMagnitude()->SetValue(defaultRemovingDuplicateMagnitude());
  }
 }
*/
}
//------------------------------------------------------------------------------------------
void CatalBaseImpl::SetCatalogInfo(QString &file,QLabel *fileName,QLabel *rec,QLabel *dateStart,QLabel *dateFinish){
   Catalog cat;
   RECORD record;
   RECORD record1;
   int numrec;
   if (cat.GetCatalogInfo(file,numrec,record,record1)) {
   QString name = "unnamed";
   if(file != "")   name = MainWindow::self->strippedName(file);
   fileName->setText(QString("Catalog: \"%1\"").arg(name));
   rec->setText(QString("Records: %1").arg(numrec));
   dateStart->setText ("First record: " + cat.getQStringTime(record));
   dateFinish->setText("Last  record: " + cat.getQStringTime(record1));

   }

}
//------------------------------------------------------------------------------------------
void CatalBaseImpl::SetProjectCatalogInfo(QString &name) {
    if( catAct == MergeCatalog)
    SetCatalogInfo(name,labelNameIn,labelRecordIn,labelDateInStart,labelDateInFinish);
    if( catAct == CompareCatalog)
    SetCatalogInfo(name,labelNameInC,labelRecordInC,labelDateInStartC,labelDateInFinishC);}
//------------------------------------------------------------------------------------------

void CatalBaseImpl::SetDocumentToDialog()
{
if (type == Tool) {
    QString tmp =  MainWindow::self->GetCurrentCatalogName();
    if( catAct == MergeCatalog)
    SetCatalogInfo(tmp,labelNameIn,labelRecordIn,labelDateInStart,labelDateInFinish);
    if( catAct == CompareCatalog)
    SetCatalogInfo(tmp,labelNameInC,labelRecordInC,labelDateInStartC,labelDateInFinishC);

}

    if( catAct == MergeCatalog) {
    listMergeCatalog.clear();
    listWidget->clear();
    QStringList tmp = doc->GetListMergeCatalog()->GetStringList();
    if(!tmp.empty()) listMergeCatalog = SetListWidgetMergeFiles(tmp);

    }

    if( catAct == CompareCatalog) {
     SecondCatalogName = doc->GetSecondCatalogName()->GetValue();
     QFont fn = font ();
     QPalette pl = labelSecond->palette ();
if (SecondCatalogName.isEmpty()) {
   fn.setBold(true);
   labelSecond->setFont(fn);
   pl.setColor (QPalette::WindowText, QColor(0,0,127) );
   labelSecond->setPalette ( pl );
   labelSecond->setText(_ENTER_CATALOG_NAME_);
}  else {
   QFont fn = font ();
   fn.setBold(false);
   labelSecond->setFont(fn);
   pl.setColor (QPalette::WindowText, QColor(Qt::black) );
   labelSecond->setPalette ( pl );
   QString tmp = MainWindow::self->strippedName(SecondCatalogName);
   QString tmp1 = "\"" + tmp + "\"";
   labelSecond->setText(tmp1);
}
    }

    comboBoxMode->setCurrentIndex(doc->GetCompareCatalogAction()->GetValue().toInt());

    

///----------------------Delta Magnitude Functions  ----------------------------------------

  if (first->valIsOn){
  checkBoxDeltaM1->setChecked (TRUE);
  comboBoxDeltaM1->setCurrentIndex(first->valIndexMagnitude);
  } else {
  checkBoxDeltaM1->setChecked (FALSE);
  comboBoxDeltaM1->setCurrentIndex(first->defIndexMagnitude);
  }

  if (second->valIsOn){
  checkBoxDeltaM2->setChecked (TRUE);
  comboBoxDeltaM2->setCurrentIndex(second->valIndexMagnitude);
  } else {
  checkBoxDeltaM2->setChecked (FALSE);
  comboBoxDeltaM2->setCurrentIndex(second->defIndexMagnitude);
  }

  if (third->valIsOn){
  checkBoxDeltaM3->setChecked (TRUE);
  comboBoxDeltaM3->setCurrentIndex(third->valIndexMagnitude);
  } else {
  checkBoxDeltaM3->setChecked (FALSE);
  comboBoxDeltaM3->setCurrentIndex(third->defIndexMagnitude);
  }

  if (fourth->valIsOn){
  checkBoxDeltaM4->setChecked (TRUE);
  comboBoxDeltaM4->setCurrentIndex(fourth->valIndexMagnitude);
  } else {
  checkBoxDeltaM4->setChecked (FALSE);
  comboBoxDeltaM4->setCurrentIndex(fourth->defIndexMagnitude);
  }


comboBoxDeltaFunction->setCurrentIndex(doc->GetDeltaCatMagnitudeFunction()->GetValue().toInt());
/*
if( catAct == MergeCatalog) {
  if (doc->GetAssignDuplicateMagnitude()->GetValue() == "1" ) {
   checkBoxDuplicateMagnitude->setChecked (TRUE);
   comboBoxSel->setCurrentIndex(doc->GetSelectedDuplicateMagnitude()->GetValue().toInt());
   comboBoxRem->setCurrentIndex(doc->GetRemovingDuplicateMagnitude()->GetValue().toInt());
  // isTransformMagnitude = true;
  }  else {
   checkBoxDuplicateMagnitude->setChecked (FALSE);
   comboBoxSel->setCurrentIndex(doc->GetSelectedDuplicateMagnitude()->GetDefaultvalue().toInt());
   comboBoxRem->setCurrentIndex(doc->GetRemovingDuplicateMagnitude()->GetDefaultvalue().toInt());
//  isTransformMagnitude = false;
  }
}
*/
 foreach (LineDocProperty *docprop, propDocLine) docprop->SetValueFromDoc();
}

//--------------------------------------------------------------------------------------------
void CatalBaseImpl::browse(){
          QStringList FileNames = QFileDialog::getOpenFileNames(this,"Select one or more add-in files.",
                            openUserToolFileDirectory,
                            MainWindow::self->GetFileFilters());
		  QStringList tmp =  SetListWidgetMergeFiles(FileNames);
		  
          if ( tmp.count() == 0 ) return;		  
          listMergeCatalog = tmp;	


}
QStringList CatalBaseImpl::SetListWidgetMergeFiles(QStringList &FileNames) {
   if (!FileNames.empty()){
            listWidget->clear();
            QStringList errFiles;
	    QStringList::Iterator it = FileNames.begin();
	    while( it != FileNames.end() ) {
	       QString fileName = *it ;
               Catalog cat;
               if (cat.CheckStandardBinaryFormat(fileName)) {
                 QString tmp =   MainWindow::self->strippedName(fileName);
                 listWidget->addItem(new QListWidgetItem(tmp));
               }  else errFiles.push_back(fileName);
            ++it;
	    }
            if(!errFiles.empty ()) {
              QStringList::iterator i;
              for (i = errFiles.begin(); i != errFiles.end(); ++i) {
                int find = FileNames.indexOf(*i);
                FileNames.removeAt (find);
              }
            }
    if(FileNames.empty()) return QStringList();
    SetCatalogInfo((QString &)FileNames.at(0),labelNameAdd,labelRecordAdd,labelDateAddStart,labelDateAddFinish);
    listWidget->setCurrentRow (0);
	it = FileNames.begin();
	openUserToolFileDirectory = QFileInfo(*it).absolutePath ();
    return QStringList(FileNames);
    } else return QStringList();

}
void CatalBaseImpl::RowClicked(QListWidgetItem * item){
int row =    item->listWidget ()->currentRow ();
SetCatalogInfo((QString &)listMergeCatalog.at(row),labelNameAdd,labelRecordAdd,labelDateAddStart,labelDateAddFinish);

}
//----------------------------------------------------------------------------------
void CatalBaseImpl::ProgressBarChanged(int value){
if (value > 1) {
 
 textLabel->setText(QString("Merging catalog \"%1\" : Record: %2").arg(MainWindow::self->strippedName(SecondCatalogName)).arg(value));
 textLabel->repaint ();
}
}
//----------------------------------------------------------------------------------

void CatalBaseImpl::ins(){
	  QString fileName =
		QFileDialog::getOpenFileName(this,"Open an existing catalog file",
                openUserToolFileDirectory,
                MainWindow::self->GetFileFilters());
	  if (!fileName.isEmpty()) {
          Catalog cat;
               if (cat.CheckStandardBinaryFormat(fileName)) {
                 QString tmp =   MainWindow::self->strippedName(fileName);
                 listWidget->addItem(new QListWidgetItem(tmp));
                 listMergeCatalog.push_back(fileName);
			     openUserToolFileDirectory = QFileInfo(fileName).absolutePath ();
           }  else return; 
        }
/*
QStringList::Iterator it = listMergeCatalog.begin();
	    while( it != listMergeCatalog.end() ) {
            qWarning(" '%s'",(*it).toAscii().data());
            it++;
            }
*/
}
void CatalBaseImpl::del(){if (
listWidget->count () < 1) return;
int row = listWidget->currentRow();
int curRow = row;
if (row == listWidget->count () -1 )  curRow = row -1;

listWidget->takeItem (row);
listMergeCatalog.takeAt (row);
listWidget->setCurrentRow(curRow);

SetCatalogInfo((QString &)listMergeCatalog.at(curRow),labelNameAdd,labelRecordAdd,labelDateAddStart,labelDateAddFinish);

}
void CatalBaseImpl::down(){
if (listWidget->count () < 2) return;
int row = listWidget->currentRow() ;
QListWidgetItem * item = listWidget->currentItem ();
listWidget->takeItem ( row );
listWidget->insertItem(row+1,item);
listWidget->setCurrentRow(row+1);

QString tmp = listMergeCatalog.at(row);
listMergeCatalog.takeAt (row);
listMergeCatalog.insert ( row+1, tmp);

}
void CatalBaseImpl::up(){
if (listWidget->count () < 2) return;
int row = listWidget->currentRow() ;
QListWidgetItem * item = listWidget->currentItem ();
listWidget->takeItem ( row );
listWidget->insertItem(row-1,item);
listWidget->setCurrentRow(row-1);

QString tmp = listMergeCatalog.at(row);
listMergeCatalog.takeAt (row);
listMergeCatalog.insert ( row-1, tmp);
}

void CatalBaseImpl::reset(){

foreach (PropertyValue* val, values) val->SetResetvalueToValue();
SetDocumentToDialog();
}
void CatalBaseImpl::project(){

foreach (PropertyValue* val, values) val->SetInitial();
SetDocumentToDialog();
}
void CatalBaseImpl::defaults(){

foreach (PropertyValue* val, values) val->SetDefault();
SetDocumentToDialog();
}
void CatalBaseImpl::WriteCatalogFromTwoCatatalgIndex(ModeAction action){
    in->clear();  inSecond->clear();
    RECORD record;
    QString filename  = MainWindow::self->GetOpenBinaryFileName();
    filename.replace( openBinaryCatalogfileName(), openTempBinaryCatalogfileName() );
    ofstream outfile(filename.toAscii(), ios::binary | ios::trunc);
    if (!(outfile) ){ QApplication::restoreOverrideCursor();error(QString("cannot open temporary output file"),filename);return;}
    int numberNewRecord = indexDouble->size();
    outfile.seekp(0,ios::beg);
    outfile.write((char*)&numberNewRecord,sizeof(int));
    if(outfile.fail()){QApplication::restoreOverrideCursor();error(QString("An writing error has occurred (catalog size)"),"");return;}

    in->seekg(sizeof(int),ios::beg);
    quint32 magic;
    in->read((char*)&magic,sizeof(quint32));
    if(in->fail()){QApplication::restoreOverrideCursor();error(QString("An reading error has occurred (rec %1)").arg(1),"");return;}
    outfile.write((char*)&magic,sizeof(quint32));
    if(outfile.fail()){QApplication::restoreOverrideCursor();error(QString("An writing error has occurred (format indicator)"),"");return;}
    outfile.seekp(sizeof(RECORD),ios::beg);
    in->seekg(sizeof(RECORD),ios::beg);


    int numRec = 0;
    in->clear();
    inSecond->clear();
    ItrMultiMap pos;
    for (pos = indexDouble->begin();pos !=indexDouble->end();pos++) {
  if (pos->second >=0 ) {
	int inpos = pos->second +1;
	in->seekg(inpos*sizeof(RECORD),ios::beg);
	in->read((char*)&record,sizeof(RECORD ));
	if(in->eof()){QApplication::restoreOverrideCursor();error(QString("An expected eof of first catalog has occurred"),"");return;  }
	if(in->fail()){QApplication::restoreOverrideCursor();error(QString("An reading error of first has occurred (rec %1)").arg(inpos),"");return;}
if (action == CatalBaseImpl::Equivalence || action == CatalBaseImpl::Nonequivalence) record.inten = 1;
	outfile.write((char*)&record,sizeof(RECORD));
	   if(outfile.fail()){QApplication::restoreOverrideCursor();error(QString("An writing  buffer error has occurred (rec %1)").arg(numRec+1),"");return;}
 }  else {
	int inpos = -pos->second;
	inSecond->seekg(inpos*sizeof(RECORD),ios::beg);
	inSecond->read((char*)&record,sizeof(RECORD ));
	if(inSecond->eof()){QApplication::restoreOverrideCursor();error(QString("An expected eof of second catalog has occurred"),"");return;  }
	if(inSecond->fail()){QApplication::restoreOverrideCursor();error(QString("An reading error of second has occurred (rec %1)").arg(inpos),"");return;}
if (action == CatalBaseImpl::Equivalence || action == CatalBaseImpl::Nonequivalence) record.inten = 2;
	outfile.write((char*)&record,sizeof(RECORD));
	   if(outfile.fail()){QApplication::restoreOverrideCursor();error(QString("An writing error has occurred (rec %1)").arg(numRec+1),"");return;}

 }
   numRec++;
  }

       in->close();
	   inSecond->close();
       outfile.close();
	   
	QDir dp(MainWindow::self->tempDirectory);
    dp.remove(TempCatalogName);
    dp.rename (filename,TempCatalogName);
}
void CatalBaseImpl::WriteCatFromIndex(DoubleIntMultiMap* index){
    in->clear(); 
    RECORD record;
	
    QString filename  = MainWindow::self->GetOpenBinaryFileName();
    filename.replace( openBinaryCatalogfileName(), openTempBinaryCatalogfileName() );
    ofstream outfile(filename.toAscii(), ios::binary | ios::trunc);
    if (!(outfile) ){ QApplication::restoreOverrideCursor();error(QString("cannot open temporary output file"),filename);return;}

	int numberNewRecord = index->size();
    outfile.seekp(0,ios::beg);
    outfile.write((char*)&numberNewRecord,sizeof(int));
    if(outfile.fail()){QApplication::restoreOverrideCursor();error(QString("An writing error has occurred (catalog size)"),"");return;}

    in->seekg(sizeof(int),ios::beg);
    quint32 magic;
    in->read((char*)&magic,sizeof(quint32));
    if(in->fail()){QApplication::restoreOverrideCursor();error(QString("An reading error has occurred (rec %1)").arg(1),"");return;}
    outfile.write((char*)&magic,sizeof(quint32));
    if(outfile.fail()){QApplication::restoreOverrideCursor();error(QString("An writing error has occurred (format indicator)"),"");return;}
    outfile.seekp(sizeof(RECORD),ios::beg);
    in->seekg(sizeof(RECORD),ios::beg);


    int numRec = 0;
    in->clear();
    ItrMultiMap pos;
    for (pos = index->begin();pos !=index->end();pos++) {
	int inpos = pos->second +1;
	in->seekg(inpos*sizeof(RECORD),ios::beg);
	in->read((char*)&record,sizeof(RECORD ));
	if(in->eof()){QApplication::restoreOverrideCursor();error(QString("An expected eof catalog has occurred"),"");return;  }
	if(in->fail()){QApplication::restoreOverrideCursor();error(QString("An reading error has occurred (rec %1)").arg(inpos),"");return;}
	outfile.write((char*)&record,sizeof(RECORD));
	   if(outfile.fail()){QApplication::restoreOverrideCursor();error(QString("An writing buffer error has occurred (rec %1)").arg(numRec+1),"");return;}
	   numRec++;
    }

       in->close();
       outfile.close();

	QDir dp(MainWindow::self->tempDirectory);
    dp.remove(TempCatalogName);
    dp.rename (filename,TempCatalogName);  
	   
}
void CatalBaseImpl::IntersectionTwoCatalogs(){
    DoubleIntMultiMap index;
    index.insert(indexDoubleModeActionFirst.begin(),indexDoubleModeActionFirst.end());
    WriteCatFromIndex(&index);
	
}
void CatalBaseImpl::EquivalenceTwoCatalogs(){
    indexDouble->clear();
    indexDouble->insert(indexDoubleModeActionFirst.begin(),indexDoubleModeActionFirst.end());
    indexDouble->insert(indexDoubleModeActionSecond.begin(),indexDoubleModeActionSecond.end());
    WriteCatalogFromTwoCatatalgIndex(CatalBaseImpl::Equivalence);
}
void CatalBaseImpl::UnequivalenceTwoCatalogs(){
  ItrMultiMap pos;
  map<double,int>::iterator it = indexDoubleModeActionFirst.begin();
  for (it = indexDoubleModeActionFirst.begin();it !=indexDoubleModeActionFirst.end();it++) {
    pos = indexDouble->find(it->first);
    indexDouble->erase(pos);
}
    WriteCatalogFromTwoCatatalgIndex(CatalBaseImpl::Nonequivalence);
} 
void CatalBaseImpl::DifferenceTwoCatalogs(){
  ItrMultiMap pos,pos1; 
  map<double,int>::iterator it = indexDoubleModeActionFirst.begin();
  for (it = indexDoubleModeActionFirst.begin();it !=indexDoubleModeActionFirst.end();it++) {
    pos = indexDouble->find(it->first);
    indexDouble->erase(pos);
}
  pos = indexDouble->begin();
  pos1 = indexDouble->begin();
  while(pos != indexDouble->end()) {
    if(pos->second <= -1){
      pos1 = pos;  pos1++;
      indexDouble->erase(pos);pos = pos1;
     } else pos++;
  }
 WriteCatFromIndex(indexDouble);
} 




