#ifndef _DOUBLE_CATALOG_BASE_IMPL_H
#define _DOUBLE_CATALOG_BASE_IMPL_H
#include <fstream>
#include <map>
#include <vector>
#include "ui_mergecomp.h"
#include "catalog.h"
#include "document.h"
using namespace std;
class QComboBox; 
class QWidget;
class QTextEdit;
class QLabel; 
class CatTable;
class FDocument;
class FindDupFunc;
class RemoveDupFunc;
class LineDocProperty;
class HelpWindow;
class CatalBaseImpl : public QDialog, private Ui::CatalBase
{
    typedef vector<PropertyValue* > PropValVector;
    typedef vector<PropertyValue* >::iterator PropValIterator;

    typedef multimap<double,int> DoubleIntMultiMap;
    typedef multimap<double,short> DoubleShortMultiMap;
    typedef DoubleIntMultiMap::iterator ItrMultiMap;
    Q_OBJECT
public:
   enum CatalogAction {
        MergeCatalog,
        CompareCatalog
    };
    enum TransformMag {
        Replace,
        Ignore
    };
    enum ModeAction {
        Merge,
        Intersection,
        Difference,
        Equivalence,
        Nonequivalence
    };
    enum TypeUsing
    {
        Tool,
        Wizard,
        Execute
    };
    CatalBaseImpl(QWidget *parent,FDocument* dc,CatalogAction act,TypeUsing type); 
    void  (FindDupFunc::*ptrFindFunction) ();
    FindDupFunc* findFunction;
    ~CatalBaseImpl();
    bool DoubleProccessing();
    void DuplicateProgress(int progress);
    int findNextDouble();
    void SetFindDoubleInfo();
    int GetValuesFromCatalogsRecord(ItrMultiMap pos,float &lat,float &lon,float &dep,
         float &mb,float &ms,float &ml,float &mp,RECORD &record);
    DoubleIntMultiMap* indexDouble;
    map<double,int> indexDoubleModeActionFirst;
    map<double,int> indexDoubleModeActionSecond;
    DoubleShortMultiMap indexMagnitude;
    bool NextOk();
    void FinishOk();
    bool execute();
    bool applay();
    void SetProjectCatalogInfo(QString &name);
    QString GetSecondCatalogName(){return SecondCatalogName;}
    QStringList &GetListMergeCatalog(){ return listMergeCatalog;}
    CatalogAction GetCatAct(){ return catAct;}
    ModeAction    GetCompModeAction(){return mode;}
    QTabWidget *GetTabWidget(){return tabWidget;}
protected:
    void closeEvent(QCloseEvent *event); 
public slots:

protected slots:
    void btHelp();    
    void accept(); 
    void reject();
    void start();
    void ins();
    void del();
    void browse();
    void down();
    void up();
    void BrowseSecondCatalogName ();
    void reset();
    void project();
    void defaults();
    void ProgressBarChanged(int value);
    void RowClicked(QListWidgetItem * item);
    void TimeOutShot();
private:
    void ResizeHorizontalHeader();
    void SetDocumentToDialog();
    void GetDocumentFromDialog();
    bool GetRemDupFunc();
    void EraseFirstRecordOfDouble();
    void EraseSecondRecordOfDouble();
//    void DuplicateAction(ItrMultiMap sel,ItrMultiMap rem);
    void SetCatalogInfo(QString &file,QLabel *fileName,QLabel *rec,QLabel *dateStart,QLabel *dateFinish);
    QStringList SetListWidgetMergeFiles(QStringList &FileNames);
	void WriteCatalogFromTwoCatatalgIndex(ModeAction action);
    void MergeTwoCatalogs(CatalBaseImpl::TransformMag action);
	void WriteCatFromIndex(DoubleIntMultiMap* index);
    void IntersectionTwoCatalogs();
    void EquivalenceTwoCatalogs();
    void UnequivalenceTwoCatalogs();
    void DifferenceTwoCatalogs();	
    void InitLineDocProperty();

    QList<LineDocProperty* > propDocLine;
    PropValVector EditLineValues;
    RECORD record1;
    RECORD record2;
    int numRec;
    CatTable* parentWindow;
    FDocument* doc;
    fstream* in;
    fstream* inSecond;
    ItrMultiMap pos1,pos2;

    Catalog cat;
    int min1, min2;
    int sec1,sec2;
    float lat1,lon1,dep1,mb1,ms1,ml1,mp1;
    float lat2,lon2,dep2,mb2,ms2,ml2,mp2;  
    int    dtime,ddep;
    float dlat,dlon,dmf;
    int returnCode;
    int numberOfDoubles;
    int numberOfIndexDouble;
    QList<QComboBox *> comboBoxes;
PropertyTransformFunction* first;
PropertyTransformFunction* second;
PropertyTransformFunction* third;
PropertyTransformFunction* fourth;
QList<PropertyTransformFunction *> transFunc;
bool isTransformMagnitude;
QString SecondCatalog;
    ModeAction   mode;
    CatalogAction catAct;
    TypeUsing type;
QString SecondCatalogName;
QStringList listMergeCatalog;
QList<PropertyValue* > values;
    QTextEdit* texted;
    QString message;
    QTextEdit* correctioned;
    QString    corrmess;
    QString    actionName;
    int maxCorrectionPageDouble;
	int currentNumberCatalog;
	QString TempCatalogName;
    QString SaveCatalogName;
bool firstStart;
HelpWindow* help;
QString openUserToolFileDirectory;

};

#endif
