#include <QtGui>
#include <stdlib.h>
#include <fstream>
#include <iostream>
#include <iomanip>
 
#include "catalog.h"  

extern QStringList _OUTPUT_FORMAT_LIST_;

const quint32 CatalogMagicNumber = 0x97c73f12;
void error(QString s, QString s2 )
     {
    QString tmp = s; tmp = tmp + " "; tmp = tmp + s2; 
    QMessageBox::critical(0,mainWindowCaption(),tmp);
   
     }

bool Catalog::GetTwoCatalogMode(QString& catalogNameFirst,QString& catalogNameSecond)
{
   RECORD recstart1,recstart2,recfinish1,recfinish2;
   if(!GetCatalogInfo(catalogNameFirst,numberRecordFirst,recstart1,recfinish1) ) return false;
   if(!GetCatalogInfo(catalogNameSecond,numberRecordSecond,recstart2,recfinish2)) return false;


double start1  = DateTime(recstart1);
double finish1 = DateTime(recfinish1);
double start2  = DateTime(recstart2);
double finish2 = DateTime(recfinish2);

	mapTwoCatRec.insert(make_pair(start2,-1));
	mapTwoCatRec.insert(make_pair(finish2,-numberRecordSecond));
	
	mapTwoCatRec.insert(make_pair(start1,1));
	mapTwoCatRec.insert(make_pair(finish1,numberRecordFirst));

	if (!mapTwoCatRec.empty())  {
		map<double,int>::iterator it;
		for (it = mapTwoCatRec.begin(); it != mapTwoCatRec.end();it++)  {
			modeKeys << it->first;
			modeValues << it->second;
//			tmp += QString(" %1 %2 %3\n").arg(i++).arg(it->first).arg(it->second);
		}
	}		
//	QMessageBox::information(this,"",tmp);
	
	
	
/*
    size = 2        size = 3
	-  Subst.(1);   - Repl-Prep.(5)  - Subst.(1) + Repl-App.(6)
    -               -                +           -
				    +                -           -  
	
    size = 4  
	-  Prep(2);  - Repl-Prep(5); -  Subst.(1) + Repl.(4) + Repl-App(6) + App(3);
	-            +               +            -          -             +
	+            -               +            -          +             -
	+            +               -            +          -             -
	
*/
	
if( (int)mapTwoCatRec.size() == 2 ) mode = Substitute;

if( (int)mapTwoCatRec.size() == 3 ) {
//                     -                   -                  +	
	if ( modeValues.at(0) < 0 && modeValues.at(1) < 0 && modeValues.at(2) > 0) mode = ReplacePrepend;
//                    -                   +                   -
	if ( modeValues.at(0) < 0 && modeValues.at(1) > 0 && modeValues.at(2) < 0) mode = Substitute;
//                    +                   -                   -
	if ( modeValues.at(0) > 0 && modeValues.at(1) < 0 && modeValues.at(2) < 0) mode = ReplaceAppend; 
}
if( (int)mapTwoCatRec.size() == 4 ) {	
	if ( modeValues.at(0) < 0 ){
//		-             -                   +                   +
	if ( modeValues.at(1) < 0 && modeValues.at(2) > 0 && modeValues.at(3) > 0) mode = Prepend;
//      -             +                   -                   +
	if ( modeValues.at(1) > 0 && modeValues.at(2) < 0 && modeValues.at(3) > 0) mode = ReplacePrepend;
//      -             +                   +                   -
	if ( modeValues.at(1) > 0 && modeValues.at(2) > 0 && modeValues.at(3) < 0) mode = Substitute;
	}
	if ( modeValues.at(0) > 0 ){
//      +               -                 -                  +
	if ( modeValues.at(1) < 0 && modeValues.at(2) < 0 && modeValues.at(3) > 0) mode = Replace;
//      +               -                  +                  -
	if ( modeValues.at(1) < 0 && modeValues.at(2) > 0 && modeValues.at(3) < 0) mode = ReplaceAppend;
//      +               +                 -                   -
	if ( modeValues.at(1) > 0 && modeValues.at(2) < 0 && modeValues.at(3) < 0) mode = Append;
	}
}
	
/*
if (mode == Substitute) 
	QMessageBox::information(0,"","mode == Substitute");

if (mode == Prepend)
	QMessageBox::information(0,"","mode == Prepend");

if (mode == Append) 
	QMessageBox::information(0,"","mode == Append");

if (mode == Replace) 
	QMessageBox::information(0,"","mode == Replace");

if (mode == ReplacePrepend) 
	QMessageBox::information(0,"","mode == ReplacePrepend");

if (mode == ReplaceAppend) 
	QMessageBox::information(0,"","mode == ReplaceAppend");
*/
//-----------------------------------------------------------------------------	
	
return true;
}
QString    Catalog::getQStringISODate(RECORD record){
   short y = record.yr, m = record.mo, d = record.da, h = record.hr, mn = record.mn,sc;
    sc = record.sc/secondMagnification();
   //Qt::ISODate                                           YYYY-MM-DDTHH:MM:SS
     char buf[128];
    ::sprintf(buf, "%4d-%2d-%2dT%2d:%2d:%2d",y,m,d,h,mn,sc);
    QString tmp = QString::fromAscii(buf);
    tmp.replace(' ','0');
    return tmp;
}
void  Catalog::GetLatLonDepthMagnitude(RECORD record,float &lat,float &lon,float &dep,float &mb,float &ms,float &ml,float &mp){

lat =   (float)record.fi/latitudeMagnification();
lon =  (float)record.la/longitudeMagnification();
dep = (float)record.h/depthMagnification();
mb =  (float)record.m[0]/magnitudeMagnification();
ms =  (float)record.m[1]/magnitudeMagnification();
ml =   (float)record.m[2]/magnitudeMagnification();
mp =  (float)record.m[3]/magnitudeMagnification();  
}
QString    Catalog::getFieldsFromRecord(RECORD record) {
    short y = record.yr, m = record.mo, d = record.da, h = record.hr, mn = record.mn;
    QString temp  =	QString("%1 %2 %3 %4 %5 %6 %7 %8 %9 ").arg(y).arg(m).arg(d).arg(h).arg(mn).arg((double)record.sc/secondMagnification()).arg((double)record.fi/latitudeMagnification()).arg((double)record.la/longitudeMagnification()).arg((double)record.h/depthMagnification());
QString temp1  =	QString("%1 %2 %3 %4 %5").arg((double)record.m[0]/magnitudeMagnification()).arg((double)record.m[1]/magnitudeMagnification()).arg((double)record.m[2]/magnitudeMagnification()).arg((double)record.m[3]/magnitudeMagnification()).arg( record.inten);    
    return temp+temp1;
}
QString    Catalog::getAsciiRecord(RECORD record){
    	    short y = record.yr, m = record.mo, d = record.da, h = record.hr, mn = record.mn;
	   // t_ymdhm((long)record.time, &y, &m,  &d, &h, &mn);
  if (y <= 0 && m <= 0 && d <= 0 && h <= 0 && mn <= 0 && record.sc <= 0) return QString();
  else {
     char buf[128];
    ::sprintf(buf,"%4d/%2d/%2d %2d:%2d:%5.2f %7.3f %8.3f %5.1f %4.2f  %4.2f %4.2f %4.2f %2d",
	 y,m,d,h,mn,(float)record.sc/secondMagnification(),(float)record.fi/latitudeMagnification(),(float)record.la/longitudeMagnification(),(float)record.h/depthMagnification(),
	 (float)record.m[0]/magnitudeMagnification(),(float)record.m[1]/magnitudeMagnification(),(float)record.m[2]/magnitudeMagnification(),(float)record.m[3]/magnitudeMagnification(),record.inten);
    return  QString::fromAscii(buf);
  }
 }
QString    Catalog::getQStringTimeInMinuts(double tm){
int time; int sec;
GetTimeSec(tm,time,sec);
short y; short m; short d; short hr; short mn;
t_ymdhm((long )time,&y,&m,&d,&hr, &mn);
    char buf[128];
    ::sprintf(buf,"%4d/%2d/%2d %2d:%2d ",y,m,d,hr,mn);
    return QString::fromAscii(buf);	
}
QString    Catalog::getQStringTime(double tm){
int time; int sec;
GetTimeSec(tm,time,sec);
//QMessageBox::information(0,"",QString("getQStringTime  %1 %2").arg(time).arg(sec));
short y; short m; short d; short hr; short mn;
long ltime = time;
t_ymdhm(ltime,&y,&m,&d,&hr, &mn);

//QMessageBox::information(0,"",QString("getQStringTime  %1 %2 %3 %4 %5").
//	arg(y).arg(m).arg(d).arg(hr).arg(mn));

    char buf[128];
    ::sprintf(buf,"%4d/%2d/%2d %2d:%2d:%5.2f",y,m,d,hr,mn,(float)sec/secondMagnification());
    return QString::fromAscii(buf);
}
QString    Catalog::getQStringTime(RECORD record) {
    short y = record.yr, m = record.mo, d = record.da, h = record.hr, mn = record.mn;
    char buf[128];
    ::sprintf(buf,"%4d/%2d/%2d %2d:%2d:%5.2f",y,m,d,h,mn,(float)record.sc/secondMagnification() );
    return QString::fromAscii(buf);
}

bool Catalog::CheckStandardBinaryFormat(QString name) {
    ifstream infile(name.toAscii(),ios::binary);
    if (!infile) {error(QString("cannot open input file"),name);return false;}    
    int numRec = 0;
    infile.read((char*)&numRec,sizeof(int));
    quint32 macn;
    infile.read((char*)&macn,sizeof(quint32));
    infile.seekg(0,ios::beg);
    if (macn != CatalogMagicNumber) {error(QString("Opened file '%1' is not a standard binary catalog file. Bad Format.").arg(name),""); infile.close(); return false;}
    infile.close();
return true;
}

bool Catalog::loadBinaryFile(QString name,MainWindow::TempFileType type){

    ifstream infile(name.toAscii(),ios::binary);
    if (!infile) {QApplication::restoreOverrideCursor();error(QString("cannot open input file"),name);return false;}    
    int numRec = 0;
    infile.read((char*)&numRec,sizeof(int));
    quint32 macn;
    infile.read((char*)&macn,sizeof(quint32));
    infile.seekg(0,ios::beg);
    if (macn != CatalogMagicNumber) { QApplication::restoreOverrideCursor();error(QString("Opened file '%1' is not a standard binary catalog file. Bad Format.").arg(name),""); infile.close(); return false;}
    QString filename = MainWindow::self->GetOpenBinaryFileName();
    if (type == MainWindow::Second)
        filename.replace( openBinaryCatalogfileName(), openSecondBinaryCatalogfileName()); 
    ofstream outfile(filename.toAscii(), ios::binary | ios::trunc);
    infile.seekg(0,ios::beg);    
    if (!(outfile) ){ QApplication::restoreOverrideCursor();error(QString("cannot open output file"),filename);return false;}	
    outfile << infile.rdbuf();
    outfile.close(); 
    infile.close();

return true;
}
bool Catalog::makeBinaryFile(QString name,int numFormat,int ){

    QString filename = MainWindow::self->GetOpenBinaryFileName();
    RECORD record;
    char buf[500]="";
    int numRec = 0;
    QString output = filename ; 
    ofstream to(output.toAscii(),ios::binary);
    if (!to) {QApplication::restoreOverrideCursor();error(QString("cannot open output file"),output);return false;}
    to.write(buf,sizeof(RECORD));
    if (numFormat < 1) {
	ifstream from(name.toAscii(),ios::binary);
	if (!from) {QApplication::restoreOverrideCursor();error(QString("cannot open input file"),name);return false;}
	int latmag   = latitudeMagnification()/100;
	int lonmag  = longitudeMagnification()/100;	
	int depmag = depthMagnification();
	int magmag = magnitudeMagnification()/100;
	RECORD20 rec20;
	from.read((char*)&rec20,sizeof(RECORD20));
	while(from.read((char*)&rec20,sizeof(RECORD20))){
	    short y, m, d , h, mn;
	    t_ymdhm((long)rec20.time, &y, &m,  &d, &h, &mn);
	    record.yr= y; record.mo = m; record.da = d;record.hr =h; record.mn =mn;
	    record.sc = 0;
	    record.fi =  rec20.fi*latmag; 
	    record.la =  rec20.la*lonmag;
	    record.h  =  rec20.h*depmag;
	    record.m[0] = rec20.m[0]*magmag; 
	    record.m[1] = rec20.m[1]*magmag;
	    record.m[2] = rec20.m[2]*magmag;	 
	    record.m[3] = rec20.m[3]*magmag;
	    record.inten = rec20.inten;
	    to.write((char*)&record,sizeof(RECORD));
	    numRec++;
	}

	from.close();

    } else {
	FILE *ipf;
	struct FORMAT41 *format41;
	ipf=fopen(name.toAscii(),"r"); if (!ipf) {
	    QApplication::restoreOverrideCursor();error(QString("cannot open input file"),name);
	    return false;
	 }
	format41=(struct FORMAT41 *) malloc(sizeof(struct FORMAT41));
	format41->fmt_len=43;
	getfmt(numFormat+1,format41);
	while(fgets(buf,500,ipf))
	{
	    if (convert41(record,buf,format41)) {
		to.write((char*)&record,sizeof(RECORD));
		numRec++;
	    }
	}
	fclose(ipf);
	free (format41);    
   
    }
    to.seekp	(0,ios::beg);	
    to.write((char*)&numRec,sizeof(int));
    to.write((char*)&CatalogMagicNumber,sizeof(quint32));	 
    to.close();

    return true;
}
bool Catalog::tryAsciiFormat(QString name,int numFormat,QString &catLine){
     FILE *ipf;
    struct FORMAT41 *format41;
    char buf[500]="";
    RECORD record;
    int nin  = 0;
    int return_code;
    int numRec = 0;
    bool possibleErr = false;
    ipf=fopen(name.toAscii(),"r"); if (!ipf) {
	QApplication::restoreOverrideCursor();error(QString("cannot open input file"),name);
	return false;
    }

    format41=(struct FORMAT41 *) malloc(sizeof(struct FORMAT41));
    format41->fmt_len=43;

    if (!getfmt(numFormat+1,format41)) {

	QString tmp = QString("Error in format file format number %1").arg(numFormat);  
	QApplication::restoreOverrideCursor();error(tmp);	
	fclose(ipf);
	free (format41);    
	return false; 
    }

    catLine = "";
    QString possibleStr = "";
    while(fgets(buf,500,ipf))
    {
	QString temp;
//qWarning(" numformat %d file =  '%s'",numFormat,name.toAscii().data());
	return_code = convert41(record,buf,format41);

        

	if (return_code) {
	  //  temp = getAsciiRecord(record);
	    
	   // if (temp.isEmpty()) {
	//	possibleErr++;
	   // } 
        //error(QString(buf));
            if (!tryBufferFormat(buf,format41)) possibleErr = true;
            else temp = getAsciiRecord(record);
	    if (possibleErr) return false; 
	    catLine += QString ("\n%1: %2").arg(nin+1).arg(temp);
	    nin++;

	}  
	
	numRec++;
	if( numRec > 50) return false;
	if( nin > 2 ) { break;}
    }
    if (catLine == "") return false;
    fclose(ipf);
    free (format41);
    return true;    
}
bool Catalog::tryBin20Format(QString name,QString &catLine){
    FILE *ipf;    
    ipf=fopen(name.toAscii(),"rb"); if (!ipf) {
	QApplication::restoreOverrideCursor();error(QString("cannot open input file"),name);
	return false;
    }   
    RECORD20 *rec20;
    int size = sizeof(RECORD20);
    rec20=(RECORD20 *) malloc(size);
    uint numRec;
    bool error = false;
    catLine = "";
    if ( fread(rec20,size,1,ipf) == 0) error = true;
    if (ferror(ipf) != 0) error = true;
    numRec = rec20->time - 1;

    QFileInfo fi( name);
    uint sizeFile =  fi.size ();
    if ( (numRec + 1 )* 20 != sizeFile) error = true;
	if(numRec < 1 ) {
		QMessageBox::critical(0,"Check 20byte-binary format","Number of catalog records equal zero");
		error = true;
		
	}
    if (error == false ) {
	uint curRec = 0;
	catLine = QString("\n  -------- Number of Records: %1  -------- ").arg(numRec);
	short y; short m; short d; short hr; short mn;
	int i = 0;
	for(i = 0; i < 2;i++) {
	    curRec++;
	    if (curRec > numRec) break;
	    if ( fread(rec20,size,1,ipf) == 0) error = true; 
	    if (ferror(ipf) != 0) error = true;
	    t_ymdhm((long)rec20->time, &y, &m, &d, &hr, &mn);
      char buf[128];
      ::sprintf(buf,"\n%2d: %d/%d/%d %d:%d:00 %6.2f %7.2f %d %4.2f %4.2f %4.2f %4.2f %d",i+1,y,m,d,hr,mn,
			(float)rec20->fi/100,(float)rec20->la/100,rec20->h,
			(float)rec20->m[0]/100,(float)rec20->m[1]/100,
			(float)rec20->m[2]/100,(float)rec20->m[3]/100,
			 rec20->inten);
	    catLine += QString::fromAscii(buf);;
	}
    }
    if (error == true) {
	fclose(ipf);
	free(rec20);   
	return false;    
    }
    fclose(ipf);
    free(rec20);
    return true;    
}
bool Catalog::expotFile(const QString fileName, const QString format)
{
if ( format == _OUTPUT_FORMAT_LIST_.at(0).toUpper()) writeBin20Format(fileName);
if ( format == _OUTPUT_FORMAT_LIST_.at(1).toUpper()) writeAscii41Format(fileName);
if ( format == _OUTPUT_FORMAT_LIST_.at(2).toUpper()) writeAsciiIntierFormat(fileName);
return true;
}
bool Catalog::writeBin20Format(const QString fileName)
{
  RECORD record;
  RECORD20 rec20;
  QApplication::setOverrideCursor(Qt::WaitCursor);
  QString name  = MainWindow::self->GetOpenBinaryFileName();

  fstream in (name.toAscii(),ios::binary | ios::in );
  if (!(in)) {QApplication::restoreOverrideCursor();error(QString("cannot open input file"),name);
               return false;}

  ofstream outfile(fileName.toAscii(), ios::binary | ios::trunc );
  if (!(outfile) ){ QApplication::restoreOverrideCursor();error(QString("cannot open temporary output file"),fileName);return false;}

  int numberNewRecord = 0;

  in.read((char*)&numberNewRecord,sizeof(int)); numberNewRecord++;
  if(in.fail()){QApplication::restoreOverrideCursor();error(QString("An reading error has occurred"),name);return false;}
  in.seekg(sizeof(RECORD),ios::beg);

  outfile.seekp(0,ios::beg);
  outfile.write((char*)&numberNewRecord,sizeof(int));
  if(outfile.fail()){QApplication::restoreOverrideCursor();error(QString("An writing error has occurred (catalog size)"),"");return false;}
  outfile.seekp(sizeof(RECORD20),ios::beg);

  int numRec = 1;
   for(;;){
      in.read((char*)&record,sizeof(RECORD));
      if(in.eof())  break;
	    if(in.fail()){QApplication::restoreOverrideCursor();
        error(QString("An reading error has occurred (#%1)").arg(numRec),name);return false;}
      rec20 = getBin20FromStandardRecord(record);
      outfile.write((char*)&rec20,sizeof(RECORD20));
      if(outfile.fail()){QApplication::restoreOverrideCursor();
         error(QString("An writing error has occurred (#%1)").arg(numRec),fileName);return false;}
      numRec++;
  }
 in.close();
 outfile.close();
  QApplication::restoreOverrideCursor();
  return true;
}
RECORD20 Catalog::getBin20FromStandardRecord(RECORD& record)
{
   RECORD20 rec20;
   short y  = record.yr;
   short m  = record.mo;
   short d  = record.da;
   short h  = record.hr;
   short mn = record.mn;
   float sec = (float)record.sc/secondMagnification();
   rec20.time = time(y,m,d,h,mn);
   if (sec > 30)  rec20.time +=1;
   int latmag   = latitudeMagnification()/100;
   int lonmag   = longitudeMagnification()/100;
   int depmag   = depthMagnification();
//   int magmag   = magnitudeMagnification()/100;

   if (record.fi < 0)   rec20.fi = (record.fi-5)/latmag;
   else rec20.fi = (record.fi+5)/latmag;

   if (record.la < 0)   rec20.la = (record.la-5)/lonmag;
   else  rec20.la = (record.la+5)/lonmag;

   if (record.h < 0)   rec20.h  = (record.h-5)/depmag;
   else  rec20.h  = (record.h+5)/depmag;

   rec20.m[0] = record.m[0];
   rec20.m[1] = record.m[1];
   rec20.m[2] = record.m[2];
   rec20.m[3] = record.m[3];
   rec20.inten = record.inten;
return  rec20;
}

bool Catalog::writeAscii41Format(const QString fileName)
{
  RECORD record;
  QApplication::setOverrideCursor(Qt::WaitCursor);
  QString name  = MainWindow::self->GetOpenBinaryFileName();
  fstream in (name.toAscii().data(),ios::binary | ios::in | ios::out);
  if (!(in)) {QApplication::restoreOverrideCursor();error(QString("cannot open input file"),name);
               return false;}
  in.seekg(sizeof(RECORD),ios::beg);

  ofstream outfile(fileName.toAscii());
  if (!(outfile) ){ QApplication::restoreOverrideCursor();error(QString("cannot open temporary output file"),fileName);return false;}
  int numRec = 1;

   for(;;){
      in.read((char*)&record,sizeof(RECORD));
      if(in.eof())  break;
	    if(in.fail()){QApplication::restoreOverrideCursor();
        error(QString("An reading error has occurred (#%1)").arg(numRec),name);return false;}
      short y  = record.yr;
      short m  = record.mo;
      short d  = record.da;
      short h  = record.hr;
      short mn = record.mn;
      int sec = (int)((float)record.sc/secondMagnification() + 0.5);
      if (sec == 60)
      {
       long tm = time(y,m,d,h,mn) + 1;
       t_ymdhm(tm,&y,&m,&d,&h,&mn);
       sec = 0;
      }
      outfile << std::setw(4) << std::setfill(' ') << y;
      outfile << std::setw(2) << std::setfill(' ') << m;
      outfile << std::setw(2) << std::setfill(' ') << d;
      outfile << std::setw(2) << std::setfill(' ') << h;
      outfile << std::setw(2) << std::setfill(' ') << mn;
      outfile << std::setw(2) << std::setfill(' ') << sec;
      int latmag   = latitudeMagnification()/100;
      int lonmag   = longitudeMagnification()/100;
      int depmag   = depthMagnification();
 
      int tmp = 0;
      if (record.fi < 0)   tmp = (record.fi-5)/latmag;
      else tmp = (record.fi+5)/latmag;
      outfile << std::setw(5) << std::setfill(' ') << tmp;

      if (record.la < 0)   tmp = (record.la-5)/lonmag;
      else  tmp = (record.la+5)/lonmag;
      outfile << std::setw(6) << std::setfill(' ') << tmp;

      if (record.h < 0)   tmp  = (record.h-5)/depmag;
      else  tmp  = (record.h+5)/depmag;
      outfile << std::setw(3) << std::setfill(' ') << tmp;
      
      outfile << std::setw(3) << std::setfill(' ') << record.m[0];
      outfile << std::setw(3) << std::setfill(' ') << record.m[1];
      outfile << std::setw(3) << std::setfill(' ') << record.m[2];
      outfile << std::setw(3) << std::setfill(' ') << record.m[3];
      outfile << std::setw(1) << std::setfill(' ') << record.inten;
      outfile << endl;
    
      if(outfile.fail()){QApplication::restoreOverrideCursor();
         error(QString("An writing error has occurred (#%1)").arg(numRec),fileName);return false;}
      numRec++;
  }
 in.close();
 outfile.close();

  QApplication::restoreOverrideCursor();
  return true;
}
bool Catalog::writeAsciiIntierFormat(const QString fileName)
{
  RECORD record;
  QApplication::setOverrideCursor(Qt::WaitCursor);
  QString name  = MainWindow::self->GetOpenBinaryFileName();
  fstream in (name.toAscii ().data(),ios::binary | ios::in | ios::out);
  if (!(in)) {QApplication::restoreOverrideCursor();error(QString("cannot open input file"),name);
               return false;}
  in.seekg(sizeof(RECORD),ios::beg);

  ofstream outfile(fileName.toAscii());
  if (!(outfile) ){ QApplication::restoreOverrideCursor();error(QString("cannot open temporary output file"),fileName);return false;}
  int numRec = 1;
 QString temp;
 QDateTime dt =  QDateTime::currentDateTime ();
  QString dts = dt.toString(Qt::ISODate);
  dts.replace('-','/'); dts.replace('T',' ');
 temp =  QString("#    68 bytes - Standard Wide Text Format File");
 outfile << temp.toAscii().data() << endl;
 temp =  QString("# created on %1 by CompiCat program\n#").arg( dts);
 outfile << temp.toAscii().data() <<  endl;
   for(;;){
      in.read((char*)&record,sizeof(RECORD));
      if(in.eof())  break;
	    if(in.fail()){QApplication::restoreOverrideCursor();
        error(QString("An reading error has occurred (#%1)").arg(numRec),name);return false;}
      temp =  getFieldsFromRecord(record).toAscii();
      outfile << std::setw(4) << temp.section(' ',numberCatalogYear(),numberCatalogYear()).toAscii().data() << '/';
      outfile << std::setw(2) << temp.section(' ',numberCatalogMonth(),numberCatalogMonth()).toAscii().data()<< '/';
      outfile << std::setw(2) << temp.section(' ',numberCatalogDay(),numberCatalogDay()).toAscii().data() << ' ';
      outfile << std::setw(2) << temp.section(' ',numberCatalogHour(),numberCatalogHour()).toAscii().data() << ':';
      outfile << std::setw(2) << temp.section(' ',numberCatalogMinute(),numberCatalogMinute()).toAscii().data()<< ':';

      float flt = temp.section(' ',numberCatalogSecond(),numberCatalogSecond()).toFloat();
      outfile << std::setw(5) << std::showpoint << std::fixed << std::setprecision(2) << flt << ' ';

      flt = temp.section(' ',numberCatalogLatitude(),numberCatalogLatitude()).toFloat();
      outfile << std::setw(7) << std::showpoint << std::fixed << std::setprecision(3) << flt << ' ';

      flt = temp.section(' ',numberCatalogLongitude(),numberCatalogLongitude()).toFloat();
      outfile << std::setw(8) << std::showpoint << std::fixed << std::setprecision(3) << flt << ' ';

      flt = temp.section(' ',numberCatalogDepth(),numberCatalogDepth()).toFloat();
      outfile << std::setw(5) << std::showpoint << std::fixed << std::setprecision(1) << flt << ' ';

      flt =  temp.section(' ',numberCatalogMb(),numberCatalogMb()).toFloat();
      outfile << std::setw(4) << std::showpoint << std::fixed << std::setprecision(2) << flt << ' ';

      flt =  temp.section(' ',numberCatalogMs(),numberCatalogMs()).toFloat();
      outfile << std::setw(4) << std::showpoint << std::fixed << std::setprecision(2) << flt << ' ';

      flt =  temp.section(' ',numberCatalogMl(),numberCatalogMl()).toFloat();
      outfile << std::setw(4) << std::showpoint << std::fixed << std::setprecision(2) << flt << ' ';

      flt =  temp.section(' ',numberCatalogMp(),numberCatalogMp()).toFloat();
      outfile << std::setw(4) << std::showpoint << std::fixed << std::setprecision(2) << flt << ' ';
 
      outfile << std::setw(2) << temp.section(' ',numberCatalogIntensity(),numberCatalogIntensity()).toAscii().data();



      outfile <<endl;

      if(outfile.fail()){QApplication::restoreOverrideCursor();
         error(QString("An writing error has occurred (#%1)").arg(numRec),fileName);return false;}
      numRec++;
  }
 in.close();
 outfile.close();

  QApplication::restoreOverrideCursor();
  return true;
}

void Catalog::exportUserFormatFile(const QString & fileName, const QList<int> & fieldList){
  RECORD record;
  QApplication::setOverrideCursor(Qt::WaitCursor);
  QString name  = MainWindow::self->GetOpenBinaryFileName();
  fstream in (name.toAscii ().data(),ios::binary | ios::in | ios::out);
  if (!(in)) {QApplication::restoreOverrideCursor();error(QString("cannot open input file"),name);
               return;}
  in.seekg(sizeof(RECORD),ios::beg);

  ofstream outfile(fileName.toAscii());
  if (!(outfile) ){ QApplication::restoreOverrideCursor();error(QString("cannot open temporary output file"),fileName);return;}
  int numRec = 1;
  QString temp;
  QDateTime dt =  QDateTime::currentDateTime ();
  QString dts = dt.toString(Qt::ISODate);
  dts.replace('-','/'); dts.replace('T',' ');
     
  temp =  QString("# Created on %1 by CompiCat program\n").arg(dts);
  outfile << temp.toAscii().data();
  temp = "# Output of ";
  outfile << temp.toAscii().data();
  
   for (int i = 0; i < fieldList.size(); ++i) {

		  if (fieldList.at(i) == 0)  outfile << "Year ";
		  if (fieldList.at(i) == 1)  outfile << "Month ";
		  if (fieldList.at(i) == 2)  outfile << "Day ";
		  
		  
		  if (fieldList.at(i) == 3)  outfile << "Hour ";
		  if (fieldList.at(i) == 4)  outfile << "Min ";
		  if (fieldList.at(i) == 5)  outfile << "Sec ";
		  
		  if (fieldList.at(i) == 6)  outfile << "Latitude ";
		  if (fieldList.at(i) == 7)  outfile << "Longitude ";
		  if (fieldList.at(i) == 8)  outfile << "Depth ";
		  
		  if (fieldList.at(i) == 9)  outfile << "M1 ";
		  if (fieldList.at(i) == 10)  outfile << "M2 ";
		  if (fieldList.at(i) == 11)  outfile << "M3 ";
		  if (fieldList.at(i) == 12)  outfile << "M4 ";
		  
		  if (fieldList.at(i) == 13)  outfile << "Intensity ";
   }
   
   
  temp =  QString("\n# extracted from file\n# %1\n").arg(MainWindow::self->GetCurrentCatalogName());
  outfile << temp.toAscii().data();
   outfile << "#\n" << endl;
   for(;;){
	  in.read((char*)&record,sizeof(RECORD));
      if(in.eof())  break;
	  if(in.fail()){QApplication::restoreOverrideCursor();
	  error(QString("An reading error has occurred (#%1)").arg(numRec),name);return;}
      temp =  getFieldsFromRecord(record).toAscii();
	  float flt = 0.0;
	  for (int i = 0; i < fieldList.size(); ++i) {
		  if (fieldList.at(i) == 0)
			  outfile << std::setw(4) << temp.section(' ',numberCatalogYear(),numberCatalogYear()).toAscii().data() << ' ';
          if (fieldList.at(i) == 1)
			  outfile << std::setw(2) << temp.section(' ',numberCatalogMonth(),numberCatalogMonth()).toAscii().data()<< ' ';
		  if (fieldList.at(i) == 2)      
			  outfile << std::setw(2) << temp.section(' ',numberCatalogDay(),numberCatalogDay()).toAscii().data() << ' ';
      
		  if (fieldList.at(i) == 3)
			  outfile << std::setw(2) << temp.section(' ',numberCatalogHour(),numberCatalogHour()).toAscii().data() << ' ';

		  if (fieldList.at(i) == 4)      
			  outfile << std::setw(2) << temp.section(' ',numberCatalogMinute(),numberCatalogMinute()).toAscii().data()<< ' ';

		  if (fieldList.at(i) == 5) {
			  flt = temp.section(' ',numberCatalogSecond(),numberCatalogSecond()).toFloat();
			  outfile << std::setw(5) << std::showpoint << std::fixed << std::setprecision(2) << flt << ' ';
		  }
		  if (fieldList.at(i) == 6) {
			  flt = temp.section(' ',numberCatalogLatitude(),numberCatalogLatitude()).toFloat();
			  outfile << std::setw(7) << std::showpoint << std::fixed << std::setprecision(3) << flt << ' ';
		  }
		  if (fieldList.at(i) == 7) {
			  flt = temp.section(' ',numberCatalogLongitude(),numberCatalogLongitude()).toFloat();
			  outfile << std::setw(8) << std::showpoint << std::fixed << std::setprecision(3) << flt << ' ';
		  }
		  if (fieldList.at(i) == 8) {
			  flt = temp.section(' ',numberCatalogDepth(),numberCatalogDepth()).toFloat();
			  outfile << std::setw(5) << std::showpoint << std::fixed << std::setprecision(1) << flt << ' ';
		  }
		  if (fieldList.at(i) == 9) {
			  flt =  temp.section(' ',numberCatalogMb(),numberCatalogMb()).toFloat();
			  outfile << std::setw(4) << std::showpoint << std::fixed << std::setprecision(2) << flt << ' ';
		  }
		  if (fieldList.at(i) == 10) {
			  flt =  temp.section(' ',numberCatalogMs(),numberCatalogMs()).toFloat();
			  outfile << std::setw(4) << std::showpoint << std::fixed << std::setprecision(2) << flt << ' ';
		  }
		  if (fieldList.at(i) == 11) {
			  flt =  temp.section(' ',numberCatalogMl(),numberCatalogMl()).toFloat();
			  outfile << std::setw(4) << std::showpoint << std::fixed << std::setprecision(2) << flt << ' ';
		  }
		  if (fieldList.at(i) == 12) {
			  flt =  temp.section(' ',numberCatalogMp(),numberCatalogMp()).toFloat();
			  outfile << std::setw(4) << std::showpoint << std::fixed << std::setprecision(2) << flt << ' ';
		  }
		  if (fieldList.at(i) == 13)
			  outfile << std::setw(2) << temp.section(' ',numberCatalogIntensity(),numberCatalogIntensity()).toAscii().data();
	  
	  } 
	  
	  outfile <<endl;
  }
 in.close();
 outfile.close();

  QApplication::restoreOverrideCursor();   

}
bool Catalog::CopyFile(QString &source,QString &distination) {
   ofstream outfile(distination.toAscii(), ios::binary | ios::out);
   if (!(outfile)) {error(QString("cannot open output file"),distination);return false;}
   fstream in(source.toAscii(),ios::binary | ios::in);
   if (!(in)) {error(QString("cannot open input file"),source);return false;}
   outfile << in.rdbuf();outfile.close(); in.close();
   return true;
}
bool Catalog::GetCatalogInfo(QString &name,int &numRec,RECORD& record,RECORD& record1){
    QString file = "";
    if (name == "unnamed" || name.isEmpty()) file = MainWindow::self->GetOpenBinaryFileName();
    else file = name;
    ifstream infile(file.toAscii(),ios::binary);
    if (!infile) {error(QString("cannot open input file"),name);return false;}    
    infile.read((char*)&numRec,sizeof(int));
    infile.seekg(sizeof(RECORD),ios::beg);
    infile.read((char*)&record,sizeof(RECORD));
    infile.seekg(-((int)sizeof(RECORD)),ios::end);
    infile.read((char*)&record1,sizeof(RECORD ));
    infile.close();
    return true;
}
QString Catalog::GetCatalogInfoMessage(QString& name){
        QString strmes = "";
        RECORD record;
        RECORD record1;
        int numrec;
        if (GetCatalogInfo(name,numrec,record,record1)) {
          QString namefile = "";
          if(name == "unnamed" || name.isEmpty())   namefile = "unnamed";
          else namefile = MainWindow::self->strippedName(name);
          strmes += QString("Initial catalog \"%1\" ").arg(namefile);
          strmes += QString("has %1 records ").arg(numrec);
          strmes += "from " + getQStringTime(record) + " to " +   getQStringTime(record1) + "\n\n";
        } else strmes = "cannot open input catalog file";
return strmes;
}


QString Catalog::GetCatalogShortInfoMessage(QString& name){
        QString strmes = "";
        RECORD record;
        RECORD record1;
        int numrec;
        if (GetCatalogInfo(name,numrec,record,record1)) {
          strmes += QString("has %1 records ").arg(numrec);
          strmes += "from " + getQStringTime(record) + " to " +   getQStringTime(record1) + "\n\n";
        } else strmes = "cannot open input catalog file";
return strmes;
}

QString Catalog::GetOneLineCatalogInfoMessage(QString& name){
        QString strmes = "";
        RECORD record;
        RECORD record1;
        int numrec;
        if (GetCatalogInfo(name,numrec,record,record1)) {
          QString namefile = "";
          if(name == "unnamed" || name.isEmpty())   namefile = "unnamed";
          else namefile = MainWindow::self->strippedName(name);
          strmes += QString("\"%1\"  ").arg(namefile);
          strmes += QString("has %1 records ").arg(numrec);
          strmes += "from " + getQStringTime(record) + " to " +   getQStringTime(record1) + "\n";
        } else strmes = "cannot open input catalog file";
return strmes;
}
