#ifndef _CATALOG_PROCESSING_H
#define _CATALOG_PROCESSING_H
#include "mainwindow.h"
#include "convert.h" 
#include "default.h"
#include <map>
#include <functional>
using namespace std;

void error(QString  s,  QString s2 ="");
class QString;
class Catalog
{
public:
	  enum TwoCatMode
    {
		Substitute,
		Prepend,
		Append,
		Replace,
		ReplacePrepend,
		ReplaceAppend,
        None
    };
	struct timeGreater : public binary_function < double,double, bool> {
        bool operator()(double x, double y) {
			long long xlong = (long long)((x + acuracyCompareTimeValue())*1e4);
			long long ylong = (long long)((y + acuracyCompareTimeValue())*1e4);
			//> acuracyCompareTimeValue()
			if ( ylong > xlong ) return true;
			else return false;
		}
	};
    Catalog(){};
	bool GetTwoCatalogMode(QString& catalogNameFirst,QString& catalogNameSecond);
    ~Catalog(){};
	bool GetTwoCatalogMode(TwoCatMode& mode,QList<double>& keys,QList<int>& values,
		int& numrec1,int& numrec2);
    bool tryAsciiFormat(QString name,int format, QString &catLine);
    bool tryBin20Format(QString name, QString &catLine);
    bool makeBinaryFile(QString name,int numFormat,int curNumber);
    bool loadBinaryFile(QString name,MainWindow::TempFileType type);
    bool GetCatalogInfo(QString &fileName,int &numrec,RECORD& record,RECORD& record1);
    QString    getAsciiRecord(RECORD record);
    QString    getQStringTime(RECORD record);
    QString    getQStringTime(double time);
	QString    getQStringTimeInMinuts(double time);
    QString    getFieldsFromRecord(RECORD record);
    QString    getQStringISODate(RECORD record);
    void       GetLatLonDepthMagnitude(RECORD record,float &lat,float &lon,float &dep,float &mb,float &ms,float &ml,float &mp);
    bool       expotFile(const QString fileName, const QString format);
	void exportUserFormatFile(const QString & fileName, const QList<int> & fieldList);
    bool CheckStandardBinaryFormat(QString name);
    bool CopyFile(QString &source,QString &distination);
    QString    GetCatalogInfoMessage(QString& name);
    QString    GetCatalogShortInfoMessage(QString& name);
    QString    GetOneLineCatalogInfoMessage(QString& name);
	//---------------------------------------------------------
	
	TwoCatMode mode;
	map<double,int,timeGreater> mapTwoCatRec;
	QList<double> modeKeys;
	QList<int> modeValues;
	int numberRecordFirst;
	int numberRecordSecond;
	//---------------------------------------------------------
private:
    bool writeBin20Format(const QString fileName);
    bool writeAscii41Format(const QString fileName);
    bool writeAsciiIntierFormat(const QString fileName);
    RECORD20 getBin20FromStandardRecord(RECORD& record);

};

#endif
