#include <QtGui>
#include "convert.h"  
#include "default.h" 
double DateTime(RECORD record) {
    return (double)time(record.yr,record.mo,record.da,record.hr,record.mn) + (double)record.sc/ (double)(100*secondMagnification()); 
}
void GetTimeSec(double datetime,int &time , int &sec) { 
double iptr = 0.0;
    sec = (int)(modf(datetime, &iptr)*100*secondMagnification()+0.5);
    time = (int)iptr;     
}
int getYearFromDateTime(double tm) {
int time; int sec;
GetTimeSec(tm,time,sec);
short y; short m; short d; short hr; short mn;
t_ymdhm((long )time,&y,&m,&d,&hr, &mn);
return (int)y;
}

long getTimeInMinuts(short yr, short mo, short da, short hr, short mn){
	return time(yr, mo,da, hr, mn);
}
float GetYearIntYearsFloat(double datetime,float &years){
double iptr = 0.0;	
modf(datetime, &iptr);
int tm = (int)iptr;
short y; short m; short d; short hr; short mn;
t_ymdhm((long )tm,&y,&m,&d,&hr, &mn);
	long ftime = time(y+1,1,1,0,0);
	long stime = time(y,1,1,0,0);
	years = (float)y +  (float)(tm - stime)/(float)(ftime - stime);
	return (float)y;

}
void t_ymdhm(long time, short *y, short *m, short *d,short *hr, short *mn)
{
long date;
short yr,mo,da,visokos;
short yr4;
date=(long)((time-998795520L)/1440L)+693608L;
yr4=(short)(date/1461L);
date%=1461L;
yr=(short)(yr4*4);
yr+=((short)(date/365L)); if (date < 1460) yr++;
if (yr%4) visokos=0; else  visokos=1;
if (date < 1460) date%=365L; else date=365;
for (mo=1;mo<12;mo++) if (date < cal0[visokos][mo]) break;
da=(short)(date-cal0[visokos][mo-1]+1);
*y=yr; *m=mo; *d=da;
*mn=(short)((time-998795520L)%1440L);
*hr=(short)(*mn/60);
*mn=(*mn%60);
}

long time(short yr, short mo, short da, short hr, short mn)
{
long return_value;
short date[5];
short yr4,visokos;
date[0]=yr;
date[1]=mo;
date[2]=da;
date[3]=hr;
date[4]=mn;
if (date[1] < 1) date[1]=1;
else if (date[1] > 12) date[1]=12;
if (date[0]%4) visokos=0; else visokos=1;
return_value=cal0[visokos][date[1]-1]+date[2]-1;
date[0]--;
yr4=date[0]/4; 
return_value+=(yr4*1461L);
return_value+=((date[0]-yr4*4)*365L);
return_value*=24L;
return_value+=date[3];
return_value*=60L;
return_value+=date[4];
return(return_value);
} 

void day_moda(short day, short yr, short *m, short *d)
{
short visokos,mo,da;
if (yr%4) visokos=0; else  visokos=1;
for (mo=1;mo<12;mo++) if (day < cal0[visokos][mo]) break;
da=(short)(day-cal0[visokos][mo-1]+1);
*m=mo; *d=da;
}
//0--------------------------------------------------------------------------------
bool tryBufferFormat(char* buf,struct FORMAT41 *format41){
QString str = QString(buf);
bool ok;
//qWarning("\n\ntryBufferFormat str '%s'",str.toAscii().data());
QString tmp = str.mid(format41->yr_pos,format41->yr_len);
//                  qWarning("tryBufferFormat y '%s'",tmp.toAscii().data());
tmp.toInt(&ok);
if(!ok) return false;

if (!format41->fyr_len && !format41->fda_len){
     tmp = str.mid(format41->mo_pos,2);
//                  qWarning("tryBufferFormat mo '%s'",tmp.toAscii().data());
     tmp.toInt(&ok);
     if(!ok) return false;
}

     tmp = str.mid(format41->da_pos,2);
//                  qWarning("tryBufferFormat da '%s'",tmp.toAscii().data());
     tmp.toInt(&ok);
     if(!ok) return false;

if (format41->fda_len) {
     tmp = str.mid(format41->da_pos,2);
//                  qWarning("tryBufferFormat fda '%s'",tmp.toAscii().data());
     tmp.toInt(&ok);
     if(!ok) return false;
}
if (!format41->fyr_len) {
     tmp = str.mid(format41->hr_pos,2);
//                  qWarning("tryBufferFormat hr '%s'",tmp.toAscii().data());
     tmp.toInt(&ok);
     if(!ok) return false;
}

if (!format41->fyr_len) {
     tmp = str.mid(format41->mn_pos,2);
//                  qWarning("tryBufferFormat mn '%s'",tmp.toAscii().data());
     tmp.toInt(&ok);
     if(!ok) return false;
}
if (!format41->fyr_len) {
tmp = str.mid(format41->sc_pos,2);
//qWarning("------------> sec pos %d len %d",format41->sc_pos,format41->fsc_len);
//                 qWarning("tryBufferFormat sc '%s'",tmp.toAscii().data());
     tmp.toInt(&ok);
     if(!ok) return false;
}
if (format41->fsc_len >0){ 
     tmp = str.mid(format41->fsc_pos,format41->fsc_len);
//qWarning("------------> micro sc pos %d len %d",format41->fsc_pos,format41->fsc_len);
//                  qWarning("tryBufferFormat msc '%s'",tmp.toAscii().data());
     tmp.toInt(&ok);
     if(!ok) return false;

}
//lat, lon
tmp = str.mid(format41->slat_pos,1); 
   // qWarning("tryBufferFormat sign-lat '%s'",tmp.toAscii().data());

tmp = str.mid(format41->dlat_pos, format41->dlat_len);
                // qWarning("tryBufferFormat dlat '%s'",tmp.toAscii().data());
tmp.toInt(&ok);
if(!ok) return false;

if (format41->flat_len > 0) {
     tmp = str.mid(format41->flat_pos, format41->flat_len);
                 // qWarning("tryBufferFormat flat '%s'",tmp.toAscii().data());
     tmp.toInt(&ok);
     if(!ok) return false;

}
if (format41->flat1_len >0) {
     tmp = str.mid(format41->flat1_pos,format41->flat1_len);
               //   qWarning("tryBufferFormat flat1 '%s'",tmp.toAscii().data());
     tmp.toInt(&ok);
     if(!ok) return false;

}

tmp = str.mid(format41->slon_pos,1); 
    //qWarning("tryBufferFormat sign-lon '%s'",tmp.toAscii().data());

tmp = str.mid(format41->dlon_pos, format41->dlon_len);
               //  qWarning("tryBufferFormat dlat '%s'",tmp.toAscii().data());
tmp.toInt(&ok);
if(!ok) return false;

if (format41->flon_len > 0) {
     tmp = str.mid(format41->flon_pos, format41->flon_len);
               //   qWarning("tryBufferFormat flat '%s'",tmp.toAscii().data());
     tmp.toInt(&ok);
     if(!ok) return false;

}
if (format41->flon1_len >0) {
     tmp = str.mid(format41->flon1_pos,format41->flon1_len);
                //  qWarning("tryBufferFormat flat1 '%s'",tmp.toAscii().data());
     tmp.toInt(&ok);
     if(!ok) return false;
}
//depth
     tmp = str.mid(format41->dep_pos,format41->dep_len);
                 // qWarning("tryBufferFormat dep '%s'",tmp.toAscii().data());
    if (tmp.size () != tmp.count(' ') ) {
     tmp.toInt(&ok);
     if(!ok) return false;
   }
if (format41->fdep_len >0) {
     tmp = str.mid(format41->fdep_pos,format41->fdep_len);
                 // qWarning("tryBufferFormat fdep '%s'",tmp.toAscii().data());
   if (tmp.size () != tmp.count(' ') ) {
     tmp.toInt(&ok);
     if(!ok) return false;
   }
}
for (int j = 0; j < 4; j++) {
if (format41->m_len[j] > 0) {
     tmp = str.mid(format41->m_pos[j],format41->m_len[j]);
                  //qWarning("tryBufferFormat mag%d m '%s'",j+1,tmp.toAscii().data());
    if (tmp.size () != tmp.count(' ') ) {
       // qWarning("tryBufferFormat size %d count %d",tmp.size (),tmp.count(' '));
     tmp.toInt(&ok);
    if( !ok) return false;
   }
}

if (format41->fm_len[j] > 0) {
tmp = str.mid(format41->fm_pos[j],format41->fm_len[j]);
                //  qWarning("tryBufferFormat %d fm '%s'",j+1,tmp.toAscii().data());
    if (tmp.size () != tmp.count(' ') ) {
              //   qWarning("tryBufferFormat size %d count %d",tmp.size (),tmp.count(' '));
     tmp.toInt(&ok);
    if( !ok) return false;
   }
}

}
// intencity
 if (format41->intens_len != 0) {
    tmp = str.mid(format41->intens_pos,format41->intens_len);
                  //  qWarning("tryBufferFormat inten '%s'",tmp.toAscii().data());
    if (tmp.size () != tmp.count(' ') ) {
     if (format41->intens_type == 'a') { 
      QChar ch =  tmp[0];
       if (ch.digitValue () == -1) {
               bool isgood = false;
	      if ( format41->intens_list[0] == ch)   isgood = true;
	      if ( format41->intens_list[1] == ch)   isgood = true;
	      if ( format41->intens_list[2] == ch)   isgood = true;
              if (isgood==false) return false;
        }
     }
    if (format41->intens_type == 'd'){
             tmp.toInt(&ok);
             if( !ok) return false;
    }
 }
} 

return true;
}
int convert41(RECORD &record, char *bufin, struct FORMAT41 *format41)
{
int j=0,k=0;
short yr=0,mo=0,da=0,hr=0,mn=0;
int sc=0,fsc=0,fyr=0,fda=0;
double val=0.0;
int ival=0;
long lval=0L;
//skip non-data records
if ((int)strlen(bufin) < format41->fmt_minlen) return(0);
for (j=0;j<format41->skip_num;j++)
	{
    k=memcmp(bufin+format41->skip_pos[j],format41->skip_char[j],format41->skip_len[j]);
	if (k) k=1;
	if (k-format41->skip_type[j]) return(0);
	}

//time

yr=(short)chtoi(bufin+format41->yr_pos,format41->yr_len);
if (format41->yr_add) { if (yr < 15) yr+=2000; else yr+=1900; }
if (!format41->fyr_len && !format41->fda_len) mo=(short)chtoi(bufin+format41->mo_pos,2);
da=(short)chtoi(bufin+format41->da_pos,2);
if (format41->fda_len) fda=(short)chtoi(bufin+format41->fda_pos,format41->fda_len);
if (!format41->fyr_len) hr=(short)chtoi(bufin+format41->hr_pos,2);
if (!format41->fyr_len) mn=(short)chtoi(bufin+format41->mn_pos,2);
if (!format41->fyr_len) sc=chtoi(bufin+format41->sc_pos,2);
 
float myfsc =0.0;  // mostinskiy
if (!format41->fyr_len){ 
    fsc=chtoi(bufin+format41->fsc_pos,format41->fsc_len);
    // mostinskiy
      myfsc = pow(10.0,-(double)format41->fsc_len)*fsc;
     fsc = (int) (myfsc*secondMagnification() +0.5);
     if (fsc == 60) sc++; else sc = fsc + sc*secondMagnification();
     // mostinskiy
}
//if (fsc > (int)(0.5*pow(10.0,(double)format41->fsc_len))) sc++; /*round-up seconds */
if (format41->fda_len) day_moda(fda,yr,&mo,&da);

if (format41->fyr_len) // mostinskiy - not use ???
	{ 
	fyr=chtoi(bufin+format41->fyr_pos, format41->fsc_len);
	val=(double) yr + fyr/pow(10.0,(double) format41->fsc_len);
	lval=(long)((val-1980.0)*365.25*1440.0);
	// mostinsk
//	record.time=time(1980,1,1,0,0)+lval;
	long dtime = time(1980,1,1,0,0)+lval;
	short y, m, d , h, mn;
	    t_ymdhm(dtime, &y, &m,  &d, &h, &mn);
	    record.yr= y; record.mo = m; record.da = d;record.hr =h; record.mn =mn;
	    
	sc=(short)((val-1980.0)*365.25*1440.0*60.0-lval*60.0+0.5);
	}
else {record.yr=yr;   record.mo=mo;     record.da=da;   record.hr=hr;   record.mn=mn; }
record.sc = sc;
for (j=0;j<4;j++) record.m[j]=0;
record.inten=0;
record.fi=0;
record.la=0;
record.h=0;

//lat, lon
val=(double)chtoi(bufin+format41->flat1_pos,format41->flat1_len)*format41->flat1_coeff;
val+=(double)chtoi(bufin+format41->flat_pos,format41->flat_len);
val*=format41->flat_coeff;
ival=chtoi(bufin+format41->dlat_pos,format41->dlat_len);
// mostinskiy 100 -> latitudeMagnification()
record.fi=(int)(val*latitudeMagnification()+0.5)+ival*latitudeMagnification();
if( ival < 0 ) record.fi=(int)(-val*latitudeMagnification()-0.5)+ival*latitudeMagnification();
if(format41->latExtra==0)
if ((bufin[format41->slat_pos] == '-') || (bufin[format41->slat_pos] == 'S') || (bufin[format41->slat_pos] == 's')) 
	record.fi*=(-1);

if(format41->latExtra==1)
if ((bufin[format41->slat_pos] == 'S') || (bufin[format41->slat_pos] == 's')) record.fi*=(-1);

val=(double)chtoi(bufin+format41->flon1_pos,format41->flon1_len)*format41->flon1_coeff;
val+=(double)chtoi(bufin+format41->flon_pos,format41->flon_len);
val*=format41->flon_coeff;
ival=chtoi(bufin+format41->dlon_pos,format41->dlon_len);

// mostinskiy 100 -> longitudeMagnification()


record.la=(int)(val*longitudeMagnification()+0.5)+ival*longitudeMagnification();
if( ival < 0 ) record.la=(int)(-val*longitudeMagnification()-0.5)+ival*longitudeMagnification();

if(format41->latExtra==0)
if ((bufin[format41->slon_pos] == '-') || (bufin[format41->slon_pos] == 'W') || (bufin[format41->slon_pos] == 'w')) 
record.la*=(-1);

if(format41->latExtra==1)
if ((bufin[format41->slon_pos] == ' ') ) record.la*=(-1);


//depth
val=(double)chtoi(bufin+format41->dep_pos,format41->dep_len);
val+=(double)chtoi(bufin+format41->fdep_pos,format41->fdep_len)/pow(10.0,(double)format41->fdep_len);
// mostinskiy 1-> depthMagnification()
record.h=(short)(val*depthMagnification());
//magnitudes
for (j=0;j<4;j++)
	{
	val=(double)chtoi(bufin+format41->m_pos[j],format41->m_len[j]);
	val+=(double)chtoi(bufin+format41->fm_pos[j],format41->fm_len[j])/pow(10.0,(double)format41->fm_len[j]);
	// mostinskiy 100-> magnitudeMagnification()
	record.m[j]=(short)(val*magnitudeMagnification()+0.5);
        if (bufin[format41->m_pos[j]-1] == '-') record.m[j] = -record.m[j];
	}
//intensity
 if (format41->intens_len != 0) {
    if (format41->intens_type == 'a') { 
      QChar ch =  QChar((char)bufin[format41->intens_pos ]);
      if (ch.digitValue () !=-1) record.inten =  ch.digitValue ();
      else  {
	      if ( format41->intens_list[0] == ch.toLatin1())   record.inten = 10;
	      if ( format41->intens_list[1] == ch.toLatin1())   record.inten = 11;
	      if ( format41->intens_list[2] == ch.toLatin1())   record.inten = 12;
      }
    }
    if (format41->intens_type == 'd'){
    record.inten =  QByteArray( bufin+format41->intens_pos,format41->intens_len).toInt();
   
   // val=(double)chtoi(bufin+format41->intens_pos,format41->intens_len);
    }
} 

return(format41->fmt_len);
}


int getfmt (int indFormat, struct FORMAT41 *fmt)
{
char bf[200]="";
int count=0,count1=0,pos0=0;
int p1,p2,p3,p4,p5,p6,p7,p8,p9;
int errors=0;
int j=0;
FILE *fmtf;
int skipFormat = 0;
fmt->yr_pos=0; fmt->yr_len=0; fmt->yr_add=0;
fmt->fyr_pos=0; fmt->fyr_len=0; 
fmt->fda_pos=0; fmt->fda_len=0;
fmt->mo_pos=0;fmt->da_pos=0; fmt->hr_pos=0;  
fmt->mn_pos=0; fmt->sc_pos=0; fmt->fsc_pos=0; fmt->fsc_len=0;
fmt->slat_pos=0; fmt->dlat_pos=0; fmt->dlat_len=0;
fmt->flat_pos=0;fmt->flat_len=0; fmt->flat1_pos=0; fmt->flat1_len=0;
fmt->flat_coeff=1.0;
fmt->flat1_coeff=1.0;
fmt->flon_coeff=1.0;
fmt->flon1_coeff=1.0;
fmt->slon_pos=0;fmt->dlon_pos=0;fmt->dlon_len=0;
fmt->flon_pos=0;fmt->flon_len=0;fmt->flon1_pos=0;fmt->flon1_len=0;
fmt->dep_pos=0;fmt->dep_len=0;
fmt->fdep_pos=0;fmt->fdep_len=0;
for (j=0;j<4;j++) { fmt->m_pos[j]=0;fmt->m_len[j]=0; fmt->fm_pos[j]=0;fmt->fm_len[j]=0; }
fmt->intens_pos = 0;fmt->intens_len = 0;fmt->intens_list[0] =' ';fmt->intens_list[1] =' ';fmt->intens_list[2] =' ';
fmt->skip_num=0;
fmt->latExtra=fmt->lonExtra=0;
QString formatFileName = ecpRootPath() + "/ref/standardformat.list";
        formatFileName =  QDir::toNativeSeparators(formatFileName);

fmtf=fopen(formatFileName.toAscii(),"r"); 
if (!fmtf) {
    QApplication::restoreOverrideCursor();
    QString tmp; QString("can't find format catalog file %1").arg(formatFileName);
    QMessageBox::critical( 0, "Checking Format",tmp );  
    return (1);}

while(skipFormat < indFormat) { 
    fgets(bf,200,fmtf);
    if (strncmp(bf,fileFormatSeparator().toAscii(),strlen(fileFormatSeparator().toAscii())) == 0) skipFormat++;
    
    }

while( fgets(bf,200,fmtf) )
{

    if (strncmp(bf,"TITLE",strlen("TITLE")) == 0) continue;
    if (strncmp(bf,"URL",strlen("URL")) == 0) continue;
	  if (strncmp(bf,"REF",strlen("REF")) == 0) continue;
    if (strncmp(bf,"REM",strlen("REM")) == 0) continue;
	  if (strncmp(bf,fileFormatSeparator().toAscii(),strlen(fileFormatSeparator().toAscii())) == 0) break;
	   
	//TIME
if (!memcmp(bf,"TIME",4))
	{
	count1=count=0;
	count+=strcspn(bf+count,"(");  count++;
	pos0=atoi(bf+count)-1;
	count+=strcspn(bf+count,",");  count++;
                                                           // most insert: fmt->fsc_pos 
	fmt->yr_pos=fmt->mo_pos=fmt->da_pos=fmt->hr_pos=fmt->mn_pos=fmt->sc_pos=fmt->fsc_pos=pos0;
	p1=p2=p3=p4=p5=p6=p7=p8=p9=1;
	count1=0;
	while((count < (int)strlen(bf)) && memcmp(bf+count,");",2))
		{
		if (bf[count]=='Y')      {fmt->yr_len++; if (p1) fmt->yr_pos+=count1; p1=0;}
		else if (bf[count]=='y') {fmt->fyr_len++; if (p2) fmt->fyr_pos+=count1; p2=0;}
		else if (bf[count]=='M') {if (p3) fmt->mo_pos+=count1; p3=0;}
		else if (bf[count]=='D') {if (p4) fmt->da_pos+=count1; p4=0;}
		else if (bf[count]=='d') {fmt->fda_len++; if (p5) fmt->fda_pos+=count1; p5=0;}
		else if (bf[count]=='H') {if (p6) fmt->hr_pos+=count1; p6=0; }
		else if (bf[count]=='m') {if (p7) fmt->mn_pos+=count1; p7=0; }
		else if (bf[count]=='S') {if (p8) fmt->sc_pos+=count1; p8=0; }
		else if (bf[count]=='s') {fmt->fsc_len++; if (p9) fmt->fsc_pos+=count1; p9=0;}
		count++; count1++;
		}
	if (fmt->yr_len==2) fmt->yr_add=1;
	}

//LAT
else if (!memcmp(bf,"LAT",3))
	{
	count1=count=0;
	count+=strcspn(bf+count,"(");  count++;
	pos0=atoi(bf+count)-1;
	count+=strcspn(bf+count,",");  count++;
	fmt->slat_pos=fmt->dlat_pos=fmt->flat_pos=fmt->flat1_pos=pos0;
	p1=p2=p3=p4=1;
	while((count < (int)strlen(bf)) && memcmp(bf+count,");",2))
		{
		if (bf[count]=='-')		{ if (p1) fmt->slat_pos+=count1; p1=0;}
		else if (bf[count]=='N')	{ if (p1) fmt->slat_pos+=count1; p1=0;}
		else if (bf[count]=='S')	{ if (p1) fmt->slat_pos+=count1; p1=0;}
		else if (bf[count]=='D') { fmt->dlat_len++; if (p2) fmt->dlat_pos+=count1; p2=0;}
		else if (bf[count]=='d') { fmt->flat_len++; if (p3) fmt->flat_pos+=count1; p3=0;}
		else if (bf[count]=='M') { fmt->flat_len++; fmt->flat_coeff=1.6667; if (p3) fmt->flat_pos+=count1; p3=0;}
		else if (bf[count]=='m') { fmt->flat1_len++; if (p4) fmt->flat1_pos+=count1; p4=0;}
		else if (bf[count]=='s') { fmt->flat1_len++; fmt->flat1_coeff	 =1.6667; if (p4) fmt->flat1_pos+=count1; p4=0;}
		count++; count1++;
		}
	fmt->flat_coeff/=pow(10.0,(double)fmt->flat_len);
	fmt->flat1_coeff/=pow(10.0,(double)fmt->flat1_len);
	}
else if ( QString(bf).indexOf("Latitude Extra") != -1)
	{
         QString tmp(bf);
         fmt->latExtra =tmp.mid(tmp.indexOf(':')-1,1).toInt();
        }
//LON
else if (!memcmp(bf,"LON",3))
	{
	count1=count=0;
	count+=strcspn(bf+count,"(");  count++;
	pos0=atoi(bf+count)-1;
	count+=strcspn(bf+count,",");  count++;
	fmt->slon_pos=fmt->dlon_pos=fmt->flon_pos=fmt->flon1_pos=pos0;
	p1=p2=p3=p4=1;
	while((count < (int)strlen(bf)) && memcmp(bf+count,");",2))
		{
		if (bf[count]=='-')		{ if (p1) fmt->slon_pos+=count1; p1=0;}
		else if (bf[count]=='W')	{ if (p1) fmt->slon_pos+=count1; p1=0;}
		else if (bf[count]=='E')	{ if (p1) fmt->slon_pos+=count1; p1=0;}
		else if (bf[count]=='D') { fmt->dlon_len++; if (p2) fmt->dlon_pos+=count1; p2=0;}
		else if (bf[count]=='d') { fmt->flon_len++; if (p3) fmt->flon_pos+=count1; p3=0;}
		else if (bf[count]=='M') { fmt->flon_len++; fmt->flon_coeff=1.6667; if (p3) fmt->flon_pos+=count1; p3=0;}
		else if (bf[count]=='m') { fmt->flon1_len++; if (p4) fmt->flon1_pos+=count1; p4=0;}
		else if (bf[count]=='s') { fmt->flon1_len++; fmt->flon1_coeff=1.6667; if (p4) fmt->flon1_pos+=count1; p4=0;}
		count++; count1++;
		}
	fmt->flon_coeff/=pow(10.0,(double)fmt->flon_len);
	fmt->flon1_coeff/=pow(10.0,(double)fmt->flon1_len);
	}
else if (QString(bf).indexOf("Longitude Extra") != -1)
	{
         QString tmp(bf);
         fmt->lonExtra =tmp.mid(tmp.indexOf(':')-1,1).toInt();
        }
//DEP
else if (!memcmp(bf,"DEP",3))
	{
	count1=count=0;
	count+=strcspn(bf+count,"(");  count++;
	pos0=atoi(bf+count)-1;
	count+=strcspn(bf+count,",");  count++;
	fmt->dep_pos=fmt->fdep_pos=pos0;
	p1=p2=1;
	while((count < (int)strlen(bf)) && memcmp(bf+count,");",2))
		{
		if (bf[count]=='D') { fmt->dep_len++; if (p1) fmt->dep_pos+=count1; p1=0; } 
		else if (bf[count]=='d') { fmt->fdep_len++; if (p2) fmt->fdep_pos+=count1; p2=0; } 
		count++; count1++;
		}
	}

//Magnitudes
else if (!memcmp(bf,"M1",2) ||!memcmp(bf,"M2",2) ||!memcmp(bf,"M3",2) ||!memcmp(bf,"M4",2))
	{
	j=(int)(bf[1]-'0')-1;
	count1=count=0;
	count+=strcspn(bf+count,"(");  count++;
	pos0=atoi(bf+count)-1;
	count+=strcspn(bf+count,",");  count++;
	fmt->m_pos[j]=fmt->fm_pos[j]=pos0;
	p1=p2=1;
	while((count < (int)strlen(bf)) && memcmp(bf+count,");",2))
		{
               // if (bf[count]=='-') { (fmt->m_len[j])++; (fmt->m_pos[j])++;}
		if (bf[count]=='D') { (fmt->m_len[j])++; if (p1) (fmt->m_pos[j])+=count1; p1=0; }
		else if (bf[count]=='d') {(fmt->fm_len[j])++; if (p2) (fmt->fm_pos[j])+=count1; p2=0; } 
		count++; count1++;
		}
	}
//Intensity
else if (!memcmp(bf,"INT",3))
	{
	count=0;
	count+=strcspn(bf+count,"(");  count++;

	QString intenStr = "";
	int cnt = count;
	while (*(bf + cnt) != ')') {intenStr += *(bf + cnt); cnt++;}
                                                           
	fmt->intens_pos = intenStr.left( intenStr.indexOf( ',')).toInt()-1;
	intenStr = intenStr.right(intenStr.length() -  intenStr.indexOf( ',') -1);

	if (intenStr [0] == 'a') {
      fmt->intens_type =  'a';
	    intenStr = intenStr.right(intenStr.length() -2);
	    fmt->intens_list[0] = intenStr[0].toLatin1();
	    fmt->intens_list[1] = intenStr[1].toLatin1();
	    fmt->intens_list[2] = intenStr[2].toLatin1();
	    fmt->intens_len=1;
//	   qWarning(QString("=== '%1'  %2  %3 %4 %5 ---  %6")
//     .arg(intenStr).arg(fmt->intens_pos).arg(fmt->intens_list[0] )
//     .arg(fmt->intens_list[1] ).arg(fmt->intens_list[2] ).arg(fmt->intens_type));

	}
 if (intenStr [0] == 'd') {
      fmt->intens_type =  'd';
	    fmt->intens_len = intenStr.count('D');
//	   qWarning(QString("=== '%1'  %2  %3 ---  %4")
//     .arg(intenStr).arg(fmt->intens_pos).arg(fmt->intens_len).arg(fmt->intens_type));
     
 	}	
	
	}
else if (!memcmp(bf,"SKIP",3))
	{
	if (fmt->skip_num > 9) { 
	    QApplication::restoreOverrideCursor();
	    QMessageBox::critical( 0, "Checking Format","Only upto 10 SKIP records allowed, other will not be used" );  
	    continue; }
	count=0;
	count+=strcspn(bf+count,"(");  count++;
	pos0=atoi(bf+count)-1; 
	count+=strcspn(bf+count,",");  count++;
	if (bf[count]=='!') 
		{
		count++;
		fmt->skip_type[fmt->skip_num]=0;
		}
	else fmt->skip_type[fmt->skip_num]=1;
	count1=strcspn(bf+count,")");
	if (count1 > 9) count1=9;
	memcpy(fmt->skip_char[fmt->skip_num],bf+count,count1);
	fmt->skip_len[fmt->skip_num]=count1;
	fmt->skip_pos[fmt->skip_num]=pos0;
	fmt->skip_num++;
	}
else { 	    
    QString tmp = QString("bad format string: '%1'").arg(bf);
    QApplication::restoreOverrideCursor();
    QMessageBox::critical( 0, "Checking Format",tmp);  
    //printf("bad format string: '"); puts(bf); 
    errors++; }
}
fmt->fmt_minlen=0;
if (fmt->da_pos > fmt->fmt_minlen) fmt->fmt_minlen=fmt->da_pos;
for (j=0;j<4;j++) if ((fmt->fm_len[j]) && (fmt->fm_pos[j] > fmt->fmt_minlen))  fmt->fmt_minlen=fmt->fm_pos[j];
if (fmt->flat_pos > fmt->fmt_minlen) fmt->fmt_minlen=fmt->flat_pos;
if (fmt->flon_pos > fmt->fmt_minlen) fmt->fmt_minlen=fmt->flon_pos;
if (fmt->fdep_pos > fmt->fmt_minlen) fmt->fmt_minlen=fmt->fdep_pos;
fclose(fmtf);
if (errors) return(0);
return(1);
}
	

int chtoi(char *buff, int len)
{
char tmpbuf[32]="";
if (len < 1) return(0);
memcpy(tmpbuf,buff,len);
tmpbuf[len]='\0';
return(atoi(tmpbuf));
}
