#ifndef  _CONVERT_CATALOG_H
#define  _CONVERT_CATALOG_H
#include <stdio.h>
#include <cstdlib>
#include <cmath>

#if defined(Q_WS_WIN) 
#include <malloc.h>
#endif

#if defined(Q_WS_X11) 
#include <malloc.h>
#endif		

#if defined(Q_WS_MAC) 
#include <malloc/malloc.h>
#endif

typedef struct CATALOG_RECORD {short yr; short mo;short da;short hr;short mn;short sc;
                               int fi; int la; short h; short m[4]; short inten; } RECORD;
typedef struct CATALOG_BINARY20 {int time; short fi; short la; short h; short m[4]; short inten; } RECORD20;

double DateTime(RECORD rec);
void GetTimeSec(double datetime,int &time , int &sec);
int getYearFromDateTime(double tm);
long getTimeInMinuts(short yr, short mo, short da, short hr, short mn);
float GetYearIntYearsFloat(double datetime,float &years);
const long cal0[2][12]= {{0,31,59,90,120,151,181,212,243,273,304,334},
		   {0,31,60,91,121,152,182,213,244,274,305,335}};

struct FORMAT41
 {
 int fmt_len;
 int fmt_minlen;
 int yr_pos; int yr_len; int yr_add;
 int fyr_pos; int fyr_len;
 int mo_pos;
 int da_pos;
 int fda_pos; int fda_len;
 int hr_pos;
 int mn_pos;
 int sc_pos;
 int fsc_pos; int fsc_len;
 int slat_pos; int dlat_pos; int dlat_len;
 int flat_pos; int flat_len;
 int flat1_pos; int flat1_len;
 double flat_coeff;
 double flat1_coeff;
 int slon_pos; int dlon_pos; int dlon_len;
 int flon_pos; int flon_len;
 int flon1_pos; int flon1_len;
 double flon_coeff;

 double flon1_coeff;
 int dep_pos; int dep_len;
 int fdep_pos; int fdep_len;
 int m_pos[4]; int m_len[4];
 int fm_pos[4]; int fm_len[4];

 int intens_pos; int intens_len; char intens_type;char intens_list[3];
 int skip_num; int skip_pos[10]; int skip_len[10]; int skip_type[10]; char skip_char[10][10];
 int latExtra,lonExtra;
 };
int getfmt(int indFormat, struct FORMAT41 *fmt);
int convert41(RECORD &record, char* bufin, struct FORMAT41 *format41);
bool tryBufferFormat(char* buf,struct FORMAT41 *format41);
int chtoi(char*,int);
void day_moda(short,short,short *, short *);
long time(short, short, short, short, short);
void t_ymdhm(long time, short *y, short *m, short *d,short *hr, short *mn);

#endif
