#include <QString>
#include <QVector>
#include <QDir>
#include <float.h>
extern  QString ECP_ROOT_PATH;
extern QString ECP_SEARCH_HELP_PATH;

static const  QString USER_HOME_PATH = QDir::homePath();

const QString  userHomePath()               { return USER_HOME_PATH;}

const QString  ecpRootPath()               { return ECP_ROOT_PATH;}
const QString  searchHelpPath()            { return ECP_SEARCH_HELP_PATH;}

static const  QString MAIN_WINDOW_CAPTION = "Compilation Catalog Panel";
const QString  mainWindowCaption()                  { return MAIN_WINDOW_CAPTION; }

static const float ECP_FLOAT_MAXIMUM = 1.0e+6;
const float    maxEcpFloat()       { return ECP_FLOAT_MAXIMUM;     }

	
static const  QString TEMPORARY_SYSTEM_DIRECTORY_PATH = QDir::temp().absolutePath ();
const QString  temporarySystemDirectoryPath()    { return TEMPORARY_SYSTEM_DIRECTORY_PATH; }

static const QString TEMPORARY_DIRECTORY_PREFIX    = "ecpTemp-";
const QString  temporaryDirectoryPrifix()    { return TEMPORARY_DIRECTORY_PREFIX; }


///------------- QDataStream version read-write constants : ------------------------------------------- 
static const  QString  Ecp_Current_Version = "121"; 
// version "111" contains  addition member numOriginRow; version "110" is not!

static const  QString  Ecp_Versions_For_Qt4 = "110 120";
static const  QString  Ecp_Versions_For_Qt_4_3 = "121 130"; 
const QString  EcpCurrentVersion()                  { return Ecp_Current_Version;               }

const QString  EcpVersionsForQt4()                 { return  Ecp_Versions_For_Qt4;              }
const QString  EcpVersionsForQt4_3()                 { return  Ecp_Versions_For_Qt_4_3;         }
// When Qt with next QDataStream version will come then change
//  Qt_Current_Version = 7 
// and put   real limits for Ecp_Versions_For_ Qt6 and make next
// Ecp_Versions_For_ Qt7 for example
//  Ecp_Versions_For_ Qt6 = "110 117"; 
//Ecp_Current_Version = 118
// Ecp_Versions_For_ Qt7 = "118 130";
// !!  and put correction code to  FDocument::loadBinary
static const float   ECP_ACURACY_COMPARE_FLOAT_VALUE    = 0.5e-4;
const float    acuracyCompareFloatValue()       { return ECP_ACURACY_COMPARE_FLOAT_VALUE;  }

static const float   ECP_ACURACY_COMPARE_TIME_VALUE    = 0.5e-5;
const float    acuracyCompareTimeValue()       { return ECP_ACURACY_COMPARE_TIME_VALUE ;}
static const  QString  _FILE_FORMAT_SEPARATOR_ = "--------------------------";
const QString  fileFormatSeparator()                  { return _FILE_FORMAT_SEPARATOR_;            }
static const  QString FILE_FILTER_LOCATOR = ".csf";
const QString fileFilterLocator()                          { return FILE_FILTER_LOCATOR;           }
static const  QString PROJECT_FILE_FILTER_LOCATOR = ".pro";
const QString projectFileFilterLocator()                          { return PROJECT_FILE_FILTER_LOCATOR;   }
static const  QString PROTOCOL_FILE_FILTER_LOCATOR = ".protocol";
const QString protocolFileFilterLocator()                          { return PROTOCOL_FILE_FILTER_LOCATOR;   }
static QString OPEN_BINARY_CATALOG_FILE_NAME = "openbin";
const QString openBinaryCatalogfileName()                       { return OPEN_BINARY_CATALOG_FILE_NAME; }
static QString OPEN_TEMP_BINARY_CATALOG_FILE_NAME = "tempbin";
const QString openTempBinaryCatalogfileName()                   { return OPEN_TEMP_BINARY_CATALOG_FILE_NAME; }
static QString OPEN_TEMP_MERGE_BINARY_CATALOG_FILE_NAME = "tempmergebin";
const QString openTempMergeBinaryCatalogfileName()                   { return OPEN_TEMP_MERGE_BINARY_CATALOG_FILE_NAME; }
static QString OPEN_SECOND_BINARY_CATALOG_FILE_NAME = "secondbin";
const QString openSecondBinaryCatalogfileName()                   { return OPEN_SECOND_BINARY_CATALOG_FILE_NAME; }

static QString OPEN_PROJECT_CATALOG_FILE_NAME = "projectbin";
const QString openProjectBinaryCatalogfileName()                   { return OPEN_PROJECT_CATALOG_FILE_NAME; }

static const  QString TXT_FILE_FILTER_LOCATOR = ".txt";
const QString txtFilterLocator()                          { return TXT_FILE_FILTER_LOCATOR;           }

static const  QString POLYGON_FILE_FILTER_LOCATOR = ".txt";
const QString poligonFilterLocator()                          { return POLYGON_FILE_FILTER_LOCATOR;           }


static QString USER_DETERMINATION_EXPORT_FORMAT = "User defined TEXT output";
const QString exportUserFormat()                   { return USER_DETERMINATION_EXPORT_FORMAT; }

static QString PREFIX_MESSAGES_PROTOCOL_PAGE =  "*** Task: ";
const QString prefixMessage()                   { return PREFIX_MESSAGES_PROTOCOL_PAGE; }

static QString POSTFIX_ACTION_MESSAGES_PROTOCOL_PAGE = "*** End of Task: ";
const QString postfixActionMessage()                   { return POSTFIX_ACTION_MESSAGES_PROTOCOL_PAGE; }

static QString CANCEL_MESSAGES_PROTOCOL_PAGE = "*** Canceled ***";
const QString cancelMessage()                   { return CANCEL_MESSAGES_PROTOCOL_PAGE; }

static const QString          ECP_LINE_EDIT_FONT_METRIC_WIDTH = "1-180.9999" ; 
const QString  fontmetricLineEdit()     { return ECP_LINE_EDIT_FONT_METRIC_WIDTH ; }

// VIEW BUFFER SIZE SPECIFICATIONS
////////////////////////////////////////////////

static const int SIZE_MAXIMUM_ERROR_BUFFER_TABLE = 25;
const int  maxSizeErrorBufferTable() {return SIZE_MAXIMUM_ERROR_BUFFER_TABLE;}
static const int                  ECP_ERROR_RECORD_MAX                                             = 100;
const int          maxErrorRecord()              { return ECP_ERROR_RECORD_MAX;                                            }

             // MAX LINES DOUBLES CORRECTION PAGE
static const int       ECP_MAX_LINES_DOUBLES_CORRECTION_PAGE_ID   = 500; 
static const QString   ECP_MAX_LINES_DOUBLES_CORRECTION_PAGE_NAME     = "Correction Page: maximum found double lines";
static const QString   ECP_MAX_LINES_DOUBLES_CORRECTION_PAGE_DEFAULT  = "200";
static const int       ECP_MAX_LINES_DOUBLES_CORRECTION_PAGE_MIN  = 50; 
static const int       ECP_MAX_LINES_DOUBLES_CORRECTION_PAGE_MAX                     = 1000;
static const int       ECP_MAX_LINES_DOUBLES_CORRECTION_PAGE_SPINBOX_STEP                     = 50;
static const bool      ECP_MAX_LINES_DOUBLES_CORRECTION_PAGE_SIGNED_VALUE    = FALSE;
const int       idMaxLinesDoublesCorrectonPage()   { return ECP_MAX_LINES_DOUBLES_CORRECTION_PAGE_ID;  }
const QString   nameMaxLinesDoublesCorrectonPage()     { return ECP_MAX_LINES_DOUBLES_CORRECTION_PAGE_NAME;    }
const QString   defaultMaxLinesDoublesCorrectonPage()  { return ECP_MAX_LINES_DOUBLES_CORRECTION_PAGE_DEFAULT; }
const int       minMaxLinesDoublesCorrectonPage()  { return ECP_MAX_LINES_DOUBLES_CORRECTION_PAGE_MIN;     }
const int       maxMaxLinesDoublesCorrectonPage()  { return ECP_MAX_LINES_DOUBLES_CORRECTION_PAGE_MAX;     }
const bool      signedMaxLinesDoublesCorrectonPage() { return ECP_MAX_LINES_DOUBLES_CORRECTION_PAGE_SIGNED_VALUE;  }
const int       stepMaxLinesDoublesCorrectonPage()     { return ECP_MAX_LINES_DOUBLES_CORRECTION_PAGE_SPINBOX_STEP;  }

////////////////////////////////////////////////
             // CATALOG BUFFER
static const int       ECP_SIZE_VIEW_BUFFER_CATALOG_ID                      = 501; 
static const QString   ECP_SIZE_VIEW_BUFFER_CATALOG_NAME          = "Change view catalog segment size";
static const QString   ECP_SIZE_VIEW_BUFFER_CATALOG_DEFAULT  = "50"; //"100";
static const int       ECP_SIZE_VIEW_BUFFER_CATALOG_MIN      = 25; //50
static const int       ECP_SIZE_VIEW_BUFFER_CATALOG_MAX                     = 10000;
static const int       ECP_SIZE_VIEW_BUFFER_CATALOG_SPINBOX_STEP                     = 25;//50;
static const bool      ECP_SIZE_VIEW_BUFFER_CATALOG_SIGNED_VALUE    = FALSE;
const int       idViewBufferCatalog()                     { return ECP_SIZE_VIEW_BUFFER_CATALOG_ID;          }
const QString   nameViewBufferCatalog()                { return ECP_SIZE_VIEW_BUFFER_CATALOG_NAME;    }
const QString   defaultViewBufferCatalog()               { return ECP_SIZE_VIEW_BUFFER_CATALOG_DEFAULT; }
const int       minViewBufferCatalog()                   { return ECP_SIZE_VIEW_BUFFER_CATALOG_MIN;          }
const int       maxViewBufferCatalog()                  { return ECP_SIZE_VIEW_BUFFER_CATALOG_MAX;         }
const bool      signedViewBufferCatalog()               { return ECP_SIZE_VIEW_BUFFER_CATALOG_SIGNED_VALUE;  }
const int       stepViewBufferCatalog()               { return ECP_SIZE_VIEW_BUFFER_CATALOG_SPINBOX_STEP;  }
          // ERROR BUFFER
static const int       ECP_SIZE_VIEW_BUFFER_ERROR_ID                      = 502; 
static const QString   ECP_SIZE_VIEW_BUFFER_ERROR_NAME          = "Change errors page size";
static const QString   ECP_SIZE_VIEW_BUFFER_ERROR_DEFAULT  = "25";
static const int       ECP_SIZE_VIEW_BUFFER_ERROR_MIN      = 25;
static const int       ECP_SIZE_VIEW_BUFFER_ERROR_MAX                     = 200;
static const int       ECP_SIZE_VIEW_BUFFER_ERROR_SPINBOX_STEP                     = 25;
static const bool      ECP_SIZE_VIEW_BUFFER_ERROR_SIGNED_VALUE    = FALSE;
const int       idViewBufferError()                     { return ECP_SIZE_VIEW_BUFFER_ERROR_ID;          }
const QString   nameViewBufferError()                { return ECP_SIZE_VIEW_BUFFER_ERROR_NAME;    }
const QString   defaultViewBufferError()               { return ECP_SIZE_VIEW_BUFFER_ERROR_DEFAULT; }
const int       minViewBufferError()                   { return ECP_SIZE_VIEW_BUFFER_ERROR_MIN;          }
const int       maxViewBufferError()                  { return ECP_SIZE_VIEW_BUFFER_ERROR_MAX;         }
const bool      signedViewBufferError()               { return ECP_SIZE_VIEW_BUFFER_ERROR_SIGNED_VALUE;  }
const int       stepViewBufferError()               { return ECP_SIZE_VIEW_BUFFER_ERROR_SPINBOX_STEP;  }

             // MAX ERROR  LINES CORRECTION PAGE
static const int       ECP_MAX_LINES_ERRORS_CORRECTION_PAGE_ID   = 503; 
static const QString   ECP_MAX_LINES_ERRORS_CORRECTION_PAGE_NAME     = "Change corrections page size";
static const QString   ECP_MAX_LINES_ERRORS_CORRECTION_PAGE_DEFAULT  = "1000";
static const int       ECP_MAX_LINES_ERRORS_CORRECTION_PAGE_MIN  = 500; 
static const int       ECP_MAX_LINES_ERRORS_CORRECTION_PAGE_MAX                     = 5000;
static const int       ECP_MAX_LINES_ERRORS_CORRECTION_PAGE_SPINBOX_STEP                     = 100;
static const bool      ECP_MAX_LINES_ERRORS_CORRECTION_PAGE_SIGNED_VALUE    = FALSE;
const int       idMaxLinesErrorsCorrectonPage()   { return ECP_MAX_LINES_ERRORS_CORRECTION_PAGE_ID;  }
const QString   nameMaxLinesErrorsCorrectonPage()     { return ECP_MAX_LINES_ERRORS_CORRECTION_PAGE_NAME;    }
const QString   defaultMaxLinesErrorsCorrectonPage()  { return ECP_MAX_LINES_ERRORS_CORRECTION_PAGE_DEFAULT; }
const int       minMaxLinesErrorsCorrectonPage()  { return ECP_MAX_LINES_ERRORS_CORRECTION_PAGE_MIN;     }
const int       maxMaxLinesErrorsCorrectonPage()  { return ECP_MAX_LINES_ERRORS_CORRECTION_PAGE_MAX;     }
const bool      signedMaxLinesErrorsCorrectonPage() { return ECP_MAX_LINES_ERRORS_CORRECTION_PAGE_SIGNED_VALUE;  }
const int       stepMaxLinesErrorsCorrectonPage()     { return ECP_MAX_LINES_ERRORS_CORRECTION_PAGE_SPINBOX_STEP;  }

// CATALOG TABLE SPECIFICATIONS:
// Number of catalog record
static const int                 ECP_CATALOG_RECORD_NUMBER_COLUMN       = 0; 
static const QString          ECP_CATALOG_RECORD_HEADER_COLUMN          = " record" ; 
static const QString          ECP_CATALOG_RECORD_HEADER_FONT_METRIC_WIDTH = "19999999" ; 
static const int                  ECP_CATALOG_RECORD_MIN                = 1;  
static const int                  ECP_CATALOG_RECORD_MAX                = 2500000;
static const bool                ECP_CATALOG_RECORD_SIGNED_VALUE                          = FALSE;

const int          numberCatalogRecord()       { return ECP_CATALOG_RECORD_NUMBER_COLUMN;          }
const QString  headerCatalogRecord()         { return ECP_CATALOG_RECORD_HEADER_COLUMN;            }
const QString  fontmetricCatalogRecord()     { return ECP_CATALOG_RECORD_HEADER_FONT_METRIC_WIDTH; }
const int          minCatalogRecord()         { return ECP_CATALOG_RECORD_MIN;                     }
const int          maxCatalogRecord()             { return ECP_CATALOG_RECORD_MAX;                 }
const bool       signedCatalogRecord()          { return ECP_CATALOG_RECORD_SIGNED_VALUE;          }

// Year 

static const int                 ECP_CATALOG_YEAR_NUMBER_COLUMN                      = 0; 
static const QString          ECP_CATALOG_YEAR_HEADER_COLUMN                      = "Y"; 
static const QString          ECP_CATALOG_YEAR_HEADER_FONT_METRIC_WIDTH = "W9999" ; 
static const int                  ECP_CATALOG_YEAR_MIN                                              = 0;
static const int                  ECP_CATALOG_YEAR_MAX                                             = 8000;
static const bool                ECP_CATALOG_YEAR_SIGNED_VALUE                          = FALSE;

const int          numberCatalogYear()       { return ECP_CATALOG_YEAR_NUMBER_COLUMN;                      }
const QString  headerCatalogYear()         { return ECP_CATALOG_YEAR_HEADER_COLUMN;                      }
const QString  fontmetricCatalogYear()     { return ECP_CATALOG_YEAR_HEADER_FONT_METRIC_WIDTH; }
const int          minCatalogYear()              { return ECP_CATALOG_YEAR_MIN;                 }
const int          maxCatalogYear()             { return ECP_CATALOG_YEAR_MAX;                      }
const bool       signedCatalogYear()          { return ECP_CATALOG_YEAR_SIGNED_VALUE;                           }

// Month 

static const int                 ECP_CATALOG_MONTH_NUMBER_COLUMN                      = 1; 
static const QString          ECP_CATALOG_MONTH_HEADER_COLUMN                      = "M"; 
static const QString          ECP_CATALOG_MONTH_HEADER_FONT_METRIC_WIDTH = "W99" ; 
static const int                  ECP_CATALOG_MONTH_MIN                                              = 1;  
static const int                  ECP_CATALOG_MONTH_MAX                                             = 12;
static const bool                ECP_CATALOG_MONTH_SIGNED_VALUE                          = FALSE;

const int          numberCatalogMonth()       { return ECP_CATALOG_MONTH_NUMBER_COLUMN;          }
const QString  headerCatalogMonth()         { return ECP_CATALOG_MONTH_HEADER_COLUMN;            }
const QString  fontmetricCatalogMonth()     { return ECP_CATALOG_MONTH_HEADER_FONT_METRIC_WIDTH; }
const int          minCatalogMonth()              { return ECP_CATALOG_MONTH_MIN;                }
const int          maxCatalogMonth()             { return ECP_CATALOG_MONTH_MAX;                 }
const bool       signedCatalogMonth()          { return ECP_CATALOG_MONTH_SIGNED_VALUE;          }

 // Day 

static const int                 ECP_CATALOG_DAY_NUMBER_COLUMN                      = 2; 
static const QString          ECP_CATALOG_DAY_HEADER_COLUMN                      = "D"; 
static const QString          ECP_CATALOG_DAY_HEADER_FONT_METRIC_WIDTH = "W99" ; 
static const int                  ECP_CATALOG_DAY_MIN                                              = 1;  
static const int                  ECP_CATALOG_DAY_MAX                                             = 31;
static const bool                ECP_CATALOG_DAY_SIGNED_VALUE                          = FALSE;

const int          numberCatalogDay()       { return ECP_CATALOG_DAY_NUMBER_COLUMN;                      }
const QString  headerCatalogDay()         { return ECP_CATALOG_DAY_HEADER_COLUMN;                      }
const QString  fontmetricCatalogDay()     { return ECP_CATALOG_DAY_HEADER_FONT_METRIC_WIDTH; }
const int          minCatalogDay()              { return ECP_CATALOG_DAY_MIN;                }
const int          maxCatalogDay()             { return ECP_CATALOG_DAY_MAX;                 }
const bool       signedCatalogDay()          { return ECP_CATALOG_DAY_SIGNED_VALUE;          }


 // Hour 

static const int                 ECP_CATALOG_HOUR_NUMBER_COLUMN                      = 3; 
static const QString          ECP_CATALOG_HOUR_HEADER_COLUMN                      = "h"; 
static const QString          ECP_CATALOG_HOUR_HEADER_FONT_METRIC_WIDTH = "W99" ; 
static const int                  ECP_CATALOG_HOUR_MIN                                              = 0;  
static const int                  ECP_CATALOG_HOUR_MAX                                             = 23;
static const bool                ECP_CATALOG_HOUR_SIGNED_VALUE                          = FALSE;

const int          numberCatalogHour()       { return ECP_CATALOG_HOUR_NUMBER_COLUMN;                      }
const QString  headerCatalogHour()         { return ECP_CATALOG_HOUR_HEADER_COLUMN;                      }
const QString  fontmetricCatalogHour()     { return ECP_CATALOG_HOUR_HEADER_FONT_METRIC_WIDTH; }
const int          minCatalogHour()              { return ECP_CATALOG_HOUR_MIN;                }
const int          maxCatalogHour()             { return ECP_CATALOG_HOUR_MAX;                 }
const bool       signedCatalogHour()          { return ECP_CATALOG_HOUR_SIGNED_VALUE;                           }


// Minute 

static const int                 ECP_CATALOG_MINUTE_NUMBER_COLUMN                      = 4; 
static const QString          ECP_CATALOG_MINUTE_HEADER_COLUMN                      = "m"; 
static const QString          ECP_CATALOG_MINUTE_HEADER_FONT_METRIC_WIDTH = "W99" ; 
static const int                  ECP_CATALOG_MINUTE_MIN                                              = 0;  
static const int                  ECP_CATALOG_MINUTE_MAX                                             = 59;
static const bool                ECP_CATALOG_MINUTE_SIGNED_VALUE                          = FALSE;

const int          numberCatalogMinute()       { return ECP_CATALOG_MINUTE_NUMBER_COLUMN;                      }
const QString  headerCatalogMinute()         { return ECP_CATALOG_MINUTE_HEADER_COLUMN;                      }
const QString  fontmetricCatalogMinute()     { return ECP_CATALOG_MINUTE_HEADER_FONT_METRIC_WIDTH; }
const int          minCatalogMinute()              { return ECP_CATALOG_MINUTE_MIN;                }
const int          maxCatalogMinute()             { return ECP_CATALOG_MINUTE_MAX;                 }
const bool       signedCatalogMinute()          { return ECP_CATALOG_MINUTE_SIGNED_VALUE;                           }
 
// Second

static const int SECOND_MAGNIFICATION = 100;
const int  secondMagnification()     {return SECOND_MAGNIFICATION;}

static const int                 ECP_CATALOG_SECOND_NUMBER_COLUMN                      = 5; 
static const QString          ECP_CATALOG_SECOND_HEADER_COLUMN                      = "sec"; 
static const QString          ECP_CATALOG_SECOND_HEADER_FONT_METRIC_WIDTH = "W99.99" ; 
static const float               ECP_CATALOG_SECOND_MIN                                              = 0;  
static const float               ECP_CATALOG_SECOND_MAX                                             = (float)59.99;
static const int                  ECP_CATALOG_SECOND_DECIMAL                                      = 2;

const int          numberCatalogSecond()       { return ECP_CATALOG_SECOND_NUMBER_COLUMN;                      }
const QString  headerCatalogSecond()         { return ECP_CATALOG_SECOND_HEADER_COLUMN;                      }
const QString  fontmetricCatalogSecond()     { return ECP_CATALOG_SECOND_HEADER_FONT_METRIC_WIDTH; }
const float       minCatalogSecond()              { return ECP_CATALOG_SECOND_MIN;                 }
const float       maxCatalogSecond()             { return ECP_CATALOG_SECOND_MAX;                  }
const int          decimalCatalogSecond()          { return ECP_CATALOG_SECOND_DECIMAL;            }

 // Latitude
// latitude   >= 100 (bin20 format magnification = 100)
static const int LATITUDE_MAGNIFICATION = 1000;
const int  latitudeMagnification()     {return LATITUDE_MAGNIFICATION;}

static const int                 ECP_CATALOG_LATITUDE_NUMBER_COLUMN                      = 6; 
static const QString          ECP_CATALOG_LATITUDE_HEADER_COLUMN                      = "Lat"; 
static const QString          ECP_CATALOG_LATITUDE_HEADER_FONT_METRIC_WIDTH = "W-89.999" ;
static const float               ECP_CATALOG_LATITUDE_MIN                                              = -90.000;  
static const float               ECP_CATALOG_LATITUDE_MAX                                             = 90.000;
static const int                  ECP_CATALOG_LATITUDE_DECIMAL                                      = 3;

const int          numberCatalogLatitude()       { return ECP_CATALOG_LATITUDE_NUMBER_COLUMN;                      }
const QString  headerCatalogLatitude()         { return ECP_CATALOG_LATITUDE_HEADER_COLUMN;                      }
const QString  fontmetricCatalogLatitude()     { return ECP_CATALOG_LATITUDE_HEADER_FONT_METRIC_WIDTH; }
const float       minCatalogLatitude()              { return ECP_CATALOG_LATITUDE_MIN;                 }
const float       maxCatalogLatitude()             { return ECP_CATALOG_LATITUDE_MAX;                  }
const int          decimalCatalogLatitude()          { return ECP_CATALOG_LATITUDE_DECIMAL;            }

 // Longitude
//longitude   >= 100 (bin20 format magnification = 100)
//-------------------------------Latitude Minimum property ----------------------------------------------------------
static const int        ECP_MINIMUM_PROPERTY_LATITUDE_ID        = 1001; 
static const QString ECP_MINIMUM_PROPERTY_LATITUDE              = "min";
static const QString ECP_MINIMUM_PROPERTY_LATITUDE_DEFAULT      = QString("%1").arg(ECP_CATALOG_LATITUDE_MIN);
static const float      ECP_MINIMUM_PROPERTY_LATITUDE_MIN       = -maxEcpFloat();
static const float      ECP_MINIMUM_PROPERTY_LATITUDE_MAX       = maxEcpFloat();
static const int        ECP_MINIMUM_PROPERTY_LATITUDE_DECIMAL   = 3;
const int          idMinimumPropertyLatitude()        { return ECP_MINIMUM_PROPERTY_LATITUDE_ID;        }
const QString  nameMinimumPropertyLatitude()          { return ECP_MINIMUM_PROPERTY_LATITUDE;           }
const QString defaultMinimumPropertyLatitude()        { return ECP_MINIMUM_PROPERTY_LATITUDE_DEFAULT;   }
const float      minMinimumPropertyLatitude()         { return ECP_MINIMUM_PROPERTY_LATITUDE_MIN;       }
const float      maxMinimumPropertyLatitude()         { return ECP_MINIMUM_PROPERTY_LATITUDE_MAX;       }
const int        decimalMinimumPropertyLatitude()     { return ECP_MINIMUM_PROPERTY_LATITUDE_DECIMAL;   }
//--------------------------------------------------------------------------------------------------------------
//-------------------------------Latitude Maximum property ----------------------------------------------------------
static const int        ECP_MAXIMUM_PROPERTY_LATITUDE_ID         = 1002; 
static const QString ECP_MAXIMUM_PROPERTY_LATITUDE               = "max";
static const QString ECP_MAXIMUM_PROPERTY_LATITUDE_DEFAULT       = QString("%1").arg(ECP_CATALOG_LATITUDE_MAX);
static const float      ECP_MAXIMUM_PROPERTY_LATITUDE_MIN        = -maxEcpFloat();
static const float      ECP_MAXIMUM_PROPERTY_LATITUDE_MAX        = maxEcpFloat();
static const int        ECP_MAXIMUM_PROPERTY_LATITUDE_DECIMAL    = 3;
const int          idMaximumPropertyLatitude()        { return ECP_MAXIMUM_PROPERTY_LATITUDE_ID;         }
const QString  nameMaximumPropertyLatitude()          { return ECP_MAXIMUM_PROPERTY_LATITUDE;            }
const QString defaultMaximumPropertyLatitude()        { return ECP_MAXIMUM_PROPERTY_LATITUDE_DEFAULT;    }
const float      minMaximumPropertyLatitude()         { return ECP_MAXIMUM_PROPERTY_LATITUDE_MIN;        }
const float      maxMaximumPropertyLatitude()         { return ECP_MAXIMUM_PROPERTY_LATITUDE_MAX;        }
const int        decimalMaximumPropertyLatitude()     { return ECP_MAXIMUM_PROPERTY_LATITUDE_DECIMAL;    }
//--------------------------------------------------------------------------------------------------------------

static const int LONGITUDE_MAGNIFICATION = 1000;
const int  longitudeMagnification()   {return LONGITUDE_MAGNIFICATION;}

static const int                 ECP_CATALOG_LONGITUDE_NUMBER_COLUMN                      = 7; 
static const QString          ECP_CATALOG_LONGITUDE_HEADER_COLUMN                      = "Lon"; 
static const QString          ECP_CATALOG_LONGITUDE_HEADER_FONT_METRIC_WIDTH = "W-199.999" ;
static const float               ECP_CATALOG_LONGITUDE_MIN                                              = -180.000;  
static const float               ECP_CATALOG_LONGITUDE_MAX                                             = 180.000;
static const int                  ECP_CATALOG_LONGITUDE_DECIMAL                                      = 3;

const int          numberCatalogLongitude()       { return ECP_CATALOG_LONGITUDE_NUMBER_COLUMN;         }
const QString  headerCatalogLongitude()         { return ECP_CATALOG_LONGITUDE_HEADER_COLUMN;           }
const QString  fontmetricCatalogLongitude()     { return ECP_CATALOG_LONGITUDE_HEADER_FONT_METRIC_WIDTH; }
const float       minCatalogLongitude()              { return ECP_CATALOG_LONGITUDE_MIN;        }
const float       maxCatalogLongitude()             { return ECP_CATALOG_LONGITUDE_MAX;         }
const int          decimalCatalogLongitude()          { return ECP_CATALOG_LONGITUDE_DECIMAL;   }

//-------------------------------Longitude Minimum property ----------------------------------------------------------
static const int        ECP_MINIMUM_PROPERTY_LONGITUDE_ID        = 1003; 
static const QString ECP_MINIMUM_PROPERTY_LONGITUDE              = "min";
static const QString ECP_MINIMUM_PROPERTY_LONGITUDE_DEFAULT      = QString("%1").arg(ECP_CATALOG_LONGITUDE_MIN);
static const float      ECP_MINIMUM_PROPERTY_LONGITUDE_MIN       = -maxEcpFloat();
static const float      ECP_MINIMUM_PROPERTY_LONGITUDE_MAX       = maxEcpFloat();
static const int        ECP_MINIMUM_PROPERTY_LONGITUDE_DECIMAL   = 3;
const int          idMinimumPropertyLongitude()        { return ECP_MINIMUM_PROPERTY_LONGITUDE_ID;        }
const QString  nameMinimumPropertyLongitude()          { return ECP_MINIMUM_PROPERTY_LONGITUDE;           }
const QString defaultMinimumPropertyLongitude()        { return ECP_MINIMUM_PROPERTY_LONGITUDE_DEFAULT;   }
const float      minMinimumPropertyLongitude()         { return ECP_MINIMUM_PROPERTY_LONGITUDE_MIN;       }
const float      maxMinimumPropertyLongitude()         { return ECP_MINIMUM_PROPERTY_LONGITUDE_MAX;       }
const int        decimalMinimumPropertyLongitude()     { return ECP_MINIMUM_PROPERTY_LONGITUDE_DECIMAL;   }
//--------------------------------------------------------------------------------------------------------------
//-------------------------------Longitude Maximum property ----------------------------------------------------------
static const int        ECP_MAXIMUM_PROPERTY_LONGITUDE_ID         = 1004; 
static const QString ECP_MAXIMUM_PROPERTY_LONGITUDE               = "max";
static const QString ECP_MAXIMUM_PROPERTY_LONGITUDE_DEFAULT       = QString("%1").arg(ECP_CATALOG_LONGITUDE_MAX);
static const float      ECP_MAXIMUM_PROPERTY_LONGITUDE_MIN        = -maxEcpFloat();
static const float      ECP_MAXIMUM_PROPERTY_LONGITUDE_MAX        = maxEcpFloat();
static const int        ECP_MAXIMUM_PROPERTY_LONGITUDE_DECIMAL    = 3;
const int          idMaximumPropertyLongitude()        { return ECP_MAXIMUM_PROPERTY_LONGITUDE_ID;         }
const QString  nameMaximumPropertyLongitude()          { return ECP_MAXIMUM_PROPERTY_LONGITUDE;            }
const QString defaultMaximumPropertyLongitude()        { return ECP_MAXIMUM_PROPERTY_LONGITUDE_DEFAULT;    }
const float      minMaximumPropertyLongitude()         { return ECP_MAXIMUM_PROPERTY_LONGITUDE_MIN;        }
const float      maxMaximumPropertyLongitude()         { return ECP_MAXIMUM_PROPERTY_LONGITUDE_MAX;        }
const int        decimalMaximumPropertyLongitude()     { return ECP_MAXIMUM_PROPERTY_LONGITUDE_DECIMAL;    }
//--------------------------------------------------------------------------------------------------------------

 // Depth
// depth  >= 1 (bin20 format magnification = 1)
static const int DEPTH_MAGNIFICATION = 10;
const int  depthMagnification()        {return DEPTH_MAGNIFICATION;}

static const int                 ECP_CATALOG_DEPTH_NUMBER_COLUMN                      = 8; 
static const QString          ECP_CATALOG_DEPTH_HEADER_COLUMN                      = "Dep"; 
static const QString          ECP_CATALOG_DEPTH_HEADER_FONT_METRIC_WIDTH = "W999.9" ; 
static const float               ECP_CATALOG_DEPTH_MIN                                              = -10.0;  
static const float               ECP_CATALOG_DEPTH_MAX                                             = (float)999;
static const int                  ECP_CATALOG_DEPTH_DECIMAL                                      = 1;

const int          numberCatalogDepth()       { return ECP_CATALOG_DEPTH_NUMBER_COLUMN;          }
const QString  headerCatalogDepth()         { return ECP_CATALOG_DEPTH_HEADER_COLUMN;            }
const QString  fontmetricCatalogDepth()     { return ECP_CATALOG_DEPTH_HEADER_FONT_METRIC_WIDTH; }
const float       minCatalogDepth()              { return ECP_CATALOG_DEPTH_MIN;                 }
const float       maxCatalogDepth()             { return ECP_CATALOG_DEPTH_MAX;                  }
const int          decimalCatalogDepth()        { return ECP_CATALOG_DEPTH_DECIMAL;              }

//-------------------------------Depth Minimum property ----------------------------------------------------------
static const int        ECP_MINIMUM_PROPERTY_DEPTH_ID        = 1005; 
static const QString ECP_MINIMUM_PROPERTY_DEPTH              = "min";
static const QString ECP_MINIMUM_PROPERTY_DEPTH_DEFAULT      = QString("%1").arg(ECP_CATALOG_DEPTH_MIN);
static const float      ECP_MINIMUM_PROPERTY_DEPTH_MIN       = -maxEcpFloat();
static const float      ECP_MINIMUM_PROPERTY_DEPTH_MAX       = maxEcpFloat();
static const int        ECP_MINIMUM_PROPERTY_DEPTH_DECIMAL   = 3;
const int          idMinimumPropertyDepth()        { return ECP_MINIMUM_PROPERTY_DEPTH_ID;        }
const QString  nameMinimumPropertyDepth()          { return ECP_MINIMUM_PROPERTY_DEPTH;           }
const QString defaultMinimumPropertyDepth()        { return ECP_MINIMUM_PROPERTY_DEPTH_DEFAULT;   }
const float      minMinimumPropertyDepth()         { return ECP_MINIMUM_PROPERTY_DEPTH_MIN;       }
const float      maxMinimumPropertyDepth()         { return ECP_MINIMUM_PROPERTY_DEPTH_MAX;       }
const int        decimalMinimumPropertyDepth()     { return ECP_MINIMUM_PROPERTY_DEPTH_DECIMAL;   }
//--------------------------------------------------------------------------------------------------------------
//-------------------------------Depth Maximum property ----------------------------------------------------------
static const int        ECP_MAXIMUM_PROPERTY_DEPTH_ID         = 1006; 
static const QString ECP_MAXIMUM_PROPERTY_DEPTH               = "max";
static const QString ECP_MAXIMUM_PROPERTY_DEPTH_DEFAULT       = QString("%1").arg(ECP_CATALOG_DEPTH_MAX);
static const float      ECP_MAXIMUM_PROPERTY_DEPTH_MIN        = -maxEcpFloat();
static const float      ECP_MAXIMUM_PROPERTY_DEPTH_MAX        = maxEcpFloat();
static const int        ECP_MAXIMUM_PROPERTY_DEPTH_DECIMAL    = 3;
const int          idMaximumPropertyDepth()        { return ECP_MAXIMUM_PROPERTY_DEPTH_ID;         }
const QString  nameMaximumPropertyDepth()          { return ECP_MAXIMUM_PROPERTY_DEPTH;            }
const QString defaultMaximumPropertyDepth()        { return ECP_MAXIMUM_PROPERTY_DEPTH_DEFAULT;    }
const float      minMaximumPropertyDepth()         { return ECP_MAXIMUM_PROPERTY_DEPTH_MIN;        }
const float      maxMaximumPropertyDepth()         { return ECP_MAXIMUM_PROPERTY_DEPTH_MAX;        }
const int        decimalMaximumPropertyDepth()     { return ECP_MAXIMUM_PROPERTY_DEPTH_DECIMAL;    }
//--------------------------------------------------------------------------------------------------------------

// Magnitudes


// magnitude  >= 100 (bin20 format magnification = 100)
static const int MAGNITUDE_MAGNIFICATION = 100;
const int  magnitudeMagnification() {return MAGNITUDE_MAGNIFICATION;}

// Mb

static const int                 ECP_CATALOG_MB_NUMBER_COLUMN                      = 9; 
static const QString          ECP_CATALOG_MB_HEADER_COLUMN                      = "M1"; 
static const QString          ECP_CATALOG_MB_HEADER_FONT_METRIC_WIDTH = "-19.99" ; 
static const float               ECP_CATALOG_MB_MIN                                              = -10.0; 
static const float               ECP_CATALOG_MB_MAX                                             = 10.0;
static const int                  ECP_CATALOG_MB_DECIMAL                                      = 2;

const int          numberCatalogMb()       { return ECP_CATALOG_MB_NUMBER_COLUMN;                      }
const QString  headerCatalogMb()         { return ECP_CATALOG_MB_HEADER_COLUMN;                      }
const QString  fontmetricCatalogMb()     { return ECP_CATALOG_MB_HEADER_FONT_METRIC_WIDTH; }
const float       minCatalogMb()              { return ECP_CATALOG_MB_MIN;                                              }
const float       maxCatalogMb()             { return ECP_CATALOG_MB_MAX;                                             }
const int          decimalCatalogMb()          { return ECP_CATALOG_MB_DECIMAL;                                    }
//-------------------------------Mb Minimum property ----------------------------------------------------------
static const int        ECP_MINIMUM_PROPERTY_MB_ID               = 1007; 
static const QString ECP_MINIMUM_PROPERTY_MB                    = "min";
static const QString ECP_MINIMUM_PROPERTY_MB_DEFAULT   = QString("%1").arg(ECP_CATALOG_MB_MIN);
static const float      ECP_MINIMUM_PROPERTY_MB_MIN            = -maxEcpFloat();
static const float      ECP_MINIMUM_PROPERTY_MB_MAX           = maxEcpFloat();
static const int        ECP_MINIMUM_PROPERTY_MB_DECIMAL    = 2;
const int          idMinimumPropertyMb()               { return ECP_MINIMUM_PROPERTY_MB_ID;                }
const QString  nameMinimumPropertyMb()          { return ECP_MINIMUM_PROPERTY_MB;                      }
const QString defaultMinimumPropertyMb()         { return ECP_MINIMUM_PROPERTY_MB_DEFAULT;      }
const float      minMinimumPropertyMb()              { return ECP_MINIMUM_PROPERTY_MB_MIN;               }
const float      maxMinimumPropertyMb()             { return ECP_MINIMUM_PROPERTY_MB_MAX;              }
const int        decimalMinimumPropertyMb()         { return ECP_MINIMUM_PROPERTY_MB_DECIMAL;      }
//--------------------------------------------------------------------------------------------------------------
//-------------------------------Mb Maximum property ----------------------------------------------------------
static const int        ECP_MAXIMUM_PROPERTY_MB_ID               = 1008; 
static const QString ECP_MAXIMUM_PROPERTY_MB                    = "max";
static const QString ECP_MAXIMUM_PROPERTY_MB_DEFAULT   = QString("%1").arg(ECP_CATALOG_MB_MAX);
static const float      ECP_MAXIMUM_PROPERTY_MB_MIN            = -maxEcpFloat();
static const float      ECP_MAXIMUM_PROPERTY_MB_MAX           = maxEcpFloat();
static const int        ECP_MAXIMUM_PROPERTY_MB_DECIMAL    = 2;
const int          idMaximumPropertyMb()               { return ECP_MAXIMUM_PROPERTY_MB_ID;                }
const QString  nameMaximumPropertyMb()          { return ECP_MAXIMUM_PROPERTY_MB;                      }
const QString defaultMaximumPropertyMb()         { return ECP_MAXIMUM_PROPERTY_MB_DEFAULT;      }
const float      minMaximumPropertyMb()              { return ECP_MAXIMUM_PROPERTY_MB_MIN;               }
const float      maxMaximumPropertyMb()             { return ECP_MAXIMUM_PROPERTY_MB_MAX;              }
const int        decimalMaximumPropertyMb()         { return ECP_MAXIMUM_PROPERTY_MB_DECIMAL;      }
//--------------------------------------------------------------------------------------------------------------

// Ms

static const int                 ECP_CATALOG_MS_NUMBER_COLUMN                      = 10; 
static const QString          ECP_CATALOG_MS_HEADER_COLUMN                      = "M2"; 
static const QString          ECP_CATALOG_MS_HEADER_FONT_METRIC_WIDTH = "-19.99" ; 
static const float               ECP_CATALOG_MS_MIN                                              = -10.0;  
static const float               ECP_CATALOG_MS_MAX                                             = 10.0;
static const int                  ECP_CATALOG_MS_DECIMAL                                      = 2;

const int          numberCatalogMs()       { return ECP_CATALOG_MS_NUMBER_COLUMN;                      }
const QString  headerCatalogMs()         { return ECP_CATALOG_MS_HEADER_COLUMN;                      }
const QString  fontmetricCatalogMs()     { return ECP_CATALOG_MS_HEADER_FONT_METRIC_WIDTH; }
const float       minCatalogMs()              { return ECP_CATALOG_MS_MIN;                                              }
const float       maxCatalogMs()             { return ECP_CATALOG_MS_MAX;                                             }
const int          decimalCatalogMs()          { return ECP_CATALOG_MS_DECIMAL;                                    }
//-------------------------------Ms Minimum property ----------------------------------------------------------
static const int        ECP_MINIMUM_PROPERTY_MS_ID               = 1009; 
static const QString ECP_MINIMUM_PROPERTY_MS                    = "min";
static const QString ECP_MINIMUM_PROPERTY_MS_DEFAULT   = QString("%1").arg(ECP_CATALOG_MS_MIN);
static const float      ECP_MINIMUM_PROPERTY_MS_MIN            = -maxEcpFloat();
static const float      ECP_MINIMUM_PROPERTY_MS_MAX           = maxEcpFloat();
static const int        ECP_MINIMUM_PROPERTY_MS_DECIMAL    = 2;
const int          idMinimumPropertyMs()               { return ECP_MINIMUM_PROPERTY_MS_ID;                }
const QString  nameMinimumPropertyMs()          { return ECP_MINIMUM_PROPERTY_MS;                      }
const QString defaultMinimumPropertyMs()         { return ECP_MINIMUM_PROPERTY_MS_DEFAULT;      }
const float      minMinimumPropertyMs()              { return ECP_MINIMUM_PROPERTY_MS_MIN;               }
const float      maxMinimumPropertyMs()             { return ECP_MINIMUM_PROPERTY_MS_MAX;              }
const int        decimalMinimumPropertyMs()         { return ECP_MINIMUM_PROPERTY_MS_DECIMAL;      }
//--------------------------------------------------------------------------------------------------------------
//-------------------------------Ms Maximum property ----------------------------------------------------------
static const int        ECP_MAXIMUM_PROPERTY_MS_ID               = 1010; 
static const QString ECP_MAXIMUM_PROPERTY_MS                    = "max";
static const QString ECP_MAXIMUM_PROPERTY_MS_DEFAULT   = QString("%1").arg(ECP_CATALOG_MS_MAX);
static const float      ECP_MAXIMUM_PROPERTY_MS_MIN            = -maxEcpFloat();
static const float      ECP_MAXIMUM_PROPERTY_MS_MAX           = maxEcpFloat();
static const int        ECP_MAXIMUM_PROPERTY_MS_DECIMAL    = 2;
const int          idMaximumPropertyMs()               { return ECP_MAXIMUM_PROPERTY_MS_ID;                }
const QString  nameMaximumPropertyMs()          { return ECP_MAXIMUM_PROPERTY_MS;                      }
const QString defaultMaximumPropertyMs()         { return ECP_MAXIMUM_PROPERTY_MS_DEFAULT;      }
const float      minMaximumPropertyMs()              { return ECP_MAXIMUM_PROPERTY_MS_MIN;               }
const float      maxMaximumPropertyMs()             { return ECP_MAXIMUM_PROPERTY_MS_MAX;              }
const int        decimalMaximumPropertyMs()         { return ECP_MAXIMUM_PROPERTY_MS_DECIMAL;      }
//--------------------------------------------------------------------------------------------------------------

// Ml

static const int                 ECP_CATALOG_ML_NUMBER_COLUMN                      = 11; 
static const QString          ECP_CATALOG_ML_HEADER_COLUMN                      = "M3"; 
static const QString          ECP_CATALOG_ML_HEADER_FONT_METRIC_WIDTH = "-19.99" ; 
static const float               ECP_CATALOG_ML_MIN                                              = -10.0;  
static const float               ECP_CATALOG_ML_MAX                                             = 10.0;
static const int                  ECP_CATALOG_ML_DECIMAL                                      = 2;

const int          numberCatalogMl()       { return ECP_CATALOG_ML_NUMBER_COLUMN;                      }
const QString  headerCatalogMl()         { return ECP_CATALOG_ML_HEADER_COLUMN;                      }
const QString  fontmetricCatalogMl()     { return ECP_CATALOG_ML_HEADER_FONT_METRIC_WIDTH; }
const float       minCatalogMl()              { return ECP_CATALOG_ML_MIN;                                              }
const float       maxCatalogMl()             { return ECP_CATALOG_ML_MAX;                                             }
const int          decimalCatalogMl()          { return ECP_CATALOG_ML_DECIMAL;                                    }
//-------------------------------Ml Minimum property ----------------------------------------------------------
static const int        ECP_MINIMUM_PROPERTY_ML_ID               = 1011; 
static const QString ECP_MINIMUM_PROPERTY_ML                    = "min";
static const QString ECP_MINIMUM_PROPERTY_ML_DEFAULT   = QString("%1").arg(ECP_CATALOG_ML_MIN);
static const float      ECP_MINIMUM_PROPERTY_ML_MIN            = -maxEcpFloat();
static const float      ECP_MINIMUM_PROPERTY_ML_MAX           = maxEcpFloat();
static const int        ECP_MINIMUM_PROPERTY_ML_DECIMAL    = 2;
const int          idMinimumPropertyMl()               { return ECP_MINIMUM_PROPERTY_ML_ID;                }
const QString  nameMinimumPropertyMl()          { return ECP_MINIMUM_PROPERTY_ML;                      }
const QString defaultMinimumPropertyMl()         { return ECP_MINIMUM_PROPERTY_ML_DEFAULT;      }
const float      minMinimumPropertyMl()              { return ECP_MINIMUM_PROPERTY_ML_MIN;               }
const float      maxMinimumPropertyMl()             { return ECP_MINIMUM_PROPERTY_ML_MAX;              }
const int        decimalMinimumPropertyMl()         { return ECP_MINIMUM_PROPERTY_ML_DECIMAL;      }
//--------------------------------------------------------------------------------------------------------------
//-------------------------------Ml Maximum property ----------------------------------------------------------
static const int        ECP_MAXIMUM_PROPERTY_ML_ID               = 1012; 
static const QString ECP_MAXIMUM_PROPERTY_ML                    = "max";
static const QString ECP_MAXIMUM_PROPERTY_ML_DEFAULT   = QString("%1").arg(ECP_CATALOG_ML_MAX);
static const float      ECP_MAXIMUM_PROPERTY_ML_MIN            = -maxEcpFloat();
static const float      ECP_MAXIMUM_PROPERTY_ML_MAX           = maxEcpFloat();
static const int        ECP_MAXIMUM_PROPERTY_ML_DECIMAL    = 2;
const int          idMaximumPropertyMl()               { return ECP_MAXIMUM_PROPERTY_ML_ID;                }
const QString  nameMaximumPropertyMl()          { return ECP_MAXIMUM_PROPERTY_ML;                      }
const QString defaultMaximumPropertyMl()         { return ECP_MAXIMUM_PROPERTY_ML_DEFAULT;      }
const float      minMaximumPropertyMl()              { return ECP_MAXIMUM_PROPERTY_ML_MIN;               }
const float      maxMaximumPropertyMl()             { return ECP_MAXIMUM_PROPERTY_ML_MAX;              }
const int        decimalMaximumPropertyMl()         { return ECP_MAXIMUM_PROPERTY_ML_DECIMAL;      }
//--------------------------------------------------------------------------------------------------------------

// Mp

static const int                 ECP_CATALOG_MP_NUMBER_COLUMN                      = 12; 
static const QString          ECP_CATALOG_MP_HEADER_COLUMN                      = "M4"; 
static const QString          ECP_CATALOG_MP_HEADER_FONT_METRIC_WIDTH = "-19.99" ; 
static const float               ECP_CATALOG_MP_MIN                                              = -10.0;  
static const float               ECP_CATALOG_MP_MAX                                             = 10.0;
static const int                  ECP_CATALOG_MP_DECIMAL                                      = 2;

const int          numberCatalogMp()       { return ECP_CATALOG_MP_NUMBER_COLUMN;                      }
const QString  headerCatalogMp()         { return ECP_CATALOG_MP_HEADER_COLUMN;                      }
const QString  fontmetricCatalogMp()     { return ECP_CATALOG_MP_HEADER_FONT_METRIC_WIDTH; }
const float       minCatalogMp()              { return ECP_CATALOG_MP_MIN;                                              }
const float       maxCatalogMp()             { return ECP_CATALOG_MP_MAX;                                             }
const int          decimalCatalogMp()          { return ECP_CATALOG_MP_DECIMAL;                                    }
//-------------------------------Mp Minimum property ----------------------------------------------------------
static const int        ECP_MINIMUM_PROPERTY_MP_ID               = 1013; 
static const QString ECP_MINIMUM_PROPERTY_MP                    = "min";
static const QString ECP_MINIMUM_PROPERTY_MP_DEFAULT   = QString("%1").arg(ECP_CATALOG_MP_MIN);
static const float      ECP_MINIMUM_PROPERTY_MP_MIN            = -maxEcpFloat();
static const float      ECP_MINIMUM_PROPERTY_MP_MAX           = maxEcpFloat();
static const int        ECP_MINIMUM_PROPERTY_MP_DECIMAL    = 2;
const int          idMinimumPropertyMp()               { return ECP_MINIMUM_PROPERTY_MP_ID;                }
const QString  nameMinimumPropertyMp()          { return ECP_MINIMUM_PROPERTY_MP;                      }
const QString defaultMinimumPropertyMp()         { return ECP_MINIMUM_PROPERTY_MP_DEFAULT;      }
const float      minMinimumPropertyMp()              { return ECP_MINIMUM_PROPERTY_MP_MIN;               }
const float      maxMinimumPropertyMp()             { return ECP_MINIMUM_PROPERTY_MP_MAX;              }
const int        decimalMinimumPropertyMp()         { return ECP_MINIMUM_PROPERTY_MP_DECIMAL;      }
//--------------------------------------------------------------------------------------------------------------
//-------------------------------Mp Maximum property ----------------------------------------------------------
static const int        ECP_MAXIMUM_PROPERTY_MP_ID               = 1014; 
static const QString ECP_MAXIMUM_PROPERTY_MP                    = "max";
static const QString ECP_MAXIMUM_PROPERTY_MP_DEFAULT   = QString("%1").arg(ECP_CATALOG_MP_MAX);
static const float      ECP_MAXIMUM_PROPERTY_MP_MIN            = -maxEcpFloat();
static const float      ECP_MAXIMUM_PROPERTY_MP_MAX           = maxEcpFloat();
static const int        ECP_MAXIMUM_PROPERTY_MP_DECIMAL    = 2;
const int          idMaximumPropertyMp()               { return ECP_MAXIMUM_PROPERTY_MP_ID;                }
const QString  nameMaximumPropertyMp()          { return ECP_MAXIMUM_PROPERTY_MP;                      }
const QString defaultMaximumPropertyMp()         { return ECP_MAXIMUM_PROPERTY_MP_DEFAULT;      }
const float      minMaximumPropertyMp()              { return ECP_MAXIMUM_PROPERTY_MP_MIN;               }
const float      maxMaximumPropertyMp()             { return ECP_MAXIMUM_PROPERTY_MP_MAX;              }
const int        decimalMaximumPropertyMp()         { return ECP_MAXIMUM_PROPERTY_MP_DECIMAL;      }
//--------------------------------------------------------------------------------------------------------------

// Intensity

static const int                 ECP_CATALOG_INTENSITY_NUMBER_COLUMN                      = 13; 
static const QString          ECP_CATALOG_INTENSITY_HEADER_COLUMN                      = "I"; 
static const QString          ECP_CATALOG_INTENSITY_HEADER_FONT_METRIC_WIDTH = "W19" ; 
static const int                  ECP_CATALOG_INTENSITY_MIN                                              = 0;  
static const int                  ECP_CATALOG_INTENSITY_MAX                                             = 12;
static const bool                ECP_CATALOG_INTENSITY_SIGNED_VALUE                          = FALSE;

const int          numberCatalogIntensity()       { return ECP_CATALOG_INTENSITY_NUMBER_COLUMN;                     }
const QString  headerCatalogIntensity()         { return ECP_CATALOG_INTENSITY_HEADER_COLUMN;                    }
const QString  fontmetricCatalogIntensity()     { return ECP_CATALOG_INTENSITY_HEADER_FONT_METRIC_WIDTH; }
const int          minCatalogIntensity()              { return ECP_CATALOG_INTENSITY_MIN;                                                 }
const int          maxCatalogIntensity()             { return ECP_CATALOG_INTENSITY_MAX;                                               }
const bool       signedCatalogIntensity()          { return ECP_CATALOG_INTENSITY_SIGNED_VALUE;                     }

// Comment
static const int                 ECP_CATALOG_COMMENT_NUMBER_COLUMN                      = 14; 
static const QString          ECP_CATALOG_COMMENT_HEADER_COLUMN                      = "#" ; 

const int          numberCatalogComment()        { return ECP_CATALOG_COMMENT_NUMBER_COLUMN;                      }
const QString  headerCatalogComment()          { return ECP_CATALOG_COMMENT_HEADER_COLUMN;                      }

static const int  ECP_CATALOG_NUMBER_COLUMNS                  = 15; 
const int          numberCatalogColumns()        { return ECP_CATALOG_NUMBER_COLUMNS;  }          


// ERROR TABLE SPECIFICATIONS
static const int                 ECP_ERROR_RECORD_NUMBER_COLUMN                      = 0; 
static const QString          ECP_ERROR_RECORD_HEADER_COLUMN                      = "Record" ; 
static const QString          ECP_ERROR_RECORD_HEADER_FONT_METRIC_WIDTH = "1Record1" ; 

const int          numberErrorRecord()        { return ECP_ERROR_RECORD_NUMBER_COLUMN;                      }
const QString  headerErrorRecord()          { return ECP_ERROR_RECORD_HEADER_COLUMN;                      }
const QString  fontmetricErrorRecord()      { return ECP_ERROR_RECORD_HEADER_FONT_METRIC_WIDTH; }


static const int                 ECP_ERROR_CHECK_NUMBER_COLUMN                      = 1; 
static const QString          ECP_ERROR_CHECK_HEADER_COLUMN                      = " " ; 
static const QString          ECP_ERROR_CHECK_HEADER_COLUMN_PIXMAP                      = "error.png"  ; 
const int          numberErrorCheck()        { return ECP_ERROR_CHECK_NUMBER_COLUMN;                      }
const QString  headerErrorCheck()          { return ECP_ERROR_CHECK_HEADER_COLUMN;                      }
const QString  pixmapErrorCheck()          { return ECP_ERROR_CHECK_HEADER_COLUMN_PIXMAP; }
	
static const int                 ECP_ERROR_DESCRIPTION_NUMBER_COLUMN                      = 2; 
static const QString          ECP_ERROR_DESCRIPTION_HEADER_COLUMN                      = "Description" ; 
const int          numberErrorDescriptionRecord()        { return ECP_ERROR_DESCRIPTION_NUMBER_COLUMN;  }
const QString  headerErrorDescriptionRecord()          { return ECP_ERROR_DESCRIPTION_HEADER_COLUMN;  }

static const int                 ECP_ERROR_LINE_NUMBER_COLUMN                      = 3; 
static const QString          ECP_ERROR_LINE_HEADER_COLUMN                      = "#" ;
                                                                        
static const QString          ECP_ERROR_LINE_HEADER_FONT_METRIC_WIDTH = "19999999" ; 
const int          numberErrorLine()        { return ECP_ERROR_LINE_NUMBER_COLUMN;                      }
const QString  headerErrorLine()          { return ECP_ERROR_LINE_HEADER_COLUMN;                      }
const QString  fontmetricErrorLine()      { return ECP_ERROR_LINE_HEADER_FONT_METRIC_WIDTH; }

            //   ERROR DESCRIPTIONS DONT USE CHARACTER '@' !!!!
// Patern range error
static const QString          ECP_ERROR_RANGE_PATTERN                      = "  %1 (%2) is out of range"; 
//   %1 -  numberError   %2  nameError %3 parametr name 
const QString  errorRangePattern()          { return ECP_ERROR_RANGE_PATTERN;     }
static const QString          ECP_ERROR_VALID_PATTERN                      = "  %1 is invalid"; 
//   %1 -  numberError   %2  nameError %3 parametr name 
const QString  errorValidPattern()          { return ECP_ERROR_VALID_PATTERN;     }


// Year
static const QString          ECP_ERROR_YEAR_NUMBER                      = "R101"; 
static const QString          ECP_ERROR_YEAR_NAME                         = "Year" ; 
const QString  numberErrorYear()               { return ECP_ERROR_YEAR_NUMBER;     }
const QString  nameErrorYear()                  { return ECP_ERROR_YEAR_NAME;     }
// Month
static const QString          ECP_ERROR_MONTH_NUMBER                      = "R102"; 
static const QString          ECP_ERROR_MONTH_NAME                         = "Month" ; 
const QString  numberErrorMonth()               { return ECP_ERROR_MONTH_NUMBER;     }
const QString  nameErrorMonth()                  { return ECP_ERROR_MONTH_NAME;     }
// Day
static const QString          ECP_ERROR_DAY_NUMBER                      = "R103"; 
static const QString          ECP_ERROR_DAY_NAME                         = "Day" ; 
const QString  numberErrorDay()               { return ECP_ERROR_DAY_NUMBER;     }
const QString  nameErrorDay()                  { return ECP_ERROR_DAY_NAME;     }
// Hour
static const QString          ECP_ERROR_HOUR_NUMBER                      = "R104"; 
static const QString          ECP_ERROR_HOUR_NAME                         = "Hour" ; 
const QString  numberErrorHour()               { return ECP_ERROR_HOUR_NUMBER;     }
const QString  nameErrorHour()                  { return ECP_ERROR_HOUR_NAME;     }
// Minute
static const QString          ECP_ERROR_MINUTE_NUMBER                      = "R105"; 
static const QString          ECP_ERROR_MINUTE_NAME                         = "Minute" ; 
const QString  numberErrorMinute()               { return ECP_ERROR_MINUTE_NUMBER;     }
const QString  nameErrorMinute()                  { return ECP_ERROR_MINUTE_NAME;     }
// Second
static const QString          ECP_ERROR_SECOND_NUMBER                      = "R106"; 
static const QString          ECP_ERROR_SECOND_NAME                         = "Second" ; 
const QString  numberErrorSecond()               { return ECP_ERROR_SECOND_NUMBER;     }
const QString  nameErrorSecond()                  { return ECP_ERROR_SECOND_NAME;     }
// Latitude
static const QString          ECP_ERROR_LATITUDE_NUMBER                      = "R107"; 
static const QString          ECP_ERROR_LATITUDE_NAME                         = "Latitude" ; 
const QString  numberErrorLatitude()               { return ECP_ERROR_LATITUDE_NUMBER;     }
const QString  nameErrorLatitude()                  { return ECP_ERROR_LATITUDE_NAME;     }
// Longitude
static const QString          ECP_ERROR_LONGITUDE_NUMBER                      = "R108"; 
static const QString          ECP_ERROR_LONGITUDE_NAME                         = "Longitude" ; 
const QString  numberErrorLongitude()               { return ECP_ERROR_LONGITUDE_NUMBER;     }
const QString  nameErrorLongitude()                  { return ECP_ERROR_LONGITUDE_NAME;     }
// Depth
static const QString          ECP_ERROR_DEPTH_NUMBER                      = "R109"; 
static const QString          ECP_ERROR_DEPTH_NAME                         = "Depth" ; 
const QString  numberErrorDepth()               { return ECP_ERROR_DEPTH_NUMBER;     }
const QString  nameErrorDepth()                  { return ECP_ERROR_DEPTH_NAME;     }
// Mb
static const QString          ECP_ERROR_MB_NUMBER                      = "R109"; 
static const QString          ECP_ERROR_MB_NAME                         = "M1" ; 
const QString  numberErrorMb()               { return ECP_ERROR_MB_NUMBER;     }
const QString  nameErrorMb()                  { return ECP_ERROR_MB_NAME;     }
// Ms
static const QString          ECP_ERROR_MS_NUMBER                      = "R110"; 
static const QString          ECP_ERROR_MS_NAME                         = "M2" ; 
const QString  numberErrorMs()               { return ECP_ERROR_MS_NUMBER;     }
const QString  nameErrorMs()                  { return ECP_ERROR_MS_NAME;     }
// Mp
static const QString          ECP_ERROR_MP_NUMBER                      = "R111"; 
static const QString          ECP_ERROR_MP_NAME                         = "M3" ; 
const QString  numberErrorMp()               { return ECP_ERROR_MP_NUMBER;     }
const QString  nameErrorMp()                  { return ECP_ERROR_MP_NAME;     }
// Ml
static const QString          ECP_ERROR_ML_NUMBER                      = "R112"; 
static const QString          ECP_ERROR_ML_NAME                         = "M4" ; 
const QString  numberErrorMl()               { return ECP_ERROR_ML_NUMBER;     }
const QString  nameErrorMl()                  { return ECP_ERROR_ML_NAME;     }
// Intensity
static const QString          ECP_ERROR_INTENSITY_NUMBER                      = "R113"; 
static const QString          ECP_ERROR_INTENSITY_NAME                         = "Intensity" ; 
const QString  numberErrorIntensity()               { return ECP_ERROR_INTENSITY_NUMBER;     }
const QString  nameErrorIntensity()                  { return ECP_ERROR_INTENSITY_NAME;     }

// Date
static const QString          ECP_ERROR_DATE_NUMBER                      = "R201"; 
static const QString          ECP_ERROR_DATE_NAME                         = "Date" ; 
const QString  numberErrorDate()               { return ECP_ERROR_DATE_NUMBER;     }
const QString  nameErrorDate()                  { return ECP_ERROR_DATE_NAME;     }
// Time
static const QString          ECP_ERROR_TIME_NUMBER                      = "R202"; 
static const QString          ECP_ERROR_TIME_NAME                         = "Time" ; 
const QString  numberErrorTime()               { return ECP_ERROR_TIME_NUMBER;     }
const QString  nameErrorTime()                  { return ECP_ERROR_TIME_NAME;     }

// Patern sort error
static const QString          ECP_ERROR_SORT_PATTERN                      = "  place in sorted catalog: %1";
//   %1 -  numberError   %2  order place %3 after
const QString  errorSortPattern()          { return ECP_ERROR_SORT_PATTERN;     }
static const QString          ECP_ERROR_SORT_NUMBER                      = "S101";
const QString  numberErrorSort()               { return ECP_ERROR_SORT_NUMBER;     }



//             Parameter Properties Declarations :
// ECP_ is common prefix; To it the name actually parameter
// is added. It becomes  a prefix of parametr.

//               PropertyBoolValue:>
// just Default: "0" is no(false); "1" is  yes(true)

//               PropertyFloatValue:>
// prefix for  Default; prefix_MIN for minimum; prefix_MAX for maximum

//               PropertyEnumValue:>
// prefix for  Default; prefix_ENUM  for Enumeration  
// Default "0" is no(false);"1" is  yes(true)


/// Settings of parameters Settings of parameters Settings of parameters ///
///-----------------------------------------Check Range ----------------------------------------
///----------------------------------------- Latitude ----------------------------------------
static const int              ECP_RANGE_LATITUDE_MINIMUM_ID                   = 1; 
static const QString          ECP_RANGE_LATITUDE_MINIMUM                      = "Lat min"; 
static const QString          ECP_RANGE_LATITUDE_MINIMUM_DEFAULT              = "-90.000";
const int      idRangeLatitudeMin()       { return ECP_RANGE_LATITUDE_MINIMUM_ID;      }
const QString  nameRangeLatitudeMin()     { return ECP_RANGE_LATITUDE_MINIMUM;         }
const QString  defaultRangeLatitudeMin()  { return ECP_RANGE_LATITUDE_MINIMUM_DEFAULT; }

static const int              ECP_RANGE_LATITUDE_MAXIMUM_ID                   = 2; 
static const QString          ECP_RANGE_LATITUDE_MAXIMUM                      = "Lat max"; 
static const QString          ECP_RANGE_LATITUDE_MAXIMUM_DEFAULT              = "90.000";
const int      idRangeLatitudeMax()       { return ECP_RANGE_LATITUDE_MAXIMUM_ID;    }
const QString  nameRangeLatitudeMax()     { return ECP_RANGE_LATITUDE_MAXIMUM;         }
const QString  defaultRangeLatitudeMax()  { return ECP_RANGE_LATITUDE_MAXIMUM_DEFAULT; }

static const float            ECP_RANGE_LATITUDE_MIN                  = -90.000;
static const float            ECP_RANGE_LATITUDE_MAX                  = 90.000;
static const int              ECP_RANGE_LATITUDE_DECIMAL              = 3;
const float    minRangeLatitude()      { return ECP_RANGE_LATITUDE_MIN;     }
const float    maxRangeLatitude()      { return ECP_RANGE_LATITUDE_MAX;     }
const int      decimalRangeLatitude()  { return ECP_RANGE_LATITUDE_DECIMAL; }

///----------------------------------------- Longitude ----------------------------------------
static const int              ECP_RANGE_LONGITUDE_MINIMUM_ID                   = 3; 
static const QString          ECP_RANGE_LONGITUDE_MINIMUM                      = "Lon min"; 
static const QString          ECP_RANGE_LONGITUDE_MINIMUM_DEFAULT              = "-180.000";
const int      idRangeLongitudeMin()       { return ECP_RANGE_LONGITUDE_MINIMUM_ID;      }
const QString  nameRangeLongitudeMin()     { return ECP_RANGE_LONGITUDE_MINIMUM;         }
const QString  defaultRangeLongitudeMin()  { return ECP_RANGE_LONGITUDE_MINIMUM_DEFAULT; }

static const int              ECP_RANGE_LONGITUDE_MAXIMUM_ID                   = 4; 
static const QString          ECP_RANGE_LONGITUDE_MAXIMUM                      = "Lon max"; 
static const QString          ECP_RANGE_LONGITUDE_MAXIMUM_DEFAULT              = "180.000";
const int      idRangeLongitudeMax()       { return ECP_RANGE_LONGITUDE_MAXIMUM_ID;      }
const QString  nameRangeLongitudeMax()     { return ECP_RANGE_LONGITUDE_MAXIMUM;         }
const QString  defaultRangeLongitudeMax()  { return ECP_RANGE_LONGITUDE_MAXIMUM_DEFAULT; }

static const float            ECP_RANGE_LONGITUDE_MIN                  = -180.000;
static const float            ECP_RANGE_LONGITUDE_MAX                  = 180.000;
static const int              ECP_RANGE_LONGITUDE_DECIMAL              = 3;
const float    minRangeLongitude()      { return ECP_RANGE_LONGITUDE_MIN;     }
const float    maxRangeLongitude()      { return ECP_RANGE_LONGITUDE_MAX;     }
const int      decimalRangeLongitude()  { return ECP_RANGE_LONGITUDE_DECIMAL; }


///----------------------------------------- Depth ----------------------------------------
static const int              ECP_RANGE_DEPTH_MINIMUM_ID                   = 5; 
static const QString          ECP_RANGE_DEPTH_MINIMUM                      = "Depth min"; 
static const QString          ECP_RANGE_DEPTH_MINIMUM_DEFAULT              = "-10.0";
const int      idRangeDepthMin()       { return ECP_RANGE_DEPTH_MINIMUM_ID;     }
const QString  nameRangeDepthMin()     { return ECP_RANGE_DEPTH_MINIMUM;         }
const QString  defaultRangeDepthMin()  { return ECP_RANGE_DEPTH_MINIMUM_DEFAULT; }

static const int              ECP_RANGE_DEPTH_MAXIMUM_ID                   = 6; 
static const QString          ECP_RANGE_DEPTH_MAXIMUM                      = "Depth max"; 
static const QString          ECP_RANGE_DEPTH_MAXIMUM_DEFAULT              = "9999.9";
const int      idRangeDepthMax()       { return ECP_RANGE_DEPTH_MAXIMUM_ID;      }
const QString  nameRangeDepthMax()     { return ECP_RANGE_DEPTH_MAXIMUM;         }
const QString  defaultRangeDepthMax()  { return ECP_RANGE_DEPTH_MAXIMUM_DEFAULT; }

static const float            ECP_RANGE_DEPTH_MIN                  = -10.0;
static const float            ECP_RANGE_DEPTH_MAX                  = 9999.9;
static const int              ECP_RANGE_DEPTH_DECIMAL              = 1;
const float    minRangeDepth()      { return ECP_RANGE_DEPTH_MIN;     }
const float    maxRangeDepth()      { return ECP_RANGE_DEPTH_MAX;     }
const int      decimalRangeDepth()  { return ECP_RANGE_DEPTH_DECIMAL; }

///----------------------------------------- Mb ----------------------------------------
static const int              ECP_RANGE_MB_MINIMUM_ID                   = 7; 
static const QString          ECP_RANGE_MB_MINIMUM                      = "M1 min"; 
static const QString          ECP_RANGE_MB_MINIMUM_DEFAULT              = "0.0";
const int      idRangeMbMin()       { return ECP_RANGE_MB_MINIMUM_ID;      }
const QString  nameRangeMbMin()     { return ECP_RANGE_MB_MINIMUM;         }
const QString  defaultRangeMbMin()  { return ECP_RANGE_MB_MINIMUM_DEFAULT; }

static const int              ECP_RANGE_MB_MAXIMUM_ID                   = 8; 
static const QString          ECP_RANGE_MB_MAXIMUM                      = "M1 max";
static const QString          ECP_RANGE_MB_MAXIMUM_DEFAULT              = "9.0";
const int      idRangeMbMax()       { return ECP_RANGE_MB_MAXIMUM_ID;     }
const QString  nameRangeMbMax()     { return ECP_RANGE_MB_MAXIMUM;         }
const QString  defaultRangeMbMax()  { return ECP_RANGE_MB_MAXIMUM_DEFAULT; }

///----------------------------------------- Ms ----------------------------------------
static const int              ECP_RANGE_MS_MINIMUM_ID                   = 9; 
static const QString          ECP_RANGE_MS_MINIMUM                      = "M2 min"; 
static const QString          ECP_RANGE_MS_MINIMUM_DEFAULT              = "0.0";
const int      idRangeMsMin()       { return ECP_RANGE_MS_MINIMUM_ID;      }
const QString  nameRangeMsMin()     { return ECP_RANGE_MS_MINIMUM;         }
const QString  defaultRangeMsMin()  { return ECP_RANGE_MS_MINIMUM_DEFAULT; }

static const int              ECP_RANGE_MS_MAXIMUM_ID                   = 10; 
static const QString          ECP_RANGE_MS_MAXIMUM                      = "M2 max"; 
static const QString          ECP_RANGE_MS_MAXIMUM_DEFAULT              = "9.0";
const int      idRangeMsMax()       { return ECP_RANGE_MS_MAXIMUM_ID;      }
const QString  nameRangeMsMax()     { return ECP_RANGE_MS_MAXIMUM;         }
const QString  defaultRangeMsMax()  { return ECP_RANGE_MS_MAXIMUM_DEFAULT; }

///----------------------------------------- Ml ----------------------------------------
static const int              ECP_RANGE_ML_MINIMUM_ID                   = 11; 
static const QString          ECP_RANGE_ML_MINIMUM                      = "M3 min"; 
static const QString          ECP_RANGE_ML_MINIMUM_DEFAULT              = "0.0";
const int      idRangeMlMin()       { return ECP_RANGE_ML_MINIMUM_ID;      }
const QString  nameRangeMlMin()     { return ECP_RANGE_ML_MINIMUM;         }
const QString  defaultRangeMlMin()  { return ECP_RANGE_ML_MINIMUM_DEFAULT; }

static const int              ECP_RANGE_ML_MAXIMUM_ID                   = 12; 
static const QString          ECP_RANGE_ML_MAXIMUM                      = "M3 max"; 
static const QString          ECP_RANGE_ML_MAXIMUM_DEFAULT              = "9.0";
const int      idRangeMlMax()       { return ECP_RANGE_ML_MAXIMUM_ID;      }
const QString  nameRangeMlMax()     { return ECP_RANGE_ML_MAXIMUM;         }
const QString  defaultRangeMlMax()  { return ECP_RANGE_ML_MAXIMUM_DEFAULT; }

///----------------------------------------- Mp ----------------------------------------
static const int              ECP_RANGE_MP_MINIMUM_ID                   = 13; 
static const QString          ECP_RANGE_MP_MINIMUM                      = "M4 min"; 
static const QString          ECP_RANGE_MP_MINIMUM_DEFAULT              = "0.0";
const int      idRangeMpMin()       { return ECP_RANGE_MP_MINIMUM_ID;      }
const QString  nameRangeMpMin()     { return ECP_RANGE_MP_MINIMUM;         }
const QString  defaultRangeMpMin()  { return ECP_RANGE_MP_MINIMUM_DEFAULT; }

static const int              ECP_RANGE_MP_MAXIMUM_ID                   = 14; 
static const QString          ECP_RANGE_MP_MAXIMUM                      = "M4 max"; 
static const QString          ECP_RANGE_MP_MAXIMUM_DEFAULT              = "9.0";
const int      idRangeMpMax()       { return ECP_RANGE_MP_MAXIMUM_ID;      }
const QString  nameRangeMpMax()     { return ECP_RANGE_MP_MAXIMUM;         }
const QString  defaultRangeMpMax()  { return ECP_RANGE_MP_MAXIMUM_DEFAULT; }

///-------------------------------------- Magniyude min max----------------------------------------
static const float            ECP_RANGE_MAGNITUDE_MIN                  = -maxEcpFloat();
static const float            ECP_RANGE_MAGNITUDE_MAX                  = maxEcpFloat();
static const int              ECP_RANGE_MAGNITUDE_DECIMAL              = 2;
const float    minRangeMagnitude()      { return ECP_RANGE_MAGNITUDE_MIN;     }
const float    maxRangeMagnitude()      { return ECP_RANGE_MAGNITUDE_MAX;     }
const int      decimalRangeMagnitude()  { return ECP_RANGE_MAGNITUDE_DECIMAL; }


///-------------------------  Transform magnitude for   Delta Magnitude Functions ----------------
///---------------------- Magnitude of First priority -------------------------------------
static const int ECP_DELTA_MAGNITUDE_PRIORITY_FIRST_ID           =  15;
static const QString ECP_MAGNITUDE_PRIORITY_FIRST          = "Magnitude function of first priority";
static const QString ECP_MAGNITUDE_PRIORITY_FIRST_DEFAULT  = "1@0@0.0@1.0@0.0@0.0";
const int      idDeltaMagnitudePriorityFirst()        { return ECP_DELTA_MAGNITUDE_PRIORITY_FIRST_ID;      }
const QString  nameMagnitudePriorityFirst()      { return ECP_MAGNITUDE_PRIORITY_FIRST;         }
const QString  defaultMagnitudePriorityFirst()   { return ECP_MAGNITUDE_PRIORITY_FIRST_DEFAULT; }

///---------------------- Magnitude of Second priority -------------------------------------
static const int ECP_DELTA_MAGNITUDE_PRIORITY_SECOND_ID           =  16;
static const QString ECP_MAGNITUDE_PRIORITY_SECOND          = "Magnitude function of second priority";
static const QString ECP_MAGNITUDE_PRIORITY_SECOND_DEFAULT  = "1@1@0.0@1.0@0.0@0.0";
const int      idDeltaMagnitudePrioritySecond()        { return ECP_DELTA_MAGNITUDE_PRIORITY_SECOND_ID;      }
const QString  nameMagnitudePrioritySecond()      { return ECP_MAGNITUDE_PRIORITY_SECOND;         }
const QString  defaultMagnitudePrioritySecond()   { return ECP_MAGNITUDE_PRIORITY_SECOND_DEFAULT; }

///---------------------- Magnitude of Third priority -------------------------------------
static const int ECP_DELTA_MAGNITUDE_PRIORITY_THIRD_ID           =  17;
static const QString ECP_MAGNITUDE_PRIORITY_THIRD          = "Magnitude function of third priority";
static const QString ECP_MAGNITUDE_PRIORITY_THIRD_DEFAULT  = "1@2@0.0@1.0@0.0@0.0";
const int      idDeltaMagnitudePriorityThird()        { return ECP_DELTA_MAGNITUDE_PRIORITY_THIRD_ID;      }
const QString  nameMagnitudePriorityThird()      { return ECP_MAGNITUDE_PRIORITY_THIRD;         }
const QString  defaultMagnitudePriorityThird()   { return ECP_MAGNITUDE_PRIORITY_THIRD_DEFAULT; }

///---------------------- Magnitude of Fourth priority -------------------------------------
static const int ECP_DELTA_MAGNITUDE_PRIORITY_FOURTH_ID           =  18;
static const QString ECP_MAGNITUDE_PRIORITY_FOURTH          = "Magnitude function of fourth priority";
static const QString ECP_MAGNITUDE_PRIORITY_FOURTH_DEFAULT  = "1@3@0.0@1.0@0.0@0.0";
const int      idDeltaMagnitudePriorityFourth()        { return ECP_DELTA_MAGNITUDE_PRIORITY_FOURTH_ID;      }
const QString  nameMagnitudePriorityFourth()      { return ECP_MAGNITUDE_PRIORITY_FOURTH;         }
const QString  defaultMagnitudePriorityFourth()   { return ECP_MAGNITUDE_PRIORITY_FOURTH_DEFAULT; }

//------------------- Validator Goefficients of Transform Fanction and Delta-----------------------
static const float ECP_TARNSFORM_MAFNITUDE_MIN_A = 0.0;
static const float ECP_TARNSFORM_MAFNITUDE_MAX_A = 10.0;
static const int   ECP_TARNSFORM_MAFNITUDE_DECIMAL_A = 2;
const float    minTransformMagnitudeA()       { return ECP_TARNSFORM_MAFNITUDE_MIN_A;     }
const float    maxTransformMagnitudeA()       { return ECP_TARNSFORM_MAFNITUDE_MAX_A;     }
const int      decimalTransformMagnitudeA()   { return ECP_TARNSFORM_MAFNITUDE_DECIMAL_A; }

static const float ECP_TARNSFORM_MAFNITUDE_MIN_B = -10.0;
static const float ECP_TARNSFORM_MAFNITUDE_MAX_B = 10.0;
static const int   ECP_TARNSFORM_MAFNITUDE_DECIMAL_B = 2;
const float    minTransformMagnitudeB()       { return ECP_TARNSFORM_MAFNITUDE_MIN_B;     }
const float    maxTransformMagnitudeB()       { return ECP_TARNSFORM_MAFNITUDE_MAX_B;     }
const int      decimalTransformMagnitudeB()   { return ECP_TARNSFORM_MAFNITUDE_DECIMAL_B; }

static const float ECP_TARNSFORM_MAFNITUDE_MIN_C = -10.0;
static const float ECP_TARNSFORM_MAFNITUDE_MAX_C = 10.0;
static const int   ECP_TARNSFORM_MAFNITUDE_DECIMAL_C = 2;
const float    minTransformMagnitudeC()       { return ECP_TARNSFORM_MAFNITUDE_MIN_C;     }
const float    maxTransformMagnitudeC()       { return ECP_TARNSFORM_MAFNITUDE_MAX_C;     }
const int      decimalTransformMagnitudeC()   { return ECP_TARNSFORM_MAFNITUDE_DECIMAL_C; }

static const float ECP_TARNSFORM_MAFNITUDE_MIN_D = 0.0;
static const float ECP_TARNSFORM_MAFNITUDE_MAX_D = 10.0;
static const int   ECP_TARNSFORM_MAFNITUDE_DECIMAL_D = 2;
const float    minTransformMagnitudeD()       { return ECP_TARNSFORM_MAFNITUDE_MIN_D;     }
const float    maxTransformMagnitudeD()       { return ECP_TARNSFORM_MAFNITUDE_MAX_D;     }
const int      decimalTransformMagnitudeD()   { return ECP_TARNSFORM_MAFNITUDE_DECIMAL_D; }


//!!!
///-----------------------------------------Identification of doubles ----------------------------------------
///------------------------ Define Delta----------------------------------------------
///----------------------------------------- time ----------------------------------------   
static const int         ECP_DELTA_TIME_ID             = 19; 
static const QString ECP_DELTA_TIME                  = "Delta time (sec)";
static const QString ECP_DELTA_TIME_DEFAULT = "60";
static const int         ECP_DELTA_TIME_MIN          = 10;
static const int         ECP_DELTA_TIME_MAX         = 600;
static const bool       ECP_DELTA_TIME_SIGNED_VALUE    = FALSE;
const int          idDeltaTime()                     { return ECP_DELTA_TIME_ID;                                }
const QString  nameDeltaTime()                { return ECP_DELTA_TIME;                                      }
const QString  defaultDeltaTime()               { return ECP_DELTA_TIME_DEFAULT;                     }
const int          minDeltaTime()                   { return ECP_DELTA_TIME_MIN;                             }
const int          maxDeltaTime()                  { return ECP_DELTA_TIME_MAX;                            }
const bool       signedDeltaTime()               { return ECP_DELTA_TIME_SIGNED_VALUE;          }
///----------------------------------------- depth ----------------------------------------   
static const int         ECP_DELTA_DEPTH_ID             = 20; 
static const QString ECP_DELTA_DEPTH                   = "Delta depth (km)";
static const QString ECP_DELTA_DEPTH_DEFAULT  = "1";
static const int         ECP_DELTA_DEPTH_MIN           = 0;
static const int         ECP_DELTA_DEPTH_MAX                     = 999;
static const bool      ECP_DELTA_DEPTH_SIGNED_VALUE    = FALSE;
const int         idDeltaDepth()                     { return ECP_DELTA_DEPTH_ID;                                }
const QString nameDeltaDepth()                { return ECP_DELTA_DEPTH;                                     }
const QString defaultDeltaDepth()              { return ECP_DELTA_DEPTH_DEFAULT;                     }
const int        minDeltaDepth()                    { return ECP_DELTA_DEPTH_MIN;                             }
const int        maxDeltaDepth()                   { return ECP_DELTA_DEPTH_MAX;                            }
const bool     signedDeltaDepth()                 { return ECP_DELTA_DEPTH_SIGNED_VALUE;         }
///----------------------------------------- Latitude ----------------------------------------   
static const int        ECP_DELTA_LATITUDE_ID               = 21; 
static const QString ECP_DELTA_LATITUDE                    = "Delta latitude (degree)";
static const QString ECP_DELTA_LATITUDE_DEFAULT   = "0.01"  ;
static const float      ECP_DELTA_LATITUDE_MIN            = 0;
static const float      ECP_DELTA_LATITUDE_MAX           = 10;
static const int         ECP_DELTA_LATITUDE_DECIMAL    = 2;
const int          idDeltaLatitude()               { return ECP_DELTA_LATITUDE_ID;                }
const QString  nameDeltaLatitude()          { return ECP_DELTA_LATITUDE;                      }
const QString defaultDeltaLatitude()         { return ECP_DELTA_LATITUDE_DEFAULT;      }
const float      minDeltaLatitude()              { return ECP_DELTA_LATITUDE_MIN;               }
const float      maxDeltaLatitude()             { return ECP_DELTA_LATITUDE_MAX;              }
const int        decimalDeltaLatitude()         { return ECP_DELTA_LATITUDE_DECIMAL;      }
///----------------------------------------- Longitude ----------------------------------------   
static const int        ECP_DELTA_LONGITUDE_ID               = 22; 
static const QString ECP_DELTA_LONGITUDE                    = "Delta longitude (degree)";
static const QString ECP_DELTA_LONGITUDE_DEFAULT   = "0.01"  ;
static const float      ECP_DELTA_LONGITUDE_MIN            = 0;
static const float      ECP_DELTA_LONGITUDE_MAX           = maxEcpFloat();
static const int         ECP_DELTA_LONGITUDE_DECIMAL    = 2;
const int          idDeltaLongitude()               { return ECP_DELTA_LONGITUDE_ID;                }
const QString  nameDeltaLongitude()          { return ECP_DELTA_LONGITUDE;                      }
const QString defaultDeltaLongitude()         { return ECP_DELTA_LONGITUDE_DEFAULT;      }
const float      minDeltaLongitude()              { return ECP_DELTA_LONGITUDE_MIN;               }
const float      maxDeltaLongitude()             { return ECP_DELTA_LONGITUDE_MAX;              }
const int        decimalDeltaLongitude()         { return ECP_DELTA_LONGITUDE_DECIMAL;      }
///----------------------------------------- Magnitudes  ----------------------------------------
static const int        ECP_DELTA_MAGNITUDE_ID               = 23;
static const QString ECP_DELTA_MAGNITUDE                    = "Delta Magnitudes";
static const QString ECP_DELTA_MAGNITUDE_DEFAULT   = "1.0"  ;
static const float      ECP_DELTA_MAGNITUDE_MIN            = 0;
static const float      ECP_DELTA_MAGNITUDE_MAX           = maxEcpFloat();
static const int         ECP_DELTA_MAGNITUDE_DECIMAL    = 2;
const int      idDeltaMagnitude()        { return ECP_DELTA_MAGNITUDE_ID;       }
const QString  nameDeltaMagnitude()      { return ECP_DELTA_MAGNITUDE;           }
const QString  defaultDeltaMagnitude()   { return ECP_DELTA_MAGNITUDE_DEFAULT;   }
const float    minDeltaMagnitude()       { return ECP_DELTA_MAGNITUDE_MIN;       }
const float    maxDeltaMagnitude()       { return ECP_DELTA_MAGNITUDE_MAX;       }
const int      decimalDeltaMagnitude()   { return ECP_DELTA_MAGNITUDE_DECIMAL;   }
///----------------------------------------- Remove Action  ----------------------------------------
static const int     ECP_DELTA_REMOVE_ACTION_ID               = 24;
static const QString ECP_DELTA_REMOVE_ACTION                      = "remove action";
static const QString ECP_DELTA_REMOVE_ACTION_DEFAULT               = "0";
static const QString ECP_DELTA_REMOVE_ACTION_ENUM           = "auto indialog";
const int     idDeltaRemoveAction()       { return ECP_DELTA_REMOVE_ACTION_ID;      }
const QString nameDeltaRemoveAction()     { return ECP_DELTA_REMOVE_ACTION;         }
const QString defaultDeltaRemoveAction()  { return ECP_DELTA_REMOVE_ACTION_DEFAULT; }
const QString enumDeltaRemoveAction()     { return ECP_DELTA_REMOVE_ACTION_ENUM;    }
///----------------------------------------- Remove Equal  ----------------------------------------
static const int     ECP_DELTA_REMOVE_EQUAL_ID               = 124;
static const QString ECP_DELTA_REMOVE_EQUAL                      = "Remove equal";
static const QString ECP_DELTA_REMOVE_EQUAL_DEFAULT               = "0";
static const QString ECP_DELTA_REMOVE_EQUAL_ENUM           = "first second";
const int     idDeltaRemoveEqual()       { return ECP_DELTA_REMOVE_EQUAL_ID;      }
const QString nameDeltaRemoveEqual()     { return ECP_DELTA_REMOVE_EQUAL;         }
const QString defaultDeltaRemoveEqual()  { return ECP_DELTA_REMOVE_EQUAL_DEFAULT; }
const QString enumDeltaRemoveEqual()     { return ECP_DELTA_REMOVE_EQUAL_ENUM;    }

//---------------------- Functions entries ------------------------------------------

///---------------------- List of Magnitudes of each Priority -------------------------------------
static const QString ECP_COMBOBOX_MAGNITUDE_LIST_ENUM       = "m1@m2@m3@m4";
const QString enumComboBoxMagnitudeList()     { return ECP_COMBOBOX_MAGNITUDE_LIST_ENUM;    }

///---------------------- Magnitude of first priority -------------------------------------
static const QString ECP_PRIORITY_FIRST_MAGNITUDE                       = "Magnitude of first priority";
static const QString ECP_PRIORITY_FIRST_MAGNITUDE_DEFAULT               = "0";
const QString namePriorityFirstMagnitude()     { return ECP_PRIORITY_FIRST_MAGNITUDE;         }
const QString defaultPriorityFirstMagnitude()  { return ECP_PRIORITY_FIRST_MAGNITUDE_DEFAULT; }

///---------------------- Magnitude of Second priority -------------------------------------
static const QString ECP_PRIORITY_SECOND_MAGNITUDE                       = "Magnitude of Second priority";
static const QString ECP_PRIORITY_SECOND_MAGNITUDE_DEFAULT               = "1";
const QString namePrioritySecondMagnitude()     { return ECP_PRIORITY_SECOND_MAGNITUDE;         }
const QString defaultPrioritySecondMagnitude()  { return ECP_PRIORITY_SECOND_MAGNITUDE_DEFAULT; }

///---------------------- Magnitude of Third priority -------------------------------------
static const QString ECP_PRIORITY_THIRD_MAGNITUDE                       = "Magnitude of Third priority";
static const QString ECP_PRIORITY_THIRD_MAGNITUDE_DEFAULT               = "2";
const QString namePriorityThirdMagnitude()     { return ECP_PRIORITY_THIRD_MAGNITUDE;         }
const QString defaultPriorityThirdMagnitude()  { return ECP_PRIORITY_THIRD_MAGNITUDE_DEFAULT; }

///---------------------- Magnitude of Fourth priority -------------------------------------
static const QString ECP_PRIORITY_FOURTH_MAGNITUDE                       = "Magnitude of Fourth priority";
static const QString ECP_PRIORITY_FOURTH_MAGNITUDE_DEFAULT               = "3";
const QString namePriorityFourthMagnitude()     { return ECP_PRIORITY_FOURTH_MAGNITUDE;         }
const QString defaultPriorityFourthMagnitude()  { return ECP_PRIORITY_FOURTH_MAGNITUDE_DEFAULT; }


///----------------------------------------- Priority List Values   ----------------------------------------
static const QString ECP_PRIORITY_LIST_ENUM           = "False True";
const QString enumPriorityList()     { return ECP_PRIORITY_LIST_ENUM;    }

///-----------------------------------------  Priority is used   ----------------------------------------
static const QString ECP_PRIORITY_IS_USING                       = "Priority is using";
static const QString ECP_PRIORITY_IS_USING_DEFAULT               = "1";
const QString namePriorityIsUsing()     { return ECP_PRIORITY_IS_USING;         }
const QString defaultPriorityIsUsing()  { return ECP_PRIORITY_IS_USING_DEFAULT; }

///----------------------------------------- Second Priority is used   ----------------------------------------
static const QString ECP_PRIORITY_IS_NOT_USING                       = "Priority is not using";
static const QString ECP_PRIORITY_IS_NOT_USING_DEFAULT               = "0";
const QString namePriorityIsNotUsing()     { return ECP_PRIORITY_IS_NOT_USING;         }
const QString defaultPriorityIsNotUsing()  { return ECP_PRIORITY_IS_NOT_USING_DEFAULT; }


///----------------------Removing Duplicate Functions  ----------------------------------------
static const int  ECP_REMOVING_DUPLICATE_FUNCTION_ID                = 25;
static const QString ECP_REMOVING_DUPLICATE_FUNCTION                       = "Removing Duplicate Functions";
static const QString ECP_REMOVING_DUPLICATE_FUNCTION_DEFAULT               = "0";
static const QString ECP_REMOVING_DUPLICATE_FUNCTION_ENUM       = 
                                                        "value greater@value less@"
                                                        "maximum greater@maximum less@"
                                                        "minimum greater@minimum less@"
                                                        "average greater@average less";
const int idRemovingDuplicateFunction()           { return ECP_REMOVING_DUPLICATE_FUNCTION_ID;      }
const QString nameRemovingDuplicateFunction()     { return ECP_REMOVING_DUPLICATE_FUNCTION;         }
const QString defaultRemovingDuplicateFunction()  { return ECP_REMOVING_DUPLICATE_FUNCTION_DEFAULT; }
const QString enumRemovingDuplicateFunction()     { return ECP_REMOVING_DUPLICATE_FUNCTION_ENUM;    }
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
///----------------------------------------- First Priority is used   ----------------------------------------
static const int  ECP_REMOVING_FIRST_ID                = 26;
const int idRemovingFirst()           { return ECP_REMOVING_FIRST_ID;      }
///----------------------------------------- Second Priority is used   ----------------------------------------
static const int  ECP_REMOVING_SECOND_ID                = 27;
const int idRemovingSecond()           { return ECP_REMOVING_SECOND_ID;      }
///----------------------------------------- Third Priority is used   ----------------------------------------
static const int  ECP_REMOVING_THIRD_ID                = 28;
const int idRemovingThird()           { return ECP_REMOVING_THIRD_ID;      }
///----------------------------------------- Fourth Priority is used   ----------------------------------------
static const int  ECP_REMOVING_FOURTH_ID                = 29;
const int idRemovingFourth()           { return ECP_REMOVING_FOURTH_ID;      }

///---------------------- Magnitude of first priority -------------------------------------
static const int  ECP_REMOVING_FIRST_MAGNITUDE_ID                = 30;
const int idRemovingFirstMagnitude()           { return ECP_REMOVING_FIRST_MAGNITUDE_ID;      }
///---------------------- Magnitude of Second priority -------------------------------------
static const int  ECP_REMOVING_SECOND_MAGNITUDE_ID                = 31;
const int idRemovingSecondMagnitude()           { return ECP_REMOVING_SECOND_MAGNITUDE_ID;      }
///---------------------- Magnitude of Third priority -------------------------------------
static const int  ECP_REMOVING_THIRD_MAGNITUDE_ID                = 32;
const int idRemovingThirdMagnitude()           { return ECP_REMOVING_THIRD_MAGNITUDE_ID;      }
///---------------------- Magnitude of Fourth priority -------------------------------------
static const int  ECP_REMOVING_FOURTH_MAGNITUDE_ID                = 33;
const int idRemovingFourthMagnitude()           { return ECP_REMOVING_FOURTH_MAGNITUDE_ID;      }
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

///----------------------Delta Magnitude Functions  ----------------------------------------
static const int  ECP_DELTA_MAGNITUDE_FUNCTION_ID                = 34;
static const QString ECP_DELTA_MAGNITUDE_FUNCTION                       = "Delta Magnitude Functions";
static const QString ECP_DELTA_MAGNITUDE_FUNCTION_DEFAULT               = "0";
static const QString ECP_DELTA_MAGNITUDE_FUNCTION_ENUM       = "value@maximum@minimum@average";
const int idDeltaMagnitudeFunction()           { return ECP_DELTA_MAGNITUDE_FUNCTION_ID;      }
const QString nameDeltaMagnitudeFunction()     { return ECP_DELTA_MAGNITUDE_FUNCTION;         }
const QString defaultDeltaMagnitudeFunction()  { return ECP_DELTA_MAGNITUDE_FUNCTION_DEFAULT; }
const QString enumDeltaMagnitudeFunction()     { return ECP_DELTA_MAGNITUDE_FUNCTION_ENUM;    }

///-------------------------------  Merge  Catalogs ------------------------------///////////////////////
///------------------------ Define Delta----------------------------------------------
///----------------------------------------- time ----------------------------------------
static const int   ECP_DELTA_CAT_TIME_ID             = 35;
const int          idDeltaCatTime()             { return ECP_DELTA_CAT_TIME_ID;                                }
///----------------------------------------- depth ----------------------------------------
static const int         ECP_DELTA_CAT_DEPTH_ID      = 36;
const int         idDeltaCatDepth()             { return ECP_DELTA_CAT_DEPTH_ID;                                }
///----------------------------------------- Latitude ----------------------------------------
static const int        ECP_DELTA_CAT_LATITUDE_ID    = 37;
const int          idDeltaCatLatitude()         { return ECP_DELTA_CAT_LATITUDE_ID;                }
///----------------------------------------- Longitude ----------------------------------------
static const int        ECP_DELTA_CAT_LONGITUDE_ID   = 38;
const int          idDeltaCatLongitude()        { return ECP_DELTA_CAT_LONGITUDE_ID ;                }
///----------------------------------------- Magnitudes  ----------------------------------------
static const int        ECP_DELTA_CAT_MAGNITUDE_ID               = 39;
const int      idDeltaCatMagnitude()        { return ECP_DELTA_CAT_MAGNITUDE_ID;       }

//---------------------------  Delta Magnitude Functions --------------------

static const int  ECP_DELTA_CAT_MAGNITUDE_FUNCTION_ID                = 40;
const int idDeltaCatMagnitudeFunction()           { return ECP_DELTA_CAT_MAGNITUDE_FUNCTION_ID;      }
static const int ECP_DELTA_CAT_MAGNITUDE_PRIORITY_FIRST_ID           =  41;
const int      idDeltaCatMagnitudePriorityFirst()        { return ECP_DELTA_CAT_MAGNITUDE_PRIORITY_FIRST_ID;      }
static const int ECP_DELTA_CAT_MAGNITUDE_PRIORITY_SECOND_ID           =  42;
const int      idDeltaCatMagnitudePrioritySecond()        { return ECP_DELTA_CAT_MAGNITUDE_PRIORITY_SECOND_ID;      }
static const int ECP_DELTA_CAT_MAGNITUDE_PRIORITY_THIRD_ID           =  43;
const int      idDeltaCatMagnitudePriorityThird()        { return ECP_DELTA_CAT_MAGNITUDE_PRIORITY_THIRD_ID;      }
static const int ECP_DELTA_CAT_MAGNITUDE_PRIORITY_FOURTH_ID           =  44;
const int      idDeltaCatMagnitudePriorityFourth()        { return ECP_DELTA_CAT_MAGNITUDE_PRIORITY_FOURTH_ID;      }

///--------------------------- Duplicate Magnitudes ---------------------------------
///-------------------------- Assign Duplicate Magnitudes   --------------------------
static const int     ECP_ASSIGN_DUPLICATE_MAGNITUDE_ID               = 45;
static const QString ECP_ASSIGN_DUPLICATE_MAGNITUDE                      = "Assing duplicate magnitudes";
static const QString ECP_ASSIGN_DUPLICATE_MAGNITUDE_DEFAULT               = "1";
const int     idAssignDuplicateMagnitude()       { return ECP_ASSIGN_DUPLICATE_MAGNITUDE_ID;      }
const QString nameAssignDuplicateMagnitude()     { return ECP_ASSIGN_DUPLICATE_MAGNITUDE;         }
const QString defaultAssignDuplicateMagnitude()  { return ECP_ASSIGN_DUPLICATE_MAGNITUDE_DEFAULT; }
//------------------------------Selected Magnitude ---------------------------------------------------
static const int     ECP_SELECTED_DUPLICATE_MAGNITUDE_ID               = 46;
static const QString ECP_SELECTED_DUPLICATE_MAGNITUDE                      = "Selected duplicate magnitude";
static const QString ECP_SELECTED_DUPLICATE_MAGNITUDE_DEFAULT               = "3";
const int     idSelectedDuplicateMagnitude()       { return ECP_SELECTED_DUPLICATE_MAGNITUDE_ID;      }
const QString nameSelectedDuplicateMagnitude()     { return ECP_SELECTED_DUPLICATE_MAGNITUDE;         }
const QString defaultSelectedDuplicateMagnitude()  { return ECP_SELECTED_DUPLICATE_MAGNITUDE_DEFAULT; }
//------------------------------Removing Magnitude ---------------------------------------------------
static const int     ECP_REMOVING_DUPLICATE_MAGNITUDE_ID               = 47;
static const QString ECP_REMOVING_DUPLICATE_MAGNITUDE                      = "Removing duplicate magnitude";
static const QString ECP_REMOVING_DUPLICATE_MAGNITUDE_DEFAULT               = "0";
const int     idRemovingDuplicateMagnitude()       { return ECP_REMOVING_DUPLICATE_MAGNITUDE_ID;      }
const QString nameRemovingDuplicateMagnitude()     { return ECP_REMOVING_DUPLICATE_MAGNITUDE;         }
const QString defaultRemovingDuplicateMagnitude()  { return ECP_REMOVING_DUPLICATE_MAGNITUDE_DEFAULT; }
//------------------------------Second Catalogname for Intersection etc. ---------------------------
static const int     ECP_SECOND_CATALOG_ID               = 48;
static const QString ECP_SECOND_CATALOG                      = "Cat Name";
static const QString ECP_SECOND_CATALOG_DEFAULT               = QString();
const int     idSecondCatalog()       { return ECP_SECOND_CATALOG_ID;      }
const QString nameSecondCatalog()     { return ECP_SECOND_CATALOG;         }
const QString defaultSecondCatalog()  { return ECP_SECOND_CATALOG_DEFAULT; }
///----------------------------------------- Compare Action  ----------------------------------------
static const int     ECP_COMPARE_CATALOG_ACTION_ID               = 148;
static const QString ECP_COMPARE_CATALOG_ACTION                      = "Compare Act";
static const QString ECP_COMPARE_CATALOG_ACTION_DEFAULT               = "0";
static const QString ECP_COMPARE_CATALOG_ACTION_ENUM           = "Intersection,Difference,Equivalence,Nonequivalence";
const int     idCompareCatalogAction()       { return ECP_COMPARE_CATALOG_ACTION_ID ;      }
const QString nameCompareCatalogAction()     { return ECP_COMPARE_CATALOG_ACTION;         }
const QString defaultCompareCatalogAction()  { return ECP_COMPARE_CATALOG_ACTION_DEFAULT; }
const QString enumCompareCatalogAction()     { return ECP_COMPARE_CATALOG_ACTION_ENUM;    }

//------------------------------ List Merge catalog ---------------------------
static const int     ECP_LIST_MERGE_CATALOG_ID               = 49;
static const QString ECP_LIST_MERGE_CATALOG                      = "Cat List";
static const QString ECP_LIST_MERGE_CATALOG_DEFAULT               = QString();
const int     idListMergeCatalog()       { return ECP_LIST_MERGE_CATALOG_ID;      }
const QString nameListMergeCatalog()     { return ECP_LIST_MERGE_CATALOG;         }
const QString defaultListMergeCatalog()  { return ECP_LIST_MERGE_CATALOG_DEFAULT; }

///----------------------------------- Add Catalogs-----------------------------
static const int     ECP_LIST_ADD_CATALOG_ID               = 50;
static const QString ECP_LIST_ADD_CATALOG                      = "Cat List";
static const QString ECP_LIST_ADD_CATALOG_DEFAULT               = QString();
const int     idListAddCatalog()       { return ECP_LIST_ADD_CATALOG_ID;      }
const QString nameListAddCatalog()     { return ECP_LIST_ADD_CATALOG;         }
const QString defaultListAddCatalog()  { return ECP_LIST_ADD_CATALOG_DEFAULT; }

//-----------------------------------Create subcatalog ------------------------------------------
//------------------------------------ Record Sample ------------------------------------------
static const int     ECP_SAMPLE_RECORD_IS_ID               = 51;
static const QString ECP_SAMPLE_RECORD_IS                      = "Record";
static const QString ECP_SAMPLE_RECORD_IS_DEFAULT               = "0";
const int     idSampleIsRecord()       { return ECP_SAMPLE_RECORD_IS_ID;      }
const QString nameSampleIsRecord()     { return ECP_SAMPLE_RECORD_IS;         }
const QString defaultSampleIsRecord()  { return ECP_SAMPLE_RECORD_IS_DEFAULT; }

static const int     ECP_SAMPLE_RECORD_TYPE_ID               = 52;
static const QString ECP_SAMPLE_RECORD_TYPE                      = "Record Type";
static const QString ECP_SAMPLE_RECORD_TYPE_DEFAULT               = "0";
static const QString ECP_SAMPLE_RECORD_TYPE_ENUM           = "DateTime Number";
const int     idSampleRecordType()       { return ECP_SAMPLE_RECORD_TYPE_ID;      }
const QString nameSampleRecordType()     { return ECP_SAMPLE_RECORD_TYPE;         }
const QString defaultSampleRecordType()  { return ECP_SAMPLE_RECORD_TYPE_DEFAULT; }
const QString enumSampleRecordType()     { return ECP_SAMPLE_RECORD_TYPE_ENUM;    }



static const int     ECP_SAMPLE_RECORD_DATE_MIN_ID               = 53;
static const QString ECP_SAMPLE_RECORD_DATE_MIN                      = "Date Min";
static const QString ECP_SAMPLE_RECORD_DATE_MIN_DEFAULT               = "auto";
const int     idSampleRecordDateMin()       { return ECP_SAMPLE_RECORD_DATE_MIN_ID;      }
const QString nameSampleRecordDateMin()     { return ECP_SAMPLE_RECORD_DATE_MIN;         }
const QString defaultSampleRecordDateMin()  { return ECP_SAMPLE_RECORD_DATE_MIN_DEFAULT; }

static const int     ECP_SAMPLE_RECORD_DATE_MAX_ID               = 54;
static const QString ECP_SAMPLE_RECORD_DATE_MAX                      = "Date Max";
static const QString ECP_SAMPLE_RECORD_DATE_MAX_DEFAULT               = "auto";
const int     idSampleRecordDateMax()       { return ECP_SAMPLE_RECORD_DATE_MAX_ID;      }
const QString nameSampleRecordDateMax()     { return ECP_SAMPLE_RECORD_DATE_MAX;         }
const QString defaultSampleRecordDateMax()  { return ECP_SAMPLE_RECORD_DATE_MAX_DEFAULT; }

static const int     ECP_SAMPLE_RECORD_NUMBER_MIN_ID               = 55;
static const QString ECP_SAMPLE_RECORD_NUMBER_MIN                      = "Number Min";
static const QString ECP_SAMPLE_RECORD_NUMBER_MIN_DEFAULT               = "auto";
const int     idSampleRecordNumberMin()       { return ECP_SAMPLE_RECORD_NUMBER_MIN_ID;      }
const QString nameSampleRecordNumberMin()     { return ECP_SAMPLE_RECORD_NUMBER_MIN;         }
const QString defaultSampleRecordNumberMin()  { return ECP_SAMPLE_RECORD_NUMBER_MIN_DEFAULT; }

static const int     ECP_SAMPLE_RECORD_NUMBER_MAX_ID               = 56;
static const QString ECP_SAMPLE_RECORD_NUMBER_MAX                      = "Number Max";
static const QString ECP_SAMPLE_RECORD_NUMBER_MAX_DEFAULT               = "auto";
const int     idSampleRecordNumberMax()       { return ECP_SAMPLE_RECORD_NUMBER_MAX_ID;      }
const QString nameSampleRecordNumberMax()     { return ECP_SAMPLE_RECORD_NUMBER_MAX;         }
const QString defaultSampleRecordNumberMax()  { return ECP_SAMPLE_RECORD_NUMBER_MAX_DEFAULT; }

static const QString ECP_SAMPLE_WIZARD_RECORD_NUMBER_MIN                   = "1";
static const QString ECP_SAMPLE_WIZARD_RECORD_NUMBER_MAX                   = "1500000";
static const QString ECP_SAMPLE_WIZARD_DATE_MIN                     = "1752-09-14T00:00:00";
static const QString ECP_SAMPLE_WIZARD_DATE_MAX                     = "2020-01-01T00:00:00";
const QString sampleWizardRecordNumberMin()     { return ECP_SAMPLE_WIZARD_RECORD_NUMBER_MIN ;    }
const QString sampleWizardRecordNumberMax()     { return ECP_SAMPLE_WIZARD_RECORD_NUMBER_MAX;     }
const QString sampleWizardRecordDateMin()       { return ECP_SAMPLE_WIZARD_DATE_MIN;       }
const QString sampleWizardRecordDateMax()       { return ECP_SAMPLE_WIZARD_DATE_MAX;       }

//------------------------------------ Hipocenter ----------------------------------

static const int     ECP_SAMPLE_HIPO_IS_ID               = 57;
static const QString ECP_SAMPLE_HIPO_IS                      = "Hipocenter";
static const QString ECP_SAMPLE_HIPO_IS_DEFAULT               = "0";
const int     idSampleIsHipo()       { return ECP_SAMPLE_HIPO_IS_ID;      }
const QString nameSampleIsHipo()     { return ECP_SAMPLE_HIPO_IS;         }
const QString defaultSampleIsHipo()  { return ECP_SAMPLE_HIPO_IS_DEFAULT; }

static const int     ECP_SAMPLE_HIPO_TYPE_ID               = 58;
static const QString ECP_SAMPLE_HIPO_TYPE                      = "Hipocenter Type";
static const QString ECP_SAMPLE_HIPO_TYPE_DEFAULT               = "0";
static const QString ECP_SAMPLE_HIPO_TYPE_ENUM           = "Rectangle Circle Polygon";
const int     idSampleHipoType()       { return ECP_SAMPLE_HIPO_TYPE_ID;      }
const QString nameSampleHipoType()     { return ECP_SAMPLE_HIPO_TYPE;         }
const QString defaultSampleHipoType()  { return ECP_SAMPLE_HIPO_TYPE_DEFAULT; }
const QString enumSampleHipoType()     { return ECP_SAMPLE_HIPO_TYPE_ENUM;    }

//------------------------------------ Rectangle Hipocenter --------------------------

static const int     ECP_SAMPLE_HIPO_RECT_LATITUDE_MIN_ID               = 59;
static const QString ECP_SAMPLE_HIPO_RECT_LATITUDE_MIN                      = "Latitude Min";
static const QString ECP_SAMPLE_HIPO_RECT_LATITUDE_MIN_DEFAULT               = "-90.0";
const int     idSampleHipoRectLatitudeMin()       { return ECP_SAMPLE_HIPO_RECT_LATITUDE_MIN_ID;      }
const QString nameSampleHipoRectLatitudeMin()     { return ECP_SAMPLE_HIPO_RECT_LATITUDE_MIN;         }
const QString defaultSampleHipoRectLatitudeMin()  { return ECP_SAMPLE_HIPO_RECT_LATITUDE_MIN_DEFAULT; }

static const int     ECP_SAMPLE_HIPO_RECT_LATITUDE_MAX_ID               = 60;
static const QString ECP_SAMPLE_HIPO_RECT_LATITUDE_MAX                      = "Latitude Max";
static const QString ECP_SAMPLE_HIPO_RECT_LATITUDE_MAX_DEFAULT               = "90.0";
const int     idSampleHipoRectLatitudeMax()       { return ECP_SAMPLE_HIPO_RECT_LATITUDE_MAX_ID;      }
const QString nameSampleHipoRectLatitudeMax()     { return ECP_SAMPLE_HIPO_RECT_LATITUDE_MAX;         }
const QString defaultSampleHipoRectLatitudeMax()  { return ECP_SAMPLE_HIPO_RECT_LATITUDE_MAX_DEFAULT; }

static const int     ECP_SAMPLE_HIPO_RECT_LONGITUDE_MIN_ID               = 61;
static const QString ECP_SAMPLE_HIPO_RECT_LONGITUDE_MIN                      = "Longitude Min";
static const QString ECP_SAMPLE_HIPO_RECT_LONGITUDE_MIN_DEFAULT               = "-180.0";
const int     idSampleHipoRectLongitudeMin()       { return ECP_SAMPLE_HIPO_RECT_LONGITUDE_MIN_ID;      }
const QString nameSampleHipoRectLongitudeMin()     { return ECP_SAMPLE_HIPO_RECT_LONGITUDE_MIN;         }
const QString defaultSampleHipoRectLongitudeMin()  { return ECP_SAMPLE_HIPO_RECT_LONGITUDE_MIN_DEFAULT; }

static const int     ECP_SAMPLE_HIPO_RECT_LONGITUDE_MAX_ID               = 62;
static const QString ECP_SAMPLE_HIPO_RECT_LONGITUDE_MAX                      = "Longitude Max";
static const QString ECP_SAMPLE_HIPO_RECT_LONGITUDE_MAX_DEFAULT               = "180.0";
const int     idSampleHipoRectLongitudeMax()       { return ECP_SAMPLE_HIPO_RECT_LONGITUDE_MAX_ID;      }
const QString nameSampleHipoRectLongitudeMax()     { return ECP_SAMPLE_HIPO_RECT_LONGITUDE_MAX;         }
const QString defaultSampleHipoRectLongitudeMax()  { return ECP_SAMPLE_HIPO_RECT_LONGITUDE_MAX_DEFAULT; }
//------------------------------------------------------------------------
static const int     ECP_SAMPLE_HIPO_RECT_MINUS180_ID               = 63;
static const QString ECP_SAMPLE_HIPO_RECT_MINUS180                 = "Hipocenter";
static const QString ECP_SAMPLE_HIPO_RECT_MINUS180_DEFAULT         = "0";
const int     idSampleHipoRectMinus180()       { return ECP_SAMPLE_HIPO_RECT_MINUS180_ID;      }
const QString nameSampleHipoRectMinus180()     { return ECP_SAMPLE_HIPO_RECT_MINUS180;         }
const QString defaultSampleHipoRectMinus180()  { return ECP_SAMPLE_HIPO_RECT_MINUS180_DEFAULT; }

//------------------------------------ Circle Hipocenter --------------------------
static const int     ECP_SAMPLE_HIPO_CIRCLE_LATITUDE_ID               = 64;
static const QString ECP_SAMPLE_HIPO_CIRCLE_LATITUDE                      = "Circle Latitude";
static const QString ECP_SAMPLE_HIPO_CIRCLE_LATITUDE_DEFAULT               = "0.0";
const int     idSampleHipoCircleLatitude()       { return ECP_SAMPLE_HIPO_CIRCLE_LATITUDE_ID;      }
const QString nameSampleHipoCircleLatitude()     { return ECP_SAMPLE_HIPO_CIRCLE_LATITUDE;         }
const QString defaultSampleHipoCircleLatitude()  { return ECP_SAMPLE_HIPO_CIRCLE_LATITUDE_DEFAULT; }

static const int     ECP_SAMPLE_HIPO_CIRCLE_LONGITUDE_ID               = 65;
static const QString ECP_SAMPLE_HIPO_CIRCLE_LONGITUDE                      = "Circle Longitude";
static const QString ECP_SAMPLE_HIPO_CIRCLE_LONGITUDE_DEFAULT               = "0.0";
const int     idSampleHipoCircleLongitude()       { return ECP_SAMPLE_HIPO_CIRCLE_LONGITUDE_ID;      }
const QString nameSampleHipoCircleLongitude()     { return ECP_SAMPLE_HIPO_CIRCLE_LONGITUDE;         }
const QString defaultSampleHipoCircleLongitude()  { return ECP_SAMPLE_HIPO_CIRCLE_LONGITUDE_DEFAULT; }

static const int     ECP_SAMPLE_HIPO_CIRCLE_RADIUS_ID               = 66;
static const QString ECP_SAMPLE_HIPO_CIRCLE_RADIUS                      = "Circle Radius";
static const QString ECP_SAMPLE_HIPO_CIRCLE_RADIUS_DEFAULT               = "1500.0";
static const float   ECP_SAMPLE_HIPO_CIRCLE_RADIUS_MIN        = 0;
static const float   ECP_SAMPLE_HIPO_CIRCLE_RADIUS_MAX        = 8500.0;
static const int     ECP_SAMPLE_HIPO_CIRCLE_RADIUS_DECIMAL    = 1;

const int     idSampleHipoCircleRadius()       { return ECP_SAMPLE_HIPO_CIRCLE_RADIUS_ID;      }
const QString nameSampleHipoCircleRadius()     { return ECP_SAMPLE_HIPO_CIRCLE_RADIUS;         }
const QString defaultSampleHipoCircleRadius()  { return ECP_SAMPLE_HIPO_CIRCLE_RADIUS_DEFAULT; }
const float   minSampleHipoCircleRadius()      { return ECP_SAMPLE_HIPO_CIRCLE_RADIUS_MIN;     }
const float   maxSampleHipoCircleRadius()      { return ECP_SAMPLE_HIPO_CIRCLE_RADIUS_MAX;     }
const int     decimalSampleHipoCircleRadius()  { return ECP_SAMPLE_HIPO_CIRCLE_RADIUS_DECIMAL; }

//------------------------------------ Polygon Hipocenter --------------------------

static const int     ECP_SAMPLE_HIPO_POLYGON_VERTICE_ID               = 67;
static const QString ECP_SAMPLE_HIPO_POLYGON_VERTICE                  = "Vertices";
static const QString ECP_SAMPLE_HIPO_POLYGON_VERTICE_DEFAULT          = "3";
static const int     ECP_SAMPLE_HIPO_POLYGON_VERTICE_MIN              = 3;
static const int     ECP_SAMPLE_HIPO_POLYGON_VERTICE_MAX              = 50;
static const bool    ECP_SAMPLE_HIPO_POLYGON_VERTICE_SIGNED_VALUE                          = FALSE;
const int     idSampleHipoPolygonVertice()       { return ECP_SAMPLE_HIPO_POLYGON_VERTICE_ID;      }
const QString nameSampleHipoPolygonVertice()     { return ECP_SAMPLE_HIPO_POLYGON_VERTICE;         }
const QString defaultSampleHipoPolygonVertice()  { return ECP_SAMPLE_HIPO_POLYGON_VERTICE_DEFAULT; }
const int     minSampleHipoPolygonVertice()      { return ECP_SAMPLE_HIPO_POLYGON_VERTICE_MIN;     }
const int     maxSampleHipoPolygonVertice()      { return ECP_SAMPLE_HIPO_POLYGON_VERTICE_MAX;     }
const bool    signedSampleHipoPolygonVertice()   { return ECP_SAMPLE_HIPO_POLYGON_VERTICE_SIGNED_VALUE;}

static const int     ECP_SAMPLE_HIPO_POLYGON_MINUS180_ID               = 68;
static const QString ECP_SAMPLE_HIPO_POLYGON_MINUS180                 = "Hipocenter";
static const QString ECP_SAMPLE_HIPO_POLYGON_MINUS180_DEFAULT         = "0";
const int     idSampleHipoPolygonMinus180()       { return ECP_SAMPLE_HIPO_POLYGON_MINUS180_ID;      }
const QString nameSampleHipoPolygonMinus180()     { return ECP_SAMPLE_HIPO_POLYGON_MINUS180;         }
const QString defaultSampleHipoPolygonMinus180()  { return ECP_SAMPLE_HIPO_POLYGON_MINUS180_DEFAULT; }

//------------------------------  Polygon Latitude ---------------------------
static const int     ECP_SAMPLE_HIPO_POLYGON_LIST_LATITUDE_ID               = 69;
static const QString EECP_SAMPLE_HIPO_POLYGON_LIST_LATITUDE                      = "List Lat";
static const QString ECP_SAMPLE_HIPO_POLYGON_LIST_LATITUDE_DEFAULT               = "0.0*90.0*0.0";
const int     idSampleListLatitude()       { return ECP_SAMPLE_HIPO_POLYGON_LIST_LATITUDE_ID;      }
const QString nameSampleListLatitude()     { return EECP_SAMPLE_HIPO_POLYGON_LIST_LATITUDE;         }
const QString defaultSampleListLatitude()  { return ECP_SAMPLE_HIPO_POLYGON_LIST_LATITUDE_DEFAULT; }

//------------------------------  Polygon Longitude ---------------------------
static const int     ECP_SAMPLE_HIPO_POLYGON_LIST_LONGITUDE_ID               = 70;
static const QString ECP_SAMPLE_HIPO_POLYGON_LIST_LONGITUDE                      = "List Lon";
static const QString ECP_SAMPLE_HIPO_POLYGON_LIST_LONGITUDE_DEFAULT               = "-180.0*0.0*180.0";
const int     idSampleListLongitude()       { return ECP_SAMPLE_HIPO_POLYGON_LIST_LONGITUDE_ID;      }
const QString nameSampleListLongitude()     { return ECP_SAMPLE_HIPO_POLYGON_LIST_LONGITUDE;         }
const QString defaultSampleListLongitude()  { return ECP_SAMPLE_HIPO_POLYGON_LIST_LONGITUDE_DEFAULT; }

//------------------------------ Depth Hipocenter --------------------------------------
static const int     ECP_SAMPLE_DEPTH_IS_ID               = 71;
static const QString ECP_SAMPLE_DEPTH_IS                      = "Depth";
static const QString ECP_SAMPLE_DEPTH_IS_DEFAULT               = "0";
const int     idSampleIsDepth()       { return ECP_SAMPLE_DEPTH_IS_ID;      }
const QString nameSampleIsDepth()     { return ECP_SAMPLE_DEPTH_IS;         }
const QString defaultSampleIsDepth()  { return ECP_SAMPLE_DEPTH_IS_DEFAULT; }

static const int     ECP_SAMPLE_DEPTH_MIN_ID               = 72;
static const QString ECP_SAMPLE_DEPTH_MIN                      = "Depth Min";
static const QString ECP_SAMPLE_DEPTH_MIN_DEFAULT               = "0.0";
const int     idSampleDepthMin()       { return ECP_SAMPLE_DEPTH_MIN_ID;      }
const QString nameSampleDepthMin()     { return ECP_SAMPLE_DEPTH_MIN;         }
const QString defaultSampleDepthMin()  { return ECP_SAMPLE_DEPTH_MIN_DEFAULT; }

static const int     ECP_SAMPLE_DEPTH_MAX_ID               = 73;
static const QString ECP_SAMPLE_DEPTH_MAX                      = "Depth Max";
static const QString ECP_SAMPLE_DEPTH_MAX_DEFAULT               = "999.0";
const int     idSampleDepthMax()       { return ECP_SAMPLE_DEPTH_MAX_ID;      }
const QString nameSampleDepthMax()     { return ECP_SAMPLE_DEPTH_MAX;         }
const QString defaultSampleDepthMax()  { return ECP_SAMPLE_DEPTH_MAX_DEFAULT; }

//------------------------------ Magnitude Mb --------------------------------------
static const int     ECP_SAMPLE_MB_IS_ID               = 74;
static const QString ECP_SAMPLE_MB_IS                      = "M1";
static const QString ECP_SAMPLE_MB_IS_DEFAULT               = "0";
const int     idSampleIsMb()       { return ECP_SAMPLE_MB_IS_ID;      }
const QString nameSampleIsMb()     { return ECP_SAMPLE_MB_IS;         }
const QString defaultSampleIsMb()  { return ECP_SAMPLE_MB_IS_DEFAULT; }

static const int     ECP_SAMPLE_MB_MIN_ID               = 75;
static const QString ECP_SAMPLE_MB_MIN                      = "M1 Min";
static const QString ECP_SAMPLE_MB_MIN_DEFAULT               = "0.0";
const int     idSampleMbMin()       { return ECP_SAMPLE_MB_MIN_ID;      }
const QString nameSampleMbMin()     { return ECP_SAMPLE_MB_MIN;         }
const QString defaultSampleMbMin()  { return ECP_SAMPLE_MB_MIN_DEFAULT; }

static const int     ECP_SAMPLE_MB_MAX_ID               = 76;
static const QString ECP_SAMPLE_MB_MAX                      = "M1 Max";
static const QString ECP_SAMPLE_MB_MAX_DEFAULT               = "9.0";
const int     idSampleMbMax()       { return ECP_SAMPLE_MB_MAX_ID;      }
const QString nameSampleMbMax()     { return ECP_SAMPLE_MB_MAX;         }
const QString defaultSampleMbMax()  { return ECP_SAMPLE_MB_MAX_DEFAULT; }

//------------------------------ Magnitude Ms --------------------------------------
static const int     ECP_SAMPLE_MS_IS_ID               = 77;
static const QString ECP_SAMPLE_MS_IS                      = "M2";
static const QString ECP_SAMPLE_MS_IS_DEFAULT               = "0";
const int     idSampleIsMs()       { return ECP_SAMPLE_MS_IS_ID;      }
const QString nameSampleIsMs()     { return ECP_SAMPLE_MS_IS;         }
const QString defaultSampleIsMs()  { return ECP_SAMPLE_MS_IS_DEFAULT; }

static const int     ECP_SAMPLE_MS_MIN_ID               = 78;
static const QString ECP_SAMPLE_MS_MIN                      = "M2 Min";
static const QString ECP_SAMPLE_MS_MIN_DEFAULT               = "0.0";
const int     idSampleMsMin()       { return ECP_SAMPLE_MS_MIN_ID;      }
const QString nameSampleMsMin()     { return ECP_SAMPLE_MS_MIN;         }
const QString defaultSampleMsMin()  { return ECP_SAMPLE_MS_MIN_DEFAULT; }

static const int     ECP_SAMPLE_MS_MAX_ID               = 79;
static const QString ECP_SAMPLE_MS_MAX                      = "M2 Max";
static const QString ECP_SAMPLE_MS_MAX_DEFAULT               = "9.0";
const int     idSampleMsMax()       { return ECP_SAMPLE_MS_MAX_ID;      }
const QString nameSampleMsMax()     { return ECP_SAMPLE_MS_MAX;         }
const QString defaultSampleMsMax()  { return ECP_SAMPLE_MS_MAX_DEFAULT; }

//------------------------------ Magnitude Ml --------------------------------------
static const int     ECP_SAMPLE_ML_IS_ID               = 80;
static const QString ECP_SAMPLE_ML_IS                      = "M3";
static const QString ECP_SAMPLE_ML_IS_DEFAULT               = "0";
const int     idSampleIsMl()       { return ECP_SAMPLE_ML_IS_ID;      }
const QString nameSampleIsMl()     { return ECP_SAMPLE_ML_IS;         }
const QString defaultSampleIsMl()  { return ECP_SAMPLE_ML_IS_DEFAULT; }

static const int     ECP_SAMPLE_ML_MIN_ID               = 81;
static const QString ECP_SAMPLE_ML_MIN                      = "M3 Min";
static const QString ECP_SAMPLE_ML_MIN_DEFAULT               = "0.0";
const int     idSampleMlMin()       { return ECP_SAMPLE_ML_MIN_ID;      }
const QString nameSampleMlMin()     { return ECP_SAMPLE_ML_MIN;         }
const QString defaultSampleMlMin()  { return ECP_SAMPLE_ML_MIN_DEFAULT; }

static const int     ECP_SAMPLE_ML_MAX_ID               = 82;
static const QString ECP_SAMPLE_ML_MAX                      = "M3 Max";
static const QString ECP_SAMPLE_ML_MAX_DEFAULT               = "9.0";
const int     idSampleMlMax()       { return ECP_SAMPLE_ML_MAX_ID;      }
const QString nameSampleMlMax()     { return ECP_SAMPLE_ML_MAX;         }
const QString defaultSampleMlMax()  { return ECP_SAMPLE_ML_MAX_DEFAULT; }

//------------------------------ Magnitude Mp --------------------------------------
static const int     ECP_SAMPLE_MP_IS_ID               = 83;
static const QString ECP_SAMPLE_MP_IS                      = "M4";
static const QString ECP_SAMPLE_MP_IS_DEFAULT               = "0";
const int     idSampleIsMp()       { return ECP_SAMPLE_MP_IS_ID;      }
const QString nameSampleIsMp()     { return ECP_SAMPLE_MP_IS;         }
const QString defaultSampleIsMp()  { return ECP_SAMPLE_MP_IS_DEFAULT; }

static const int     ECP_SAMPLE_MP_MIN_ID               = 84;
static const QString ECP_SAMPLE_MP_MIN                      = "M4 Min";
static const QString ECP_SAMPLE_MP_MIN_DEFAULT               = "0.0";
const int     idSampleMpMin()       { return ECP_SAMPLE_MP_MIN_ID;      }
const QString nameSampleMpMin()     { return ECP_SAMPLE_MP_MIN;         }
const QString defaultSampleMpMin()  { return ECP_SAMPLE_MP_MIN_DEFAULT; }

static const int     ECP_SAMPLE_MP_MAX_ID               = 85;
static const QString ECP_SAMPLE_MP_MAX                      = "M4 Max";
static const QString ECP_SAMPLE_MP_MAX_DEFAULT               = "9.0";
const int     idSampleMpMax()       { return ECP_SAMPLE_MP_MAX_ID;      }
const QString nameSampleMpMax()     { return ECP_SAMPLE_MP_MAX;         }
const QString defaultSampleMpMax()  { return ECP_SAMPLE_MP_MAX_DEFAULT; }

//------------------------------ Intensity --------------------------------------
static const int     ECP_SAMPLE_INTENSITY_IS_ID               = 86;
static const QString ECP_SAMPLE_INTENSITY_IS                      = "Intencity";
static const QString ECP_SAMPLE_INTENSITY_IS_DEFAULT               = "0";
const int     idSampleIsIntensity()       { return ECP_SAMPLE_INTENSITY_IS_ID;      }
const QString nameSampleIsIntensity()     { return ECP_SAMPLE_INTENSITY_IS;         }
const QString defaultSampleIsIntensity()  { return ECP_SAMPLE_INTENSITY_IS_DEFAULT; }

static const int     ECP_SAMPLE_INTENSITY_MIN_ID               = 87;
static const QString ECP_SAMPLE_INTENSITY_MIN                      = "Intencity Min";
static const QString ECP_SAMPLE_INTENSITY_MIN_DEFAULT               = "0";
const int     idSampleIntensityMin()       { return ECP_SAMPLE_INTENSITY_MIN_ID;      }
const QString nameSampleIntensityMin()     { return ECP_SAMPLE_INTENSITY_MIN;         }
const QString defaultSampleIntensityMin()  { return ECP_SAMPLE_INTENSITY_MIN_DEFAULT; }

static const int     ECP_SAMPLE_INTENSITY_MAX_ID               = 88;
static const QString ECP_SAMPLE_INTENSITY_MAX                      = "Intencity Max";
static const QString ECP_SAMPLE_INTENSITY_MAX_DEFAULT               = "12";
const int     idSampleIntensityMax()       { return ECP_SAMPLE_INTENSITY_MAX_ID;      }
const QString nameSampleIntensityMax()     { return ECP_SAMPLE_INTENSITY_MAX;         }
const QString defaultSampleIntensityMax()  { return ECP_SAMPLE_INTENSITY_MAX_DEFAULT; }

//------------------------------ Magnitude Function --------------------------------------
static const int     ECP_SAMPLE_MAGFUNCTION_IS_ID               = 89;
static const QString ECP_SAMPLE_MAGFUNCTION_IS                      = "Magnitude Function";
static const QString ECP_SAMPLE_MAGFUNCTION_IS_DEFAULT               = "0";
const int     idSampleIsMagFunction()       { return ECP_SAMPLE_MAGFUNCTION_IS_ID;      }
const QString nameSampleIsMagFunction()     { return ECP_SAMPLE_MAGFUNCTION_IS;         }
const QString defaultSampleIsMagFunction()  { return ECP_SAMPLE_MAGFUNCTION_IS_DEFAULT; }

static const int     ECP_SAMPLE_MAGFUNCTION_TYPE_ID               = 90;
static const QString ECP_SAMPLE_MAGFUNCTION_TYPE                      = "Magnitude Function Type";
static const QString ECP_SAMPLE_MAGFUNCTION_TYPE_DEFAULT               = "1";
static const QString ECP_SAMPLE_MAGFUNCTION_TYPE_ENUM           = "Intervals Function";
const int     idSampleMagFunctionType()       { return ECP_SAMPLE_MAGFUNCTION_TYPE_ID;      }
const QString nameSampleMagFunctionType()     { return ECP_SAMPLE_MAGFUNCTION_TYPE;         }
const QString defaultSampleMagFunctionType()  { return ECP_SAMPLE_MAGFUNCTION_TYPE_DEFAULT; }
const QString enumSampleMagFunctionType()     { return ECP_SAMPLE_MAGFUNCTION_TYPE_ENUM;    }

static const int     ECP_SAMPLE_MAGFUNCTION_MIN_ID               = 91;
static const QString ECP_SAMPLE_MAGFUNCTION_MIN                      = "Mag Min";
static const QString ECP_SAMPLE_MAGFUNCTION_MIN_DEFAULT               = "0.0";
const int     idSampleMagFunctionMin()       { return ECP_SAMPLE_MAGFUNCTION_MIN_ID;      }
const QString nameSampleMagFunctionMin()     { return ECP_SAMPLE_MAGFUNCTION_MIN;         }
const QString defaultSampleMagFunctionMin()  { return ECP_SAMPLE_MAGFUNCTION_MIN_DEFAULT; }

static const int     ECP_SAMPLE_MAGFUNCTION_MAX_ID               = 92;
static const QString ECP_SAMPLE_MAGFUNCTION_MAX                      = "Mag Max";
static const QString ECP_SAMPLE_MAGFUNCTION_MAX_DEFAULT               = "9.0";
const int     idSampleMagFunctionMax()       { return ECP_SAMPLE_MAGFUNCTION_MAX_ID;      }
const QString nameSampleMagFunctionMax()     { return ECP_SAMPLE_MAGFUNCTION_MAX;         }
const QString defaultSampleMagFunctionMax()  { return ECP_SAMPLE_MAGFUNCTION_MAX_DEFAULT; }

///----------------------Sample Magnitude Functions  ----------------------------------------
static const int  ECP_SAMPLE_MAGFUNCTION_ID                = 93;
static const QString ECP_SAMPLE_MAGFUNCTION                       = "Sample Magnitude Functions";
static const QString ECP_SAMPLE_MAGFUNCTION_DEFAULT               = "0";
static const QString ECP_SAMPLE_MAGFUNCTION_ENUM       = "value@maximum@minimum@average";
const int idSampleMagFunction()           { return ECP_SAMPLE_MAGFUNCTION_ID;      }
const QString nameSampleMagFunction()     { return ECP_SAMPLE_MAGFUNCTION;         }
const QString defaultSampleMagFunction()  { return ECP_SAMPLE_MAGFUNCTION_DEFAULT; }
const QString enumSampleMagFunction()     { return ECP_SAMPLE_MAGFUNCTION_ENUM;    }

//-------------------------  Transform magnitude for Sample Magnitude Functions ----------------
///---------------------- Magnitude of First priority -------------------------------------
static const int ECP_SAMPLE_MAGFUNCTION_PRIORITY_FIRST_ID           =  94;
const int      idSampleMagFunctionPriorityFirst()        { return ECP_SAMPLE_MAGFUNCTION_PRIORITY_FIRST_ID;      }

///---------------------- Magnitude of Second priority -------------------------------------
static const int ECP_SAMPLE_MAGFUNCTION_PRIORITY_SECOND_ID           =  95;
const int      idSampleMagFunctionPrioritySecond()        { return ECP_SAMPLE_MAGFUNCTION_PRIORITY_SECOND_ID;      }

///---------------------- Magnitude of Third priority -------------------------------------
static const int ECP_SAMPLE_MAGFUNCTION_PRIORITY_THIRD_ID           =  96;
const int      idSampleMagFunctionPriorityThird()        { return ECP_SAMPLE_MAGFUNCTION_PRIORITY_THIRD_ID;      }

///---------------------- Magnitude of Fourth priority -------------------------------------
static const int ECP_SAMPLE_MAGFUNCTION_PRIORITY_FOURTH_ID           =  97;
const int      idSampleMagFunctionPriorityFourth()        { return ECP_SAMPLE_MAGFUNCTION_PRIORITY_FOURTH_ID;      }


///---------------------- Project parameters -------------------------------------

///---------------------- Project action list -------------------------------------
static const QString ECP_PROJECT_ACTION_LIST_ENUM       = "Convert magnitudes@Remove duplicates@Select subcatalog@Merge catalogs@Substitute catalogs";
const QString projectActionList()     { return ECP_PROJECT_ACTION_LIST_ENUM;    }


static QString ECP_PROJECT_COMPARE_TITLE = "Compare catalogs";
const QString projectCompareTitle()                   { return ECP_PROJECT_COMPARE_TITLE; }

static QString ECP_PROJECT_RANGE_TITLE = "Check specified ranges";
const QString projectRangeTitle()                   { return ECP_PROJECT_RANGE_TITLE; }

///----------------------------------- Project List-----------------------------
static const int     ECP_PROJECT_ACTION_LIST_ID         = 101;
static const QString ECP_PROJECT_ACTION_LIST                      = "Project Action";
static const QString ECP_PROJECT_ACTION_LIST_DEFAULT               = QString();
const int     idProjectActionList()       { return ECP_PROJECT_ACTION_LIST_ID;      }
const QString nameProjectActionList()     { return ECP_PROJECT_ACTION_LIST;         }
const QString defaultProjectActionList()  { return ECP_PROJECT_ACTION_LIST_DEFAULT; }

///----------------------------------- Project In Catalog Name-----------------------------
static const int     ECP_PROJECT_CATALOG_NAME_ID         = 102;
static const QString ECP_PROJECT_CATALOG_NAME                      = "Project Catalog";
static const QString ECP_PROJECT_CATALOG_NAME_DEFAULT               = QString();
const int     idProjectCatalogName()       { return ECP_PROJECT_CATALOG_NAME_ID;      }
const QString nameProjectCatalogName()     { return ECP_PROJECT_CATALOG_NAME;         }
const QString defaultProjectCatalogName()  { return ECP_PROJECT_CATALOG_NAME_DEFAULT; }

///-----------------------------------  Action Parameters (current or default)-----------------------------
static const int     ECP_PROJECT_DOCUMENT_IN_ID          = 103;
static const QString ECP_PROJECT_DOCUMENT_IN                      = "CurDoc DefDoc";
static const QString ECP_PROJECT_DOCUMENT_IN_DEFAULT               = "1";
static const QString ECP_PROJECT_DOCUMENT_IN_ENUM           = "current default";
const int     idProjectDocumentIn()       { return ECP_PROJECT_DOCUMENT_IN_ID;      }
const QString nameProjectDocumentIn()     { return ECP_PROJECT_DOCUMENT_IN;         }
const QString defaultProjectDocumentIn()  { return ECP_PROJECT_DOCUMENT_IN_DEFAULT; }
const QString enumProjectDocumentIn()     { return ECP_PROJECT_DOCUMENT_IN_ENUM;    }

///-----------------------------------  Action Action Chose (list or not)---------------
static const int     ECP_PROJECT_ACTION_CHOISE_ID        = 104;
static const QString ECP_PROJECT_ACTION_CHOISE                      = "Proj choise";
static const QString ECP_PROJECT_ACTION_CHOISE_DEFAULT               = "0";
static const QString ECP_PROJECT_ACTION_CHOISE_ENUM           = "list compare check";
const int     idProjectActionChoise()       { return ECP_PROJECT_ACTION_CHOISE_ID;      }
const QString nameProjectActionChoise()     { return ECP_PROJECT_ACTION_CHOISE;         }
const QString defaultProjectActionChoise()  { return ECP_PROJECT_ACTION_CHOISE_DEFAULT; }
const QString enumProjectActionChoise()     { return ECP_PROJECT_ACTION_CHOISE_ENUM;    }


///-----------------------------------  Histogram Parameters ----------------------------

            /// number interval axis X
static const int       ECP_NUMBER_INTERVAL_AXIS_X_ID       = 510; 
static const QString   ECP_NUMBER_INTERVAL_AXIS_X_NAME     = "number interval axis X";
static const QString   ECP_NUMBER_INTERVAL_AXIS_X_DEFAULT  = "100";
static const int       ECP_NUMBER_INTERVAL_AXIS_X_MIN      = 10; 
static const int       ECP_NUMBER_INTERVAL_AXIS_X_MAX      = 150;
static const int       ECP_NUMBER_INTERVAL_AXIS_X_SPINBOX_STEP    = 5;
static const bool      ECP_NUMBER_INTERVAL_AXIS_X_SIGNED_VALUE    = FALSE;
const int       idNumberIntervalAxisX()       { return ECP_NUMBER_INTERVAL_AXIS_X_ID;  }
const QString   nameNumberIntervalAxisX()     { return ECP_NUMBER_INTERVAL_AXIS_X_NAME;    }
const QString   defaultNumberIntervalAxisX()  { return ECP_NUMBER_INTERVAL_AXIS_X_DEFAULT; }
const int       minNumberIntervalAxisX()      { return ECP_NUMBER_INTERVAL_AXIS_X_MIN;     }
const int       maxNumberIntervalAxisX()      { return ECP_NUMBER_INTERVAL_AXIS_X_MAX;     }
const bool      signedNumberIntervalAxisX()   { return ECP_NUMBER_INTERVAL_AXIS_X_SIGNED_VALUE;  }
const int       stepNumberIntervalAxisX()     { return ECP_NUMBER_INTERVAL_AXIS_X_SPINBOX_STEP;  }

            /// number interval axis Y
static const int       ECP_NUMBER_INTERVAL_AXIS_Y_ID       = 511; 
static const QString   ECP_NUMBER_INTERVAL_AXIS_Y_NAME     = "number interval axis Y";
static const QString   ECP_NUMBER_INTERVAL_AXIS_Y_DEFAULT  = "100";
static const int       ECP_NUMBER_INTERVAL_AXIS_Y_MIN      = 10; 
static const int       ECP_NUMBER_INTERVAL_AXIS_Y_MAX      = 150;
static const int       ECP_NUMBER_INTERVAL_AXIS_Y_SPINBOX_STEP    = 5;
static const bool      ECP_NUMBER_INTERVAL_AXIS_Y_SIGNED_VALUE    = FALSE;
const int       idNumberIntervalAxisY()       { return ECP_NUMBER_INTERVAL_AXIS_Y_ID;  }
const QString   nameNumberIntervalAxisY()     { return ECP_NUMBER_INTERVAL_AXIS_Y_NAME;    }
const QString   defaultNumberIntervalAxisY()  { return ECP_NUMBER_INTERVAL_AXIS_Y_DEFAULT; }
const int       minNumberIntervalAxisY()      { return ECP_NUMBER_INTERVAL_AXIS_Y_MIN;     }
const int       maxNumberIntervalAxisY()      { return ECP_NUMBER_INTERVAL_AXIS_Y_MAX;     }
const bool      signedNumberIntervalAxisY()   { return ECP_NUMBER_INTERVAL_AXIS_Y_SIGNED_VALUE;  }
const int       stepNumberIntervalAxisY()     { return ECP_NUMBER_INTERVAL_AXIS_Y_SPINBOX_STEP;  }

           /// number interval axis Z
static const int       ECP_NUMBER_INTERVAL_AXIS_Z_ID       = 512; 
static const QString   ECP_NUMBER_INTERVAL_AXIS_Z_NAME     = "number interval axis Z";
static const QString   ECP_NUMBER_INTERVAL_AXIS_Z_DEFAULT  = "10";
static const int       ECP_NUMBER_INTERVAL_AXIS_Z_MIN      = 2; 
static const int       ECP_NUMBER_INTERVAL_AXIS_Z_MAX      = 20;
static const int       ECP_NUMBER_INTERVAL_AXIS_Z_SPINBOX_STEP    = 1;
static const bool      ECP_NUMBER_INTERVAL_AXIS_Z_SIGNED_VALUE    = FALSE;
const int       idNumberIntervalAxisZ()       { return ECP_NUMBER_INTERVAL_AXIS_Z_ID;  }
const QString   nameNumberIntervalAxisZ()     { return ECP_NUMBER_INTERVAL_AXIS_Z_NAME;    }
const QString   defaultNumberIntervalAxisZ()  { return ECP_NUMBER_INTERVAL_AXIS_Z_DEFAULT; }
const int       minNumberIntervalAxisZ()      { return ECP_NUMBER_INTERVAL_AXIS_Z_MIN;     }
const int       maxNumberIntervalAxisZ()      { return ECP_NUMBER_INTERVAL_AXIS_Z_MAX;     }
const bool      signedNumberIntervalAxisZ()   { return ECP_NUMBER_INTERVAL_AXIS_Z_SIGNED_VALUE;  }
const int       stepNumberIntervalAxisZ()     { return ECP_NUMBER_INTERVAL_AXIS_Z_SPINBOX_STEP;  }

           /// list parameters
static const QString ECP_HISTOGRAM_PARAMETER_LIST       
       = "Years@Latitude@Longitude@Depth@m1@m2@m3@m4";
const QString listHistgramParameters()     { return ECP_HISTOGRAM_PARAMETER_LIST; }


           /// list parameters min, max
static const QString ECP_HISTOGRAM_MIN_MAX_LIST       
       = "Depth@m1@m2@m3@m4";
const QString listHistgramMinMax()     { return ECP_HISTOGRAM_MIN_MAX_LIST; }

///-----------------------------------  Histogram Constants ----------------------------

///----------------------------------------- Coefficent A--------------------------------  
static const QString ECP_HISTOGRAM_COEFFICIENT_A           = "Coefficent A";
static const QString ECP_HISTOGRAM_COEFFICIENT_A_DEFAULT   = "1"  ;
static const float   ECP_HISTOGRAM_COEFFICIENT_A_MIN       = -40;
static const float   ECP_HISTOGRAM_COEFFICIENT_A_MAX       = 40;
static const int     ECP_HISTOGRAM_COEFFICIENT_A_DECIMAL   = 2;
const QString  nameHistogramCoefficentA()          { return ECP_HISTOGRAM_COEFFICIENT_A;                      }
const QString  defaultHistogramCoefficentA()       { return ECP_HISTOGRAM_COEFFICIENT_A_DEFAULT;      }
const float    minHistogramCoefficentA()           { return ECP_HISTOGRAM_COEFFICIENT_A_MIN;               }
const float    maxHistogramCoefficentA()           { return ECP_HISTOGRAM_COEFFICIENT_A_MAX;              }
const int      decimalHistogramCoefficentA()       { return ECP_HISTOGRAM_COEFFICIENT_A_DECIMAL;      }
///----------------------------------------- Coefficent B--------------------------------  
static const QString ECP_HISTOGRAM_COEFFICIENT_B           = "Coefficent B";
static const QString ECP_HISTOGRAM_COEFFICIENT_B_DEFAULT   = "1"  ;
static const float   ECP_HISTOGRAM_COEFFICIENT_B_MIN       = 0;
static const float   ECP_HISTOGRAM_COEFFICIENT_B_MAX       = 3;
static const int     ECP_HISTOGRAM_COEFFICIENT_B_DECIMAL   = 2;
const QString  nameHistogramCoefficentB()          { return ECP_HISTOGRAM_COEFFICIENT_B;                      }
const QString  defaultHistogramCoefficentB()       { return ECP_HISTOGRAM_COEFFICIENT_B_DEFAULT;      }
const float    minHistogramCoefficentB()           { return ECP_HISTOGRAM_COEFFICIENT_B_MIN;               }
const float    maxHistogramCoefficentB()           { return ECP_HISTOGRAM_COEFFICIENT_B_MAX;              }
const int      decimalHistogramCoefficentB()       { return ECP_HISTOGRAM_COEFFICIENT_B_DECIMAL;      }
///----------------------------------------- Standard Coefficents--------------------------------  

static const float ECP_HISTOGRAM_COEFFICIENT_A_ENRGY  = 11.8;
const float energyHistogramCoefficentA() { return ECP_HISTOGRAM_COEFFICIENT_A_ENRGY; }

static const float ECP_HISTOGRAM_COEFFICIENT_B_ENRGY  = 1.5;
const float energyHistogramCoefficentB() { return ECP_HISTOGRAM_COEFFICIENT_B_ENRGY; }

static const float ECP_HISTOGRAM_COEFFICIENT_A_AREA  = -4.0;
const float areaHistogramCoefficentA() { return ECP_HISTOGRAM_COEFFICIENT_A_AREA; }

static const float ECP_HISTOGRAM_COEFFICIENT_B_AREA  = 1.0;
const float areaHistogramCoefficentB() { return ECP_HISTOGRAM_COEFFICIENT_B_AREA; }

static const float ECP_HISTOGRAM_COEFFICIENT_A_LENGHT  = -2.0;
const float lenghtHistogramCoefficentA() { return ECP_HISTOGRAM_COEFFICIENT_A_LENGHT; }

static const float ECP_HISTOGRAM_COEFFICIENT_B_LENGHT  = 0.5;
const float lenghtHistogramCoefficentB() { return ECP_HISTOGRAM_COEFFICIENT_B_LENGHT; }

static const float ECP_HISTOGRAM_COEFFICIENT_A_CUSTOM  = 1.0;
const float customHistogramCoefficentA() { return ECP_HISTOGRAM_COEFFICIENT_A_CUSTOM; }

static const float ECP_HISTOGRAM_COEFFICIENT_B_CUSTOM  = 1.0;
const float customHistogramCoefficentB() { return ECP_HISTOGRAM_COEFFICIENT_B_CUSTOM; }

///----------------------------------------- Type Weght --------------------------------  

//static const QString ECP_HISTOGRAM_TYPE_WEIGHT_LIST_ENUM = "Energy, erg@Area, km squared@Length, km@Custom";
static const QString ECP_HISTOGRAM_TYPE_WEIGHT_LIST_ENUM = "Energy@Area@Length@Custom";

const QString enumHistogramTypeWeightList()     { return ECP_HISTOGRAM_TYPE_WEIGHT_LIST_ENUM;    }




