#ifndef _FTAN_DEFAULTS_H
#define _FTAN_DEFAULTS_H
const QString  ecpRootPath();
const QString  searchHelpPath();
const QString  userHomePath();
const QString  temporarySystemDirectoryPath();
const QString  temporaryDirectoryPrifix() ;
const QString  mainWindowCaption();
const QString  fileFormatSeparator();
const QString fileFilterLocator();
const QString projectFileFilterLocator();
const QString protocolFileFilterLocator();
const QString txtFilterLocator() ;
const QString poligonFilterLocator();
const QString openBinaryCatalogfileName();
const QString openTempBinaryCatalogfileName();
const QString openTempMergeBinaryCatalogfileName();
const QString openSecondBinaryCatalogfileName();
const QString openProjectBinaryCatalogfileName();

const QString prefixMessage();
const QString cancelMessage();
const QString postfixActionMessage();
const QString exportUserFormat();
const QString  fontmetricLineEdit();

const float    maxEcpFloat();
///---- QDataStream version read-write constants : -----
const QString  EcpCurrentVersion();

const QString  EcpVersionsForQt4();
const QString  EcpVersionsForQt4_3();
const float    acuracyCompareFloatValue();
const float    acuracyCompareTimeValue();
// VIEW BUFFER SIZE SPECIFICATIONS

             // MAX LINES DOUBLES CORRECTION PAGE
const int       idMaxLinesDoublesCorrectonPage();
const QString   nameMaxLinesDoublesCorrectonPage();
const QString   defaultMaxLinesDoublesCorrectonPage();
const int       minMaxLinesDoublesCorrectonPage();
const int       maxMaxLinesDoublesCorrectonPage();
const bool      signedMaxLinesDoublesCorrectonPage();
const int       stepMaxLinesDoublesCorrectonPage();

          // CATALOG BUFFER 
const int       idViewBufferCatalog();
const QString   nameViewBufferCatalog();
const QString   defaultViewBufferCatalog();
const int       minViewBufferCatalog();
const int       maxViewBufferCatalog();
const bool      signedViewBufferCatalog();
const int       stepViewBufferCatalog();
             // ERROR BUFFER
const int       idViewBufferError();
const QString   nameViewBufferError();
const QString   defaultViewBufferError();
const int       minViewBufferError();
const int       maxViewBufferError();
const bool      signedViewBufferError();
const int       stepViewBufferError();

             // MAX ERROR  LINES CORRECTION PAGE
const int       idMaxLinesErrorsCorrectonPage();
const QString   nameMaxLinesErrorsCorrectonPage();
const QString   defaultMaxLinesErrorsCorrectonPage();
const int       minMaxLinesErrorsCorrectonPage();
const int       maxMaxLinesErrorsCorrectonPage();
const bool      signedMaxLinesErrorsCorrectonPage();
const int       stepMaxLinesErrorsCorrectonPage();

// TABLE SPECIFICATIONS:
// Number of catalog record
const int          numberCatalogRecord();
const QString  headerCatalogRecord() ;
const QString  fontmetricCatalogRecord();
const int          minCatalogRecord() ;
const int          maxCatalogRecord();
const bool       signedCatalogRecord();

// Year 
const int          numberCatalogYear();
const QString  headerCatalogYear();
const QString  fontmetricCatalogYear();
const int          minCatalogYear();
const int          maxCatalogYear();
const bool       signedCatalogYear();

// Month 
const int          numberCatalogMonth();
const QString  headerCatalogMonth();
const QString  fontmetricCatalogMonth();
const int          minCatalogMonth();
const int          maxCatalogMonth();
const bool       signedCatalogMonth();

 // Day 
const int          numberCatalogDay();
const QString  headerCatalogDay();
const QString  fontmetricCatalogDay();
const int          minCatalogDay();
const int          maxCatalogDay() ;
const bool       signedCatalogDay();

 // Hour 
const int          numberCatalogHour();
const QString  headerCatalogHour();
const QString  fontmetricCatalogHour();
const int          minCatalogHour();
const int          maxCatalogHour();
const bool       signedCatalogHour();

// Minute 
const int          numberCatalogMinute();
const QString  headerCatalogMinute();
const QString  fontmetricCatalogMinute();
const int          minCatalogMinute();
const int          maxCatalogMinute();
const bool       signedCatalogMinute();

// Second
const int  secondMagnification();

const int          numberCatalogSecond();
const QString  headerCatalogSecond();
const QString  fontmetricCatalogSecond();
const float       minCatalogSecond();
const float       maxCatalogSecond();
const int          decimalCatalogSecond();


 // Latitude
// latitude   >= 100 (bin20 format magnification = 100)
const int          latitudeMagnification();

const int          numberCatalogLatitude();
const QString  headerCatalogLatitude();
const QString  fontmetricCatalogLatitude();
const float       minCatalogLatitude();
const float       maxCatalogLatitude();
const int          decimalCatalogLatitude();
//-------------------------------Latitude Minimum property ----------------------------------------------------------
const int        idMinimumPropertyLatitude();
const QString    nameMinimumPropertyLatitude();
const QString    defaultMinimumPropertyLatitude();
const float      minMinimumPropertyLatitude();
const float      maxMinimumPropertyLatitude();
const int        decimalMinimumPropertyLatitude();
//--------------------------------------------------------------------------------------------------------------
//-------------------------------Latitude Maximum property ----------------------------------------------------------
const int        idMaximumPropertyLatitude();
const QString    nameMaximumPropertyLatitude();
const QString    defaultMaximumPropertyLatitude();
const float      minMaximumPropertyLatitude();
const float      maxMaximumPropertyLatitude();
const int        decimalMaximumPropertyLatitude();
//--------------------------------------------------------------------------------------------------------------

 // Longitude
//longitude   >= 100 (bin20 format magnification = 100)
const int          longitudeMagnification();

const int          numberCatalogLongitude();
const QString  headerCatalogLongitude();
const QString  fontmetricCatalogLongitude();
const float       minCatalogLongitude();
const float       maxCatalogLongitude();
const int          decimalCatalogLongitude();
//-------------------------------Longitude Minimum property ----------------------------------------------------------
const int        idMinimumPropertyLongitude();
const QString    nameMinimumPropertyLongitude();
const QString    defaultMinimumPropertyLongitude();
const float      minMinimumPropertyLongitude();
const float      maxMinimumPropertyLongitude();
const int        decimalMinimumPropertyLongitude();
//--------------------------------------------------------------------------------------------------------------
//-------------------------------Longitude Maximum property ----------------------------------------------------------
const int        idMaximumPropertyLongitude();
const QString    nameMaximumPropertyLongitude();
const QString    defaultMaximumPropertyLongitude();
const float      minMaximumPropertyLongitude();
const float      maxMaximumPropertyLongitude();
const int        decimalMaximumPropertyLongitude();;
//--------------------------------------------------------------------------------------------------------------

 // Depth
// depth  >= 1 (bin20 format magnification = 1)
const int  depthMagnification();

const int          numberCatalogDepth();
const QString  headerCatalogDepth();
const QString  fontmetricCatalogDepth();
const float       minCatalogDepth();
const float       maxCatalogDepth();
const int          decimalCatalogDepth();

//-------------------------------Depth Minimum property ----------------------------------------------------------
const int        idMinimumPropertyDepth();
const QString    nameMinimumPropertyDepth();
const QString    defaultMinimumPropertyDepth();
const float      minMinimumPropertyDepth();
const float      maxMinimumPropertyDepth();
const int        decimalMinimumPropertyDepth();
//--------------------------------------------------------------------------------------------------------------
//-------------------------------Depth Maximum property ----------------------------------------------------------
const int        idMaximumPropertyDepth();
const QString    nameMaximumPropertyDepth();
const QString    defaultMaximumPropertyDepth();
const float      minMaximumPropertyDepth();
const float      maxMaximumPropertyDepth();
const int        decimalMaximumPropertyDepth();
//--------------------------------------------------------------------------------------------------------------

// Magnitudes
// magnitude  >= 100 (bin20 format magnification = 100)
const int  magnitudeMagnification();
// Mb
const int          numberCatalogMb();
const QString  headerCatalogMb() ;
const QString  fontmetricCatalogMb();
const float       minCatalogMb();
const float       maxCatalogMb();
const int         decimalCatalogMb();
//-------------------------------Mb Minimum property ----------------------------------------------------------
const int        idMinimumPropertyMb();
const QString    nameMinimumPropertyMb();
const QString    defaultMinimumPropertyMb();
const float      minMinimumPropertyMb();
const float      maxMinimumPropertyMb();
const int        decimalMinimumPropertyMb();
//--------------------------------------------------------------------------------------------------------------
//-------------------------------Mb Maximum property ----------------------------------------------------------
const int        idMaximumPropertyMb();
const QString    nameMaximumPropertyMb();
const QString    defaultMaximumPropertyMb();
const float      minMaximumPropertyMb();
const float      maxMaximumPropertyMb();
const int        decimalMaximumPropertyMb();
//--------------------------------------------------------------------------------------------------------------

// Ms
const int          numberCatalogMs();
const QString  headerCatalogMs();
const QString  fontmetricCatalogMs();
const float       minCatalogMs();
const float       maxCatalogMs();
const int          decimalCatalogMs();
//-------------------------------Ms Minimum property ----------------------------------------------------------
const int        idMinimumPropertyMs();
const QString    nameMinimumPropertyMs();
const QString    defaultMinimumPropertyMs();
const float      minMinimumPropertyMs();
const float      maxMinimumPropertyMs();
const int        decimalMinimumPropertyMs();
//--------------------------------------------------------------------------------------------------------------
//-------------------------------Ms Maximum property ----------------------------------------------------------
const int        idMaximumPropertyMs();
const QString    nameMaximumPropertyMs();
const QString    defaultMaximumPropertyMs();
const float      minMaximumPropertyMs();
const float      maxMaximumPropertyMs();
const int        decimalMaximumPropertyMs();
//--------------------------------------------------------------------------------------------------------------

// Ml
const int          numberCatalogMl();
const QString  headerCatalogMl();
const QString  fontmetricCatalogMl();
const float       minCatalogMl();
const float       maxCatalogMl();
const int         decimalCatalogMl();
//-------------------------------Ml Minimum property ----------------------------------------------------------
const int        idMinimumPropertyMl();
const QString    nameMinimumPropertyMl();
const QString    defaultMinimumPropertyMl();
const float      minMinimumPropertyMl();
const float      maxMinimumPropertyMl();
const int        decimalMinimumPropertyMl();
//--------------------------------------------------------------------------------------------------------------
//-------------------------------Ml Maximum property ----------------------------------------------------------
const int        idMaximumPropertyMl();
const QString    nameMaximumPropertyMl();
const QString    defaultMaximumPropertyMl();
const float      minMaximumPropertyMl();
const float      maxMaximumPropertyMl();
const int        decimalMaximumPropertyMl();
//--------------------------------------------------------------------------------------------------------------

// Mp
const int          numberCatalogMp();
const QString  headerCatalogMp();
const QString  fontmetricCatalogMp();
const float       minCatalogMp();
const float       maxCatalogMp();
const int         decimalCatalogMp();
//-------------------------------Mp Minimum property ----------------------------------------------------------
const int        idMinimumPropertyMp();
const QString    nameMinimumPropertyMp();
const QString    defaultMinimumPropertyMp();
const float      minMinimumPropertyMp();
const float      maxMinimumPropertyMp();
const int        decimalMinimumPropertyMp();
//--------------------------------------------------------------------------------------------------------------
//-------------------------------Mp Maximum property ----------------------------------------------------------
const int        idMaximumPropertyMp();
const QString    nameMaximumPropertyMp();
const QString    defaultMaximumPropertyMp();
const float      minMaximumPropertyMp();
const float      maxMaximumPropertyMp();
const int        decimalMaximumPropertyMp();
//--------------------------------------------------------------------------------------------------------------

// Intensity
const int          numberCatalogIntensity() ;
const QString  headerCatalogIntensity();
const QString  fontmetricCatalogIntensity() ;
const int          minCatalogIntensity();
const int          maxCatalogIntensity();
const bool       signedCatalogIntensity();

// Comment
const int          numberCatalogComment();
const QString  headerCatalogComment();

// Number of catalog columns
const int       numberCatalogColumns();
// ERROR TABLE SPECIFICATIONS

const int          numberErrorRecord() ;
const QString  headerErrorRecord() ;
const QString  fontmetricErrorRecord();
const int          maxErrorRecord();                        

const int          numberErrorCheck();
const QString  headerErrorCheck(); 
const QString  pixmapErrorCheck();

const int          numberErrorDescriptionRecord();
const QString  headerErrorDescriptionRecord();

const int          numberErrorLine();
const QString  headerErrorLine();
const QString  fontmetricErrorLine();

            //   ERROR DESCRIPTIONS
// Patern  range error
const QString  errorRangePattern() ;
const QString  errorValidPattern();

// Year
const QString  numberErrorYear();
const QString  nameErrorYear();
// Month
const QString  numberErrorMonth();
const QString  nameErrorMonth();
// Day
const QString  numberErrorDay();
const QString  nameErrorDay();
// Hour
const QString  numberErrorHour();
const QString  nameErrorHour();
// Minute
const QString  numberErrorMinute();
const QString  nameErrorMinute();
// Second
const QString  numberErrorSecond();
const QString  nameErrorSecond();
// Latitude
const QString  numberErrorLatitude();
const QString  nameErrorLatitude();
// Longitude
const QString  numberErrorLongitude();
const QString  nameErrorLongitude();
// Depth
const QString  numberErrorDepth();
const QString  nameErrorDepth();
// Mb
const QString  numberErrorMb();
const QString  nameErrorMb();
// Ms
const QString  numberErrorMs();
const QString  nameErrorMs();
// Mp
const QString  numberErrorMp();
const QString  nameErrorMp();
// Ml
const QString  numberErrorMl();
const QString  nameErrorMl();
// Intensity
const QString  numberErrorIntensity();
const QString  nameErrorIntensity();

// Date
const QString  numberErrorDate();
const QString  nameErrorDate();
// Time
const QString  numberErrorTime();
const QString  nameErrorTime();

// Patern sort   error 
const QString  errorSortPattern();
const QString  numberErrorSort();

/// Settings of parameters Settings of parameters Settings of parameters ///
///-----------------------------------------Check Range ----------------------------------------
///----------------------------------------- Latitude ----------------------------------------
const int      idRangeLatitudeMin();
const QString  nameRangeLatitudeMin();
const QString  defaultRangeLatitudeMin();

const int      idRangeLatitudeMax();
const QString  nameRangeLatitudeMax();
const QString  defaultRangeLatitudeMax();

const float    minRangeLatitude();
const float    maxRangeLatitude();
const int      decimalRangeLatitude();

///----------------------------------------- Longitude ----------------------------------------
const int      idRangeLongitudeMin();
const QString  nameRangeLongitudeMin();
const QString  defaultRangeLongitudeMin();

const int      idRangeLongitudeMax();
const QString  nameRangeLongitudeMax();
const QString  defaultRangeLongitudeMax();

const float    minRangeLongitude();
const float    maxRangeLongitude();
const int      decimalRangeLongitude();


///----------------------------------------- Depth ----------------------------------------
const int      idRangeDepthMin();
const QString  nameRangeDepthMin();
const QString  defaultRangeDepthMin();

const int      idRangeDepthMax();
const QString  nameRangeDepthMax();
const QString  defaultRangeDepthMax();

const float    minRangeDepth();
const float    maxRangeDepth();
const int      decimalRangeDepth();

///----------------------------------------- Mb ----------------------------------------
const int      idRangeMbMin();
const QString  nameRangeMbMin();
const QString  defaultRangeMbMin();

const int      idRangeMbMax();
const QString  nameRangeMbMax();
const QString  defaultRangeMbMax();

///----------------------------------------- Ms ----------------------------------------
const int      idRangeMsMin();
const QString  nameRangeMsMin();
const QString  defaultRangeMsMin();

const int      idRangeMsMax();
const QString  nameRangeMsMax();
const QString  defaultRangeMsMax();

///----------------------------------------- Ml ----------------------------------------
const int      idRangeMlMin();
const QString  nameRangeMlMin();
const QString  defaultRangeMlMin();

const int      idRangeMlMax();
const QString  nameRangeMlMax();
const QString  defaultRangeMlMax();

///----------------------------------------- Mp ----------------------------------------
const int      idRangeMpMin();
const QString  nameRangeMpMin();
const QString  defaultRangeMpMin();

const int      idRangeMpMax();
const QString  nameRangeMpMax();
const QString  defaultRangeMpMax();

///-------------------------------------- Magnitude min max----------------------------------------
const float    minRangeMagnitude();
const float    maxRangeMagnitude();
const int      decimalRangeMagnitude();


///-----------------------------------------Identification of doubles ----------------------------------------

///----------------------------------------- time ----------------------------------------   
const int          idDeltaTime();
const QString  nameDeltaTime() ;
const QString  defaultDeltaTime();
const int          minDeltaTime();
const int          maxDeltaTime();
const bool       signedDeltaTime();
///----------------------------------------- depth ----------------------------------------   
const int         idDeltaDepth();
const QString nameDeltaDepth();
const QString defaultDeltaDepth();
const int        minDeltaDepth();
const int        maxDeltaDepth();
const bool     signedDeltaDepth();
///----------------------------------------- Latitude ----------------------------------------  
const int          idDeltaLatitude();
const QString  nameDeltaLatitude();
const QString defaultDeltaLatitude();
const float      minDeltaLatitude();
const float      maxDeltaLatitude();
const int         decimalDeltaLatitude();
///----------------------------------------- Longitude ---------------------------------------- 
const int          idDeltaLongitude();
const QString  nameDeltaLongitude();
const QString defaultDeltaLongitude();
const float      minDeltaLongitude();
const float      maxDeltaLongitude();
const int         decimalDeltaLongitude();
///-----------------------------------------Delta Magnitude  ----------------------------------------
const int      idDeltaMagnitude();
const QString  nameDeltaMagnitude();
const QString  defaultDeltaMagnitude();
const float    minDeltaMagnitude();
const float    maxDeltaMagnitude();
const int      decimalDeltaMagnitude();

///----------------------------------------- Remove Action  ----------------------------------------
const int     idDeltaRemoveAction();
const QString nameDeltaRemoveAction();
const QString defaultDeltaRemoveAction();
const QString enumDeltaRemoveAction();

///----------------------------------------- Remove Equal  ----------------------------------------
const int     idDeltaRemoveEqual();
const QString nameDeltaRemoveEqual();
const QString defaultDeltaRemoveEqual();
const QString enumDeltaRemoveEqual();

//---------------------- Functions entries ------------------------------------------

///---------------------- List of Magnitudes of each Priority ---------------------
const QString enumComboBoxMagnitudeList();

///---------------------- Magnitude of first priority -------------------------------------
const QString namePriorityFirstMagnitude();
const QString defaultPriorityFirstMagnitude();
///---------------------- Magnitude of Second priority -------------------------------------
const QString namePrioritySecondMagnitude();
const QString defaultPrioritySecondMagnitude();
///---------------------- Magnitude of Third priority -------------------------------------
const QString namePriorityThirdMagnitude();
const QString defaultPriorityThirdMagnitude();
///---------------------- Magnitude of Fourth priority -------------------------------------
const QString namePriorityFourthMagnitude();
const QString defaultPriorityFourthMagnitude();

///----------------------------------------- Priority List Values   ----------------------------------------
const QString enumPriorityList();

///----------------------------------------- Priority is using   ----------------------------------------
const QString namePriorityIsUsing();
const QString defaultPriorityIsUsing();
///----------------------------------------- Second Priority is used   ----------------------------------------
const QString namePriorityIsNotUsing();
const QString defaultPriorityIsNotUsing();

///----------------------Removing Functions  ----------------------------------------

const int idRemovingDuplicateFunction();
const QString nameRemovingDuplicateFunction();
const QString defaultRemovingDuplicateFunction();
const QString enumRemovingDuplicateFunction();

///----------------------------------------- Priority is used   ----------------------------------------
const int idRemovingFirst();
const int idRemovingSecond();
const int idRemovingThird();
const int idRemovingFourth();

///---------------------- Magnitude of priorities -------------------------------------
const int idRemovingFirstMagnitude();
const int idRemovingSecondMagnitude();
const int idRemovingThirdMagnitude();
const int idRemovingFourthMagnitude();

///----------------------Delta Magnitude Functions  ----------------------------------------

const int idDeltaMagnitudeFunction();
const QString nameDeltaMagnitudeFunction();
const QString defaultDeltaMagnitudeFunction();
const QString enumDeltaMagnitudeFunction();


//-------------------------  Transform magnitude for   Delta Magnitude Functions ----------------

///---------------------- Magnitude of First priority -------------------------------------
const int      idDeltaMagnitudePriorityFirst();
const QString  nameMagnitudePriorityFirst();
const QString  defaultMagnitudePriorityFirst();

///---------------------- Magnitude of Second priority -------------------------------------
const int      idDeltaMagnitudePrioritySecond();
const QString  nameMagnitudePrioritySecond();
const QString  defaultMagnitudePrioritySecond();

///---------------------- Magnitude of Third priority -------------------------------------
const int      idDeltaMagnitudePriorityThird();
const QString  nameMagnitudePriorityThird();
const QString  defaultMagnitudePriorityThird();

///---------------------- Magnitude of Fourth priority -------------------------------------
const int      idDeltaMagnitudePriorityFourth();
const QString  nameMagnitudePriorityFourth();
const QString  defaultMagnitudePriorityFourth();

//------------------- Validator Goefficients of Transform Fanction -----------------------

const float    minTransformMagnitudeA();
const float    maxTransformMagnitudeA();
const int      decimalTransformMagnitudeA();

const float    minTransformMagnitudeB();
const float    maxTransformMagnitudeB();
const int      decimalTransformMagnitudeB();

const float    minTransformMagnitudeC();
const float    maxTransformMagnitudeC();
const int      decimalTransformMagnitudeC();

const float    minTransformMagnitudeD();
const float    maxTransformMagnitudeD();
const int      decimalTransformMagnitudeD();

//---------------------------- Duplicate Magniyudes ---------------------------------

//------------------------------Selected Magnitude ---------------------------------------------------
const int     idSelectedDuplicateMagnitude();
const QString nameSelectedDuplicateMagnitude();
const QString defaultSelectedDuplicateMagnitude();
//------------------------------Removing Magnitude ---------------------------------------------------
const int     idRemovingDuplicateMagnitude();
const QString nameRemovingDuplicateMagnitude();
const QString defaultRemovingDuplicateMagnitude();


//-------------------------------  Merge Two Catalog -------------------------------------

const int      idDeltaCatTime();
const int      idDeltaCatDepth();
const int      idDeltaCatLatitude();
const int      idDeltaCatLongitude();
const int      idDeltaCatMagnitude();
//---------------------------  Delta Magnitude Functions --------------------
const int      idDeltaCatMagnitudeFunction();
const int      idDeltaCatMagnitudePriorityFirst();
const int      idDeltaCatMagnitudePrioritySecond();
const int      idDeltaCatMagnitudePriorityThird();
const int      idDeltaCatMagnitudePriorityFourth();

//-------------------------- Assign Duplicate Magnitudes   --------------------------
const int     idAssignDuplicateMagnitude();
const QString nameAssignDuplicateMagnitude();
const QString defaultAssignDuplicateMagnitude();
//----------------------------------------- Compare Action  ----------------------------------------
const int     idCompareCatalogAction();
const QString nameCompareCatalogAction();
const QString defaultCompareCatalogAction();
const QString enumCompareCatalogAction();
//------------------------------Second Catalogname for Intersection etc. -------------
const int     idSecondCatalog();
const QString nameSecondCatalog();
const QString defaultSecondCatalog();

//------------------------------ List Merge catalog ---------------------------
const int     idListMergeCatalog();
const QString nameListMergeCatalog();
const QString defaultListMergeCatalog();

///----------------------------------- Add Catalogs-----------------------------
const int     idListAddCatalog();
const QString nameListAddCatalog();
const QString defaultListAddCatalog();

///-----------------------------------Create subcatalog ------------------------------------------
//------------------------------------ Record Sample ------------------------------------------
const int     idSampleIsRecord();
const QString nameSampleIsRecord();
const QString defaultSampleIsRecord();

const int     idSampleRecordType();
const QString nameSampleRecordType();
const QString defaultSampleRecordType();
const QString enumSampleRecordType();

const int     idSampleRecordDateMin();
const QString nameSampleRecordDateMin();
const QString defaultSampleRecordDateMin();

const int     idSampleRecordDateMax();
const QString nameSampleRecordDateMax();
const QString defaultSampleRecordDateMax();

const int     idSampleRecordNumberMin();
const QString nameSampleRecordNumberMin();
const QString defaultSampleRecordNumberMin();

const int     idSampleRecordNumberMax();
const QString nameSampleRecordNumberMax();
const QString defaultSampleRecordNumberMax();

const QString sampleWizardRecordNumberMin();
const QString sampleWizardRecordNumberMax();
const QString sampleWizardRecordDateMin();
const QString sampleWizardRecordDateMax();


//-----------------------------------Create subcatalog -----------------------------
//------------------------------------ Hipocenter ----------------------------------

const int     idSampleIsHipo();
const QString nameSampleIsHipo();
const QString defaultSampleIsHipo();

const int     idSampleHipoType();
const QString nameSampleHipoType();
const QString defaultSampleHipoType();
const QString enumSampleHipoType();

//------------------------------------ Rectangle Hipocenter --------------------------

const int     idSampleHipoRectLatitudeMin();
const QString nameSampleHipoRectLatitudeMin();
const QString defaultSampleHipoRectLatitudeMin();

const int     idSampleHipoRectLatitudeMax();
const QString nameSampleHipoRectLatitudeMax();
const QString defaultSampleHipoRectLatitudeMax();

const int     idSampleHipoRectLongitudeMin();
const QString nameSampleHipoRectLongitudeMin();
const QString defaultSampleHipoRectLongitudeMin();

const int     idSampleHipoRectLongitudeMax();
const QString nameSampleHipoRectLongitudeMax();
const QString defaultSampleHipoRectLongitudeMax();

const int     idSampleHipoRectMinus180();
const QString nameSampleHipoRectMinus180();
const QString defaultSampleHipoRectMinus180();

//------------------------------------ Circle Hipocenter --------------------------
const int     idSampleHipoCircleLatitude();
const QString nameSampleHipoCircleLatitude();
const QString defaultSampleHipoCircleLatitude();

const int     idSampleHipoCircleLongitude();
const QString nameSampleHipoCircleLongitude();
const QString defaultSampleHipoCircleLongitude();

const int     idSampleHipoCircleRadius();
const QString nameSampleHipoCircleRadius();
const QString defaultSampleHipoCircleRadius();
const float   minSampleHipoCircleRadius();
const float   maxSampleHipoCircleRadius();
const int     decimalSampleHipoCircleRadius();

//------------------------------------ Polygon Hipocenter --------------------------
const int     idSampleHipoPolygonVertice();
const QString nameSampleHipoPolygonVertice();
const QString defaultSampleHipoPolygonVertice();
const int     minSampleHipoPolygonVertice();
const int     maxSampleHipoPolygonVertice();
const bool    signedSampleHipoPolygonVertice();

const int     idSampleHipoPolygonMinus180();
const QString nameSampleHipoPolygonMinus180();
const QString defaultSampleHipoPolygonMinus180();
//------------------------------  Polygon Latitude ---------------------------
const int     idSampleListLatitude();
const QString nameSampleListLatitude();
const QString defaultSampleListLatitude();
//------------------------------  Polygon Longitude ---------------------------
const int     idSampleListLongitude();
const QString nameSampleListLongitude();
const QString defaultSampleListLongitude();

//------------------------------ Depth Hipocenter --------------------------------------
const int     idSampleIsDepth();
const QString nameSampleIsDepth();
const QString defaultSampleIsDepth();

const int     idSampleDepthMin();
const QString nameSampleDepthMin();
const QString defaultSampleDepthMin();

const int     idSampleDepthMax();
const QString nameSampleDepthMax();
const QString defaultSampleDepthMax();

//------------------------------ Magnitude Mb --------------------------------------
const int     idSampleIsMb();
const QString nameSampleIsMb();
const QString defaultSampleIsMb();

const int     idSampleMbMin();
const QString nameSampleMbMin();
const QString defaultSampleMbMin();

const int     idSampleMbMax();
const QString nameSampleMbMax();
const QString defaultSampleMbMax();

//------------------------------ Magnitude Ms --------------------------------------
const int     idSampleIsMs();
const QString nameSampleIsMs();
const QString defaultSampleIsMs();
const int     idSampleMsMin();
const QString nameSampleMsMin();
const QString defaultSampleMsMin();

const int     idSampleMsMax();
const QString nameSampleMsMax();
const QString defaultSampleMsMax();

//------------------------------ Magnitude Ml --------------------------------------
const int     idSampleIsMl();
const QString nameSampleIsMl();
const QString defaultSampleIsMl();

const int     idSampleMlMin();
const QString nameSampleMlMin();
const QString defaultSampleMlMin();
const int     idSampleMlMax();
const QString nameSampleMlMax();
const QString defaultSampleMlMax();

//------------------------------ Magnitude Mp --------------------------------------
const int     idSampleIsMp();
const QString nameSampleIsMp();
const QString defaultSampleIsMp();

const int     idSampleMpMin();
const QString nameSampleMpMin();
const QString defaultSampleMpMin();

const int     idSampleMpMax();
const QString nameSampleMpMax();
const QString defaultSampleMpMax();

//------------------------------ Intencity --------------------------------------
const int     idSampleIsIntensity();
const QString nameSampleIsIntensity();
const QString defaultSampleIsIntensity();

const int     idSampleIntensityMin();
const QString nameSampleIntensityMin();
const QString defaultSampleIntensityMin();

const int     idSampleIntensityMax();
const QString nameSampleIntensityMax();
const QString defaultSampleIntensityMax();

//------------------------------ Magnitude Fanction --------------------------------------
const int     idSampleIsMagFunction();
const QString nameSampleIsMagFunction();
const QString defaultSampleIsMagFunction();

const int     idSampleMagFunctionType();
const QString nameSampleMagFunctionType();
const QString defaultSampleMagFunctionType();
const QString enumSampleMagFunctionType();

const int     idSampleMagFunctionMin();
const QString nameSampleMagFunctionMin();
const QString defaultSampleMagFunctionMin();

const int     idSampleMagFunctionMax();
const QString nameSampleMagFunctionMax();
const QString defaultSampleMagFunctionMax();

const int idSampleMagFunction();
const QString nameSampleMagFunction();
const QString defaultSampleMagFunction();
const QString enumSampleMagFunction();

///--------- Transform magnitude for Sample Magnitude Functions -----
///---------------------- Magnitude of First priority --------------
const int      idSampleMagFunctionPriorityFirst();
///---------------------- Magnitude of Second priority -------------
const int      idSampleMagFunctionPrioritySecond();
///---------------------- Magnitude of Third priority --------------
const int      idSampleMagFunctionPriorityThird();
///---------------------- Magnitude of Fourth priority -------------
const int      idSampleMagFunctionPriorityFourth();

///---------------------- Project parameters -------------------------------------
///---------------------- Project action list -------------------------------------
const QString projectActionList();
const QString projectCompareTitle();
const QString projectRangeTitle();

///----------------------------------- Project List---------------------------------
const int     idProjectActionList();
const QString nameProjectActionList();
const QString defaultProjectActionList();

///----------------------------------- Project In Catalog Name-----------------------------
const int     idProjectCatalogName();
const QString nameProjectCatalogName();
const QString defaultProjectCatalogName();

///-----------------------------------  Action Parameters (current or default)--------------
const int     idProjectDocumentIn();
const QString nameProjectDocumentIn();
const QString defaultProjectDocumentIn();
const QString enumProjectDocumentIn();

///-----------------------------------  Action Action Chose (list or not)-------------------
const int     idProjectActionChoise();
const QString nameProjectActionChoise();
const QString defaultProjectActionChoise();
const QString enumProjectActionChoise();

///-----------------------------------  Histogram Parameters ----------------------------

            /// number interval axis X
const int       idNumberIntervalAxisX();
const QString   nameNumberIntervalAxisX();
const QString   defaultNumberIntervalAxisX();
const int       minNumberIntervalAxisX();
const int       maxNumberIntervalAxisX();
const bool      signedNumberIntervalAxisX();
const int       stepNumberIntervalAxisX();

            /// number interval axis Y
const int       idNumberIntervalAxisY();
const QString   nameNumberIntervalAxisY();
const QString   defaultNumberIntervalAxisY();
const int       minNumberIntervalAxisY();
const int       maxNumberIntervalAxisY();
const bool      signedNumberIntervalAxisY();
const int       stepNumberIntervalAxisY();

           /// number interval axis Z

const int       idNumberIntervalAxisZ();
const QString   nameNumberIntervalAxisZ();
const QString   defaultNumberIntervalAxisZ();
const int       minNumberIntervalAxisZ();
const int       maxNumberIntervalAxisZ();
const bool      signedNumberIntervalAxisZ();
const int       stepNumberIntervalAxisZ();

           /// list parameters
		   
const QString listHistgramParameters();
           /// list parameters min, max
const QString listHistgramMinMax();
///-----------------------------------  Histogram Constants ----------------------------

///----------------------------------------- Coefficent A--------------------------------  
const QString  nameHistogramCoefficentA();
const QString  defaultHistogramCoefficentA();
const float    minHistogramCoefficentA();
const float    maxHistogramCoefficentA();
const int      decimalHistogramCoefficentA();
///----------------------------------------- Coefficent B--------------------------------  
const QString  nameHistogramCoefficentB();
const QString  defaultHistogramCoefficentB();
const float    minHistogramCoefficentB();
const float    maxHistogramCoefficentB();
const int      decimalHistogramCoefficentB();
///----------------------------------------- Standard Coefficents--------------------------------  

const float energyHistogramCoefficentA();
const float energyHistogramCoefficentB();

const float areaHistogramCoefficentA();
const float areaHistogramCoefficentB();

const float lenghtHistogramCoefficentA();
const float lenghtHistogramCoefficentB();

const float customHistogramCoefficentA();
const float customHistogramCoefficentB();

///----------------------------------------- Type Weght --------------------------------  

const QString enumHistogramTypeWeightList();

#endif
