#include <QtGui>
#include <math.h> 
#include "mainwindow.h" 
#include "doubleimpl.h" 
#include "default.h"
#include "viewcatalogimpl.h"
#include "tableproperty.h"
#include "convert.h"
#include "editline.h"
FindDupFunc::FindDupFunc(vector<int> &priority,vector<QString> &valFunc,float dmf):
                         priority(priority),dmf(dmf){
  eps = acuracyCompareFloatValue();
  a.resize(4);b.resize(4);c.resize(4);d.resize(4);
  for(int i = 0; i< 4;i++) {
   QStringList param = valFunc[i].split( '@');
   d[i] = param[0].toFloat(); a[i]  = param[1].toFloat(); b[i] = param[2].toFloat(); c[i] = param[3].toFloat();
  }
}

void  FindDupFunc::SetValue(float mb1,float ms1,float ml1,float mp1,float mb2,float ms2,float ml2,float mp2){
vector<float> &m1 = magnitudeRecordFirst;
vector<float> &m2 = magnitudeRecordSecond;
m1.resize(4); m1[0] = mb1; m1[1] = ms1; m1[2] = ml1; m1[3] = mp1;
m2.resize(4); m2[0] = mb2; m2[1] = ms2; m2[2] = ml2; m2[3] = mp2;

}
 
float FindDupFunc::mFunct(int i,float m){
if ( m > d[i] || fabs(m - d[i]) < eps) return  m*a[i] + b[i];  else  return c[i];
}
//------------------------------------------------------------------------------------------------------
FindValue::FindValue(vector<int> &priority,vector<QString> &valFunc,float dmf)
    : FindDupFunc(priority,valFunc,dmf){ }

void  FindValue::FindVal()  {
if(!priority.empty()) {
  const vector<float> &m1 = magnitudeRecordFirst;
  const vector<float> &m2 = magnitudeRecordSecond;
  bool findNotZeroMagnitude = false;
  int indexNotZeroMagnitude = 0;
  if ((int)priority.size() == 1) findNotZeroMagnitude = true;
  else 
	  for(int i = 0; i < (int)priority.size();i++)   {
		  if( !( fabs(m1[priority[i]]) < eps && fabs(m2[priority[i]]) < eps) )
		  {findNotZeroMagnitude = true;indexNotZeroMagnitude = i;break;}
	  }

  if (findNotZeroMagnitude) {
    fm1 = mFunct(priority[indexNotZeroMagnitude],m1[priority[indexNotZeroMagnitude]]);
    fm2 = mFunct(priority[indexNotZeroMagnitude],m2[priority[indexNotZeroMagnitude]]);
    df = (float)fabs(fm1 - fm2);
    if(df < dmf ||  fabs(df - dmf) < eps) value = true; else value = false;
  }  else value = true;

 } else value = true;
}

//------------------------------------------------------------------------------------------------------

FindMaximum::FindMaximum(vector<int> &priority,vector<QString> &valFunc,float dmf)
    : FindDupFunc(priority,valFunc,dmf){ }

void  FindMaximum::FindVal()  {
if(!priority.empty()) {
  const vector<float> &m1 = magnitudeRecordFirst;
  const vector<float> &m2 = magnitudeRecordSecond;
  float fm1 = mFunct(priority[0],m1[priority[0]]);
  float fm2 = mFunct(priority[0],m2[priority[0]]);
  for(int i = 1; i < (int)priority.size();i++)   {
   float   mm1 = mFunct(priority[i],m1[priority[i]]);
   float   mm2 = mFunct(priority[i],m2[priority[i]]);
   if( mm1 > fm1 ) fm1 = mm1;
   if( mm2 > fm2 ) fm2 = mm2;
   }
   df = (float)fabs(fm1 - fm2);
   if(df < dmf ||  fabs(df - dmf) < eps) value = true; else value = false;
 } else value = true;
}


//------------------------------------------------------------------------------------------------------
FindMinimum::FindMinimum(vector<int> &priority,vector<QString> &valFunc,float dmf)
    : FindDupFunc(priority,valFunc,dmf){ }

void  FindMinimum::FindVal()  {
if(!priority.empty()) {
  const vector<float> &m1 = magnitudeRecordFirst;
  const vector<float> &m2 = magnitudeRecordSecond;
  float fm1 = mFunct(priority[0],m1[priority[0]]);
  float fm2 = mFunct(priority[0],m2[priority[0]]);
  for(int i = 1; i < (int)priority.size();i++)   {
   float   mm1 = mFunct(priority[i],m1[priority[i]]);
   float   mm2 = mFunct(priority[i],m2[priority[i]]);
   if( mm1 < fm1 ) fm1 = mm1;
   if( mm2 < fm2 ) fm2 = mm2;
   }
   df = (float)fabs(fm1 - fm2);
   if(df < dmf ||  fabs(df - dmf) < eps) value = true; else value = false;
 } else value = true;
}

//------------------------------------------------------------------------------------------------------

FindAverage::FindAverage(vector<int> &priority,vector<QString> &valFunc,float dmf)
    : FindDupFunc(priority,valFunc,dmf){ }

void  FindAverage::FindVal()  {
if(!priority.empty()) {
  const vector<float> &m1 = magnitudeRecordFirst;
  const vector<float> &m2 = magnitudeRecordSecond;
  float fm1 = mFunct(priority[0],m1[priority[0]]);
  float fm2 = mFunct(priority[0],m2[priority[0]]);
  int n1 = 0; int n2 = 0;
   if(fabs(fm1) > eps) n1++;
   if(fabs(fm2) > eps) n2++;
  for(int i = 1; i < (int)priority.size();i++)   {
   float ff1 = mFunct(priority[i],m1[priority[i]]);
   float ff2 = mFunct(priority[i],m2[priority[i]]);
   fm1 += ff1;
   fm2 += ff2;
   if(fabs(ff1) > eps) n1++;
   if(fabs(ff2) > eps) n2++;
   }
   if(n1 > 0) fm1 /= n1;
   if(n2 > 0) fm2 /= n2;
   df = (float)fabs(fm1 - fm2);
   if(df < dmf ||  fabs(df - dmf) < eps) value = true; else value = false;
 } else value = true;
}

//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

RemoveDupFunc::RemoveDupFunc(vector<int> &priority)
         : priority(priority){ eps = acuracyCompareFloatValue();}
void  RemoveDupFunc::SetValue(float mb1,float ms1,float ml1,float mp1,float mb2,float ms2,float ml2,float mp2){
vector<float> &m1 = magnitudeRecordFirst;
vector<float> &m2 = magnitudeRecordSecond;
m1.resize(4); m1[0] = mb1; m1[1] = ms1; m1[2] = ml1; m1[3] = mp1;
m2.resize(4); m2[0] = mb2; m2[1] = ms2; m2[2] = ml2; m2[3] = mp2;

}

RemValueGreater::RemValueGreater(vector<int> &priority)
             : RemoveDupFunc(priority){}
void  RemValueGreater::RemVal()  {
  const vector<float> &m1 = magnitudeRecordFirst;
  const vector<float> &m2 = magnitudeRecordSecond;
  bool findNotZeroMagnitude = false;
  int indexNotZeroMagnitude = 0;
  for(int i = 0; i < (int)priority.size();i++)
   if( !( fabs(m1[priority[i]]) < eps && fabs(m2[priority[i]]) < eps) ) {findNotZeroMagnitude = true;indexNotZeroMagnitude = i;break;}
  if (findNotZeroMagnitude) {
    valFunct1 = m1[indexNotZeroMagnitude];
    valFunct2 = m2[indexNotZeroMagnitude];
    if ( valFunct1 > valFunct2 ) delRow = 1;
    else { if ( valFunct2 > valFunct1 ) delRow = 0; else delRow = 2;}
  } else delRow = 2;
}
RemValueLess::RemValueLess(vector<int> &priority)
             : RemoveDupFunc(priority){}
void  RemValueLess::RemVal()  {
  const vector<float> &m1 = magnitudeRecordFirst;
  const vector<float> &m2 = magnitudeRecordSecond;
  bool findNotZeroMagnitude = false;
  int indexNotZeroMagnitude = 0;
  for(int i = 0; i < (int)priority.size();i++)
   if( !( fabs(m1[priority[i]]) < eps && fabs(m2[priority[i]]) < eps) ) {findNotZeroMagnitude = true;indexNotZeroMagnitude = i;break;}
  if (findNotZeroMagnitude) {
    valFunct1 = m1[indexNotZeroMagnitude];
    valFunct2 = m2[indexNotZeroMagnitude];
    if ( valFunct1 > valFunct2 ) delRow = 0;
    else { if ( valFunct2 > valFunct1 ) delRow = 1; else delRow = 2;}
  } else delRow = 2;
}


//------------------------------------------------------------------------------------------------------
RemMaximumGreater::RemMaximumGreater(vector<int> &priority)
             : RemoveDupFunc(priority){}
void  RemMaximumGreater::RemVal()  {
  const vector<float> &m1 = magnitudeRecordFirst;
  const vector<float> &m2 = magnitudeRecordSecond;
    valFunct1 = m1[priority[0]];
    valFunct2 = m2[priority[0]];
  for(int i = 1; i < (int)priority.size();i++) {
   float   mm1 = m1[priority[i]];
   float   mm2 = m2[priority[i]];
   if( mm1 > valFunct1 ) valFunct1 = mm1;
   if( mm2 > valFunct2 ) valFunct2 = mm2;
   }
   if ( valFunct1 > valFunct2 ) delRow = 1;
   else { if ( valFunct2 > valFunct1 ) delRow = 0; else delRow = 2;}  
}
RemMaximumLess::RemMaximumLess(vector<int> &priority)
             : RemoveDupFunc(priority){}
void  RemMaximumLess::RemVal()  {
  const vector<float> &m1 = magnitudeRecordFirst;
  const vector<float> &m2 = magnitudeRecordSecond;
    valFunct1 = m1[priority[0]];
    valFunct2 = m2[priority[0]];
  for(int i = 1; i < (int)priority.size();i++) {
   float   mm1 = m1[priority[i]];
   float   mm2 = m2[priority[i]];
   if( mm1 > valFunct1 ) valFunct1 = mm1;
   if( mm2 > valFunct2 ) valFunct2 = mm2;
   }
   if ( valFunct1 > valFunct2 ) delRow = 0;
   else { if ( valFunct2 > valFunct1 ) delRow = 1; else delRow = 2;}
}

//------------------------------------------------------------------------------------------------------
RemMinimumGreater::RemMinimumGreater(vector<int> &priority)
             : RemoveDupFunc(priority){}
void  RemMinimumGreater::RemVal()  {
  const vector<float> &m1 = magnitudeRecordFirst;
  const vector<float> &m2 = magnitudeRecordSecond;
    valFunct1 = m1[priority[0]];
    valFunct2 = m2[priority[0]];
  for(int i = 1; i < (int)priority.size();i++) {
   float   mm1 = m1[priority[i]];
   float   mm2 = m2[priority[i]];
   if( mm1 < valFunct1 ) valFunct1 = mm1;
   if( mm2 < valFunct2 ) valFunct2 = mm2;
   }
   if ( valFunct1 > valFunct2 ) delRow = 1;
   else { if ( valFunct2 > valFunct1 ) delRow = 0; else delRow = 2;}
}
RemMinimumLess::RemMinimumLess(vector<int> &priority)
             : RemoveDupFunc(priority){}
void  RemMinimumLess::RemVal()  {
  const vector<float> &m1 = magnitudeRecordFirst;
  const vector<float> &m2 = magnitudeRecordSecond;
    valFunct1 = m1[priority[0]];
    valFunct2 = m2[priority[0]];
  for(int i = 1; i < (int)priority.size();i++) {
   float   mm1 = m1[priority[i]];
   float   mm2 = m2[priority[i]];
   if( mm1 < valFunct1 ) valFunct1 = mm1;
   if( mm2 < valFunct2 ) valFunct2 = mm2;
   }
   if ( valFunct1 > valFunct2 ) delRow = 0;
   else { if ( valFunct2 > valFunct1 ) delRow = 1; else delRow = 2;}
}
//------------------------------------------------------------------------------------------------------
RemAverageGreater::RemAverageGreater(vector<int> &priority)
             : RemoveDupFunc(priority){}
void  RemAverageGreater::RemVal()  {
  const vector<float> &m1 = magnitudeRecordFirst;
  const vector<float> &m2 = magnitudeRecordSecond;
    valFunct1 = m1[priority[0]];
    valFunct2 = m2[priority[0]];
    int n1 = 0; int n2 = 0;
    if(fabs(valFunct1) > eps) n1++;
    if(fabs(valFunct2) > eps) n2++;
  for(int i = 1; i < (int)priority.size();i++) {
   float mm1 = m1[priority[i]];
   float mm2 = m2[priority[i]];
   valFunct1 += mm1;
   valFunct2 += mm2;
   if(fabs(mm1) > eps) n1++;
   if(fabs(mm2) > eps) n2++;
   }
   if(n1 > 0) valFunct1 /= n1;
   if(n2 > 0) valFunct2 /= n2;
   if ( valFunct1 > valFunct2 ) delRow = 1;
   else { if ( valFunct2 > valFunct1 ) delRow = 0; else delRow = 2;}
}
RemAverageLess::RemAverageLess(vector<int> &priority)
             : RemoveDupFunc(priority){}
void  RemAverageLess::RemVal()  {
  const vector<float> &m1 = magnitudeRecordFirst;
  const vector<float> &m2 = magnitudeRecordSecond;
    valFunct1 = m1[priority[0]];
    valFunct2 = m2[priority[0]];
    int n1 = 0; int n2 = 0;
    if(fabs(valFunct1) > eps) n1++;
    if(fabs(valFunct2) > eps) n2++;
  for(int i = 1; i < (int)priority.size();i++) {
   float mm1 = m1[priority[i]];
   float mm2 = m2[priority[i]];
   valFunct1 += mm1;
   valFunct2 += mm2;
   if(fabs(mm1) > eps) n1++;
   if(fabs(mm2) > eps) n2++;
   }
   if(n1 > 0) valFunct1 /= n1;
   if(n2 > 0) valFunct2 /= n2;
   if ( valFunct1 > valFunct2 ) delRow = 0;
   else { if ( valFunct2 > valFunct1 ) delRow = 1; else delRow = 2;}
}
void RemNoFunction::RemVal()  {
valFunct1 = 0;
valFunct2 = 0;
delRow = 2;
}
//------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------

bool DoubleBaseImpl::GetRemDupFunc()
{
    int indexFunction = 0;
     vector<int> priorityRem;
     bool isPriority = false;
     if(checkBoxRemM1->isChecked ()) { priorityRem.push_back(comboBoxRemM1->currentIndex ()); isPriority = true; }
     if(checkBoxRemM2->isChecked ()) { priorityRem.push_back(comboBoxRemM2->currentIndex ()); isPriority = true; }
     if(checkBoxRemM3->isChecked ()) { priorityRem.push_back(comboBoxRemM3->currentIndex ()); isPriority = true; }
     if(checkBoxRemM4->isChecked ()) { priorityRem.push_back(comboBoxRemM4->currentIndex ()); isPriority = true; }
//     if (!isPriority){
//       error(QString("Select at least one magnitude for \"Removing Duplicate Function\" definition"),"");
//     return false;}
     if (!isPriority) indexFunction = -1;
      QString strmes = "";
      Catalog cat;
      if (type == Tool) strmes += cat.GetCatalogInfoMessage(MainWindow::self->GetCurrentCatalogName());
      if (type == Execute) {
		  strmes += "Current catalog ";
		  strmes += cat.GetCatalogShortInfoMessage(MainWindow::self->GetOpenBinaryFileName());
	  }
     if(radioAuto->isChecked  ())
       strmes += "Automatic duplicate removal:\n\n";

     if(radioDialog->isChecked ())
      strmes += "Interactive duplicate removal:\n\n";



    if (removeFunction    !=0) { delete removeFunction; removeFunction = 0;}

     if (indexFunction != -1) {
     indexFunction = comboBoxRemFunction->currentIndex ();
     if (indexFunction == 0 ) removeFunction = new RemValueGreater(priorityRem);
     if (indexFunction == 1 ) removeFunction = new RemValueLess(priorityRem);
     if (indexFunction == 2 ) removeFunction = new RemMaximumGreater(priorityRem);
     if (indexFunction == 3 ) removeFunction = new RemMaximumLess(priorityRem);
     if (indexFunction == 4 ) removeFunction = new RemMinimumGreater(priorityRem);
     if (indexFunction == 5 ) removeFunction = new RemMinimumLess(priorityRem);
     if (indexFunction == 6 ) removeFunction = new RemAverageGreater(priorityRem);
     if (indexFunction == 7 ) removeFunction = new RemAverageLess(priorityRem);
} else removeFunction = new RemNoFunction();

     indexRemovalFunction = indexFunction;

     QString remFun = "Criterion for autoremoval:\nRemove by magnitude:";
     int size = (int) priorityRem.size();

     QString mag = "";
     for(int i = 0; i < size;i++) {
         if(priorityRem[i] == 0)mag += " mb,";
         if(priorityRem[i] == 1)mag += " ms,";
         if(priorityRem[i] == 2)mag += " ml,";
         if(priorityRem[i] == 3)mag += " mp,";
     }
     mag.replace(mag.lastIndexOf(','),1," ");

     nameRemoveFunction = QString("\"%1\"").arg(comboBoxRemFunction->currentText());
     remFun += "\"" + comboBoxRemFunction->currentText() + "\".  ";

     if (indexFunction == 0 || indexFunction == 1) {
         if (size > 1)  remFun += "Priority Value { " + mag + " }\n"; else remFun += "F =" + mag + "\n";
       }

    if (indexFunction == 2 || indexFunction == 3) {
         if (size > 1)  remFun += "Maximum { " + mag + " }\n"; else remFun += "F =" + mag + "\n";
       }

   if (indexFunction == 4 || indexFunction == 5) {
         if (size > 1)  remFun += "Minimum { " + mag + " }\n"; else remFun += "F =" + mag + "\n";
       }

   if (indexFunction == 6 || indexFunction == 7) {
         if (size > 1)  remFun += "Average { " + mag + " }\n"; else remFun += "F =" + mag + "\n";
       }
     remFun += "If creterion for autoremoval is the same for bouth double records then remove by order:\n"; 
if (indexFunction == -1) remFun = "Criterion for autoremoval:\nRemove by order:\n";
     if(radioAuto->isChecked  ()) {
       if(radioFirst->isChecked  ()) remFun += "The first double in the pair wiil be remove.\n";
       if(radioSecond->isChecked ()) remFun += "The second double in the pair wiil be remove.\n";
      }
     if(radioDialog->isChecked ()) {
      if(radioFirst->isChecked  ()) remFun += "The first in double the pair will be selected.\n";
      if(radioSecond->isChecked ()) remFun += "The second in double the pair will be selected.\n";
    }


QString delta = "Proximity limits: ";
delta += "Time: "      + spinBoxDeltaTime->text() + " ; ";
delta += "Latitude: "  + lineEditDeltaLatitude->text() + " ; ";
delta += "Longitude: " + lineEditDeltaLongitude->text() + " ; ";
delta += "Depth: "     + spinBoxDeltaDepth->text() + " ;\n";

     ptrRemoveFunction = & RemoveDupFunc::RemVal;

     dtime = spinBoxDeltaTime->text().toInt();
     dlat  = lineEditDeltaLatitude->text().toFloat();
     dlon  = lineEditDeltaLongitude->text().toFloat();
     ddep  = spinBoxDeltaDepth->text().toInt();
     dmf   = lineEditDf->text().toFloat();

strmes += delta  + "\n";


     vector<int> priorityFind;
//-----------------------------------------------

     vector<QString> valFunc;valFunc.resize(4);
     if(checkBoxDeltaM1->isChecked ()) priorityFind.push_back(comboBoxDeltaM1->currentIndex ());
       valFunc[0] = QString("%1@%2@%3@%4").arg(lineEditDeltaM1_D->text())
                                          .arg(lineEditDeltaM1_A->text())
                                          .arg(lineEditDeltaM1_B->text())
                                          .arg(lineEditDeltaM1_C->text());
     

     if(checkBoxDeltaM2->isChecked ()) priorityFind.push_back(comboBoxDeltaM2->currentIndex ());
       valFunc[1] = QString("%1@%2@%3@%4").arg(lineEditDeltaM2_D->text())
                                          .arg(lineEditDeltaM2_A->text())
                                          .arg(lineEditDeltaM2_B->text())
                                          .arg(lineEditDeltaM2_C->text());
     

     if(checkBoxDeltaM3->isChecked ()) priorityFind.push_back(comboBoxDeltaM3->currentIndex ());
       valFunc[2] = QString("%1@%2@%3@%4").arg(lineEditDeltaM3_D->text())
                                          .arg(lineEditDeltaM3_A->text())
                                          .arg(lineEditDeltaM3_B->text())
                                          .arg(lineEditDeltaM3_C->text());
     

     if(checkBoxDeltaM4->isChecked ()) priorityFind.push_back(comboBoxDeltaM4->currentIndex ());
       valFunc[3] = QString("%1@%2@%3@%4").arg(lineEditDeltaM4_D->text())
                                          .arg(lineEditDeltaM4_A->text())
                                          .arg(lineEditDeltaM4_B->text())
                                          .arg(lineEditDeltaM4_C->text());
     


//-----------------------------------------------
     int indexDeltaFunction = comboBoxDeltaFunction->currentIndex ();

     if (findFunction      !=0) { delete findFunction;   findFunction   = 0;}     
     if (indexDeltaFunction == 0 ) findFunction = new FindValue(priorityFind,valFunc,dmf);
     if (indexDeltaFunction == 1 ) findFunction = new FindMaximum(priorityFind,valFunc,dmf);
     if (indexDeltaFunction == 2 ) findFunction = new FindMinimum(priorityFind,valFunc,dmf);
     if (indexDeltaFunction == 3 ) findFunction = new FindAverage(priorityFind,valFunc,dmf);
     ptrFindFunction = & FindDupFunc::FindVal;



/////////////////////////////////////////////////////////////////////////////////////
     size = (int) priorityFind.size();
	if(!priorityFind.empty()) delta += "Magnitude function: " + lineEditDf->text() + " ,\nwhere\n";

    if(!priorityFind.empty()){
     strmes += "Magnitude function to define Delta Magnitude equals to\n";
     if (indexDeltaFunction == 0 ) {
        if (size > 1) strmes += " Priority Value";
        }
     if (indexDeltaFunction == 1 )  {
        if (size > 1) strmes += " Maximum";
        }
     if (indexDeltaFunction == 2 ) {
        if (size > 1) strmes += " Minimum";
        }
     if (indexDeltaFunction == 3 ) {
        if (size > 1) strmes += " Average";
        }

     QString mag = "";
     for(int i = 0; i < size;i++) {
         if(priorityFind[i] == 0)mag += " f(m1),";
         if(priorityFind[i] == 1)mag += " f(m2),";
         if(priorityFind[i] == 2)mag += " f(m3),";
         if(priorityFind[i] == 3)mag += " f(m4),";
     }
     mag.replace(mag.lastIndexOf(','),1," ");
     if (size > 1) strmes += " { " + mag + " }\n";
     for(int i = 0; i < size;i++) {
       QStringList p = valFunc[priorityFind[i]].split ('@');
       QString mag = ""; 
       if(priorityFind[i] == 0)mag = "m1";
       if(priorityFind[i] == 1)mag = "m2";
       if(priorityFind[i] == 2)mag = "m3";
       if(priorityFind[i] == 3)mag = "m4";
       QString fun = " f(" + mag + ")" + " = " ;
       strmes += fun + p.at(1) + " * " + mag + " + " + p.at(2) +
               " if " + mag + " greater or equal to " + p.at(0);
       strmes += " else " + fun + p.at(3) + "\n";
    }
 }
////////////////////////////////////////////////////////////////////////////////////


strmes +=  remFun;
message += strmes;
strmes +=  "\n";
     return true;
}

void DoubleBaseImpl::InitLineDocProperty(){

     propDocLine.append(new LineDocProperty(spinBoxDeltaTime,      doc->GetDeltaTime()));
     propDocLine.append(new LineDocProperty(lineEditDeltaLatitude, doc->GetDeltaLatitude()));
     propDocLine.append(new LineDocProperty(lineEditDeltaLongitude,doc->GetDeltaLongitude()));
     propDocLine.append(new LineDocProperty(spinBoxDeltaDepth,     doc->GetDeltaDepth()));
     propDocLine.append(new LineDocProperty(lineEditDf,            doc->GetDeltaMagnitude()));

//---------------------------------------------------------------- 
 PropertyFloatValue* M1_D = new PropertyFloatValue(101,first->valD,"",
 minTransformMagnitudeD(),maxTransformMagnitudeD(),decimalTransformMagnitudeD());
 propDocLine.append(new LineDocProperty(lineEditDeltaM1_D,M1_D));
 EditLineValues.push_back(M1_D);

 PropertyFloatValue* M1_A = new PropertyFloatValue(102,first->valA,"",
 minTransformMagnitudeA(),maxTransformMagnitudeA(),decimalTransformMagnitudeA());
 propDocLine.append(new LineDocProperty(lineEditDeltaM1_A,M1_A));
 EditLineValues.push_back(M1_A);

 PropertyFloatValue* M1_B = new PropertyFloatValue(103,first->valB,"",
 minTransformMagnitudeB(),maxTransformMagnitudeB(),decimalTransformMagnitudeB());
 propDocLine.append(new LineDocProperty(lineEditDeltaM1_B,M1_B));
 EditLineValues.push_back(M1_B);

 PropertyFloatValue* M1_C = new PropertyFloatValue(104,first->valC,"",
 minTransformMagnitudeC(),maxTransformMagnitudeC(),decimalTransformMagnitudeC());
 propDocLine.append(new LineDocProperty(lineEditDeltaM1_C,M1_C));
 EditLineValues.push_back(M1_C);
//----------------------------------------------------------------- 
 PropertyFloatValue* M2_D = new PropertyFloatValue(105,second->valD,"",
 minTransformMagnitudeD(),maxTransformMagnitudeD(),decimalTransformMagnitudeD());
 propDocLine.append(new LineDocProperty(lineEditDeltaM2_D,M2_D));
 EditLineValues.push_back(M2_D);

 PropertyFloatValue* M2_A = new PropertyFloatValue(106,second->valA,"",
 minTransformMagnitudeA(),maxTransformMagnitudeA(),decimalTransformMagnitudeA());
 propDocLine.append(new LineDocProperty(lineEditDeltaM2_A,M2_A));
 EditLineValues.push_back(M2_A);

 PropertyFloatValue* M2_B = new PropertyFloatValue(107,second->valB,"",
 minTransformMagnitudeB(),maxTransformMagnitudeB(),decimalTransformMagnitudeB());
 propDocLine.append(new LineDocProperty(lineEditDeltaM2_B,M2_B));
 EditLineValues.push_back(M2_B);

 PropertyFloatValue* M2_C = new PropertyFloatValue(108,second->valC,"",
 minTransformMagnitudeC(),maxTransformMagnitudeC(),decimalTransformMagnitudeC());
 propDocLine.append(new LineDocProperty(lineEditDeltaM2_C,M2_C));
 EditLineValues.push_back(M2_C);

//-----------------------------------------------------------------
PropertyFloatValue* M3_D = new PropertyFloatValue(109,third->valD,"",
 minTransformMagnitudeD(),maxTransformMagnitudeD(),decimalTransformMagnitudeD());
 propDocLine.append(new LineDocProperty(lineEditDeltaM3_D,M3_D));
 EditLineValues.push_back(M3_D);

 PropertyFloatValue* M3_A = new PropertyFloatValue(110,third->valA,"",
 minTransformMagnitudeA(),maxTransformMagnitudeA(),decimalTransformMagnitudeA());
 propDocLine.append(new LineDocProperty(lineEditDeltaM3_A,M3_A));
 EditLineValues.push_back(M3_A);

 PropertyFloatValue* M3_B = new PropertyFloatValue(111,third->valB,"",
 minTransformMagnitudeB(),maxTransformMagnitudeB(),decimalTransformMagnitudeB());
 propDocLine.append(new LineDocProperty(lineEditDeltaM3_B,M3_B));
 EditLineValues.push_back(M3_B);

 PropertyFloatValue* M3_C = new PropertyFloatValue(112,third->valC,"",
 minTransformMagnitudeC(),maxTransformMagnitudeC(),decimalTransformMagnitudeC());
 propDocLine.append(new LineDocProperty(lineEditDeltaM3_C,M3_C));
 EditLineValues.push_back(M3_C);

//-----------------------------------------------------------------
 PropertyFloatValue* M4_D = new PropertyFloatValue(113,fourth->valD,"",
 minTransformMagnitudeD(),maxTransformMagnitudeD(),decimalTransformMagnitudeD());
 propDocLine.append(new LineDocProperty(lineEditDeltaM4_D,M4_D));
 EditLineValues.push_back(M4_D);

 PropertyFloatValue* M4_A = new PropertyFloatValue(114,fourth->valA,"",
 minTransformMagnitudeA(),maxTransformMagnitudeA(),decimalTransformMagnitudeA());
 propDocLine.append(new LineDocProperty(lineEditDeltaM4_A,M4_A));
 EditLineValues.push_back(M4_A);

 PropertyFloatValue* M4_B = new PropertyFloatValue(115,fourth->valB,"",
 minTransformMagnitudeB(),maxTransformMagnitudeB(),decimalTransformMagnitudeB());
 propDocLine.append(new LineDocProperty(lineEditDeltaM4_B,M4_B));
 EditLineValues.push_back(M4_B);

 PropertyFloatValue* M4_C = new PropertyFloatValue(116,fourth->valC,"",
 minTransformMagnitudeC(),maxTransformMagnitudeC(),decimalTransformMagnitudeC());
 propDocLine.append(new LineDocProperty(lineEditDeltaM4_C,M4_C));
 EditLineValues.push_back(M4_C);

//-----------------------------------------------------------------
 /*
     QFont fnOld = font();
     QFont fn = fnOld;
     fn.setBold(true);
     int width =  fontMetrics().width(fontmetricLineEdit());
     foreach (LineDocProperty *docprop, propDocLine) {

     if (docprop->GetProp()->GetKind()  == PropertyValue::Property_Float){
      QLineEdit * lin = (QLineEdit *) docprop->GetEditor();
      lin->setFixedWidth (width);
    }

 }
*/
}

void DoubleBaseImpl::GetDocumentFromDialog()
{
     if(radioAuto->isChecked  ()) doc->GetDeltaRemoveAction()->SetValue("0");
     if(radioDialog->isChecked ()) doc->GetDeltaRemoveAction()->SetValue("1");

     if(radioFirst->isChecked  ()) doc->GetDeltaRemoveEqual()->SetValue("0");
     if(radioSecond->isChecked ()) doc->GetDeltaRemoveEqual()->SetValue("1");

     doc->GetDeltaTime()->SetValue(spinBoxDeltaTime->text());
     doc->GetDeltaLatitude()->SetValue(lineEditDeltaLatitude->text());
     doc->GetDeltaLongitude()->SetValue(lineEditDeltaLongitude->text());
     doc->GetDeltaDepth()->SetValue(spinBoxDeltaDepth->text());
     doc->GetDeltaMagnitude()->SetValue(lineEditDf->text());


///----------------------Removing Functions  ----------------------------------------
     if(checkBoxRemM1->isChecked()) {
     doc->GetRemovingDuplicatePriorityFirst()->SetValue("1");
     doc->GetRemovingDuplicatePriorityFirstMagnitude()->SetValue(QString("%1").arg(comboBoxRemM1->currentIndex()));
     } else {
     doc->GetRemovingDuplicatePriorityFirst()->SetValue("0");
     doc->GetRemovingDuplicatePriorityFirstMagnitude()->SetValue(defaultPriorityFirstMagnitude());
     }

     if(checkBoxRemM2->isChecked()) {
     doc->GetRemovingDuplicatePrioritySecond()->SetValue("1");
     doc->GetRemovingDuplicatePrioritySecondMagnitude()->SetValue(QString("%1").arg(comboBoxRemM2->currentIndex()));
     } else {
     doc->GetRemovingDuplicatePrioritySecond()->SetValue("0");
     doc->GetRemovingDuplicatePrioritySecondMagnitude()->SetValue(defaultPrioritySecondMagnitude());
     }


     if(checkBoxRemM3->isChecked()) {
     doc->GetRemovingDuplicatePriorityThird()->SetValue("1");
     doc->GetRemovingDuplicatePriorityThirdMagnitude()->SetValue(QString("%1").arg(comboBoxRemM3->currentIndex()));
     } else {
     doc->GetRemovingDuplicatePriorityThird()->SetValue("0");
     doc->GetRemovingDuplicatePriorityThirdMagnitude()->SetValue(defaultPriorityThirdMagnitude());
     }

     if(checkBoxRemM4->isChecked()) {
     doc->GetRemovingDuplicatePriorityFourth()->SetValue("1");
     doc->GetRemovingDuplicatePriorityFourthMagnitude()->SetValue(QString("%1").arg(comboBoxRemM4->currentIndex()));
     } else {
     doc->GetRemovingDuplicatePriorityFourth()->SetValue("0");
     doc->GetRemovingDuplicatePriorityFourthMagnitude()->SetValue(defaultPriorityFourthMagnitude());
     }
     doc->GetRemovingDuplicateFunction()->SetValue(QString("%1").arg(comboBoxRemFunction->currentIndex()));
///----------------------Delta Magnitude Functions  ----------------------------------------

    if(checkBoxDeltaM1->isChecked()) {
    first->valIsOn = true;
    first->valIndexMagnitude = comboBoxDeltaM1->currentIndex();
    first->valA = lineEditDeltaM1_A->text();
    first->valB = lineEditDeltaM1_B->text();
    first->valC = lineEditDeltaM1_C->text();
    first->valD = lineEditDeltaM1_D->text();
    } else {
    first->valIsOn = false;
    first->valIndexMagnitude = first->defIndexMagnitude;
    first->valA = first->defA;
    first->valB = first->defB;
    first->valC = first->defC;
    first->valD = first->defD;
    }
    doc->GetDefineDeltaFirstMagnitude()->SetValue(first);

    if(checkBoxDeltaM2->isChecked()) {
    second->valIsOn = true;
    second->valIndexMagnitude = comboBoxDeltaM2->currentIndex();
    second->valA = lineEditDeltaM2_A->text();
    second->valB = lineEditDeltaM2_B->text();
    second->valC = lineEditDeltaM2_C->text();
    second->valD = lineEditDeltaM2_D->text();
    } else {
    second->valIsOn = false;
    second->valIndexMagnitude = second->defIndexMagnitude;
    second->valA = second->defA;
    second->valB = second->defB;
    second->valC = second->defC;
    second->valD = second->defD;
    }
    doc->GetDefineDeltaSecondMagnitude()->SetValue(second);

   if(checkBoxDeltaM3->isChecked()) {
    third->valIsOn = true;
    third->valIndexMagnitude = comboBoxDeltaM3->currentIndex();
    third->valA = lineEditDeltaM3_A->text();
    third->valB = lineEditDeltaM3_B->text();
    third->valC = lineEditDeltaM3_C->text();
    third->valD = lineEditDeltaM3_D->text();
    } else {
    third->valIsOn = false;
    third->valIndexMagnitude = third->defIndexMagnitude;
    third->valA = third->defA;
    third->valB = third->defB;
    third->valC = third->defC;
    third->valD = third->defD;
    }
    doc->GetDefineDeltaThirdMagnitude()->SetValue(third);

   if(checkBoxDeltaM4->isChecked()) {
    fourth->valIsOn = true;
    fourth->valIndexMagnitude = comboBoxDeltaM4->currentIndex();
    fourth->valA = lineEditDeltaM4_A->text();
    fourth->valB = lineEditDeltaM4_B->text();
    fourth->valC = lineEditDeltaM4_C->text();
    fourth->valD = lineEditDeltaM4_D->text();
    } else {
    fourth->valIsOn = false;
    fourth->valIndexMagnitude = fourth->defIndexMagnitude;
    fourth->valA = fourth->defA;
    fourth->valB = fourth->defB;
    fourth->valC = fourth->defC;
    fourth->valD = fourth->defD;
    }
    doc->GetDefineDeltaFourthMagnitude()->SetValue(fourth);

    doc->GetDeltaMagnitudeFunction()->SetValue(QString("%1").arg(comboBoxDeltaFunction->currentIndex()));

}
void DoubleBaseImpl::SetDocumentToDialog()
{
tabWidget->setCurrentIndex(1);
     if(doc->GetDeltaRemoveAction()->GetValue() == "0") { 
       table->hide(); toolButtonSearch->hide();
       radioAuto->setChecked (TRUE);   inDialog = false;
     }
     if(doc->GetDeltaRemoveAction()->GetValue() == "1") { 
       table->show();  toolButtonSearch->show();
       radioSecond->setChecked (TRUE); inDialog = true; 
     }

     if(doc->GetDeltaRemoveEqual()->GetValue() == "0") { 
         radioFirst->setChecked (TRUE);removeFirst = true;removeSecond = false;
     }
     if(doc->GetDeltaRemoveEqual()->GetValue() == "1") { 
        radioSecond->setChecked (TRUE);removeFirst = false;removeSecond = true;
     }

///----------------------Removing Functions  ----------------------------------------
  if (doc->GetRemovingDuplicatePriorityFirst()->GetValue() == "1" ){
  checkBoxRemM1->setChecked (TRUE);
  comboBoxRemM1->setCurrentIndex(doc->GetRemovingDuplicatePriorityFirstMagnitude()->GetValue().toInt());
  } else {
  checkBoxRemM1->setChecked (FALSE);
  comboBoxRemM1->setCurrentIndex(doc->GetRemovingDuplicatePriorityFirstMagnitude()->GetDefaultvalue().toInt());
  }


  if (doc->GetRemovingDuplicatePrioritySecond()->GetValue() == "1" ){
  checkBoxRemM2->setChecked (TRUE);
  comboBoxRemM2->setCurrentIndex(doc->GetRemovingDuplicatePrioritySecondMagnitude()->GetValue().toInt());
  } else {
  checkBoxRemM2->setChecked (FALSE);
  comboBoxRemM2->setCurrentIndex(doc->GetRemovingDuplicatePrioritySecondMagnitude()->GetDefaultvalue().toInt());
  }
  

  if (doc->GetRemovingDuplicatePriorityThird()->GetValue() == "1" ){
  checkBoxRemM3->setChecked (TRUE);
  comboBoxRemM3->setCurrentIndex(doc->GetRemovingDuplicatePriorityThirdMagnitude()->GetValue().toInt());
  } else {
  checkBoxRemM3->setChecked (FALSE);
  comboBoxRemM3->setCurrentIndex(doc->GetRemovingDuplicatePriorityThirdMagnitude()->GetDefaultvalue().toInt());
  }


  if (doc->GetRemovingDuplicatePriorityFourth()->GetValue() == "1" ){
  checkBoxRemM4->setChecked (TRUE);
  comboBoxRemM4->setCurrentIndex(doc->GetRemovingDuplicatePriorityFourthMagnitude()->GetValue().toInt());
  } else {
  checkBoxRemM4->setChecked (FALSE);
  comboBoxRemM4->setCurrentIndex(doc->GetRemovingDuplicatePriorityFourthMagnitude()->GetDefaultvalue().toInt());
  }
  comboBoxRemFunction->setCurrentIndex(doc->GetRemovingDuplicateFunction()->GetValue().toInt());
///----------------------Delta Magnitude Functions  ----------------------------------------

  if (first->valIsOn){
  checkBoxDeltaM1->setChecked (TRUE);
  comboBoxDeltaM1->setCurrentIndex(first->valIndexMagnitude);
  } else {
  checkBoxDeltaM1->setChecked (FALSE);
  comboBoxDeltaM1->setCurrentIndex(first->defIndexMagnitude);
  }

  if (second->valIsOn){
  checkBoxDeltaM2->setChecked (TRUE);
  comboBoxDeltaM2->setCurrentIndex(second->valIndexMagnitude);
  } else {
  checkBoxDeltaM2->setChecked (FALSE);
  comboBoxDeltaM2->setCurrentIndex(second->defIndexMagnitude);
  }

  if (third->valIsOn){
  checkBoxDeltaM3->setChecked (TRUE);
  comboBoxDeltaM3->setCurrentIndex(third->valIndexMagnitude);
  } else {
  checkBoxDeltaM3->setChecked (FALSE);
  comboBoxDeltaM3->setCurrentIndex(third->defIndexMagnitude);
  }

  if (fourth->valIsOn){
  checkBoxDeltaM4->setChecked (TRUE);
  comboBoxDeltaM4->setCurrentIndex(fourth->valIndexMagnitude);

  } else {
  checkBoxDeltaM4->setChecked (FALSE);
  comboBoxDeltaM4->setCurrentIndex(fourth->defIndexMagnitude);
  }
comboBoxDeltaFunction->setCurrentIndex(doc->GetDeltaMagnitudeFunction()->GetValue().toInt());
foreach (LineDocProperty *docprop, propDocLine) docprop->SetValueFromDoc();
}
