#include <QtGui>
#include <math.h> 
#include "mainwindow.h" 
#include "doubleimpl.h" 
#include "default.h"
#include "viewcatalogimpl.h"
#include "tableproperty.h"
#include "bottomwindow.h"
#include "convert.h"
#include "editline.h"
#include "helpwindow.h"
DoubleBaseImpl::~DoubleBaseImpl(){
//	QMessageBox::critical(0,"",QString("DoubleBaseImpl::~DoubleBaseImpl()"));
if (findFunction !=0)   delete findFunction;   findFunction = 0;
if (removeFunction !=0) delete removeFunction; removeFunction = 0;
comboBoxes.clear(); transFunc.clear();
//if (!indexMagnitude.empty()) indexMagnitude.clear();
values.clear();
if(!propDocLine.empty()) {
foreach (LineDocProperty* prop, propDocLine) {delete prop;prop = 0;}
propDocLine.clear();
}  
if(!EditLineValues.empty()) {
for_each(EditLineValues.begin(),EditLineValues.end(),delAndNullify);
EditLineValues.erase(remove(EditLineValues.begin(),EditLineValues.end(),
static_cast<PropertyValue*>(0)),EditLineValues.end());
}
    if(help !=0) {delete help; help = 0;}
	if (!indexDouble->empty()) indexDouble->clear(); delete indexDouble;
}
DoubleBaseImpl::DoubleBaseImpl( QWidget *parent,FDocument* dc,TypeUsing tp)
    : QDialog(0),doc(dc),type(tp)
{

     QFont f = parent->font();
     setWindowIcon(QIcon(":/images/icon.png"));
     Ui_DoubleBase::setupUi(this);
     setWindowTitle(projectActionList().split ('@').at(1) );
     ptrFindFunction = 0;
     findFunction = 0;
     ptrRemoveFunction = 0;
     removeFunction = 0;
     help = 0;
	 indexDouble = new DoubleIntMultiMap;
     maxCorrectionPageDouble = MainWindow::self->GetSetDocument()->GetMaxCorrectionLines()->GetValue().toInt()/4;
     setModal (true);
	 if (type != Wizard) 
		 parentWindow = (CatTable* )parent;
	 else parentWindow = 0;
     setFont( parent->font() );
     model = new PropertyModel(3, numberCatalogColumns(),this);
     table->setAlternatingRowColors (TRUE);
     table->setModel(model);
     PropertyDelegate *delegate = new PropertyDelegate;
     table->setItemDelegate(delegate);
     selectModel = table->selectionModel(); 
	 model->setHeaderData(2, Qt::Vertical,"Leave");

    QModelIndex ind = model->index(2, numberCatalogComment(), QModelIndex());
    model->setData(ind, "Leave intact" );
     if (type != Wizard) 
		 parentWindow->ResizeHorizontalHeader(table->horizontalHeader ());
     numberOfDoubles = 0;
     firstStart = true;
     modified = false;
     toolButtonSearch->show();
//--------- Fill Lists Functions and Priority Magnitudes -----------------------
     comboBoxRemFunction->clear();
     QStringList lst = doc->GetRemovingDuplicateFunction()->GetStringList();
     for (int i = 0; i < lst.size(); i++) comboBoxRemFunction->addItem(lst.at(i));
     comboBoxDeltaFunction->clear();

     lst = doc->GetDeltaMagnitudeFunction()->GetStringList();

     for (int i = 0; i < lst.size(); i++) comboBoxDeltaFunction->addItem(lst.at(i));

     lst = enumComboBoxMagnitudeList().split ('@');
     comboBoxes.append(comboBoxRemM1);   comboBoxes.append(comboBoxRemM2);
     comboBoxes.append(comboBoxRemM3);   comboBoxes.append(comboBoxRemM4);
     comboBoxes.append(comboBoxDeltaM1); comboBoxes.append(comboBoxDeltaM2);
     comboBoxes.append(comboBoxDeltaM3); comboBoxes.append(comboBoxDeltaM4);
     foreach (QComboBox * box, comboBoxes) box->clear();
     for (int i = 0; i < lst.size(); i++) foreach (QComboBox * box, comboBoxes) box->addItem(lst.at(i));

//--------------------------------------------------------------------------------------------------------
     values.append(doc->GetDeltaRemoveAction());
     values.append(doc->GetDeltaRemoveEqual());

     values.append(doc->GetDeltaMagnitudeFunction());
     values.append(doc->GetRemovingDuplicateFunction());

     first  = doc->GetDefineDeltaFirstMagnitude();   transFunc.append(first);
     second = doc->GetDefineDeltaSecondMagnitude();  transFunc.append(second);
     third  = doc->GetDefineDeltaThirdMagnitude();   transFunc.append(third);
     fourth = doc->GetDefineDeltaFourthMagnitude();  transFunc.append(fourth);
     values.append(first);values.append(second);values.append(third);values.append(fourth);

     values.append(doc->GetDeltaTime());
     values.append(doc->GetDeltaLatitude());
     values.append(doc->GetDeltaLongitude());
     values.append(doc->GetDeltaDepth());
     values.append(doc->GetDeltaMagnitude());

     values.append(doc->GetRemovingDuplicatePriorityFirst());
     values.append(doc->GetRemovingDuplicatePrioritySecond());
     values.append(doc->GetRemovingDuplicatePriorityThird());
     values.append(doc->GetRemovingDuplicatePriorityFourth());

     values.append(doc->GetRemovingDuplicatePriorityFirstMagnitude());
     values.append(doc->GetRemovingDuplicatePrioritySecondMagnitude());
     values.append(doc->GetRemovingDuplicatePriorityThirdMagnitude());
     values.append(doc->GetRemovingDuplicatePriorityFourthMagnitude());
//---------------------------------------------------------------------------------------------------------
     textLabel->setText("");
	 if (type == Wizard)  textLabel->hide();
     progressBar->setRange(1,10);
     toolButtonSearch->setEnabled(FALSE);
     buttonOk->setEnabled(FALSE);
      texted = MainWindow::self->bottomWindow->messageTab;
      correctioned = MainWindow::self->bottomWindow->correctionTab;

     connect( table, SIGNAL(clicked(QModelIndex ) ),
	      this, SLOT( clickedRowCol(QModelIndex )) );
     connect( table->verticalHeader (), SIGNAL( sectionClicked(int) ),
	     this, SLOT( clickedVerticalHeader(int) ) );      

    connect( buttonOk,           SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( buttonCancel,       SIGNAL( clicked() ), this, SLOT( close() ) );
    connect( radioDialog,        SIGNAL( clicked() ), this, SLOT( rbDialog() ) );
    connect( radioFirst,         SIGNAL( clicked() ), this, SLOT( rbFirst() ) );
    connect( radioAuto,          SIGNAL( clicked() ), this, SLOT( rbAuto() ) );
    connect( radioSecond,        SIGNAL( clicked() ), this, SLOT( rbSecond() ) );
    connect( toolButtonSearch,   SIGNAL( clicked() ), this, SLOT( findNext() ) );
    connect( buttonHelp,         SIGNAL( clicked() ), this, SLOT( btHelp() ) );
    connect(pushButtonStart,     SIGNAL( clicked() ), this, SLOT( start() ) );
    connect(toolButtonReset,     SIGNAL(clicked()),   this, SLOT(reset()));
    connect(toolButtonProject,   SIGNAL(clicked()),   this, SLOT(project()));
    connect(toolButtonDefault,   SIGNAL(clicked()),   this, SLOT(defaults()));
    connect( progressBar, SIGNAL( valueChanged ( int) ), this, SLOT(ProgressBarChanged(int) ) );
    DuplicateProgress(0);
    InitLineDocProperty();
    SetDocumentToDialog();
	 comboBoxDeltaM1->adjustSize();
	 comboBoxDeltaM2->adjustSize();
	 comboBoxDeltaM3->adjustSize(); 
	 comboBoxDeltaM4->adjustSize();
	 QString tmp = projectActionList().split ('@').at(1);
      correctioned->insertPlainText(prefixMessage()  + tmp + " ***\n\n");
      if (type == Tool){
      toolButtonProject->hide();
      MainWindow::self->bottomWindow->OpenMessagesProtocolPage();
      texted->insertPlainText(prefixMessage()  + tmp + " ***\n\n");
      tabWidget->setCurrentIndex(0);
      }
      if (type == Wizard){
        //tabWidget->removeTab(0);
        tabWidget->setCurrentIndex(0);
     }

 }
bool DoubleBaseImpl::execute(){
bool ret = applay();
if (numberOfDoubles > 1) parentWindow->WriteCatFromIndex();
  Catalog cat;
  texted->insertPlainText("\nOut catalog " + 
           cat.GetCatalogShortInfoMessage(MainWindow::self->GetOpenBinaryFileName()));
  QString tmp = projectActionList().split ('@').at(1);
  texted->insertPlainText(postfixActionMessage() +  tmp + " ***\n\n");
  correctioned->insertPlainText(postfixActionMessage() +  tmp + " ***\n\n");

done( Accepted );
return ret;
}
bool DoubleBaseImpl::applay(){

  message = "";
  if ( !GetRemDupFunc() ) return false;


  if (type == Tool || type == Wizard) {
  QString tmp = QString("Do you want to execute %1?\n\n").arg(projectActionList().split ('@').at(1));
       int ret = QMessageBox::warning(0,windowTitle (),tmp + message,
                     QMessageBox::Yes | QMessageBox::Default,
                     QMessageBox::No | QMessageBox::Escape);
        if (ret == QMessageBox::No) return false;
  }

QApplication::setOverrideCursor(Qt::WaitCursor);	
if (firstStart == true) {
	firstStart = false;
	copyIndexDouble =  parentWindow->GetRecordCatalogIndex();
	indexDouble->insert(copyIndexDouble->begin(),copyIndexDouble->end());

}
else  {
	//parentWindow->RestoreIndex();
	if (numberOfDoubles > 0) {
	indexDouble->clear();
	indexDouble->insert(copyIndexDouble->begin(),copyIndexDouble->end());
	}
}

  model->removeRows(0,2);
  model->insertRows(0,2);
  parentWindow->ResizeRows();
/////////////////////////////////////////////////////////////////
     QString tmp;
//     if (type == Tool){
//      MainWindow::self->bottomWindow->OpenMessagesProtocolPage();
//      tmp = projectActionList().split ('@').at(1);
//      texted->insertPlainText(prefixMessage()  + tmp + " ***\n");
//      }

////////////////////////////////////////////////////////////////


  in =  parentWindow->GetFstream();

  numRec = indexDouble->size();
  //if (!indexMagnitude.empty()) indexMagnitude.clear();


  progressBar->setRange(1,numRec);
  DuplicateProgress(0);

  numberOfDoubles = 0;
  toolButtonSearch->setEnabled(TRUE);
  buttonOk->setEnabled(TRUE);
     tmp = projectActionList().split ('@').at(1);
 //     correctioned->insertPlainText(prefixMessage()  + tmp + " ***\n\n");
      corrmess = "";
     if(inDialog) {
		 table->show();toolButtonSearch->show();
        if ((returnCode  =   initialFindDoubleProcess()) > 0){
        if (returnCode == 1) textLabel->setText("An reading error catalog has occurred");
        if (returnCode == 2) textLabel->setText("An expected eof catalog has occurred");
       }
       else {
	     textLabel->setText("NORMAL");
      }
      IdentificationDouble();
        //findNext();
    } else {
      in->clear();
      pos1        = indexDouble->begin();
      ItrMultiMap postmp = pos1;postmp++;
      pos2        = postmp;
      DoubleProccessing();
	  texted->insertPlainText(message);
	  correctioned->insertPlainText(message);
     if (numberOfDoubles > 1) correctioned->insertPlainText("List of duplicates:\n\n");
     correctioned->insertPlainText(corrmess + "\n");
     
    }

 QApplication::restoreOverrideCursor();

return true;
}
void DoubleBaseImpl::start(){
if (!applay()) return;
}

int DoubleBaseImpl::initialFindDoubleProcess(){
    in->clear();
    pos1        = indexDouble->begin();   
    int inpos1 = pos1->second +1;
    ItrMultiMap postmp = pos1;postmp++;
    pos2        = postmp;
    int inpos2 = pos2->second +1;

	in->seekg(inpos1*sizeof(RECORD),ios::beg); 
	in->read((char*)&record1,sizeof(RECORD ));
	if(in->eof()){  
	    error(QString("An expected eof catalog has occurred"),"");
            QPalette pal = textLabel->palette();
            pal.setColor(QPalette::Foreground, QColor( 255, 0, 0 ));
            textLabel->setPalette(pal);
	    return 2;  
	}
	
	if(in->fail()){ 
	    error(QString("An reading error has occurred (rec %1)").arg(inpos1),"");
            QPalette pal = textLabel->palette();
            pal.setColor(QPalette::Foreground, QColor( 255, 0, 0 ));
	    textLabel->setPalette(pal);
	    return 1; 
	}
  
//  InsertRowTable(record1,0,inpos1);  	

	in->seekg(inpos2*sizeof(RECORD),ios::beg); 
	in->read((char*)&record2,sizeof(RECORD ));
	if(in->eof()){
	    error(QString("An expected eof catalog has occurred"),"");
            QPalette pal = textLabel->palette();
            pal.setColor(QPalette::Foreground, QColor( 255, 0, 0 ));
	    textLabel->setPalette(pal);
	    return 2; 
	} 
	if(in->fail()){ 
	    error(QString("An reading error has occurred (rec %1)").arg(inpos2),"");
            QPalette pal = textLabel->palette();
            pal.setColor(QPalette::Foreground, QColor( 255, 0, 0 ));
	    textLabel->setPalette(pal);
	    return 1; 
	}
 
// InsertRowTable(record2,1,inpos2);

	DuplicateProgress(0);

	    
	return 0;    
   
}


void DoubleBaseImpl::findNext(){

    if (!(pos1 != indexDouble->end() || pos2 != indexDouble->end()) ) return;
if(numberOfDoubles > 0)
 if (!selectModel->isRowSelected (0,QModelIndex() ) && !selectModel->isRowSelected (1,QModelIndex())
     && !selectModel->isRowSelected (2,QModelIndex())       ) {
  QMessageBox::information(this,mainWindowCaption(),
         tr("Select row to continue identification doubles."));
  return;
  }

    if (selectModel->isRowSelected (0,QModelIndex() ) ) {
	ItrMultiMap posNew = pos1; posNew++;
        corrmess += QString("      Your choise: remove record %1 \n").arg(pos1->second +1);
	indexDouble->erase(pos1);
	pos1 = posNew;
	if (pos1 == pos2) pos2++;
        modified = true;

    }
    if (selectModel->isRowSelected (1,QModelIndex() ) ) {
	ItrMultiMap posNew = pos2;posNew++;
        corrmess += QString("      Your choice: remove record %1 \n").arg(pos2->second +1);
	indexDouble->erase(pos2);
	pos2 = posNew;
	modified = true;

    }
   if (selectModel->isRowSelected (2,QModelIndex() ) ) {
     corrmess += QString("      Your choice: Leave intact \n");
      pos1++;
      if (pos1 == pos2) pos2++;
  }
    if (!(pos1 != indexDouble->end() || pos2 != indexDouble->end()) )  {  
   	QString    tmp = QString("Found %1 duplicates. Process of identification of doubles is completed.").arg(numberOfDoubles);
	textLabel->setText(tmp);
} 
IdentificationDouble();
}
void DoubleBaseImpl::SetFindDoubleInfo(){
QString tmp ="";
	     if (numberOfDoubles > 1)
	      tmp = QString("Found so far: %1 ").arg(numberOfDoubles);
	     else
	       tmp = QString("Found so far: %1 ").arg(numberOfDoubles);
      //-------------------------------------------------------------------------------------
    //  qWarning("n %d delRow %d valFunct1 %5.3f valFunct2 %5.3f",numberOfDoubles,
//                          removeFunction->delRow,removeFunction->valFunct1,removeFunction->valFunct2);
       float flt1 = removeFunction->valFunct1;
       float flt2 = removeFunction->valFunct2;
       char buf[128];
       ::sprintf(buf, " <%d>:%4.2f; <%d>:%4.2f",
	   pos1->second +1,flt1,pos2->second +1,flt2);
       Catalog cat;
       QString rec1 = QString("%1 :>     %2 - %3").arg(numberOfDoubles).arg(pos1->second +1).arg(cat.getFieldsFromRecord(record1)); 
       QString rec2 = QString("%1 :>     %2 - %3").arg(numberOfDoubles).arg(pos2->second +1).arg(cat.getFieldsFromRecord(record2)); 
       int row = 0;
       if (removeFunction->delRow < 2){
        
        if  (removeFunction->delRow == 0) row = pos1->second +1;
        if  (removeFunction->delRow == 1) row = pos2->second +1;
        tmp += QString("Remove record <%1> by magnitude: %2 > %3").
		  arg(row).arg(nameRemoveFunction).arg(QString::fromAscii(buf));
       } else {
		      if(radioFirst->isChecked  ()) row = pos1->second +1;
			  if(radioSecond->isChecked ()) row = pos2->second +1;
              if(indexRemovalFunction != -1)
              tmp += QString("Remove record <%1> by order: > %2").arg(row).arg(QString::fromAscii(buf));
              else tmp += QString("Remove record <%1> by order:").arg(row);

             }
       corrmess += tmp + "\n"; corrmess += rec1 + "\n"; corrmess += rec2 + "\n";

       if (inDialog) textLabel->setText(tmp);

}

void DoubleBaseImpl::IdentificationDouble(){
   QString tmp ="";
    returnCode  =   findNextDouble();
    if (returnCode == 1) textLabel->setText("An reading error catalog has occurred");
    if (returnCode == 2) textLabel->setText("An expected eof catalog has occurred");   

    if (returnCode == 4) {
	if (numberOfDoubles == 0) {
         DuplicateProgress(numRec);
          tmp = "Duplicates have not found. Identification complited.";
	  textLabel->setText(tmp);
        //  corrmess += "\n" + tmp + "\n";
          message += "\n" + tmp + "\n\n";
  }
	else {	
		tmp = QString("Found %1 duplicates. Identification complited.").arg(numberOfDoubles);
	    textLabel->setText(tmp);
           // corrmess += "\n" + tmp + "\n";
            message += "\n" + tmp + "\n\n";
         // print   indexMagnitude
          /*
          if (!indexMagnitude.empty())  {
           multimap<double,short>::iterator it;
           for (it = indexMagnitude.begin(); it!=indexMagnitude.end();it++)
           qWarning("--- %16.6f %d",it->first,it->second);
          }
          */
          // print   indexMagnitude

	}
	/*
    RECORD record;
    in->seekg(-(2*(int)sizeof(RECORD)),ios::end);
    in->read((char*)&record,sizeof(RECORD ));
	
    InsertRowTable(record,0,numRec-1);
    in->read((char * ) &record,sizeof(RECORD ));
	
	  InsertRowTable(record,1,numRec);
	*/
	table->hide();
    table->clearSelection ();
    table->clearFocus ();   
    }

}
int DoubleBaseImpl::findNextDouble(){
    float eps = acuracyCompareFloatValue();
    int inpos1 = 0;
    int  inpos = 0;
    bool findDouble = false;
    while(pos1 != indexDouble->end()) {
    inpos1 = pos1->second +1;
    in->seekg(inpos1 * sizeof(RECORD),ios::beg);     
    in->read((char * ) &record1,sizeof(RECORD ));
    if(in->eof()){
	error(QString("An expected eof catalog has occurred"),"");
            QPalette pal = textLabel->palette();
            pal.setColor(QPalette::Foreground, QColor( 255, 0, 0 ));
	    textLabel->setPalette(pal);
	return 2;
    }
    if(in->fail()){ 
	error(QString("An reading error has occurred (rec %1)").arg(inpos1),"");
            QPalette pal = textLabel->palette();
            pal.setColor(QPalette::Foreground, QColor( 255, 0, 0 ));
	    textLabel->setPalette(pal);
	return 1;
    }     
    cat.GetLatLonDepthMagnitude(record1,lat1,lon1,dep1,mb1,ms1,ml1,mp1);
    GetTimeSec(pos1->first,min1, sec1);
    float fsec1 = (float)sec1/100.;
     ItrMultiMap postmp = pos2;

    while(pos2 !=indexDouble->end()) {
	inpos = pos2->second +1;
	in->seekg(inpos * sizeof(RECORD),ios::beg);
	in->read((char * ) &record2,sizeof(RECORD ));
	if(in->eof()){
	    error(QString("An expected eof catalog has occurred"),"");
	    QPalette pal = textLabel->palette();
            pal.setColor(QPalette::Foreground, QColor( 255, 0, 0 ));
	    textLabel->setPalette(pal);
	    return 2;
	    }
	if(in->fail()){
	    error(QString("An reading error has occurred (rec %1)").arg(inpos),"");
            QPalette pal = textLabel->palette();
            pal.setColor(QPalette::Foreground, QColor( 255, 0, 0 ));
	    textLabel->setPalette(pal);
	    return 1;
	}
	cat.GetLatLonDepthMagnitude(record2,lat2,lon2,dep2,mb2,ms2,ml2,mp2);
	GetTimeSec(pos2->first,min2 , sec2);
	float fsec2 = (float)sec2 / 100.;
	float dt = (float)dtime;
	float dlt = fabs(lat2 - lat1);
	float dln = fabs(lon2 - lon1);
	float ddp = fabs(dep2 - dep1);
	//if ( abs(min2 - min1) < dtime + 1 ) { old dtime in min
	   float deltaSec = (float)abs(min2  - min1)*60.  + abs(fsec2 - fsec1);
	 if ( deltaSec < dt + 60. ) {  
     if ( (deltaSec < dt || fabs(deltaSec - dt) < eps )&&
		  (dlt < dlat  || fabs(dlt - dlat) < eps) &&
		  (dln < dlon  || fabs(dln - dlon) < eps )&&
		  (ddp < (float)ddep || fabs(ddp - (float)ddep) < eps) )
      {
       findFunction->SetValue(mb1,ms1,ml1,mp1,mb2,ms2,ml2,mp2);
       (findFunction->*ptrFindFunction)();
       if (findFunction->value){findDouble = true;numberOfDoubles++;break;}
       
      }

	  } else {pos2++; break;}

	pos2++;
    }
    if (findDouble == true) break;
    pos1++; postmp =pos1;  if( pos1 != pos2) pos2 = ++postmp;
    if ((inpos/100)*100 == inpos ) DuplicateProgress(inpos);	
}
    if (findDouble == true) {
      removeFunction->SetValue(mb1,ms1,ml1,mp1,mb2,ms2,ml2,mp2);
      (removeFunction->*ptrRemoveFunction)();
      if (inDialog)   {
	    InsertRowTable(record1,0,inpos1);
	    InsertRowTable(record2,1,inpos);
            table->clearSelection ();
            table->clearFocus ();
            if  (removeFunction->delRow == 0)table->selectRow (removeFunction->delRow);
            if  (removeFunction->delRow == 1)table->selectRow (removeFunction->delRow);
            if  (removeFunction->delRow == 2) {
	       if ( removeFirst ) table->selectRow(0);
	       if ( removeSecond  ) table->selectRow(1);
            }
      }
        DuplicateProgress(inpos);

        if (numberOfDoubles == maxCorrectionPageDouble +1)
        corrmess += QString("Stop info: number of doubles more than %1 ... \n").arg(maxCorrectionPageDouble);
        if (numberOfDoubles < maxCorrectionPageDouble + 1)   SetFindDoubleInfo();

       //if ( inDialog && numberOfDoubles == 0) corrmess = "";
	return 3;
    } else {

	DuplicateProgress(inpos);
	return 4;
    }
    
    return 0;
}

void DoubleBaseImpl::rbFirst(){
    if( radioFirst->isChecked ()) {
	removeFirst = true; removeSecond  = false;
	//textLabel->setText("Process of identification of doubles in progress .... "); 
    }
}
void DoubleBaseImpl::rbSecond(){
    if( radioSecond->isChecked ()) {
	removeFirst = false; removeSecond  = true;
	//textLabel->setText("Process of identification of doubles in progress .... "); 
    }
}
void DoubleBaseImpl::rbDialog(){
    if( radioDialog->isChecked()) {
       inDialog = true;
       table->show(); toolButtonSearch->show();

    } 
}
void DoubleBaseImpl::rbAuto(){
if( radioAuto->isChecked()) {
table->hide();  toolButtonSearch->hide();
inDialog = false;
}
}
void DoubleBaseImpl::btHelp(){
    QString home = searchHelpPath() + "/edcat-tool-duplicates.html";
    if(help !=0) {delete help; help =0;}
    help = new HelpWindow(home,this);
    if ( QApplication::desktop()->width() > 400
         && QApplication::desktop()->height() > 500 )
         help->show();
    else
        help->showMaximized();
}

void DoubleBaseImpl::clickedVerticalHeader(int section){
    table->selectRow (section); 
    //if (idDouble == 3)
    parentWindow->SearchNumber(model->GetHeaderRowRecordNumber(section));    
}
void DoubleBaseImpl::clickedRowCol(QModelIndex ind){

    int row = ind.row();
    table->selectRow (row);
    if (row == 2) return;
    parentWindow->SearchNumber(model->GetHeaderRowRecordNumber(row));

}
void DoubleBaseImpl::DuplicateProgress(int progress){
    progressBar->setValue(progress);
}
void DoubleBaseImpl::InsertRowTable(RECORD r,int row,int pos) {

     Catalog cat;
     int i = row;
     model->removeRows(row,1);
     model->insertRows(row,1);
     QString temp = cat.getFieldsFromRecord(r);
     model->SetNotEditRow(i,pos,temp);
 //    table->selectRow (i);
     parentWindow->ResizeRows();
 }


void DoubleBaseImpl::EraseFirstRecordOfDouble() {
		ItrMultiMap posNew = pos1; posNew++;
if (numberOfDoubles < maxCorrectionPageDouble + 1) corrmess += QString("      Removed record %1 \n").arg(pos1->second +1);
		indexDouble->erase(pos1);
		pos1 = posNew;
		if (pos1 == pos2) pos2++;
		modified = true;
}
void DoubleBaseImpl::EraseSecondRecordOfDouble() {
		ItrMultiMap posNew = pos2;posNew++;
if (numberOfDoubles < maxCorrectionPageDouble + 1) corrmess += QString("      Removed record %1 \n").arg(pos2->second +1);
		indexDouble->erase(pos2);
		pos2 = posNew;
		modified = true;
}
bool DoubleBaseImpl::NextOk(){
 message = "";
 if ( !GetRemDupFunc() ) return false;
   QString tmp = QString("Do you accept your choice for %1 action?\n\n").arg(projectActionList().split ('@').at(1));
   int ret = QMessageBox::warning(this,windowTitle (),tmp + message,
                     QMessageBox::Yes | QMessageBox::Default,
                     QMessageBox::No | QMessageBox::Escape);
   if (ret == QMessageBox::No) return false;

     return true;
}
void DoubleBaseImpl::FinishOk(){
	message = "";
	QString tmp = projectActionList().split ('@').at(1);
	texted->insertPlainText(prefixMessage() + tmp + " ***\n\n");	
	GetRemDupFunc();
	GetDocumentFromDialog();
	foreach (PropertyValue* val, values) val->SetValueToResetvalue();
	texted->insertPlainText(message);
  
	tmp = projectActionList().split ('@').at(1); 
	texted->insertPlainText("\n" + postfixActionMessage() +  tmp + " ***\n\n");

}
void DoubleBaseImpl::DoubleProccessing(){
   if (pos1 != indexDouble->end() || pos2 != indexDouble->end()  ){
    if (!inDialog) {
	  while ( pos1 != indexDouble->end() || pos2 != indexDouble->end() ) {
	    returnCode  =   findNextDouble();
//----------------------------------------------------------------------
    if (returnCode == 3) {
      if  (removeFunction->delRow == 0)EraseFirstRecordOfDouble();
      if  (removeFunction->delRow == 1)EraseSecondRecordOfDouble();
      if  (removeFunction->delRow == 2) {
	       if ( removeFirst ) EraseFirstRecordOfDouble();
	       if ( removeSecond  ) EraseSecondRecordOfDouble();
     }
   }   
//------------------------------------------------------------------------- 
	     

      QString tmp =""; 
	    if (returnCode == 1) {textLabel->setText("An reading error catalog has occurred"); return;}
	    if (returnCode == 2) {textLabel->setText("An expected eof catalog has occurred"); return;}
	    
		

	} //while
    RECORD record;
    in->seekg(-(2*(int)sizeof(RECORD)),ios::end);
    in->read((char*)&record,sizeof(RECORD ));
    InsertRowTable(record,0,numRec-1);
    in->read((char * ) &record,sizeof(RECORD ));
	  InsertRowTable(record,1,numRec);
    table->clearSelection ();
    table->clearFocus ();
    QString tmp ="";
    if (numberOfDoubles == 0) 
		tmp = "Duplicates have not found.Identification complited" ;
	
       if (numberOfDoubles > 0)
		   tmp = QString("Found %1 duplicates. Identification complited.").arg(numberOfDoubles);
	textLabel->setText(tmp); 
	DuplicateProgress(numRec);
       // corrmess += "\n" + tmp + "\n";
        message += "\n" + tmp + "\n\n";
	return;
    }   //idDouble < 3
}
}
void DoubleBaseImpl::accept()
{

if (inDialog)  
if ((pos1 != indexDouble->end() || pos2 != indexDouble->end()) ) {
   QString tmp = QString("Do you want autoremoval of dublicates ?\n");
int ret = QMessageBox::warning(this, mainWindowCaption(),tmp,
                     QMessageBox::Yes | QMessageBox::Default,
                     QMessageBox::No,
                     QMessageBox::Cancel | QMessageBox::Escape);
        if (ret == QMessageBox::Yes) {
         corrmess += "\nContinue autoremoval of dublicates\n";
         inDialog= false; 
		 numberOfDoubles--;
         DoubleProccessing();
		 table->hide();
		 toolButtonSearch->hide();
         inDialog= true; 
		 return;
        }
        if (ret == QMessageBox::Cancel) return;
		if (ret == QMessageBox::No) {
			numberOfDoubles--;
		    QString tmp = QString("Found first %1 duplicates. Identification complited.").arg(numberOfDoubles);
            textLabel->setText(tmp);
	        //DuplicateProgress(numRec);
            corrmess += "\n" + tmp + "\n\n";
            message += "\n" + tmp + "\n\n";
		    table->hide();
		    toolButtonSearch->hide();
			inDialog= false;  
			return;
		}


} 
if (inDialog)  {
if (numberOfDoubles > 1) correctioned->insertPlainText("List of duplicates:\n\n");
  correctioned->insertPlainText(message);
  correctioned->insertPlainText(corrmess + "\n");
  texted->insertPlainText(message);
}


if (numberOfDoubles > 0) {
QApplication::setOverrideCursor(Qt::WaitCursor);
	copyIndexDouble->clear();
	copyIndexDouble->insert(indexDouble->begin(),indexDouble->end());
QApplication::restoreOverrideCursor();
	parentWindow->WriteCatFromIndex();
}
  Catalog cat;
  texted->insertPlainText("Output catalog " + 
           cat.GetCatalogShortInfoMessage(MainWindow::self->GetOpenBinaryFileName()));
  QString  tmp = projectActionList().split ('@').at(1);
  texted->insertPlainText(postfixActionMessage()  + tmp + " ***\n\n");
  
  correctioned->insertPlainText("Output catalog " + 
           cat.GetCatalogShortInfoMessage(MainWindow::self->GetOpenBinaryFileName()));
  correctioned->insertPlainText(postfixActionMessage()  + tmp + " ***\n\n");
 // correctioned->insertPlainText(postfixActionMessage()  + tmp + " ***\n\n");

GetDocumentFromDialog();
foreach (PropertyValue* val, values) val->SetValueToResetvalue();
    MainWindow::self->doubleImplPos   =  pos();
    MainWindow::self->doubleImplSize  =  size();
    MainWindow::self->modifiedCatalog = true;
    MainWindow::self->modifiedProtocol= true;

  if (type == Tool) {
      texted->ensureCursorVisible ();
      correctioned->ensureCursorVisible ();
  }
   MainWindow::self->RestoreStatusbarMessage();
    done( Accepted ); 
}

void DoubleBaseImpl::closeEvent(QCloseEvent *event)
{
// like as reject
if (inDialog)  {
if (numberOfDoubles > 1) correctioned->insertPlainText("List of duplicates:\n\n");
  correctioned->insertPlainText(corrmess + "\n");
  texted->insertPlainText(message);
}
//parentWindow->RestoreIndex();

foreach (PropertyValue* val, values) val->SetResetvalueToValue();
    MainWindow::self->doubleImplPos   =  pos();
    MainWindow::self->doubleImplSize  =  size();
    texted->insertPlainText(cancelMessage() + "\n");
    correctioned->insertPlainText(corrmess + "\n");
    correctioned->insertPlainText(cancelMessage() + "\n");
    correctioned->ensureCursorVisible ();
    MainWindow::self->RestoreStatusbarMessage();
    MainWindow::self->doubleImplPos   =  pos();
    MainWindow::self->doubleImplSize  =  size();
    event->accept();
}
void DoubleBaseImpl::reset(){

foreach (PropertyValue* val, values) val->SetResetvalueToValue();
SetDocumentToDialog();
}
void DoubleBaseImpl::project(){

foreach (PropertyValue* val, values) val->SetInitial();
SetDocumentToDialog();
}
void DoubleBaseImpl::defaults(){

foreach (PropertyValue* val, values) val->SetDefault();
SetDocumentToDialog();
}
//----------------------------------------------------------------------------------
void DoubleBaseImpl::ProgressBarChanged(int value){
if (value > 1 ) {
 textLabel->setText(tr("Record: %1").arg(value));
 textLabel->repaint ();
}
}
void DoubleBaseImpl::reject()
{
return;
}


//----------------------------------------------------------------------------------
