#ifndef _DOUBLE_IMPL_H
#define _DOUBLE_IMPL_H
#include <fstream>
#include <map>
#include <vector>
#include "ui_removedouble.h"
#include "catalog.h"
#include "document.h"
using namespace std;
class QComboBox;
class QWidget;
class QTextEdit;
class CatTable;
class PropertyModel;
class QItemSelectionModel;
class FDocument;
class FindDupFunc;
class RemoveDupFunc;
class LineDocProperty;
class HelpWindow;
class DoubleBaseImpl : public QDialog, private Ui::DoubleBase//, Ui::DoubleTwoCatal
{
    typedef vector<PropertyValue* > PropValVector;
    typedef vector<PropertyValue* >::iterator PropValIterator;

    typedef multimap<double,int> DoubleIntMultiMap;
    typedef multimap<double,short> DoubleShortMultiMap;
    typedef DoubleIntMultiMap::iterator ItrMultiMap;
    Q_OBJECT
public:
    enum TransformMag {
        Replace,
        Ignore
    };
   enum TypeUsing
    {
        Tool,
        Wizard,
        Execute
    };
 
    TypeUsing GetTypeUsing() {return type;}
    QTabWidget *GetTabWidget(){return tabWidget;}
    //DoubleBaseImpl(QWidget *parent,DoubleIntMultiMap* indexx,fstream* in,FDocument* dc); 
    DoubleBaseImpl(QWidget *parent,FDocument* dc,TypeUsing type); 
    void  (FindDupFunc::*ptrFindFunction) ();
    void  (RemoveDupFunc::*ptrRemoveFunction) ();
    FindDupFunc* findFunction;
    RemoveDupFunc* removeFunction;
    ~DoubleBaseImpl();
    void InsertRowTable(RECORD r,int row,int pos);
    void DuplicateProgress(int progress);
    int initialFindDoubleProcess();
    int findNextDouble();
    void DoubleProccessing();
    void IdentificationDouble();
    DoubleIntMultiMap* indexDouble;
    DoubleIntMultiMap* copyIndexDouble;
   // DoubleShortMultiMap indexMagnitude;
    QTableView *GetTable(){return table;}
    QToolButton *GetToolButtonSearch(){return toolButtonSearch;}
    QRadioButton *GetRadioDialog(){return radioDialog;}
    QLabel *GetTextLabel(){return textLabel;}
    bool NextOk();
    void FinishOk();
    bool applay();
    bool execute();
protected:
    void closeEvent(QCloseEvent *event); 
public slots:
    void clickedRowCol(QModelIndex );
    void clickedVerticalHeader(int section);
protected slots:
    void rbFirst();
    void rbSecond();
    void rbDialog();
    void rbAuto();
    void findNext();
    void btHelp();    
    void accept(); 
    void start();
    void reset();
	void reject();
    void project();
    void defaults();
    void ProgressBarChanged(int value);
private:
    QItemSelectionModel* selectModel;
    void ResizeHorizontalHeader();
    void SetDocumentToDialog();
    void GetDocumentFromDialog();
    bool GetRemDupFunc();
    void EraseFirstRecordOfDouble();
    void EraseSecondRecordOfDouble();
    void DuplicateAction(ItrMultiMap sel,ItrMultiMap rem);
    void SetFindDoubleInfo();
    void InitLineDocProperty();
    QList<LineDocProperty* > propDocLine;
    PropValVector EditLineValues;
    PropertyModel* model;
    bool modified;
    int numRec;
    CatTable* parentWindow;
    FDocument* doc;
    TypeUsing type;
    fstream* in;
    fstream* inSecond;
    ItrMultiMap pos1,pos2;
    RECORD record1;
    RECORD record2;
    Catalog cat;
    int min1, min2;
    int sec1,sec2;
    float lat1,lon1,dep1,mb1,ms1,ml1,mp1;
    float lat2,lon2,dep2,mb2,ms2,ml2,mp2;  
    int    dtime,ddep;
    float dlat,dlon,dmf;
    int returnCode;
    bool inDialog;
    bool  removeFirst;
    bool  removeSecond;
    int numberOfDoubles;
    QList<QComboBox *> comboBoxes;
PropertyTransformFunction* first;
PropertyTransformFunction* second;
PropertyTransformFunction* third;
PropertyTransformFunction* fourth;
QList<PropertyTransformFunction *> transFunc;
QList<PropertyValue* > values;
bool firstStart;
    QTextEdit* texted;
    QString message;
    QTextEdit* correctioned;
    QString    corrmess;
    int maxCorrectionPageDouble;
    HelpWindow* help;
	QString nameRemoveFunction;
int indexRemovalFunction;
};

class FindDupFunc {
public:
 FindDupFunc(vector<int> &priority,vector<QString> &valFunc,float dmf);
 virtual ~FindDupFunc() {};
 virtual void  FindVal() = 0;
 bool  value;
 void  SetValue(float mb1,float ms1,float ml1,float mp1,float mb2,float ms2,float ml2,float mp2);
 float eps;
 protected:
 float fm1,fm2,df;
 vector<int> priority;
 float dmf;
 float mb1,ms1,ml1,mp1,mb2,ms2,ml2,mp2;

 vector<float> magnitudeRecordFirst;
 vector<float> magnitudeRecordSecond;
 vector<float> a,b,c,d;
 float mFunct(int i,float m);
};
 //------------------------------------------------------------------------------------------------------
class FindValue : public FindDupFunc
{
public:
 FindValue(vector<int> &priority,vector<QString> &valFunc,float dmf);
 void  FindVal() ;
};
//------------------------------------------------------------------------------------------------------
class FindMaximum : public FindDupFunc
{
public:
 FindMaximum(vector<int> &priority,vector<QString> &valFunc,float dmf);
 void  FindVal() ;
};
//------------------------------------------------------------------------------------------------------
class FindMinimum : public FindDupFunc
{
public:
 FindMinimum(vector<int> &priority,vector<QString> &valFunc,float dmf);
 void  FindVal() ;
};
//------------------------------------------------------------------------------------------------------
class FindAverage : public FindDupFunc
{
public:
 FindAverage(vector<int> &priority,vector<QString> &valFunc,float dmf);
 void  FindVal() ;
};

//---------------------------------------------------------------------------------
class RemoveDupFunc  {
 public:
 RemoveDupFunc(vector<int> &priority);
 RemoveDupFunc() {};
 virtual ~RemoveDupFunc() {};
 virtual void  RemVal() = 0;
 int   delRow;
 float valFunct1;
 float valFunct2;
 void  SetValue(float mb1,float ms1,float ml1,float mp1,float mb2,float ms2,float ml2,float mp2);
 float eps;
 protected:
 vector<int> priority;
 float mb1,ms1,ml1,mp1,mb2,ms2,ml2,mp2;
 vector<float> magnitudeRecordFirst;
 vector<float> magnitudeRecordSecond;
};


class RemValueGreater : public RemoveDupFunc
{
public:
 RemValueGreater(vector<int> &priority);
 void  RemVal() ;
};
class RemValueLess : public RemoveDupFunc
{
public:
 RemValueLess(vector<int> &priority);
 void  RemVal() ;
};
//------------------------------------------------------------------------------------------------------
class RemMaximumGreater : public RemoveDupFunc
{
public:
 RemMaximumGreater(vector<int> &priority);
 void  RemVal() ;
};
class RemMaximumLess : public RemoveDupFunc
{
public:
 RemMaximumLess(vector<int> &priority);
 void  RemVal() ;
};
//------------------------------------------------------------------------------------------------------
class RemMinimumGreater : public RemoveDupFunc
{
public:
 RemMinimumGreater(vector<int> &priority);
 void  RemVal() ;
};
class RemMinimumLess : public RemoveDupFunc
{
public:
 RemMinimumLess(vector<int> &priority);
 void  RemVal() ;
};
//------------------------------------------------------------------------------------------------------
class RemAverageGreater : public RemoveDupFunc
{
public:
 RemAverageGreater(vector<int> &priority);
 void  RemVal() ;
};
class RemAverageLess : public RemoveDupFunc
{
public:
 RemAverageLess(vector<int> &priority);
 void  RemVal() ;
};
class RemNoFunction : public RemoveDupFunc
{
public:
 RemNoFunction(): RemoveDupFunc(){};
 void  RemVal();
};
#endif
