#include <QtGui>
 
#include "editline.h"
#include "document.h"
#include "default.h"
LineDocProperty::LineDocProperty(QWidget * wd,PropertyValue* pr):
                 widget(wd),prop(pr) {

 if (prop->GetKind()  == PropertyValue::Property_Float){
	 
     editor = (QLineEdit *) widget;
     //editor = new LineEditor(prop,prop->GetValue(),widget);
editedValue = prop->GetValue();
///===================================================================
if (prop->GetKind()  == PropertyValue::Property_Float){
 PropertyFloatValue * p = (PropertyFloatValue *)prop;
 editor->setValidator(new QDoubleValidator (p->GetMin(),
                       p->GetMax(),p->GetDecimal(), this));
}
if (prop->GetKind()  == PropertyValue::Property_Int){
 PropertyIntValue * p = (PropertyIntValue *)prop;
 editor->setValidator(new QIntValidator(p->GetMin(),p->GetMax(), this));
 }

       installEventFilter(editor);
       connect( editor, SIGNAL( textChanged( const QString & ) ),
		      this, SLOT( setValue(const QString &) ) );
       connect( editor, SIGNAL( editingFinished () ),
                      this, SLOT( editFinish() ) );

///====================================================================

 }

 if (prop->GetKind()  == PropertyValue::Property_Int){
 spin = (QSpinBox *) widget;
 PropertyIntValue * p = (PropertyIntValue *)prop;
 spin->setRange(p->GetMin(),p->GetMax());
 }

if (prop->GetKind()  == PropertyValue::Property_IntSpin){
 spin = (QSpinBox *) widget;
 PropertyIntSpinValue * p = (PropertyIntSpinValue *)prop;
 spin->setRange(p->GetMin(),p->GetMax());
 spin->setSingleStep(p->GetStep());
 }
}
void LineDocProperty::SetValueFromDoc(){
 if (prop->GetKind()  == PropertyValue::Property_Float){
 editor->setText(prop->GetValue());
}
 if (prop->GetKind()  == PropertyValue::Property_Int){
 spin->QSpinBox::setValue(prop->GetValue().toInt());
 QSpinBox* ed = (QSpinBox*)widget;
 ed->QSpinBox::setValue(prop->GetValue().toInt());
}
 if (prop->GetKind()  == PropertyValue::Property_IntSpin){
 spin->QSpinBox::setValue(prop->GetValue().toInt());
 QSpinBox* ed = (QSpinBox*)widget;
 ed->QSpinBox::setValue(prop->GetValue().toInt());
}
}
void LineDocProperty::ReplaceProperty(PropertyValue* newprop){
 if (newprop->GetKind()  == PropertyValue::Property_Float){
 FinishEditLine();
 prop->SetValue(editor->text());
 PropertyFloatValue* p= (PropertyFloatValue*) newprop;
 QDoubleValidator * vld = (QDoubleValidator*)editor->validator ();
 vld->setRange(p->GetMin(),p->GetMax(),p->GetDecimal());
 SetProp(p);
 editor->setText(newprop->GetValue());
 SetEditedValue(newprop->GetValue());
 SetProp(p);
 editor->setText(p->GetValue());

}

}


//==================================================================================
void LineDocProperty::editFinish() {
//	QMessageBox::warning(0, "",QString("LineEditor::editFinish: text %1 editedValue%2").arg(text()).arg(editedValue));
  int pos = 0; QString temp = editor->text();
  QString edVal = QString();
  if ( editor->validator()->validate(temp,pos)  != QValidator::Acceptable)
       {editor->setText(editedValue); edVal = editedValue;}
  else {
     if (prop->GetKind()  == PropertyValue::Property_Float){
       bool ok;
       QString tmp = QString("%1").arg(temp.toFloat(&ok));
        if(ok){ editor->setText(editor->text()); edVal = editor->text();}else{ editor->setText(editedValue); edVal = editedValue;}
        
     }
     if (prop->GetKind()  == PropertyValue::Property_Int){
       bool ok;
       QString tmp = QString("%1").arg(temp.toInt(&ok));
        if(ok) { editor->setText(editor->text()); edVal = editor->text();} else 
		{editor->setText(editedValue);edVal = editedValue;}

     }
   }
editedValue = edVal;
if (!isTreeView) {
editor->setText(editor->text());
}
}

void LineDocProperty::setValue( const QString  &v )
{
        QString temp = v;
        editor->blockSignals( TRUE );
        int oldCursorPos;
        oldCursorPos = editor->cursorPosition();
        int j = 0;

    if (prop->GetKind()  == PropertyValue::Property_Float){

       const QValidator * vld = editor->validator ();
       if (!(temp[0] == '-' && temp.length() == 1 )){
          if ( vld->validate( temp , j )  == QValidator::Intermediate) {
             double min =    ((QDoubleValidator*) vld)->bottom ();
             double max =    ((QDoubleValidator*) vld)->top ();
             if (min > 0 ) {
               if(temp.toFloat() >= ((QDoubleValidator*) vld)->bottom () || temp.toFloat() <= 0)
                if ( vld->validate( temp , j )  != QValidator::Acceptable) temp.remove( temp.length()-1, 1);
             }
             if (max < 0) {
                if(temp.toFloat() <= ((QDoubleValidator*) vld)->top () || temp.toFloat() >=0)
                  if ( vld->validate( temp , j )  != QValidator::Acceptable) temp.remove( temp.length()-1, 1);
     
            }
            if (min <= 0 && max >= 0) if ( vld->validate( temp , j )  != QValidator::Acceptable) 
              temp.remove( temp.length()-1, 1);
      }
    }
   }

    if (prop->GetKind()  == PropertyValue::Property_Int){

      const QValidator * vld = editor->validator ();
      if (!(temp[0] == '-' && temp.length() == 1)){
          if ( vld->validate( temp , j )  == QValidator::Intermediate) {
             int min =    ((QIntValidator*) vld)->bottom ();
             int max =    ((QIntValidator*) vld)->top ();
             if (min > 0 ) {
               if(temp.toFloat() >= ((QIntValidator*) vld)->bottom () || temp.toFloat() <= 0)
                if ( vld->validate( temp , j )  != QValidator::Acceptable) temp.remove( temp.length()-1, 1);
             }
             if (max < 0) {
                if(temp.toFloat() <= ((QIntValidator*) vld)->top () || temp.toFloat() >=0)
                  if ( vld->validate( temp , j )  != QValidator::Acceptable) temp.remove( temp.length()-1, 1);
     
            }
            if (min <= 0 && max >= 0) if ( vld->validate( temp , j )  != QValidator::Acceptable) 
              temp.remove( temp.length()-1, 1);
      }
    }
   }

        editor->setText(temp);
        if ( oldCursorPos < (int)editor->text().length() )
            editor->setCursorPosition( oldCursorPos );
        editor->blockSignals( FALSE );
}



//----------------------------------------------------------------------------------

 LineEditor::~LineEditor(){

}
 LineEditor::LineEditor(PropertyValue* prop,QString val,QWidget *parent,bool isTreeView)
    : QLineEdit(val,parent),prop(prop),editedValue(val),isTreeView(isTreeView){
      setFont( parent->font() );

	
if (prop->GetKind()  == PropertyValue::Property_Float){
	//parent->setContentsMargins (2, 2,2, 2);
 PropertyFloatValue * p = (PropertyFloatValue *)prop;
 setValidator(new QDoubleValidator (p->GetMin(),
                       p->GetMax(),p->GetDecimal(), this));
}
if (prop->GetKind()  == PropertyValue::Property_Int){
 PropertyIntValue * p = (PropertyIntValue *)prop;
 setValidator(new QIntValidator(p->GetMin(),p->GetMax(), this));
				}

       installEventFilter(this);
       connect( this, SIGNAL( textChanged( const QString & ) ),
		      this, SLOT( setValue(const QString &) ) );
       connect( this, SIGNAL( editingFinished () ),
                      this, SLOT( editFinish() ) );
}
void LineEditor::editFinish() {
//	QMessageBox::warning(0, "",QString("LineEditor::editFinish: text %1 editedValue%2").arg(text()).arg(editedValue));
  int pos = 0; QString temp = text();
  QString edVal = QString();
  if ( validator()->validate(temp,pos)  != QValidator::Acceptable)
       {setText(editedValue); edVal = editedValue;}
  else {
     if (prop->GetKind()  == PropertyValue::Property_Float){
       bool ok;
       QString tmp = QString("%1").arg(temp.toFloat(&ok));
        if(ok){ setText(text()); edVal = text();}else{ setText(editedValue); edVal = editedValue;}
        
     }
     if (prop->GetKind()  == PropertyValue::Property_Int){
       bool ok;
       QString tmp = QString("%1").arg(temp.toInt(&ok));
        if(ok) { setText(text()); edVal = text();} else {setText(editedValue);edVal = editedValue;}

     }
   }
editedValue = edVal;
if (!isTreeView) {
QLineEdit* ed = (QLineEdit*) parent();
ed->setText(text());
}
}

void LineEditor::setValue( const QString  &v )
{
        QString temp = v;
        blockSignals( TRUE );
        int oldCursorPos;
        oldCursorPos = cursorPosition();
        int j = 0;

    if (prop->GetKind()  == PropertyValue::Property_Float){

       const QValidator * vld = validator ();
       if (!(temp[0] == '-' && temp.length() == 1 )){
          if ( vld->validate( temp , j )  == QValidator::Intermediate) {
             double min =    ((QDoubleValidator*) vld)->bottom ();
             double max =    ((QDoubleValidator*) vld)->top ();
             if (min > 0 ) {
               if(temp.toFloat() >= ((QDoubleValidator*) vld)->bottom () || temp.toFloat() <= 0)
                if ( vld->validate( temp , j )  != QValidator::Acceptable) temp.remove( temp.length()-1, 1);
             }
             if (max < 0) {
                if(temp.toFloat() <= ((QDoubleValidator*) vld)->top () || temp.toFloat() >=0)
                  if ( vld->validate( temp , j )  != QValidator::Acceptable) temp.remove( temp.length()-1, 1);
     
            }
            if (min <= 0 && max >= 0) if ( vld->validate( temp , j )  != QValidator::Acceptable) 
              temp.remove( temp.length()-1, 1);
      }
    }
   }

    if (prop->GetKind()  == PropertyValue::Property_Int){

      const QValidator * vld = validator ();
      if (!(temp[0] == '-' && temp.length() == 1)){
          if ( vld->validate( temp , j )  == QValidator::Intermediate) {
             int min =    ((QIntValidator*) vld)->bottom ();
             int max =    ((QIntValidator*) vld)->top ();
             if (min > 0 ) {
               if(temp.toFloat() >= ((QIntValidator*) vld)->bottom () || temp.toFloat() <= 0)
                if ( vld->validate( temp , j )  != QValidator::Acceptable) temp.remove( temp.length()-1, 1);
             }
             if (max < 0) {
                if(temp.toFloat() <= ((QIntValidator*) vld)->top () || temp.toFloat() >=0)
                  if ( vld->validate( temp , j )  != QValidator::Acceptable) temp.remove( temp.length()-1, 1);
     
            }
            if (min <= 0 && max >= 0) if ( vld->validate( temp , j )  != QValidator::Acceptable) 
              temp.remove( temp.length()-1, 1);
      }
    }
   }

        setText(temp);
        if ( oldCursorPos < (int)text().length() )
            setCursorPosition( oldCursorPos );
        blockSignals( FALSE );
}



