#include <QtGui>
#include "mainwindow.h"
#include "exportuser.h"
#include "default.h"
ExportUser::~ExportUser (){

}
ExportUser::ExportUser(QWidget* parent)
	: QDialog(0),parent(parent)
{
	QFont f = parent->font();
	setFont( parent->font() );
	setupUi(this);
	setWindowTitle("Select TEXT output");
	exportFileName = QString();
    connect( toolButtonBrowse, SIGNAL( clicked() ), this, SLOT( browse() ) );
	connect( buttonOk, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( buttonHelp, SIGNAL( clicked() ), this, SLOT( btnHelp() ) );
    connect( buttonCancel, SIGNAL( clicked() ), this, SLOT( close() ) );
    connect( toolButtonClear, SIGNAL( clicked() ), this, SLOT( clear() ) );

	
	labelList.append(labelYear);
	labelList.append(labelMonth);
	labelList.append(labelDay);
	
	labelList.append(labelHour);
	labelList.append(labelMinute);
	labelList.append(labelSecond);
	
	
	labelList.append(labelLatitude);
	labelList.append(labelLohgitude);
	labelList.append(labelDepth);
	
	
	labelList.append(labelM1);
	labelList.append(labelM2);
	labelList.append(labelM3);
	labelList.append(labelM4);

	
	labelList.append(labelIntensity);
	
	pixmapList.append(new QPixmap(QString::fromUtf8(":/images/numbers/one.png")));
	pixmapList.append(new QPixmap(QString::fromUtf8(":/images/numbers/two.png")));
	pixmapList.append(new QPixmap(QString::fromUtf8(":/images/numbers/three.png")));
	pixmapList.append(new QPixmap(QString::fromUtf8(":/images/numbers/four.png")));
	pixmapList.append(new QPixmap(QString::fromUtf8(":/images/numbers/five.png")));
	pixmapList.append(new QPixmap(QString::fromUtf8(":/images/numbers/six.png")));
	pixmapList.append(new QPixmap(QString::fromUtf8(":/images/numbers/seven.png")));
	pixmapList.append(new QPixmap(QString::fromUtf8(":/images/numbers/eight.png")));
	pixmapList.append(new QPixmap(QString::fromUtf8(":/images/numbers/nine.png")));
	pixmapList.append(new QPixmap(QString::fromUtf8(":/images/numbers/ten.png")));
	pixmapList.append(new QPixmap(QString::fromUtf8(":/images/numbers/eleven.png")));
	pixmapList.append(new QPixmap(QString::fromUtf8(":/images/numbers/tvelve.png")));
	pixmapList.append(new QPixmap(QString::fromUtf8(":/images/numbers/thirteen.png")));
	pixmapList.append(new QPixmap(QString::fromUtf8(":/images/numbers/fourteen.png")));

	checkboxList.append(checkBoxYear);
	checkboxList.append(checkBoxMonth);
	checkboxList.append(checkBoxDay);
	
	checkboxList.append(checkBoxHour);
	checkboxList.append(checkBoxMin);
	checkboxList.append(checkBoxSec);
	
	
	checkboxList.append(checkBoxLatitude);
	checkboxList.append(checkBoxLongitude);
	checkboxList.append(checkBoxDepth);
	
	
	checkboxList.append(checkBoxM1);
	checkboxList.append(checkBoxM2);
	checkboxList.append(checkBoxM3);
	checkboxList.append(checkBoxM4);
	
	
	checkboxList.append(checkBoxIntensity);
	
	foreach (QLabel * label, labelList) {
	
		label->setPixmap(QPixmap(QString::fromUtf8(":/images/numbers/empties.png")));
		//label->setText(" ");
	}
	
	foreach (QCheckBox * box, checkboxList) 
        connect(box, SIGNAL(clicked()), this, SLOT(checkBox()));
	curNumber = 0;
}
///---------------------------------------------------------------------------------- 
void ExportUser::clear(){
	fieldList.clear();
	foreach (QLabel * label, labelList) 
		label->setPixmap(QPixmap(QString::fromUtf8(":/images/numbers/empties.png")));
	foreach (QCheckBox * box, checkboxList)  box->setChecked( false ); 
	curNumber = 0;
}
///----------------------------------------------------------------------------------
void ExportUser::checkBox(){
	QCheckBox *clickedCheckBox = qobject_cast<QCheckBox *>(sender());
	QString tmp = clickedCheckBox->text ();
	int num =0;
	bool uncheck = false;
	int remnum = 0;
	//QMessageBox::warning(0,"",QString("A   fieldList %1").arg(fieldList.size()));
	foreach (QCheckBox * box, checkboxList) {
		if(tmp == box->text () ) {
		if(box->checkState () == Qt::Checked) {
			fieldList.append(num);
			labelList.at(num)->setPixmap(*(pixmapList.at(curNumber)));
			curNumber++;
			break;
		}
		else {
			remnum =  fieldList.indexOf(num);
			fieldList.takeAt ( remnum) ;
			curNumber--;
			labelList.at(num)->setPixmap(QPixmap(QString::fromUtf8(":/images/numbers/empties.png")));
			//QMessageBox::warning(0,"",QString("unchecked num %1 remnum %2 text %3").
			//arg(num).arg(remnum).arg(box->text ()));
			uncheck = true;
			break;
		}
		
		} 
		num++;
}

	
    if (uncheck ) {
		int j = 0;
		for (int i = 0; i < fieldList.size(); ++i) {
		int k = fieldList.at(i);
			labelList.at(k)->setPixmap(*(pixmapList.at(j)));
			j++;
		//labelList.at(k)->setText(QString("%1").arg(++j));
		}
	}
		//QMessageBox::warning(0,"",QString("B   fieldList %1").arg(fieldList.size()));

}
///----------------------------------------------------------------------------------
void ExportUser::closeEvent(QCloseEvent *event)
{
			

	event->accept();
} 
///----------------------------------------------------------------------------------

void ExportUser::reject()
{
return;
} 
///----------------------------------------------------------------------------------
	
void ExportUser::accept(){
		if (exportFileName.isEmpty()) {
			QMessageBox::warning(0,mainWindowCaption(),
				"Browse files and choose one for export");
				return;
		}

	    QString fields = "";
		foreach (int i, fieldList) {
			fields += checkboxList.at(i)->text() + "\n";
		}
        if(fieldList.isEmpty()) {
			QMessageBox::warning(0,mainWindowCaption(),
				"Select at least one field for exporting file");
				return;
			
		}

  QString tmp = QString("Do you want to output - \n\n%1\ninto the file\n%2 ?").
  arg(fields ).arg(exportFileName);
  
  
       int ret = QMessageBox::warning(0,windowTitle (),tmp,
                     QMessageBox::Yes | QMessageBox::Default,
                     QMessageBox::No | QMessageBox::Escape);
        if (ret == QMessageBox::No) return;
		
	done( Accepted );
} 
///----------------------------------------------------------------------------------

void ExportUser::btnHelp(){

} 
///----------------------------------------------------------------------------------

void ExportUser::browse(){
	QString fileFilters = tr("txt files (*%1);;All Files (*)").arg(txtFilterLocator());
    QString fileName =
            QFileDialog::getSaveFileName(this,"Save the catalog under a new name",
			MainWindow::self->exportUserFileDirectory, fileFilters);
    if (fileName.isEmpty()) return;
    int ind = fileName.length () - txtFilterLocator().length ()-1; if (ind < 0) ind =0;
    if ( ( fileName.indexOf(txtFilterLocator(),ind)) == -1 && ( fileName.indexOf(txtFilterLocator().toUpper(),ind)) == -1) {
        fileName.append(txtFilterLocator());
    }
	    exportFileName = fileName;
        lineEditFileName->setText(MainWindow::self->strippedName(fileName));
		MainWindow::self->exportUserFileDirectory = QFileInfo(fileName).absolutePath ();
} 


