#include <QtGui>
#include "mainwindow.h"
#include "findrecord.h" 
#include "viewcatalogimpl.h" 
#include "default.h"
FindRecord::FindRecord(QWidget *parent)
      : QDialog(0)

{ 
    setFont( parent->font() );
    setupUi(this);
    cancelButton->setFocus ();
	setWindowIcon(QIcon(":/images/icon.png"));
	parentWindow = (CatTable*) parent;
	setModal(false);
    cancelButton->setDefault(true);
    connect(cancelButton, SIGNAL(clicked()), this, SLOT(close()));
	connect(toolButtonTimeSearch, SIGNAL(clicked()), this, SLOT(timeSearch()));
	connect(toolButtonNimberSearch, SIGNAL(clicked()), this, SLOT(numberSearch()));
	
	connect(dateTimeEdit, SIGNAL(dateTimeChanged ( const QDateTime &)), 
	              this, SLOT(dateChanged ( const QDateTime &)));
	connect(spinBoxNumber, SIGNAL(valueChanged ( int)), 
	              this, SLOT(valChanged ( int)));
	
	 
    toolButtonTimeSearch->setIcon((QIcon(":/images/find.png")));
	toolButtonNimberSearch->setIcon((QIcon(":/images/find.png")));
	
    resize(MainWindow::self->viewSegmentSize);
    move(MainWindow::self->viewSegmentPos);
    curNumber = 1;
	curDt.setDate(QDate(1000,0,0)); 
	curDt.setTime(QTime(0,0,0));
	spinBoxNumber->setValue(curNumber);
	dateTimeEdit->setDateTime(curDt);
	
}
void FindRecord::closeEvent(QCloseEvent *event)
{
MainWindow::self->viewSegmentPos   =  pos();
MainWindow::self->viewSegmentSize  =  size();
event->accept();
}
void FindRecord::valChanged ( int){
	toolButtonNimberSearch->setDefault(true);
}
void FindRecord::dateChanged ( const QDateTime &){

    toolButtonTimeSearch->setDefault(true);
	
}
void FindRecord::SetDatesNumbersToFinddialog(QString& timeRecordFirst,
					     QString& timeRecordLast,
			             int catalogSize){
	//====================================================
    QString value = timeRecordFirst; value.replace('-','/'); value.replace('T',' ');	
	textLabelBegin->setText( QString("First: %1").arg(value));
    value = timeRecordLast; value.replace('-','/'); value.replace('T',' ');		
	textLabelEnd->setText( QString("Last: %1").arg(value));
	textLabelStart->setText( QString("First: %1").arg(1));
	textLabelFinish->setText( QString("Last: %1").arg(catalogSize));

	dateTimeEdit->setDisplayFormat(QApplication::translate("dateTimeEditMin",
                         "yyyy/MM/dd hh:mm:ss"));

    QDate dateStart;
    QString tmp = timeRecordFirst.section('T',0,0);
    dateStart.setYMD(tmp.section('-',0,0).toInt(),tmp.section('-',1,1).toInt(),
                 tmp.section('-',2,2).toInt());

    QDate dateEnd;
    tmp = timeRecordLast.section('T',0,0);
    dateEnd.setYMD(tmp.section('-',0,0).toInt(),tmp.section('-',1,1).toInt(),
               tmp.section('-',2,2).toInt());
/*
QMessageBox::warning(this, "",QString ("timeRecordLast AA: %1 year '%2' month '%3' day '%4' tmp '%5'")
    .arg(timeRecordLast)
	.arg(tmp.section('/',0,0))
	.arg(tmp.section('/',1,1))
	.arg(tmp.section('/',2,2))
	.arg(tmp) 
   );
*/
    dateTimeEdit->setDateRange(dateStart,dateEnd);
	
    QTime timeStart;
    tmp = timeRecordFirst.section('T',1,1);
    timeStart.setHMS(tmp.section(':',0,0).toInt(),tmp.section(':',1,1).toInt(),
                 tmp.section(':',2,2).toInt());
				 
    QTime timeEnd;
    tmp = timeRecordLast.section('T',1,1);
    timeEnd.setHMS(tmp.section(':',0,0).toInt(),tmp.section(':',1,1).toInt(),
                 tmp.section(':',2,2).toInt());
    dateTimeEdit->setTimeRange(timeStart,timeEnd);


    spinBoxNumber->setRange(1,catalogSize);
	if  (  !(curNumber >= 1 && curNumber <= catalogSize ) ) 
		spinBoxNumber->setValue(1);
	curNumber = spinBoxNumber->value ();
    
	
	QDateTime dt; dt.setDate(dateStart);  dt.setTime(timeStart);
	
/*	
	QMessageBox::warning(this, "",
	QString ("year %1 month %2 day %3 hour %4 minute %5 second %6")
	                       .arg(dateEnd.year ())
	                       .arg(dateEnd.month ())
						   .arg(dateEnd.day  ())
						   .arg(timeEnd.hour ())
						   .arg(timeEnd.minute ())
						   .arg(timeEnd.second ()));
*/
	QDateTime min; min.setDate(dateStart); min.setTime(timeStart);
	QDateTime max; max.setDate(dateEnd); max.setTime(timeEnd);
	if  (  !( curDt >= min && curDt <= max ) )
		dateTimeEdit->setDateTime(dt);
	curDt = dateTimeEdit->dateTime ();
	
    cancelButton->setDefault(true); 
}
void FindRecord::reject()
{
return;   
}
void FindRecord::timeSearch(){
multimap<double,int>* index = parentWindow->GetRecordCatalogIndex();

    QDateTime datetime = dateTimeEdit->dateTime ();
    QDate  dt = datetime.date();
    QTime tm = datetime.time();
    short  yr = dt.year ();
    short  mo = dt.month();
    short da = dt.day();
    short  hr =  tm.hour();
    short  mn =  tm.minute();
    short  sc =  tm. second();
    double dttm = time(yr,mo,da,hr,mn) + (double)sc/ (double)(100);
    multimap<double,int>::iterator pos = index->lower_bound(dttm ); 
	int lowNumber = (*pos).second;
    parentWindow->SearchNumber(lowNumber+1);
	
}
void FindRecord::numberSearch(){
parentWindow->SearchNumber(spinBoxNumber->value ());


}
