#ifndef HELPWINDOW_H
#define HELPWINDOW_H
#include <QMainWindow>
#include <QDir>
#include <QUrl>
#include "ui_managebookm.h"
class QTextBrowser;
class QComboBox;
class QPopupMenu;
class QActionGroup;
class HelpWindow : public QMainWindow
{
    Q_OBJECT
public:
    HelpWindow( const QString& home_, QWidget* parent = 0 );
    ~HelpWindow();
protected:
    void closeEvent(QCloseEvent *event);
private slots:
    void setBackwardAvailable( bool );
    void setForwardAvailable( bool );
    void sourceChanged( const QUrl & );
    void about();
    void aboutQt();
    void openFile();
    void newWindow();
    void print();
    void exit();    
    void zoomin();
    void zoomout();

    void pathSelected( const QString & );
    void bookmChosen();
    void addBookmark();
    void manBookmark();

private:
    void readBookmarks();
    void SetEmptyBookMarks();
    void SetModifiedBookMarks(QStringList &titlelist,QStringList &bookmlist);
    void CreateBookMarksMenu();
    QTextBrowser* browser;
    QComboBox *pathCombo;
    QAction* backwardId;
    QAction* forwardId;
	QAction *zoominAct; 
    QAction *zoomoutAct;
    QStringList bookmarks;
    QMenu* bookm;
    QActionGroup* bookmActs;
    QStringList searchList;
};

class ManageBookmarkImpl : public QDialog, private Ui::ManageBookmark
{
    Q_OBJECT

public:
   ManageBookmarkImpl(QWidget *parent,QStringList &bookmlist);
   QStringList bookmarks;
   QStringList title;
private slots:
    void accept();
    void reject();
    void up();
    void down();
    void del();
    void delAll();
private:

};

#endif

