#include <QtGui>
#include "listproperty.h"
#include "document.h"
#include "editline.h"
static const  QString LEFT_BREAKET = "  [ ";
static const  QString RIGHT_BREAKET = " ]";
static const  QString MIDL_BREAKET = " , "; 
PropertyInt::PropertyInt(QModelIndex ind,const QString &initStr,const QString &defStr,PropertyValue* p,int min,int max,bool s )
     : ItemProperty(ind,initStr,defStr,p),
       minimum(min),maximum(max),signedValue(s)  {}
//-------------------------------------------------------------------
PropertyIntSpin::PropertyIntSpin(QModelIndex ind,const QString &initStr,const QString &defStr,PropertyValue* p,int min,int max,int st )
     : ItemProperty(ind,initStr,defStr,p),
       minimum(min),maximum(max),step(st)  {}
//-------------------------------------------------------------------
PropertyDouble::PropertyDouble(QModelIndex ind,const QString &initStr,const QString &defStr,PropertyValue* p,double min,double max,int dec)
     : ItemProperty(ind,initStr,defStr,p),
       minimum(min),maximum(max),decimals(dec)  {}
//-------------------------------------------------------------------
PropertyString::PropertyString(QModelIndex ind,const QString &initStr,const QString &defStr,PropertyValue* p)
     : ItemProperty(ind,initStr,defStr,p) {}
//-------------------------------------------------------------------
PropertyTittle::PropertyTittle(QModelIndex ind,const QString &tittle)
     : ItemProperty(ind,tittle) {}
//-------------------------------------------------------------------

PropertyNotEdit::PropertyNotEdit(QModelIndex ind,const QString &initStr,const QString &defStr,PropertyValue* p)
     : ItemProperty(ind,initStr,defStr,p) {}
//-------------------------------------------------------------------
PropertyDateTime::PropertyDateTime(QModelIndex ind,const QString &initStr,const QString &defStr,PropertyValue* p)
     : ItemProperty(ind,initStr,defStr,p) {}
//-------------------------------------------------------------------
//-------------------------------------------------------------------
TreePropertyModel::~TreePropertyModel(){
if(!ipList.empty()) qDeleteAll(ipList);  ipList.clear();

}
TreePropertyModel::TreePropertyModel(int columns, QObject * parent )
    : QStandardItemModel(0, columns,parent),NumCols(columns) {
NumRows=0;
SetHorizontalHeader();
}
void TreePropertyModel::SetHorizontalHeader(){
setHeaderData(0, Qt::Horizontal,"Parameters");
setHeaderData(1, Qt::Horizontal,"Values");
}
bool TreePropertyModel::CheckValidValue(QModelIndex &index) {

  foreach(ItemProperty * prop,ipList) if (prop->GetInvalid()) {
        index = prop->index;
        return false;
  }
index = QModelIndex();
return true;
}
void TreePropertyModel::SetChildItem(int col,QModelIndex &indexParent,PropertyValue* p){
          QModelIndex indexCol0 = index(col, 0, indexParent);
          setData(indexCol0, QVariant(p->GetName()));
          ItemProperty * ip  = new   PropertyNotEdit(indexParent,p->GetName(),"",0); ipList.append(ip);

         QModelIndex indexCol1 = index(col, 1, indexParent);
         setData(indexCol1, QVariant(p->GetValue()));

          if (dynamic_cast<PropertyValue *>(p) == dynamic_cast<PropertyIntSpinValue *>(p)) {
          PropertyIntSpinValue * pp =  (PropertyIntSpinValue *)p;
          ip = new    PropertyIntSpin(indexCol1,pp->GetValue(),pp->GetDefaultvalue(),p,pp->GetMin(),pp->GetMax(),pp->GetStep());
          }
          if (dynamic_cast<PropertyValue *>(p) == dynamic_cast<PropertyFloatValue *>(p)) {
          PropertyFloatValue * pp =  (PropertyFloatValue *)p;
          ip = new    PropertyDouble(indexCol1,pp->GetValue(),pp->GetDefaultvalue(),p,pp->GetMin(),pp->GetMax(),pp->GetDecimal());
          }
          if (dynamic_cast<PropertyValue *>(p) == dynamic_cast<PropertyDateTimeValue *>(p)) {
          PropertyDateTimeValue * pp =  (PropertyDateTimeValue *)p;
          ip = new    PropertyDateTime(indexCol1,pp->GetValue(),pp->GetDefaultvalue(),p);
          }

          ipList.append(ip);
}

void TreePropertyModel::SetItem(const QString tittle){
        insertRows ( NumRows,1);
        int rows =  NumRows;
        ItemProperty * ip = 0;
        QModelIndex indexParent0Col0 = index(rows, 0, QModelIndex());
        setData(indexParent0Col0, QVariant(tittle));
        ip = new   PropertyTittle(indexParent0Col0,tittle); ipList.append(ip);
        NumRows ++; 
}
void TreePropertyModel::SetItem(PropertyValue* p){

        insertRows ( NumRows,1);
        int rows =  NumRows;
        ItemProperty * ip = 0;
        QModelIndex indexParent0Col0 = index(rows, 0, QModelIndex());

        setData(indexParent0Col0, QVariant(p->GetName()));
        ip = new   PropertyNotEdit(indexParent0Col0,p->GetName(),"",0); ipList.append(ip);

       QModelIndex indexCol1 = index(rows, 1, QModelIndex());
       setData(indexCol1, QVariant(p->GetValue()));
        if (dynamic_cast<PropertyValue *>(p) == dynamic_cast<PropertyIntValue *>(p)) {
          PropertyIntValue * pp =  (PropertyIntValue *)p;
          ip = new    PropertyInt(indexCol1,pp->GetValue(),pp->GetDefaultvalue(),p,pp->GetMin(),pp->GetMax(),pp->GetSignedValue());
          }
        if (dynamic_cast<PropertyValue *>(p) == dynamic_cast<PropertyIntSpinValue *>(p)) {
          PropertyIntSpinValue * pp =  (PropertyIntSpinValue *)p;
          ip = new    PropertyIntSpin(indexCol1,pp->GetValue(),pp->GetDefaultvalue(),p,pp->GetMin(),pp->GetMax(),pp->GetStep());
          }
          if (dynamic_cast<PropertyValue *>(p) == dynamic_cast<PropertyFloatValue *>(p)) {
          PropertyFloatValue * pp =  (PropertyFloatValue *)p;
          ip = new    PropertyDouble(indexCol1,pp->GetValue(),pp->GetDefaultvalue(),p,pp->GetMin(),pp->GetMax(),pp->GetDecimal());
          }
          if (dynamic_cast<PropertyValue *>(p) == dynamic_cast<PropertyDateTimeValue *>(p)) {
          PropertyDateTimeValue * pp =  (PropertyDateTimeValue *)p;
          ip = new    PropertyDateTime(indexCol1,pp->GetValue(),pp->GetDefaultvalue(),p);
          }

          ipList.append(ip);
          NumRows ++; 

}
void TreePropertyModel::SetItem(QString name,PropertyValue* p,PropertyValue* p1){
        insertRows ( NumRows,1);
        int rows =  NumRows;
        ItemProperty * ip = 0;

         QModelIndex indexParent0Col0 = index(rows, 0, QModelIndex());
         setData(indexParent0Col0, QVariant(name));
         ip = new   PropertyNotEdit(indexParent0Col0,name,"",0); ipList.append(ip);

         QModelIndex indexRow0Col1 = index(rows, 1, QModelIndex());
         QString tmp = LEFT_BREAKET + p->GetValue()+ MIDL_BREAKET + p1->GetValue() +RIGHT_BREAKET;
         setData(indexRow0Col1,tmp);
         QString deftmp =  LEFT_BREAKET + p->GetDefaultvalue()+ MIDL_BREAKET + p1->GetDefaultvalue() +RIGHT_BREAKET;
         ip = new   PropertyNotEdit(indexRow0Col1,tmp,deftmp,0); ipList.append(ip);
         insertRows ( rows,2, indexParent0Col0 );insertColumns( 0,2, indexParent0Col0);
 
         SetChildItem(0,indexParent0Col0,p);
         SetChildItem(1,indexParent0Col0,p1);

         NumRows ++;         
}
void TreePropertyModel::SetItem(QString name,PropertyValue* p,PropertyValue* p1,
                                PropertyValue* p2){
        insertRows ( NumRows,1);
        int rows =  NumRows;
        ItemProperty * ip = 0;

         QModelIndex indexParent0Col0 = index(rows, 0, QModelIndex());
         setData(indexParent0Col0, QVariant(name));
         ip = new   PropertyNotEdit(indexParent0Col0,name,"",0); ipList.append(ip);

         QModelIndex indexRow0Col1 = index(rows, 1, QModelIndex());
         QString tmp = p->GetValue()+ "/" + p1->GetValue() +"/" + p2->GetValue();
         setData(indexRow0Col1,tmp);
         QString deftmp = p->GetDefaultvalue()+ "/" + p1->GetDefaultvalue() +"/" + p2->GetDefaultvalue();
         ip = new   PropertyNotEdit(indexRow0Col1,tmp,deftmp,0); ipList.append(ip);
         insertRows ( rows,3, indexParent0Col0 );insertColumns( 0,2, indexParent0Col0);

         SetChildItem(0,indexParent0Col0,p);
         SetChildItem(1,indexParent0Col0,p1);
         SetChildItem(2,indexParent0Col0,p2);
         NumRows ++;         

}

QString TreePropertyModel::GetItemValue(int row,int child){
QModelIndex indexParent0Col0 = index(row, 0, QModelIndex());
QModelIndex indexParent0Child0Col1 = index(child, 1, indexParent0Col0);
return   data(indexParent0Child0Col1).toString();

}
ItemProperty * TreePropertyModel::findProperty(const QModelIndex & index)
{
    for (int i = 0; i < ipList.size(); ++i) {
        if (ipList.at(i)->index == index) {return ipList.at(i);}
     }
return 0;
}
void TreePropertyModel::SetValuesToPropertyNotEditRows() {
  foreach(ItemProperty * ip,ipList) {
    PropertyValue* p = ip->GetPropertyValue();
    if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyNotEdit *>(p)) {
//----------------------------------------------------------------------------------------
    QModelIndex parent = ip->index.parent();
    if(parent !=  QModelIndex()) {
      if (rowCount(parent) == 2) {
        QModelIndex i  = index(0, 1, parent);
        QModelIndex i1 = index(1, 1, parent);
        QModelIndex parentCol1 = index(parent.row(),1);  
        ItemProperty * ip  = findProperty(parentCol1);
        QString s  =  data(i).toString();
        QString s1 =  data(i1).toString();
        QString tmp = LEFT_BREAKET + s + MIDL_BREAKET + s1 + RIGHT_BREAKET;
        if (ip->GetInitStr() == tmp) ip->SetChanged(false);
        else ip->SetChanged(true);
        setData(parentCol1, QVariant(tmp));
     }
 if (rowCount(parent) == 3) {
        QModelIndex i  = index(0, 1, parent);
        QModelIndex i1 = index(1, 1, parent);
        QModelIndex i2 = index(2, 1, parent);
        QModelIndex parentCol1 = index(parent.row(),1);

        ItemProperty * ip  = findProperty(parentCol1);
        QString s  =  data(i).toString();
        QString s1 =  data(i1).toString();
        QString s2 =  data(i2).toString();
        QString tmp = s + "/" + s1 + "/" + s2;
        if (ip->GetInitStr() == tmp) ip->SetChanged(false);
        else ip->SetChanged(true);
        setData(parentCol1, QVariant(tmp));
     }
    }
   }
  }
}
//-------------------------------------------------------------------
void TreePropertyModel::DefResIniButton(int ind){
  foreach(ItemProperty * ip,ipList) {
    PropertyValue* p = ip->GetPropertyValue();
    ip->SetInvalid(false);
    QString def = QString();
    if (p) {
    if (ind == 0)  def = p->GetDefaultvalue();
    if (ind == 1)  def = p->GetResetvalue();
    if (ind == 2)  def = p->GetInitialvalue();
    setData(ip->index, def);
    if (ip->GetInitStr() == def) ip->SetChanged(false);
    else ip->SetChanged(true);

    }
  }
 SetValuesToPropertyNotEditRows();
}
//-------------------------------------------------------------------
void TreePropertyModel::Default(){
DefResIniButton(0);
}
//-------------------------------------------------------------------
void TreePropertyModel::Reset(){
DefResIniButton(1);
}
//-------------------------------------------------------------------
void TreePropertyModel::Initial(){
DefResIniButton(2);
}
void TreePropertyModel::SetPropertyValueToResetValue() {
foreach(ItemProperty * ip,ipList) {
    PropertyValue* p = ip->GetPropertyValue();
    if (p) p->SetValueToResetvalue();
  }
}
void TreePropertyModel::GetPropertyValueFromTreeView() {
  foreach(ItemProperty * ip,ipList) {
    PropertyValue* p = ip->GetPropertyValue();
    QString value = QString();
    if (p) {
    value = data(ip->index, Qt::DisplayRole).toString();
//qWarning("name '%s'  --  '%s'",p->GetName().toAscii().data(),value.toAscii().data());
    p->SetValue(value);
    }
  }
}
//-------------------------------------------------------------------
RoleEditor::~RoleEditor() { ip->edited = false; }
RoleEditor::RoleEditor(PropertyNotEdit* ip,const QModelIndex & index,QWidget *parent)
    : QWidget(parent),ip(ip),index(index)
{
    m_edited = false;
    QHBoxLayout *layout = new QHBoxLayout(this);
    layout->setMargin(0);
    layout->setSpacing(0);
    ip->edited = true;
    m_label = new QLabel(this);
    layout->addWidget(m_label);
    m_label->setBackgroundRole(QPalette::Base);
    m_label->setIndent(1); // ### hardcode it should have the same value of textMargin in QItemDelegate

    button = new QToolButton(this);
    button->setToolButtonStyle(Qt::ToolButtonIconOnly);
    button->setIcon(QIcon(QString(":/images/resetproperty.png")));
    button->setIconSize(QSize(8,8));
    button->setSizePolicy(QSizePolicy(QSizePolicy::Fixed, QSizePolicy::MinimumExpanding));
    layout->addWidget(button);
    connect(button, SIGNAL(clicked()), this, SLOT(emitResetProperty()));
    if (ip->GetDefaultStr() == index.model()->data(index, Qt::DisplayRole).toString()) button->setEnabled(false);
}

void RoleEditor::setLabel(const QString &label)
{
   m_label->setText(label);
}

void RoleEditor::setEdited(bool on)
{
    if (on == true) {
        QFont font = m_label->font();
        font.setBold(on);
        m_label->setFont(font);
    } else
        m_label->setFont(QFont());
    m_edited = on;
}

bool RoleEditor::edited() const
{
    return m_edited;
}

void RoleEditor::emitResetProperty()
{
     TreePropertyModel *mod = (TreePropertyModel *)index.model();
     ItemProperty * p = mod->findProperty(index);
     if (p->GetInitStr() == p->GetDefaultStr()) p->SetChanged(false);
        else p->SetChanged(true);
    p->SetInvalid(false);
    setLabel(ip->GetDefaultStr());
    QModelIndex children = index.sibling( index.row(),0);
    if(children !=  QModelIndex()) {
     for (int i = 0; i < mod->rowCount(children); ++i){
     QModelIndex child = mod->index(i, 1, children);
     p = mod->findProperty(child);
     p->SetInvalid(false);
     if (p->GetInitStr() == p->GetDefaultStr()) p->SetChanged(false);
        else p->SetChanged(true); 
     mod->setData(child, QVariant(p->GetDefaultStr()));
    // QString value = mod->data(child).toString();
    // qWarning("RoleEditor::emitResetProperty() '%s'",value.toAscii().data());

     } 

}
    if (ip->GetDefaultStr() == index.model()->data(index, Qt::DisplayRole).toString()) button->setEnabled(false);
    setEdited(false);
    emit changed(this);
}
//---------------------------------------------------------------------------
//-------------------------------------------------------------------
ResetSpinBox::~ResetSpinBox(){ ip->edited = false; }
ResetSpinBox::ResetSpinBox(PropertyIntSpin* ip,const QModelIndex & index,QWidget *parent)
    : QWidget(parent),ip(ip),index(index)
{
    m_edited = false;
    ip->edited = true;
    QHBoxLayout *layout = new QHBoxLayout(this);
    layout->setMargin(0);
    layout->setSpacing(0);

    spin = new QSpinBox(this);
    layout->addWidget(spin);
    spin->setBackgroundRole(QPalette::Base);
    spin->setRange(ip->minimum,ip->maximum);
    spin->setSingleStep(ip->step);

    button = new QToolButton(this);
    button->setToolButtonStyle(Qt::ToolButtonIconOnly);
    button->setIcon(QIcon(QString(":/images/resetproperty.png")));
    button->setIconSize(QSize(8,8));
    button->setSizePolicy(QSizePolicy(QSizePolicy::Fixed, QSizePolicy::MinimumExpanding));
    layout->addWidget(button);
    connect(button, SIGNAL(clicked()), this, SLOT(emitResetProperty()));
   if (ip->GetDefaultStr() == index.model()->data(index, Qt::DisplayRole).toString()) button->setEnabled(false);
}
void ResetSpinBox::setSpin(const QString &label)
{
    spin->QSpinBox::setValue(label.toInt());
}

void ResetSpinBox::setEdited(bool on)
{
    if (on == true) {
        QFont font = spin->font();
        font.setBold(on);
        spin->setFont(font);
    } else
       spin->setFont(QFont());
    m_edited = on;
}

bool ResetSpinBox::edited() const
{
    return m_edited;
}

void ResetSpinBox::emitResetProperty()
{
     TreePropertyModel *mod = (TreePropertyModel *)index.model();
     ItemProperty * p = mod->findProperty(index);
     if (p->GetInitStr() == p->GetDefaultStr()) p->SetChanged(false);
        else p->SetChanged(true);
    setSpin(ip->GetDefaultStr());

    mod->setData(index, QVariant(p->GetDefaultStr()));
    if (ip->GetDefaultStr() == index.model()->data(index, Qt::DisplayRole).toString()) button->setEnabled(false);
    setEdited(false);
    emit changed(this);
}
//----------------------------------------------------------------------------------
//-------------------------------------------------------------------
ResetLineEdit::~ResetLineEdit(){ ip->edited = false; }
ResetLineEdit::ResetLineEdit(PropertyDouble* ip,const QModelIndex & index,QWidget *parent)
    : QWidget(parent),ip(ip),index(index)
{
    ip->edited = true;
    QHBoxLayout *layout = new QHBoxLayout(this);
    layout->setMargin(0);
    layout->setSpacing(0);
    QString iniVal = index.model()->data(index, Qt::DisplayRole).toString();
    lin = new LineEditor(ip->GetPropertyValue(),iniVal,this,true);
    layout->addWidget(lin);
    lin->setBackgroundRole(QPalette::Base);
    QDoubleValidator* v = new QDoubleValidator( ip->minimum,ip->maximum,ip->decimals ,lin);
    lin->setValidator(v);

    button = new QToolButton(this);
    button->setToolButtonStyle(Qt::ToolButtonIconOnly);
    button->setIcon(QIcon(QString(":/images/resetproperty.png")));
    button->setIconSize(QSize(8,8));
    button->setSizePolicy(QSizePolicy(QSizePolicy::Fixed, QSizePolicy::MinimumExpanding));
    layout->addWidget(button);
    connect(button, SIGNAL(clicked()), this, SLOT(emitResetProperty()));
    connect(lin, SIGNAL( textChanged( const QString & ) ), this, SLOT( TreePropertyDelegate::setValue(const QString &) ) );
    if (ip->GetDefaultStr() == index.model()->data(index, Qt::DisplayRole).toString()) button->setEnabled(false);
}
void ResetLineEdit::setLine(const QString &label)
{
    lin->setText(label);
}

void ResetLineEdit::emitResetProperty()
{
     TreePropertyModel *mod = (TreePropertyModel *)index.model();
     ItemProperty * p = mod->findProperty(index);
     if (p->GetInitStr() == p->GetDefaultStr()) p->SetChanged(false);
        else p->SetChanged(true);
    setLine(ip->GetDefaultStr());
    mod->setData(index, QVariant(p->GetDefaultStr()));
    if (ip->GetDefaultStr() == index.model()->data(index, Qt::DisplayRole).toString()) button->setEnabled(false);

}
//---------------------------------------------------------------------------
QWidget *TreePropertyDelegate::createEditor(QWidget *parent,
    const QStyleOptionViewItem &,
    const QModelIndex & index) const
{
    TreePropertyModel *mod = (TreePropertyModel *)index.model();
    ItemProperty * p = mod->findProperty(index);
    QModelIndex children = index.parent();
    if(p != 0) {
      if (index.column() == 1) {
       if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyNotEdit *>(p)) {
       PropertyNotEdit * pp =  (PropertyNotEdit *)p;
       RoleEditor *editor = new RoleEditor(pp,index,parent);

       return editor;
       }
       }
       if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyDateTime *>(p)) {
       QDateTimeEdit *editor = new QDateTimeEdit(parent);

       editor->setDisplayFormat(QApplication::translate("TreePropertyDelegate", "yyyy:MM:dd hh:mm:ss"));
       editor->installEventFilter(const_cast<TreePropertyDelegate*>(this));
       return editor;
    } 
     if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyDouble *>(p)) { 
       PropertyDouble * pp =  (PropertyDouble *)p;
       if(children != QModelIndex() ) {
       QString val = index.model()->data(index, Qt::DisplayRole).toString();
       LineEditor *editor = new LineEditor(pp->GetPropertyValue(),val,parent,true);
       return editor;
       } else {
           ResetLineEdit* editor = new ResetLineEdit(pp,index,parent);
           return editor;

       }
       }


       if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyIntSpin *>(p)) {
         PropertyIntSpin * pp =  (PropertyIntSpin *)p;
         if(children != QModelIndex() ) {
            QSpinBox *editor = new QSpinBox(parent);
            editor->setFrame(0);
            editor->setRange(pp->minimum, pp->maximum);
            editor->setSingleStep (pp->step);
            editor->installEventFilter(const_cast<TreePropertyDelegate*>(this));
            //qWarning("Has children %d",mod->rowCount(children) );
            return editor;
         } else  {
            ResetSpinBox *editor = new ResetSpinBox(pp,index,parent);
            return editor;
         }
       }

//////////////////////////////////////////////////////////////////////////////////
       if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyInt *>(p)) {
         PropertyInt* pp =  (PropertyInt *)p;
         if(children != QModelIndex() ) {
//            QSpinBox *editor = new QSpinBox(parent);
//            editor->setFrame(0);
//            editor->setRange(pp->minimum, pp->maximum);
//            editor->setSingleStep (pp->step);
 //           editor->installEventFilter(const_cast<TreePropertyDelegate*>(this));
            //qWarning("Has children %d",mod->rowCount(children) );
 //           return editor;
         } else  {
       QString val = index.model()->data(index, Qt::DisplayRole).toString();
       LineEditor *editor = new LineEditor(pp->GetPropertyValue(),val,parent);
           return editor;
         }
       }


/////////////////////////////////////////////////////////////////////////////////


       if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyString *>(p)) {                                                      //"[_a-zA-Z][_a-zA-Z0-9]*"
       QLineEdit *editor = new QLineEdit(parent);

       editor->setValidator(new QRegExpValidator(QRegExp("[!@#$%^&*()_+-=<>?,./:\"\\|;'a-zA-Z0-9]*"), editor));
       editor->installEventFilter(const_cast<TreePropertyDelegate*>(this));
       QObject::connect( editor, SIGNAL( textChanged( const QString & ) ),
		      this, SLOT( QLineEdit::setValue(const QString &) ) );
       return editor;
       }   
 

//-------------------------------------------------------------------
//-------------------------------------------------------------------
 } else return 0;
return 0;
}
TreePropertyDelegate::TreePropertyDelegate(QObject *parent)
    : QItemDelegate(parent)
{

}
//-------------------------------------------------------------------

void TreePropertyDelegate::setEditorData(QWidget *editor,
                                    const QModelIndex &index) const
{
     QString value = index.model()->data(index, Qt::DisplayRole).toString();         
     TreePropertyModel *mod = (TreePropertyModel *)index.model();
     ItemProperty * p = mod->findProperty(index);
     QModelIndex children = index.parent();
     if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyNotEdit *>(p)) {
      if (index.column() == 1) {
          RoleEditor *reditor = static_cast<RoleEditor *>(editor);
          reditor->setLabel(value);
     }
    }
    if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyDateTime *>(p)){
      QDateTimeEdit *datetimeEdit = static_cast<QDateTimeEdit*>(editor);
      QDateTime dateTime;
      value.replace('/','-'); value.replace(' ','T');
      datetimeEdit->setDateTime (dateTime.fromString(value,Qt::ISODate));

    } 
    if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyDouble *>(p)) {
      if(children != QModelIndex() ) {
         LineEditor *lineEdit = static_cast<LineEditor*>(editor);
         lineEdit->setText(value);
      } else {
         ResetLineEdit* reditor = static_cast<ResetLineEdit *>(editor);
         reditor->setLine(value);
      }
    }
////////////////////////////////////////////////////////////////////////////////////////////
       if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyInt *>(p)) {
         if(children != QModelIndex() ) {
//            QSpinBox *editor = new QSpinBox(parent);
//            editor->setFrame(0);
//            editor->setRange(pp->minimum, pp->maximum);
//            editor->setSingleStep (pp->step);
 //           editor->installEventFilter(const_cast<TreePropertyDelegate*>(this));
            //qWarning("Has children %d",mod->rowCount(children) );
 //           return editor;
         } else  {
         LineEditor *lineEdit = static_cast<LineEditor*>(editor);
         lineEdit->setText(value);
         }
       }
///////////////////////////////////////////////////////////////////////////////////////////
   if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyIntSpin *>(p)) {
       if(children != QModelIndex() ) {
         QSpinBox *sp = static_cast<QSpinBox*>(editor);
         sp->QSpinBox::setValue(value.toInt());
      } else {
         ResetSpinBox*reditor = static_cast<ResetSpinBox *>(editor);
         reditor->setSpin(value);
      }
    }
  if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyString *>(p)) {
      QLineEdit *lineEdit = static_cast<QLineEdit*>(editor);
      lineEdit->setText(value);
  }
}

void TreePropertyDelegate::setModelData(QWidget *editor, QAbstractItemModel *,
                                   const QModelIndex &index) const
{

    QString prev = index.model()->data(index, Qt::DisplayRole).toString();
    TreePropertyModel *mod = (TreePropertyModel *)index.model();
    ItemProperty * p = mod->findProperty(index);
    QModelIndex children = index.parent();
    QString value = "";
if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyNotEdit *>(p)) {
    if (index.column() == 1) {
       PropertyNotEdit * pp =  (PropertyNotEdit *)p;
       RoleEditor *reditor = static_cast<RoleEditor*>(editor);
       value = reditor->GetLabel()->text();
       if (pp->GetDefaultStr() == value) reditor->GetButton()->setEnabled(false);
       else reditor->GetButton()->setEnabled(true);

      }

       }
   if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyDateTime *>(p)){
       QDateTimeEdit *datetimeEdit = static_cast<QDateTimeEdit*>(editor);
       value = datetimeEdit->dateTime().toString(Qt::ISODate);
       value.replace('-','/'); value.replace('T',' ');
   }

    if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyDouble *>(p)) {
    if(children != QModelIndex() ) {
       LineEditor *lineEdit = static_cast<LineEditor *>(editor);
       value = lineEdit->text();
       } else {
             PropertyDouble * pp =  (PropertyDouble *)p;
             ResetLineEdit *reditor = static_cast<ResetLineEdit*>(editor);
              value = reditor->GetLineEditor()->text();
            // if ( value == "") value = p->GetInitStr();
             if (pp->GetDefaultStr() == value) reditor->GetButton()->setEnabled(false);
             else reditor->GetButton()->setEnabled(true);
     }
   }
////////////////////////////////////////////////////////////////////////////////////////////
       if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyInt *>(p)) {
         if(children != QModelIndex() ) {
//            QSpinBox *editor = new QSpinBox(parent);
//            editor->setFrame(0);
//            editor->setRange(pp->minimum, pp->maximum);
//            editor->setSingleStep (pp->step);
 //           editor->installEventFilter(const_cast<TreePropertyDelegate*>(this));
            //qWarning("Has children %d",mod->rowCount(children) );
 //           return editor;
         } else  {
       LineEditor *lineEdit = static_cast<LineEditor *>(editor);
       value = lineEdit->text();
         }
       }
///////////////////////////////////////////////////////////////////////////////////////////
    if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyString *>(p)) {
       QLineEdit *lineEdit = static_cast<QLineEdit *>(editor);    
       value = lineEdit->text();
   }
    if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyIntSpin *>(p)) {
     if(children != QModelIndex() ) {
       QSpinBox *sp = static_cast<QSpinBox*>(editor);    
       value = QString("%1").arg(sp-> value ());
     } else {
             PropertyIntSpin * pp =  (PropertyIntSpin *)p;
             ResetSpinBox *reditor = static_cast<ResetSpinBox*>(editor);
             value = reditor->GetSpin()->text();
             if (pp->GetDefaultStr() == value) reditor->GetButton()->setEnabled(false);
             else reditor->GetButton()->setEnabled(true);
     }
   }
   // mod->setData(index, QVariant(value.toFloat()));

    mod->setData(index, QVariant(value));

    if (p->GetInitStr() == value) p->SetChanged(false);
    else  p->SetChanged(true);
    QModelIndex parent = index.parent();
//if (!ip->GetInvalid())
    if(parent !=  QModelIndex()) {
      if (mod->rowCount(parent) == 2) {
        QModelIndex i  = mod->index(0, 1, parent);
        QModelIndex i1 = mod->index(1, 1, parent);
        QModelIndex parentCol1 = mod->index(parent.row(),1);  
       // QModelIndex parentCol0 = mod->index(parent.row(),0);
      //  ItemProperty * fp   = mod->findProperty(i);
      //  ItemProperty * fp1  = mod->findProperty(i1);
        ItemProperty * ip  = mod->findProperty(parentCol1);
        //ItemProperty * ip0  = mod->findProperty(parentCol0);

        QString s  =  mod->data(i).toString();
        QString s1 =  mod->data(i1).toString();
        QString tmp = LEFT_BREAKET + s + MIDL_BREAKET + s1 + RIGHT_BREAKET;
        if (ip->GetInitStr() == tmp) ip->SetChanged(false);
        else ip->SetChanged(true);
        //mod->setData(parentCol0, mod->data(parentCol0).toString());
      // if (!ip->GetInvalid()) {
        mod->setData(parentCol1, tmp);

            if(s.toFloat() >= s1.toFloat()) {
            if (!ip->GetInvalid())  {
/*
            QMessageBox::critical(0,"Setting parameters","Numbers must be sorted in ascending order",
                     QMessageBox::Yes | QMessageBox::Default,
                     QMessageBox::No | QMessageBox::Escape);
*/
               }
            ip->SetInvalid(true);

          } else ip->SetInvalid(false);

       //}

  }
 if (mod->rowCount(parent) == 3) {
        QModelIndex i  = mod->index(0, 1, parent);
        QModelIndex i1 = mod->index(1, 1, parent);
        QModelIndex i2 = mod->index(2, 1, parent);
        QModelIndex parentCol1 = mod->index(parent.row(),1);

        ItemProperty * ip  = mod->findProperty(parentCol1);
        QString s  =  mod->data(i).toString();
        QString s1 =  mod->data(i1).toString();
        QString s2 =  mod->data(i2).toString();
        QString tmp = s + "/" + s1 + "/" + s2;
        if (ip->GetInitStr() == tmp) ip->SetChanged(false);
        else ip->SetChanged(true);
        mod->setData(parentCol1, QVariant(tmp));
     }
   }

}

void TreePropertyDelegate::paint(QPainter *painter, const QStyleOptionViewItem &opt, const QModelIndex &index) const
{
    bool paintAct = true;
    QStyleOptionViewItem option = opt;
    option.displayAlignment =  Qt::AlignLeft|Qt::AlignVCenter;
    //option.displayAlignment =  Qt::AlignHCenter;
    TreePropertyModel *mod = (TreePropertyModel *)index.model();

    ItemProperty * p = mod->findProperty(index);
    if(p != 0) {
    if (p->GetChanged()) { option.font.setBold(true); option.palette.setColor(QPalette::Text,QColor("blue"));     }
    if (p->GetInvalid()) { option.font.setBold(true); option.palette.setColor(QPalette::Text,QColor("red"));     }

    if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyNotEdit *>(p) ) {
        if(index.column() == 1)  {
         PropertyNotEdit * pp =  (PropertyNotEdit *)p;
                if (pp->edited) paintAct = false;
           }
       }
     if (dynamic_cast<ItemProperty *>(p) == dynamic_cast<PropertyTittle *>(p) ) {
        option.font.setItalic(true);option.palette.setColor(QPalette::Text,QColor("blue"));
       }
    }

 
  //  option.palette.setColor(QPalette::Highlight,QColor(100,160,180)); //QColor(80,132,166)

    if(paintAct)   QItemDelegate::paint(painter, option, index);

  
    if (index.column() == 0 || index.column() == 1) {
        painter->drawLine(option.rect.right(), option.rect.y(),
                option.rect.right(), option.rect.bottom());
    }
    painter->drawLine(option.rect.x(), option.rect.bottom(),
            option.rect.right(), option.rect.bottom());
}

//---------------------------------------------------
