#include <QtGui>
#include <stdlib.h>
#include "default.h"
#include "mainwindow.h"
QStringList _INPUT_FORMAT_LIST_;
QStringList _OUTPUT_FORMAT_LIST_;
QStringList _IMPORT_FORMAT_FILTER_LIST_;
QString ECP_ROOT_PATH;
QString ECP_SEARCH_HELP_PATH;
bool GetFormatLists();
void tryRemoveYesterdayWorkingMaterials();
int main(int argc, char *argv[])
{
    

    Q_INIT_RESOURCE(edcat);
    QApplication app(argc, argv);
    app.setStyle(QStyleFactory::create("plastique"));
    app.setPalette(app.style()->standardPalette());
		QString absoluteInstallEcpPath = app.applicationDirPath();
		int pos = absoluteInstallEcpPath.lastIndexOf("/bin");
		absoluteInstallEcpPath.remove ( pos, 4 ); 
		ECP_ROOT_PATH = absoluteInstallEcpPath;
		
#if defined(Q_WS_WIN) 
		ECP_SEARCH_HELP_PATH = "file:///" + ECP_ROOT_PATH + "/doc";
#endif

#if defined(Q_WS_X11) 
		ECP_SEARCH_HELP_PATH = "file://" + ECP_ROOT_PATH + "/doc";
#endif		
#if defined(Q_WS_MAC) 
		ECP_SEARCH_HELP_PATH = "file://" + ECP_ROOT_PATH + "/doc";
#endif
    tryRemoveYesterdayWorkingMaterials();
    if (!GetFormatLists()) return 1;
    MainWindow mainWin;
    mainWin.show();

if (argc == 2 ) mainWin.loadFileAuto(QString("%1").arg(argv[1]));
    return app.exec();
}
void tryRemoveYesterdayWorkingMaterials(){
	QString ecpDirectoryPath = ecpRootPath();
	QDir ecpDirectory(ecpDirectoryPath);
    QDir tempDir(temporarySystemDirectoryPath());
   // QMessageBox::critical(0,"",temporarySystemDirectoryPath());
    QFileInfoList info = tempDir.entryInfoList (QDir::Dirs,QDir::Name);
   
  for (int i = 0; i < info.size(); ++i) {
	  QString curAbsoluteFilePath =  QDir::toNativeSeparators(info.at(i).absoluteFilePath());
	 	 if (curAbsoluteFilePath.contains(temporaryDirectoryPrifix()) ) { 
			 QString str =  curAbsoluteFilePath.section("-",1,1);
             uint fileTime_t = str.toUInt();
    QDate date = QDate::currentDate ();
    QTime time = QTime::currentTime ();
    QDateTime datetime (date, time ) ; 
    uint currentTime_t = datetime.toTime_t ();
			 if((currentTime_t - fileTime_t) > (uint) (86400)) {
			// QMessageBox::critical(0,"",QString("%1 fileTime_t %2 currentTime_t %3 dt %4").
			// arg(info.at(i).fileName()).arg(fileTime_t).arg(currentTime_t).arg((currentTime_t - fileTime_t)));
			 QDir tempCurDir(curAbsoluteFilePath);
			 
			 QFileInfoList infolist = tempCurDir.entryInfoList (QDir::Files,QDir::Name);
			// QMessageBox::critical(0,"",QString("%1 size %2").arg(curAbsoluteFilePath).arg(infolist.size()));
			 for (int j = 0; j < infolist.size(); ++j) {
				 QString fileName = infolist.at(j).fileName();
				 if (fileName.contains(".") ) continue;
				 if (fileName.contains("..") ) continue;
			//	 QMessageBox::critical(0,"",fileName);
				 tempCurDir.remove(fileName);
			 }
			 tempDir.rmdir(curAbsoluteFilePath);
			 }
			 //QDate dtt = QDate ().fromString(filePath.section(".",0,2),"dd.MM.yyyy");			 
		 }
  }
   
   
   
   
   if (ecpDirectory.exists("temp") ) {

    QDate date = QDate::currentDate ();
    QTime time = QTime::currentTime ();
    QDateTime datetime (date, time ) ; 
    uint currentTime = datetime.toTime_t ();
    QString tempDirectoryPath = ecpDirectoryPath + QDir::toNativeSeparators("/") +"tmp"+ QDir::toNativeSeparators("/") +
                        QString("%1%2").arg(temporaryDirectoryPrifix()).arg(currentTime);
   }
}
bool GetFormatLists() {
QString formatFileName = ecpRootPath() + "/ref/standardformat.list";
        formatFileName =  QDir::toNativeSeparators(formatFileName);
     QFile f( formatFileName );
     if ( !f.open(QIODevice::ReadOnly ) )
     {
	 QString tmp = QString("Can't find file standardformat.list \n");
	 QMessageBox::critical(0,mainWindowCaption(),tmp);
	 return false;
    }
     QString dummy;
     QTextStream ts( &f );
     while( !ts.atEnd () ) { 
	 dummy = ts.readLine();
	 if (dummy.indexOf (_FILE_FORMAT_SEPARATOR_) != -1)  break;
    }
_IMPORT_FORMAT_FILTER_LIST_.append(" Any files (*)");
while( !ts.atEnd () )
{
	 QString temp("TITLE");
	 dummy = ts.readLine();
	 if (dummy.indexOf(temp) != -1) {
		 _INPUT_FORMAT_LIST_.append( dummy.right(dummy.length() 
		 - (dummy.lastIndexOf(temp) + temp.length ()))); 
		 QString hyphen("-");
		 if (dummy.indexOf(hyphen) != -1) {
			 QString str = dummy.right(dummy.length() - 
			 (dummy.lastIndexOf(hyphen) + hyphen.length ())); 
			 QString str1 = dummy.left(dummy.indexOf(hyphen));
			 str1 = str1.right(str1.length() 
			 - (str1.lastIndexOf(temp) + temp.length ()));
			 str1 = str1.remove(' ');
			 QString str2 = QString("%1 (*.%2)").arg(str).arg(str1);
			 _IMPORT_FORMAT_FILTER_LIST_.append(str2);
		 }	
	 }	 
}
_OUTPUT_FORMAT_LIST_ << (_INPUT_FORMAT_LIST_.at(0));
_OUTPUT_FORMAT_LIST_ << (_INPUT_FORMAT_LIST_.at(1));
_OUTPUT_FORMAT_LIST_ << (_INPUT_FORMAT_LIST_.at(2));
    f.close();
return true;



}
