#ifndef _NEW_OPEN_SAVE_H
#define _NEW_OPEN_SAVE_H
#include <qfiledialog.h>
#include <QLabel>
#include "catalog.h"
#include "ui_import.h" 
class QWidget;
class QFileDialog;
class QLabel;
class QComboBox;
class QPushButton;
class QTextEdit;
class QGroupBox;
class QGridLayout;
class QSplitter;
class ImportFormat;
class MyOpenFileDialog;
class QItemSelection;
///===============================================================
class ImportFormatSetDialogs : public QDialog
{
	Q_OBJECT
	public:
		ImportFormatSetDialogs(QWidget* parent);
		~ImportFormatSetDialogs();
		QSplitter *GetSlitter() {return  splitter;}
		ImportFormat* GetImportformatWindow(){ return imFormat;}
		MyOpenFileDialog* GetOpenDialog() { return openDialog;} 
		void accept ();	
		void reject ();
	protected:
	protected slots:
	private:
		QSplitter * splitter;
		ImportFormat* imFormat;
		MyOpenFileDialog* openDialog;

};
///===============================================================
class ImportFormat : public QDialog, private Ui::ImportFormatBase
{
	Q_OBJECT
	public:
		ImportFormat(QWidget* parent); 
		~ImportFormat ();
		QWidget* GetParentWindow(){ return parent;}
		QTextEdit* GetTextEdit(){return textEdit;}
		QComboBox* GetBomboBox(){return comboBox;} 
		bool AutoCheckCatalogFormat(QString name);
		bool CheckCatalogFormat(QString name,int numFormat);
		
	public slots:
		virtual void textChangeComboBox( const QString &  );
	private:
		QWidget* parent;
		Catalog catalog;

};
///===============================================================
class MyOpenFileDialog : public QFileDialog
{
	Q_OBJECT
	private:
		Catalog catalog;
		QWidget* parent;
	public:
		MyOpenFileDialog(QWidget* parent); 
		~MyOpenFileDialog ();
	protected slots:
		void changedSelection ( const QItemSelection & , const QItemSelection & );
		void accept ();	
		void reject ();
};
///===============================================================

#endif
