#include <QtGui>
#include <QMessageBox>
#include "profile.h"
#include "default.h"
#include "document.h"
#include "transmagimpl.h"
#include "doubleimpl.h"
#include "subcatalog.h"
#include "helpwindow.h"
#include "append.h"
#include "rangelimit.h"
#include "mainwindow.h"
#include "bottomwindow.h"
//ProjectWizard *ProjectWizard::wizardWin = 0;
static const  QString  _ENTER_PROJECT_CATALOG_NAME_ = "";
ProfileImpl::~ProfileImpl(){
listWidgetIn->clear ();
listWidgetOut->clear ();
if(!values.empty())  values.clear();
if(!listProjectAction.empty()) listProjectAction.clear();
if(!toolButtonList.empty()) toolButtonList.clear();
 
};
ProfileImpl::ProfileImpl(QWidget *parent,FDocument* docDefault,FDocument* docCurrent,
		ProWizard::DocumentUsing documentUsing)
      : QDialog(parent),doc(docDefault),docDefault(docDefault),docCurrent(docCurrent),
		documentUsing(documentUsing)  

{
    setFont( parent->font() );
	setWindowIcon(QIcon(":/images/icon.png"));
    setupUi(this);
    setModal (true);
	labelNoText->hide();
    listWidgetIn->clear ();
    QStringList listAction = projectActionList().split ('@');
    listWidgetIn->addItem(new QListWidgetItem(QIcon(":/images/magnitude.png"), listAction.at(0)));
    listWidgetIn->addItem(new QListWidgetItem(QIcon(":/images/duplicate.png"), listAction.at(1)));
    listWidgetIn->addItem(new QListWidgetItem(QIcon(":/images/sample.png"), listAction.at(2)));
    listWidgetIn->addItem(new QListWidgetItem(QIcon(":/images/mergecell.png"), listAction.at(3)));
    listWidgetIn->addItem(new QListWidgetItem(QIcon(":/images/append.png"), listAction.at(4)));
    listAction.clear();
    radioButtonCompare->setIcon(QIcon(":/images/comp.png"));
    radioButtonCompare->setText(projectCompareTitle());

    radioButtonRange->setIcon(QIcon(":/images/error.png"));
    radioButtonRange->setText(projectRangeTitle());

    listWidgetIn->setCurrentRow (0);

    toolButtonList.append(pushButtonAdd);
    toolButtonList.append(pushButtonRemove);
    toolButtonList.append(pushButtonUp);
    toolButtonList.append(pushButtonDown);
    foreach (QToolButton * button, toolButtonList) button->setEnabled ( true );

GetDialogFromDocument();

values.append(doc->GetProjectActionList());
values.append(doc->GetProjectCatalogName());
values.append(doc->GetProjectActionChoise());

 //   connect(cancelButton,        SIGNAL(clicked()),   this, SLOT(reject()));
//    connect(okButton,            SIGNAL(clicked()),   this, SLOT(accept()));
    connect(pushButtonAdd,       SIGNAL(clicked()),   this, SLOT(add()));
    connect(pushButtonRemove,    SIGNAL(clicked()),   this, SLOT(remove()));
    connect(pushButtonUp,        SIGNAL(clicked()),   this, SLOT(up()));
    connect(pushButtonDown,      SIGNAL(clicked()),   this, SLOT(down()));
    connect(toolButtonBrowse,    SIGNAL(clicked()),   this, SLOT(browse()));
    connect(radioButtonList,     SIGNAL( clicked()),  this, SLOT( rbList() ) );
    connect(radioButtonCompare,  SIGNAL( clicked()),  this, SLOT( rbCompare() ) );
    connect(radioButtonRange,    SIGNAL( clicked()),  this, SLOT( rbRange() ) );
    connect(toolButtonReset,     SIGNAL(clicked()),   this, SLOT(reset()));
    connect(toolButtonProject,   SIGNAL(clicked()),   this, SLOT(project()));
    connect(toolButtonDefault,   SIGNAL(clicked()),   this, SLOT(defaults()));
    connect(radioButtonCurrent,  SIGNAL(clicked()),   this, SLOT(rbCurrentDoc()));
    connect(radioButtonDefault,  SIGNAL(clicked()),   this, SLOT(rbDefaultDoc()));
    openUserToolFileDirectory = MainWindow::self->openUserFileDirectory;

}

int ProfileImpl::nextIdPage(int id){

	QMap<int,int> nextIdMap;
	QVector<int> vector;
	QStringList listAction = projectActionList().split ('@');
	QListWidget* ListWizardTask = listWidgetOut;
	QString tmp = QString("SetListWizardPages: listWidgetOut size %1 \n").arg(ListWizardTask->count ());
	for (int i = 0; i <  ListWizardTask->count (); i++) {
	QString text = ListWizardTask->item(i)->text();
	tmp += QString("%1:> %2\n").arg(i).arg(text);
	if ( text == listAction.at(0)     ) vector.append (ProWizard::Current_ConvertMagnitudes);
	if ( text == listAction.at(1)     ) vector.append (ProWizard::Current_RemoveDuplicate);
	if ( text == listAction.at(2)     ) vector.append (ProWizard::Current_SelectSubcatalog);
	if ( text == listAction.at(3)     ) vector.append (ProWizard::Current_MergeCatalogs);
	if ( text == listAction.at(4)     ) vector.append (ProWizard::Current_SubstituteCatalogs);
	if ( text == projectCompareTitle()) vector.append (ProWizard::Current_CompareCatalogs);
	if ( text == projectRangeTitle()  ) vector.append (ProWizard::Current_CheckRanges);

	}
	//QMessageBox::critical(0,"",tmp);

	if( radioButtonDefault->isChecked ()) {
		isDocDfault = true;
		for (int i = 0; i < vector.size(); i++) vector[i] += 7;
	} else 
		isDocDfault = false;
	
	nextIdMap.insert (0,vector[0]);
	for (int i = 1; i <  vector.size(); i++) {
	nextIdMap.insert (vector[i-1],vector[i]);
	}
	nextIdMap.insert (vector[vector.size()-1],vector[vector.size()-1]);
	projectActSize = nextIdMap.size();
	
	return nextIdMap[id];
}
void ProfileImpl::rbCurrentDoc(){
   
	doc = docCurrent;
}
void ProfileImpl::rbDefaultDoc(){
	
	doc = docDefault;
}

//-----------------------------------------------------------------------
void ProfileImpl::reject()
{
    done( Rejected );
}
//-----------------------------------------------------------------------
bool ProfileImpl::NextOk() {

if (label->text() == _ENTER_PROJECT_CATALOG_NAME_) {
  QMessageBox::information(this,"Project Wizard",
          "Initial Catalog section: Insert Project Catalog.\n"
		  "Push  \"Browse\" button to select catalog.");
return false;
}

  if(listWidgetOut->count() == 0) {
  QMessageBox::information(this,"Project Wizard",
          "Tasks section: List of task is empty. Insert at least one task in this list.");
  return false;
 }

  
  return true;
}
void ProfileImpl::FinishOk(){
    GetDocumentFromDialog();
    foreach (PropertyValue* val, values) val->SetValueToResetvalue();
	QString tmp = "\n*** The definition of  parametres of the project by Project Wizard. ***\n\n";
	Catalog cat;
    tmp +=  "Initial catalogs ";
	QString catName = doc->GetProjectCatalogName()->GetValue();
	tmp +=  cat.GetCatalogInfoMessage(catName);

	if( radioButtonDefault->isChecked ()) tmp += "Initially \"Default Parameters of Tasks\" was used.\n";
	else tmp += "Initially \"Currently Defined Parameters of Tasks\" was used.\n";
	tmp += "List of Tasks:\n";
	QStringList list = doc->GetProjectActionList()->GetStringList();
	for (int i = 0; i < list.size(); ++i) 
		tmp += list.at(i) + "\n";
	tmp += "\n";
	QTextEdit* texted = MainWindow::self->bottomWindow->messageTab;
	texted->insertPlainText(tmp);
	
}
void ProfileImpl::accept()
{
if (!NextOk()) return;
FinishOk();
  done( Accepted );

}
void ProfileImpl::reset(){

foreach (PropertyValue* val, values) val->SetResetvalueToValue();

GetDialogFromDocument();
}
void ProfileImpl::project(){

foreach (PropertyValue* val, values) val->SetInitial();
GetDialogFromDocument();
}
void ProfileImpl::defaults(){

foreach (PropertyValue* val, values) val->SetDefault();
GetDialogFromDocument();
}
//-----------------------------------------------------------------------
void ProfileImpl::add(){
QListWidgetItem * item = listWidgetIn->currentItem ();
if(item == 0) return;
bool findItem = false;
for (int i = 0; i <  listWidgetOut->count (); i++){
  QListWidgetItem * it =  listWidgetOut->item(i);
  if (item->text () == it->text () ) {
  QString tmp = "Task \"" + item->text () + "\"";
  QMessageBox::information(this,"Project Wizard",
          tmp + " has exist in list of Compilation of a catalog  already");
  findItem = true;
  }
}
if (!findItem)
listWidgetOut->addItem( new QListWidgetItem(*item ));
}
//-----------------------------------------------------------------------
void ProfileImpl::remove(){
//qWarning("--- %d",listWidgetOut->currentRow());
listWidgetOut->takeItem ( listWidgetOut->currentRow() );
}
//-----------------------------------------------------------------------
void ProfileImpl::up(){
if (listWidgetOut->currentRow() == 0 ) return;
int row = listWidgetOut->currentRow() ;
QListWidgetItem * item = listWidgetOut->currentItem ();

listWidgetOut->takeItem ( row );
listWidgetOut->insertItem(row-1,item);
listWidgetOut->setCurrentRow(row-1);
}
//-----------------------------------------------------------------------
void ProfileImpl::down(){
if (listWidgetOut->currentRow() == listWidgetOut->count () - 1 ) return;
int row = listWidgetOut->currentRow() ;
QListWidgetItem * item = listWidgetOut->currentItem ();
listWidgetOut->takeItem ( row );
listWidgetOut->insertItem(row+1,item);
listWidgetOut->setCurrentRow(row+1);

}
void ProfileImpl::browse(){
	QString fileName =
	QFileDialog::getOpenFileName(this,"Open standard format catalog",
		openUserToolFileDirectory,
		MainWindow::self->GetFileFilters());
	if (!fileName.isEmpty()) {
		Catalog cat;
		if (!cat.CheckStandardBinaryFormat(fileName)) return;
		doc->GetProjectCatalogName()->SetValue(fileName);
		if(radioButtonCurrent->isChecked()) 
			docDefault->GetProjectCatalogName()->SetValue(fileName);
		if(radioButtonDefault->isChecked()) 
			docCurrent->GetProjectCatalogName()->SetValue(fileName);
		label->setText(MainWindow::self->strippedName(fileName));
		openUserToolFileDirectory = QFileInfo(fileName).absolutePath ();
	}
}
void ProfileImpl::GetDialogFromDocument(){
	
	
if (documentUsing == ProWizard::ProjectNew){
doc = docDefault;
radioButtonCurrent->setChecked (false);
radioButtonDefault->setChecked (true);
}

if (documentUsing == ProWizard::ProjectEdit){
doc = docCurrent;
radioButtonCurrent->setChecked (true);
radioButtonDefault->setChecked (false);
}
	
	
	
    listProjectAction.clear();
    listWidgetOut->clear();
    listProjectAction = doc->GetProjectActionList()->GetStringList();
    listWidgetOut->addItems(listProjectAction);
	QStringList listAction = projectActionList().split ('@');
	for(int i = 0; i < listWidgetOut->count (); ++i){
	QListWidgetItem * item = listWidgetOut->item(i);
	QString text = item->text (); 
	if ( text == listAction.at(0)     ) item->setIcon (QIcon(":/images/magnitude.png") ); 
	if ( text == listAction.at(1)     ) item->setIcon (QIcon(":/images/duplicate.png") ); 
	if ( text == listAction.at(2)     ) item->setIcon (QIcon(":/images/sample.png") ); 
	if ( text == listAction.at(3)     ) item->setIcon (QIcon(":/images/mergecell.png") ); 
	if ( text == listAction.at(4)     ) item->setIcon (QIcon(":/images/append.png") ); 
	if ( text == projectCompareTitle()) item->setIcon (QIcon(":/images/comp.png") ); 
	if ( text == projectRangeTitle()  ) item->setIcon (QIcon(":/images/error.png") );
	}

	label->setText(MainWindow::self->strippedName(doc->GetProjectCatalogName()->GetValue()));

	if(doc->GetProjectActionChoise()->GetValue() == "0") {
		radioButtonList->setChecked (TRUE);
		radioButtonCompare->setChecked (FALSE);
		radioButtonRange->setChecked (FALSE);
	}
	if(doc->GetProjectActionChoise()->GetValue() == "1") {
		radioButtonList->setChecked (FALSE);
		radioButtonCompare->setChecked (TRUE);
		radioButtonRange->setChecked (FALSE);
	}

	if(doc->GetProjectActionChoise()->GetValue() == "2") {
		radioButtonList->setChecked (FALSE);
		radioButtonCompare->setChecked (FALSE);
		radioButtonRange->setChecked (TRUE);
}


}
void ProfileImpl::GetDocumentFromDialog(){
     listProjectAction.clear();
     for (int i = 0; i < listWidgetOut->count(); ++i) listProjectAction.append(listWidgetOut->item(i)->text());
     doc->GetProjectActionList()->SetListToValue(listProjectAction);
     if(radioButtonList->isChecked  ())    doc->GetProjectActionChoise()->SetValue("0");
     if(radioButtonCompare->isChecked ())  doc->GetProjectActionChoise()->SetValue("1");
     if(radioButtonRange->isChecked ())    doc->GetProjectActionChoise()->SetValue("2");

}
void ProfileImpl::rbList(){

bool findItem = false;
for (int i = 0; i <  listWidgetOut->count (); i++){
  QListWidgetItem * item =  listWidgetOut->item(i);
  if (item->text () == radioButtonCompare->text () || item->text () == radioButtonRange->text ()) 
     findItem = true;
}
if (findItem || listWidgetOut->count () == 0) listWidgetOut->clear();
foreach (QToolButton * button, toolButtonList) button->setEnabled ( TRUE );
}
void ProfileImpl::rbCompare(){
bool findItem = false;
for (int i = 0; i <  listWidgetOut->count (); i++){
  QListWidgetItem * item =  listWidgetOut->item(i);
  if (item->text () != radioButtonCompare->text ()) 
     findItem = true;
}
if (findItem || listWidgetOut->count () == 0) {
listWidgetOut->clear();
listWidgetOut->addItem(new QListWidgetItem(radioButtonCompare->icon (), radioButtonCompare->text ()));
}
foreach (QToolButton * button, toolButtonList) button->setEnabled ( FALSE );
}
void ProfileImpl::rbRange(){
bool findItem = false;
for (int i = 0; i <  listWidgetOut->count (); i++){
  QListWidgetItem * item =  listWidgetOut->item(i);
  if (item->text () != radioButtonRange->text ()) 
     findItem = true;
}
if (findItem || listWidgetOut->count () == 0) {
listWidgetOut->clear();
listWidgetOut->addItem(new QListWidgetItem(radioButtonRange->icon (), radioButtonRange->text ()));
}
foreach (QToolButton * button, toolButtonList) button->setEnabled ( FALSE );
}
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
ProfileList::ProfileList(FDocument* dc,QString tittle, QWidget * parent,
          TypeProfile tp)
      :QDialog(0),type(tp),doc(dc){
	    setFont( parent->font() );
		
        setWindowIcon(QIcon(":/images/icon.png"));
        listWidget = new ProfileTreeView(1,this,tittle,type);
        listWidget->GetModel()->type = type;
 	QGridLayout* gridLayout = new QGridLayout(this);
	gridLayout->setSpacing(6);
    gridLayout->setMargin(9);
    gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
	gridLayout->addWidget(listWidget, 0, 0, 1, 1);
//  resize(100,100);
  //setWidget ( listWidget);
 // setFixedWidth (200);
 //setSizePolicy ( QSizePolicy::Fixed, QSizePolicy::Preferred);
 // setMaximumWidth(200);
 //resize(QSize(100, 100).expandedTo(minimumSizeHint()));
//  hide();
 //qWarning("width %d",listWidget->width());
//showNormal ();

}
void ProfileList::closeProfile(){
listWidget->GetModel()->closeProfile();
}
void ProfileList::closeOpenedEditor(){
QModelIndex sel = listWidget->GetModel()->index(0, 0, QModelIndex());
       listWidget->setCurrentIndex (sel);

}
void ProfileList::SetRowList(FDocument* dc,QString name){
doc = dc;
//QMessageBox::information(this,"",name);
   QString projectCatalog = doc->GetProjectCatalogName()->GetValue();
   if (type == Normal)
      projectCatalog = MainWindow::self->strippedName(projectCatalog);

   QStringList listmerge = QStringList();
   QStringList listMergeCatalog = doc->GetListMergeCatalog()->GetStringList();

   if (!listMergeCatalog.empty())
   for (int i = 0; i < listMergeCatalog.size(); ++i)
   if (type == Normal)
      listmerge.append(MainWindow::self->strippedName(listMergeCatalog.at(i)));
   else listmerge.append(listMergeCatalog.at(i));

   QStringList listadd = QStringList();
   QStringList listAddCatalog = doc->GetListAddCatalog()->GetStringList();
   if (!listAddCatalog.empty())
   for (int i = 0; i < listAddCatalog.size(); ++i)
   if (type == Normal)
      listadd.append(MainWindow::self->strippedName(listAddCatalog.at(i)));
   else listadd.append(listAddCatalog.at(i));

   QString compFileName = doc->GetSecondCatalogName()->GetValue();

   if (compFileName != "") {
   if (type == Normal)
   compFileName = MainWindow::self->strippedName(compFileName);
   else compFileName = compFileName;
  }
   QStringList  listAction = doc->GetProjectActionList()->GetStringList();

   CatalBaseImpl::ModeAction compModAct = CatalBaseImpl::Intersection;
   if (doc->GetCompareCatalogAction()->GetValue() == "1") compModAct = CatalBaseImpl::Difference;
   if (doc->GetCompareCatalogAction()->GetValue() == "2") compModAct = CatalBaseImpl::Equivalence;
   if (doc->GetCompareCatalogAction()->GetValue() == "3") compModAct = CatalBaseImpl::Nonequivalence;



   listWidget->SetRowList(name,projectCatalog,listAction,listmerge,listadd,compFileName,compModAct);
}
//===========================================================================
//-----------------------------------------------------------------------
void ProfileList::SetProjectName(QString &name){
listWidget->SetProjectName(name);
}

//-----------------------------------------------------------------------
ProfileTreeView::ProfileTreeView(int numCol,QWidget* parent, QString name,ProfileList::TypeProfile type)
  : QTreeView(parent),type(type)
{
	
    QFont f = parent->font();
    setFont( f );
    setAlternatingRowColors (TRUE);
if (type == ProfileList::Normal)
    setEditTriggers (QAbstractItemView::NoEditTriggers); //SelectedClicked
if (type == ProfileList::Repair){
    setEditTriggers (QAbstractItemView::DoubleClicked); //QTreeView::DoubleClicked 

}
	edIndex =  QModelIndex();
    model = new TreeProfileModel(numCol,name,this);
    setModel(model);
    delegate = new TreeProfileDelegate;
    setItemDelegate(delegate);
}
//-----------------------------------------------------------------------

void ProfileTreeView::SetProjectName(QString &name){
QModelIndex ind = model->index(0, 0, QModelIndex());
QModelIndex indexCol0 = model->index(0, 0, ind);
          model->setData(indexCol0,name);
}
//-----------------------------------------------------------------------
void ProfileTreeView::SetRowList(QString name,QString &file,QStringList &listAction,
     QStringList &listMergeCatalog,QStringList &listAddCatalog,
          QString &compFile,CatalBaseImpl::ModeAction compModAct){
GetDelegate()->GetExecuteAction() = false;
model->removeRows( 0,model->rowCount()); 

model->numberActiveRow = -1;
model->SetHorizontalHeader();

     QIcon ic;
     ic = QIcon(":/images/catalog.png");
     QSize size (22,22) ;
     ic.actualSize (size);

     QIcon icnot;
     icnot = QIcon(":/images/notexists.png");
     icnot.actualSize (size);

model->SetItem(0,"Project: ");
model->SetColumns(0);
model->SetChildItem(0,0,name);

QModelIndex ind = model->index(0, 0, QModelIndex());
model->setData (model->index(0, 0,ind), QVariant(ic),Qt::DecorationRole);
setExpanded ( ind,true );

QStringList& listRepair = MainWindow::self->GetRepairFileName();

model->SetItem(1,"Catalog: ");
model->SetColumns(1);
model->SetChildItem(1,0,file);

ind = model->index(1, 0, QModelIndex());
if (model->type == ProfileList::Repair) {
   if( listRepair.contains(file)) {
   model->rlist.append(model->index(0, 0,ind));
   model->setData (model->index(0, 0,ind), QVariant(icnot),Qt::DecorationRole);
  } else
    model->setData (model->index(0, 0,ind), QVariant(ic),Qt::DecorationRole);
} else
model->setData (model->index(0, 0,ind), QVariant(ic),Qt::DecorationRole);

setExpanded ( ind,true );

model->SetItem(2,"Tasks:");
model->SetColumns(2);
model->SetChildItem(2,listAction,listMergeCatalog,listAddCatalog,compFile,compModAct);

ind = model->index(2, 0, QModelIndex());
setExpanded ( ind,true );
//QHeaderView * hd = header ();
//hd->setDefaultSectionSize(150);
}
//-----------------------------------------------------------------------
void ProfileTreeView::drawBranches(QPainter *painter, const QRect &rect, const QModelIndex &index) const
{
    QStyleOptionViewItem opt = viewOptions();
    QStyleOptionViewItem option = opt;

      if (selectionModel()->isSelected(index))
        painter->fillRect(option.rect, option.palette.brush(QPalette::Highlight));

    if (model->hasChildren(index)) {
        static const int size = 9;
        opt.state |= QStyle::State_Children;
        opt.rect.setRect(rect.width() - (indentation() + size) / 2,
                         rect.y() + (rect.height() - size) / 2, size, size);
        if (isExpanded(index))
            opt.state |= QStyle::State_Open;
        painter->fillRect(opt.rect, Qt::white);
        style()->drawPrimitive(QStyle::PE_IndicatorBranch, &opt, painter, this);
    }
    painter->drawLine(rect.x(), rect.bottom(), rect.right(), rect.bottom());
}
//-----------------------------------------------------------------------

TreeProfileModel::TreeProfileModel(int columns, QString tittle, QObject * parent )
    : QStandardItemModel(0, columns,parent),NumCols(columns) {
NumRows=0;
SetItem(0,tittle);
SetHorizontalHeader();
parentWindow = (ProfileTreeView*) parent;
numberActiveRow = -1;
curOpenFile = MainWindow::self->GetCurrentCatalogName();
}
void TreeProfileModel::closeProfile(){
removeRows (0, rowCount());
NumRows=0;
SetItem(0,"No Project");
numberActiveRow = -1;
curOpenFile = MainWindow::self->GetCurrentCatalogName();
}
void TreeProfileModel::SetHorizontalHeader(){
setHeaderData(0, Qt::Horizontal,"Tasks");
//setHeaderData(1, Qt::Horizontal,"#");
}
void TreeProfileModel::SetColumns(int rowFirst){
 QModelIndex indexParent = index(rowFirst, 0, QModelIndex());
 insertColumns( 0,NumCols, indexParent);
}
void TreeProfileModel::SetColumns(int rowFirst,int rowSecond){
 QModelIndex ind = index(rowFirst, 0, QModelIndex());
 QModelIndex indexParent = index(rowSecond, 0, ind);
 insertColumns( 0,NumCols, indexParent);
}
void TreeProfileModel::SetItem(int rowFirst,QString value){
     QModelIndex rowIndex = index(rowFirst, 0, QModelIndex());
     int rows = rowCount(rowIndex);
     insertRows ( rows ,1);
     QModelIndex rowNewIndex = index(rowFirst, 0, QModelIndex());
     setData(rowNewIndex, value);
}

void TreeProfileModel::SetChildItem(int rowFirst,int rowSecond,const QString value){
     QModelIndex indexParent = index(rowFirst, 0, QModelIndex());
     int rows = rowCount(indexParent);
     insertRows ( rows ,1,indexParent);
     QModelIndex rowIndexSecond = index(rowSecond, 0, indexParent);
     setData(rowIndexSecond, value);
		
}

 void TreeProfileModel::SetItem(int rowFirst,int rowSecond,int rowThird,const QString value,QIcon* icon){
 QModelIndex ind = index(rowFirst, 0, QModelIndex());
 QModelIndex indexParent = index(rowSecond, 0, ind);
 int rows = rowCount(indexParent);
     insertRows ( rows ,1,indexParent);
     QModelIndex rowIndexThirdCol0 = index(rowThird, 0, indexParent);
     setData(rowIndexThirdCol0 , value);
     if (icon != 0 ) {
		setData (rowIndexThirdCol0, QVariant(*icon),Qt::DecorationRole);
     }

}

void TreeProfileModel::SetChildItem(int rowFirst,QStringList &list,
          QStringList &listMergeCatalog,QStringList &listAddCatalog,
                  QString &compFile,CatalBaseImpl::ModeAction compModAct){

QModelIndex indexParent = index(rowFirst, 0, QModelIndex());
QStringList listAction = projectActionList().split ('@');
for (int i = 0; i <  list.size(); i++)
{
     QString str = list.at(i);
	 SetChildItem(rowFirst,i,str);
     QIcon ic;
     if (str == listAction.at(0)) ic = QIcon(":/images/magnitude.png");
     if (str == listAction.at(1)) ic = QIcon(":/images/duplicate.png");
     if (str == listAction.at(2)) ic = QIcon(":/images/sample.png");
     if (str == listAction.at(3)) ic = QIcon(":/images/mergecell.png");
     if (str == listAction.at(4)) ic = QIcon(":/images/append.png");
     if (str == projectCompareTitle()) ic = QIcon(":/images/comp.png");
     if (str == projectRangeTitle()) ic = QIcon(":/images/error.png");
     QModelIndex rowIndexSecond = index(i, 0, indexParent);
     QSize size (22,22) ;
     ic.actualSize (size);
     setData (rowIndexSecond, QVariant(ic),Qt::DecorationRole);
	  QIcon iconCat;
          iconCat = QIcon(":/images/catalog.png");
          iconCat.actualSize (QSize(22,22));

          QIcon icnot;
          icnot = QIcon(":/images/notexists.png");
          icnot.actualSize (size);
          QStringList& listRepair = MainWindow::self->GetRepairFileName();
     if (str == listAction.at(3)) 
	 {
	     SetColumns(rowFirst,i); 
	     for (int j = 0; j < listMergeCatalog.size(); ++j) {
//---------------------------------------------------------------
             if (type == ProfileList::Repair) {
                if( listRepair.contains(listMergeCatalog.at(j))) {
                SetItem(rowFirst,i,j,listMergeCatalog.at(j),&icnot);
 QModelIndex ind = index(rowFirst, 0, QModelIndex());
 QModelIndex indexParent = index(i, 0, ind);
 QModelIndex rowIndexThirdCol0 = index(j, 0, indexParent);
                rlist.append(rowIndexThirdCol0);
                } else
                 SetItem(rowFirst,i,j,listMergeCatalog.at(j),&iconCat);
            } else
             SetItem(rowFirst,i,j,listMergeCatalog.at(j),&iconCat);
//---------------------------------------------------------------

	     }
	     parentWindow->expand (rowIndexSecond);
	 }
	 if (str == listAction.at(4)) 
	 {
         SetColumns(rowFirst,i); 
         for (int j = 0; j < listAddCatalog.size(); ++j) 
         {
//---------------------------------------------------------------
             if (type == ProfileList::Repair) {
                if( listRepair.contains(listAddCatalog.at(j))) {
                SetItem(rowFirst,i,j,listAddCatalog.at(j),&icnot);
 QModelIndex ind = index(rowFirst, 0, QModelIndex());
 QModelIndex indexParent = index(i, 0, ind);
 QModelIndex rowIndexThirdCol0 = index(j, 0, indexParent);
                rlist.append(rowIndexThirdCol0);
                } else
                 SetItem(rowFirst,i,j,listAddCatalog.at(j),&iconCat);
            } else
            SetItem(rowFirst,i,j,listAddCatalog.at(j),&iconCat);
//---------------------------------------------------------------
         }
		 parentWindow->expand (rowIndexSecond);
	 }
	 if (str == projectCompareTitle()) 
	 {
		 SetColumns(rowFirst,i);
		 QString tmp = "";
		 if(compModAct == CatalBaseImpl::Intersection)  tmp = "Intersection";
		 if(compModAct == CatalBaseImpl::Difference)    tmp = "Difference";
		 if(compModAct == CatalBaseImpl::Equivalence)   tmp ="Equivalence";
		 if(compModAct == CatalBaseImpl::Nonequivalence) tmp ="Nonequivalence";
//---------------------------------------------------------------
             if (type == ProfileList::Repair) {
                if( listRepair.contains(compFile)) {
                SetItem(rowFirst,i,0,compFile,&icnot);
 QModelIndex ind = index(rowFirst, 0, QModelIndex());
 QModelIndex indexParent = index(i, 0, ind);
 QModelIndex rowIndexThirdCol0 = index(0, 0, indexParent);
                rlist.append(rowIndexThirdCol0);
                } else
                 SetItem(rowFirst,i,0,compFile,&iconCat);
            } else
            SetItem(rowFirst,i,0,compFile,&iconCat);
//---------------------------------------------------------------
                 SetItem(rowFirst,i,1,"mode: " + tmp);	
         	

		 parentWindow->expand (rowIndexSecond);
	 }
}

}
void TreeProfileModel::SetActiveAction(const QString &act){
  QModelIndex indexParent = index(2, 0,QModelIndex());
  bool find = false; 
  numberActiveRow = -1; 
  QModelIndex indexChild = QModelIndex();
  for (int i = 0; i < rowCount(indexParent);++i) {
     indexChild = index(i, 0, indexParent);
     if (data(indexChild).toString() == act )
      {
       numberActiveRow = i; find = true;
       break;
      }
   }
    if (find) setData(indexChild,act);
}
QString TreeProfileModel::GetItemValue(int first,int second,int third){
 QModelIndex indexFirst = index(first, 0, QModelIndex());
 QModelIndex indexSecond = index(second, 0,indexFirst);
 QModelIndex indexThird = index(third, 0, indexSecond);
 return   data(indexThird).toString();
}
QString TreeProfileModel::GetItemValue(int first,int second){
 QModelIndex indexFirst = index(first, 0, QModelIndex());
 QModelIndex indexSecond = index(second, 0,indexFirst);
 return   data(indexSecond).toString();
}
QString TreeProfileModel::GetItemValue(int first){
 QModelIndex indexFirst = index(first, 0, QModelIndex());
 return   data(indexFirst).toString();
}
//-----------------------------------------------------------------------
TreeProfileDelegate::TreeProfileDelegate(QObject *parent)
    : QItemDelegate(parent)
{
		 

executeAction = false;
}
//=========================================================================
QWidget *TreeProfileDelegate::createEditor(QWidget *parent,
    const QStyleOptionViewItem &,
    const QModelIndex & index) const
{

    TreeProfileModel *mod = (TreeProfileModel *)index.model();
    if (mod->type == ProfileList::Normal) return 0;
	
    QList<QModelIndex> list = mod->rlist;
      if( list.indexOf(index) != -1){
       FindFileEditor *editor = new FindFileEditor(index,parent);
       return editor;

   } else return 0;
}
//=========================================================================
void TreeProfileDelegate::setEditorData(QWidget *editor,
                                    const QModelIndex &index) const
{
     QString value = index.model()->data(index, Qt::DisplayRole).toString();
      FindFileEditor *lineEdit = static_cast<FindFileEditor*>(editor);
      lineEdit->GetLineEditor()->setText(value);

}

void TreeProfileDelegate::setModelData(QWidget *editor, QAbstractItemModel *,
                                   const QModelIndex &index) const
{
       TreeProfileModel *mod = (TreeProfileModel *)index.model();
       QString value = "";
       FindFileEditor* lineEdit = static_cast<FindFileEditor *>(editor);    
       value = lineEdit->GetLineEditor()->text();
       mod->setData(index, QVariant(value));

}


//-----------------------------------------------------------------------

void TreeProfileDelegate::paint(QPainter *painter, const QStyleOptionViewItem &opt, const QModelIndex &index) const
{
    QStyleOptionViewItem option = opt;
    option.displayAlignment =  Qt::AlignLeft|Qt::AlignVCenter;
    TreeProfileModel *mod = (TreeProfileModel *)index.model();
    QModelIndex parent  = mod->parent(index);
    if (mod->type == ProfileList::Normal) {
	if(parent != QModelIndex() )
        if(executeAction && mod->data(parent).toString() == "Tasks:"){
	//QMessageBox::warning(0, "",QString ("action %1").arg(mod->data(index).toString()));
         //option.font.setBold(true); 
         option.palette.setColor(QPalette::Text,QColor("blue"));
       }
   }
   if (mod->type == ProfileList::Repair) {
      QStringList& listRepair = MainWindow::self->GetRepairFileName();
      QList<QModelIndex> list = mod->rlist;
          if( list.indexOf(index) != -1) {
          QString str = mod->data(index).toString();
              if( !listRepair.contains(str) )
                  option.palette.setColor(QPalette::Text,QColor("blue"));
          }
  }
    //option.palette.setColor(QPalette::Highlight,QColor(70,120,220)); //QColor(80,132,166)    100,160,180

    QItemDelegate::paint(painter, option, index);

    if (index.column() == 0 || index.column() == 1) {
        painter->drawLine(option.rect.right(), option.rect.y(),
                option.rect.right(), option.rect.bottom());
    }
    painter->drawLine(option.rect.x(), option.rect.bottom(),
            option.rect.right(), option.rect.bottom());
}

//===========================================================================
FindFileEditor::~FindFileEditor() { 
}
FindFileEditor::FindFileEditor(const QModelIndex & index,QWidget *parent)
    : QWidget(parent),index(index)
{
    QHBoxLayout *layout = new QHBoxLayout(this);
    layout->setMargin(0);
    layout->setSpacing(0);
    QString iniVal = index.model()->data(index, Qt::DisplayRole).toString();
    lin = new QLineEdit(this);
    layout->addWidget(lin);
    lin->setBackgroundRole(QPalette::Base);
    lin->setReadOnly(true);
    button = new QPushButton(this);
     QIcon ic;
     ic = QIcon(":/images/open.png");
     QSize size (22,22) ;
     ic.actualSize (size);
    button->setIcon(ic);
    button->setSizePolicy(QSizePolicy(QSizePolicy::Fixed, QSizePolicy::MinimumExpanding));
    button->setFlat ( true );
    button->setBackgroundRole(QPalette::Base);
    button->setFixedWidth(22);
    layout->addWidget(button);

    connect(button, SIGNAL(clicked()), this, SLOT(clickButton()));
    connect(lin, SIGNAL( editingFinished () ),
                      this, SLOT( editFinish() ) );
     openUserToolFileDirectory = MainWindow::self->openUserFileDirectory;

}

void FindFileEditor::editFinish(){
//TreeProfileModel *mod = (TreeProfileModel *)index.model();

}
void FindFileEditor::clickButton()
{
   TreeProfileModel *mod = (TreeProfileModel *)index.model();
   QString fileFilters =    MainWindow::self->GetFileFilters();
   QString fileName = 
        QFileDialog::getOpenFileName(this,"Open an existing catalog file",
		openUserToolFileDirectory, fileFilters);
	if (!fileName.isEmpty()) {
         mod->curOpenFile = fileName;
         lin->setText(fileName);
         mod->setData(index, fileName);
        // mod->rlist.removeAt(mod->rlist.indexOf(index));
         QIcon ic;
         ic = QIcon(":/images/catalog.png");
         QSize size (22,22) ;
         ic.actualSize (size);
         mod->setData (index,QVariant(ic) ,Qt::DecorationRole);
		 openUserToolFileDirectory = QFileInfo(fileName).absolutePath ();
        }
}
//===========================================================================//------------------------------------------------------------------------------------------------
const QString PEFIX_MESSAGE_TEXT = "*** Message page ***\n\n";
const QString POSTFIX_MESSAGE_TEXT = "\n*** End of Message page ***\n\n================================================================\n\n";
const QString PEFIX_CORRECTION_TEXT = "*** Correction page ***\n\n";
const QString POSTFIX_CORRECTION_TEXT = "\n*** End of Correction page ***\n\n";

PreviewImpl::~PreviewImpl(){
if(help !=0) {delete help; help = 0;}
}
PreviewImpl::PreviewImpl(QWidget *parent,FDocument* dc)
    : QDialog(parent),doc(dc)
{

    setupUi(this);
    setFont( parent->font() );
    help = 0;
    connect(buttonOk, SIGNAL(clicked()), this, SLOT(accept()));
    connect(toolButtonSave, SIGNAL(clicked()), this, SLOT(save()));
    connect(buttonHelp, SIGNAL(clicked()), this, SLOT(btnHelp()));
    help = 0;
    QDateTime dt =  QDateTime::currentDateTime ();
    QString tmp = QString("CompiCat program Protocol created on %1\n\n").arg( dt.toString(Qt::ISODate));
    tmp.replace('-','/'); tmp.replace('T',' ');
    textEdit->insertPlainText( tmp);

    QString message     = MainWindow::self->bottomWindow->messageTab->toPlainText();
    QString correction  = MainWindow::self->bottomWindow->correctionTab->toPlainText();

if(!message.isEmpty ()) {
    textEdit->insertPlainText( PEFIX_MESSAGE_TEXT );
    textEdit->insertPlainText(message);
    textEdit->insertPlainText( POSTFIX_MESSAGE_TEXT);
}
if(!correction.isEmpty ()) {
    textEdit->insertPlainText( PEFIX_CORRECTION_TEXT);
    textEdit->insertPlainText(correction);
    textEdit->insertPlainText( POSTFIX_CORRECTION_TEXT);
}

protocolFile = "";

}
void PreviewImpl::accept(){
/*
QString txt = textEdit->toPlainText ();
QString message = txt.section("************", 2, 2);
QString correction = txt.section("************", 6, 6);
qWarning("MESSAGE:\n%s",message.toAscii().data());
qWarning("CORRECTION:\n%s",correction.toAscii().data());
*/
done( Accepted );
}
void PreviewImpl::save(){
    QString fileName =
            QFileDialog::getSaveFileName(this,"Save the protocol file under a new name",
            MainWindow::self->saveUserProtocolDirectory,
            MainWindow::self->GetProtocolFilters());
    if (fileName.isEmpty()) return;

    int ind = fileName.length () - protocolFileFilterLocator().length ()-1; if (ind < 0) ind =0;
    if ( ( fileName.indexOf(protocolFileFilterLocator(),ind)) == -1 && 
         ( fileName.indexOf(protocolFileFilterLocator().toUpper(),ind)) == -1) {
        fileName.append(protocolFileFilterLocator());
        if (QFile::exists(fileName)) {
        int ret = QMessageBox::warning(this, mainWindowCaption(),
                     QString("File %1 already exists.\n Do you want to overwrite it?")
                     .arg(QDir::toNativeSeparators(fileName)),
                     QMessageBox::Yes | QMessageBox::Default,
                     QMessageBox::No | QMessageBox::Escape);
        if (ret == QMessageBox::No)
            return;
       }
    }

    if (!fileName.isEmpty()) {
		MainWindow::self->saveUserProtocolDirectory = QFileInfo(fileName).absolutePath ();
		saveProtocol(fileName);
	}

}
void PreviewImpl::saveProtocol(const QString &fileName){
        QFile file(fileName);
        if (!file.open(QIODevice::WriteOnly | QIODevice::Text))  return;
        QTextStream out(&file);
        out << textEdit->toPlainText ();
        protocolFile = fileName;

}
void PreviewImpl::btnHelp(){
     QString home = searchHelpPath() + "/edcat-protocol.html";
    if(help !=0) {delete help; help =0;}
    help = new HelpWindow(home,this);
    if ( QApplication::desktop()->width() > 400
         && QApplication::desktop()->height() > 500 )
         help->show();
    else
        help->showMaximized();
}
//===========================================================================

