#include <QtGui>
#include "rangelimit.h" 
#include "default.h"
#include "document.h"
#include "mainwindow.h"
#include "subcatalog.h"
#include "viewcatalogimpl.h"
#include "bottomwindow.h"
#include "editline.h"
#include "helpwindow.h"
#include <sstream>
#include <iomanip>
RangeLimitImpl::~RangeLimitImpl(){
foreach (LineDocProperty* prop, propEditLine) {delete prop;prop = 0;}
values.clear();
if(help !=0) {delete help; help =0;}
}
RangeLimitImpl::RangeLimitImpl( QWidget * parent,FDocument* dc,TypeUsing tp)
      : QDialog(0),doc(dc),type(tp)

{ 
    setFont( parent->font() );
	setWindowIcon(QIcon(":/images/icon.png"));
    setupUi(this);
    setWindowTitle(projectRangeTitle());
    help =0;
    setModal (true);
	if (type != Wizard) {
    parentWindow = (CatTable*) parent;
    parentWindow->GetCheckRangeLimits() = true;
	} else parentWindow = 0;
    textLabel->setText("");
	 if (type == Wizard)  textLabel->hide();
    SetDocumentToDialog();
    connect(okButton, SIGNAL(clicked()), this, SLOT(accept()));
    connect(cancelButton, SIGNAL(clicked()), this, SLOT(close()));
    connect(helpButton, SIGNAL(clicked()), this, SLOT(btnHelp()));
    connect(toolButtonReset, SIGNAL(clicked()), this, SLOT(reset()));
    connect(toolButtonProject, SIGNAL(clicked()), this, SLOT(project()));
    connect(toolButtonDefault, SIGNAL(clicked()), this, SLOT(defaults()));
    connect( pushButtonStart, SIGNAL( clicked() ), this, SLOT(CheckRange() ) );
    connect( progressBar, SIGNAL( valueChanged ( int) ), this, SLOT(ProgressBarChanged(int) ) );

    progressBar->setValue(0);
    okButton->setEnabled(FALSE);

      texted = MainWindow::self->bottomWindow->messageTab;

      if (type == Tool){
      toolButtonProject->hide();
      MainWindow::self->bottomWindow->OpenMessagesProtocolPage();
      }
}


void RangeLimitImpl::SetDocumentToDialog(){

   values.append(doc->GetRangeLatitudeMin());
   values.append(doc->GetRangeLatitudeMax());
   values.append(doc->GetRangeLongitudeMin());
   values.append(doc->GetRangeLongitudeMax());
   values.append(doc->GetRangeDepthMin());
   values.append(doc->GetRangeDepthMax());
   values.append(doc->GetRangeMbMin());
   values.append(doc->GetRangeMbMax());
   values.append(doc->GetRangeMsMin());
   values.append(doc->GetRangeMsMax());
   values.append(doc->GetRangeMlMin());
   values.append(doc->GetRangeMlMax());
   values.append(doc->GetRangeMpMin());
   values.append(doc->GetRangeMpMax());

   propEditLine.append(new LineDocProperty(lineEditLatMin,doc->GetRangeLatitudeMin()));

   propEditLine.append(new LineDocProperty(lineEditLatMax,doc->GetRangeLatitudeMax()));

   propEditLine.append(new LineDocProperty(lineEditLonMin,doc->GetRangeLongitudeMin()));

   propEditLine.append(new LineDocProperty(lineEditLonMax,doc->GetRangeLongitudeMax()));

   propEditLine.append(new LineDocProperty(lineEditDepMin,doc->GetRangeDepthMin()));

   propEditLine.append(new LineDocProperty(lineEditDepMax,doc->GetRangeDepthMax()));

   propEditLine.append(new LineDocProperty(lineEditMbMin,doc->GetRangeMbMin()));

   propEditLine.append(new LineDocProperty(lineEditMbMax,doc->GetRangeMbMax()));

   propEditLine.append(new LineDocProperty(lineEditMsMin,doc->GetRangeMsMin()));

   propEditLine.append(new LineDocProperty(lineEditMsMax,doc->GetRangeMsMax()));

   propEditLine.append(new LineDocProperty(lineEditMlMin,doc->GetRangeMlMin()));

   propEditLine.append(new LineDocProperty(lineEditMlMax,doc->GetRangeMlMax()));

   propEditLine.append(new LineDocProperty(lineEditMpMin,doc->GetRangeMpMin()));

   propEditLine.append(new LineDocProperty(lineEditMpMax,doc->GetRangeMpMax()));

   foreach (LineDocProperty *docprop, propEditLine) docprop->SetValueFromDoc();


}
bool RangeLimitImpl::CheckDialogBoxes(){

SubCatalogImpl dlg(this);
dlg.setFont( font() );
float min = lineEditLatMin->text().toFloat();
float max = lineEditLatMax->text().toFloat();

if(!dlg.CheckQLineEdit(lineEditLatMin,min,max,"Latitude: ")) return false;

min = lineEditLonMin->text().toFloat();
max = lineEditLonMax->text().toFloat();
if(!dlg.CheckQLineEdit(lineEditLonMin,min,max,"Longitude: ")) return false;

min = lineEditDepMin->text().toFloat();
max = lineEditDepMax->text().toFloat();
if(!dlg.CheckQLineEdit(lineEditDepMin,min,max,"Depth: ")) return false;

min = lineEditMbMin->text().toFloat();
max = lineEditMbMax->text().toFloat();
if(!dlg.CheckQLineEdit(lineEditMbMin,min,max,"M1: ")) return false;

min = lineEditMsMin->text().toFloat();
max = lineEditMsMax->text().toFloat();
if(!dlg.CheckQLineEdit(lineEditMsMin,min,max,"M2: ")) return false;

min = lineEditMlMin->text().toFloat();
max = lineEditMlMax->text().toFloat();
if(!dlg.CheckQLineEdit(lineEditMlMin,min,max,"M3: ")) return false;

min = lineEditMpMin->text().toFloat();
max = lineEditMpMax->text().toFloat();
if(!dlg.CheckQLineEdit(lineEditMpMin,min,max,"M4: ")) return false;


return true;
}
void RangeLimitImpl::GetDocumentFromDialog(){

doc->GetRangeLatitudeMin()->SetValue(lineEditLatMin->text());
doc->GetRangeLatitudeMax()->SetValue(lineEditLatMax->text());

doc->GetRangeLongitudeMin()->SetValue(lineEditLonMin->text());
doc->GetRangeLongitudeMax()->SetValue(lineEditLonMax->text());

doc->GetRangeDepthMin()->SetValue(lineEditDepMin->text());
doc->GetRangeDepthMax()->SetValue(lineEditDepMax->text());

doc->GetRangeMbMin()->SetValue(lineEditMbMin->text());
doc->GetRangeMbMax()->SetValue(lineEditMbMax->text());

doc->GetRangeMsMin()->SetValue(lineEditMsMin->text());
doc->GetRangeMsMax()->SetValue(lineEditMsMax->text());

doc->GetRangeMlMin()->SetValue(lineEditMlMin->text());
doc->GetRangeMlMax()->SetValue(lineEditMlMax->text());

doc->GetRangeMpMin()->SetValue(lineEditMpMin->text());
doc->GetRangeMpMax()->SetValue(lineEditMpMax->text());

      Catalog cat;
      if (type == Tool) message += cat.GetCatalogInfoMessage(MainWindow::self->GetCurrentCatalogName());
      if (type == Execute) message += cat.GetCatalogShortInfoMessage(MainWindow::self->GetOpenBinaryFileName());

   message += "Range thresholds:\n\n";
   ostringstream  os;
   float min = lineEditLatMin->text().toFloat();
   float max = lineEditLatMax->text().toFloat();
   ios::fmtflags oldFlags = os.flags();

          os.setf(ios::right, ios::adjustfield);
          os.setf(std::ios::showpoint | std::ios::fixed);

          os  << "[ " << std::setw(7)  << std::setprecision(3) << min << " , " <<
                         std::setw(7)  << std::setprecision(3) << max  << " ] ...................  ";

          os.setf(ios::left, ios::adjustfield);
          os  << std::setw(10) << std::setfill(' ') << "Latitude;" << endl;

   min = lineEditLonMin->text().toFloat();
   max = lineEditLonMax->text().toFloat();

          os.flags(oldFlags);
          os.setf(ios::right, ios::adjustfield);
          os.setf( std::ios::showpoint | std::ios::fixed);

          os  << "[ " << std::setw(8) <<  std::setprecision(3) << min << " , " <<
                         std::setw(8) <<  std::setprecision(3) << max  << " ] ...............  ";

          os.setf(ios::left, ios::adjustfield);
          os  << std::setw(10) << std::setfill(' ') << "Longitude;" << endl;



   min = lineEditDepMin->text().toFloat();
   max = lineEditDepMax->text().toFloat();

          os.flags(oldFlags);
          os.setf(ios::right, ios::adjustfield);
          os.setf( std::ios::showpoint | std::ios::fixed);

          os  << "[ " << std::setw(6) <<  std::setprecision(1) << min << " , " <<
                         std::setw(6) <<  std::setprecision(1) << max  << " ] ......................  ";

          os.setf(ios::left, ios::adjustfield);
          os  << std::setw(10) << std::setfill(' ') << "Depth;" << endl;


   min = lineEditMbMin->text().toFloat();
   max = lineEditMbMax->text().toFloat();

          os.flags(oldFlags);
          os.setf(ios::right, ios::adjustfield);
          os.setf( std::ios::showpoint | std::ios::fixed);

          os  << "[ " << std::setw(4) <<  std::setprecision(2) << min << " , " <<
                         std::setw(4) <<  std::setprecision(2) << max  << " ] ............................  ";

          os.setf(ios::left, ios::adjustfield);
          os  << std::setw(10) << std::setfill(' ') << "M1;" << endl;

   min = lineEditMsMin->text().toFloat();
   max = lineEditMsMax->text().toFloat();

          os.flags(oldFlags);
          os.setf(ios::right, ios::adjustfield);
          os.setf( std::ios::showpoint | std::ios::fixed);

          os  << "[ " << std::setw(4) <<  std::setprecision(2) << min << " , " <<
                         std::setw(4) <<  std::setprecision(2) << max  << " ] ............................  ";

          os.setf(ios::left, ios::adjustfield);
          os  << std::setw(10) << std::setfill(' ') << "M2;" << endl;


   min = lineEditMlMin->text().toFloat();
   max = lineEditMlMax->text().toFloat();

          os.flags(oldFlags);
          os.setf(ios::right, ios::adjustfield);
          os.setf( std::ios::showpoint | std::ios::fixed);

          os  << "[ " << std::setw(4) <<  std::setprecision(2) << min << " , " <<
                         std::setw(4) <<  std::setprecision(2) << max  << " ] ............................  ";

          os.setf(ios::left, ios::adjustfield);
          os  << std::setw(10) << std::setfill(' ') << "M3;" << endl;

   min = lineEditMpMin->text().toFloat();
   max = lineEditMpMax->text().toFloat();

          os.flags(oldFlags);
          os.setf(ios::right, ios::adjustfield);
          os.setf( std::ios::showpoint | std::ios::fixed);

          os  << "[ " << std::setw(4) <<  std::setprecision(2) << min << " , " <<
                         std::setw(4) <<  std::setprecision(2) << max  << " ] ............................  ";

          os.setf(ios::left, ios::adjustfield);
          os  << std::setw(10) << std::setfill(' ') << "M4;" << endl;


         message += QString("%1").arg(os.str().c_str());


}
bool RangeLimitImpl::execute(){
bool ret = applay();
if (numRecErr > 0) parentWindow->SetErrorRange(true);
parentWindow->RestoreIndex();
done( Accepted );
return ret;
}

void RangeLimitImpl::accept()
{
if (numRecErr > 0)  parentWindow->SetErrorRange(true);
parentWindow->RestoreIndex();
foreach (PropertyValue* val, values) val->SetValueToResetvalue();
MainWindow::self->modifiedCatalog = true;
MainWindow::self->modifiedProtocol = true;
  if (type == Tool) {
      texted->ensureCursorVisible ();
  }
		MainWindow::self->rangePos   =  pos();
		MainWindow::self->rangeSize  =  size();
   MainWindow::self->RestoreStatusbarMessage();
   done( Accepted );
}
void RangeLimitImpl::reject()
{
return;
}
void RangeLimitImpl::closeEvent(QCloseEvent *event)
{
// like as reject
    foreach (PropertyValue* val, values) val->SetResetvalueToValue();
    texted->insertPlainText(cancelMessage() + "\n");
		MainWindow::self->rangePos   =  pos();
		MainWindow::self->rangeSize  =  size();
    MainWindow::self->RestoreStatusbarMessage();
    event->accept();
}
void RangeLimitImpl::btnHelp(){
    QString home = searchHelpPath() + "/edcat-tool-range.html";
    if(help !=0) {delete help; help =0;}
    help = new HelpWindow(home,this);
    if ( QApplication::desktop()->width() > 400
         && QApplication::desktop()->height() > 500 )
         help->show();
    else
        help->showMaximized();
}
void RangeLimitImpl::reset(){
foreach (PropertyValue* val, values) val->SetResetvalueToValue();
foreach (LineDocProperty *docprop, propEditLine) docprop->SetValueFromDoc();
}
void RangeLimitImpl::project(){
foreach (PropertyValue* val, values) val->SetInitial();
foreach (LineDocProperty *docprop, propEditLine) docprop->SetValueFromDoc();
}
void RangeLimitImpl::defaults(){
foreach (PropertyValue* val, values) val->SetDefault();
foreach (LineDocProperty *docprop, propEditLine) docprop->SetValueFromDoc();
}

bool  RangeLimitImpl::NextOk(){
if (!CheckDialogBoxes()) return false;
      MainWindow::self->bottomWindow->OpenMessagesProtocolPage();
      texted->insertPlainText(prefixMessage() + projectRangeTitle() + " ***\n\n");
  message = "";
  GetDocumentFromDialog();
  if (type == Tool || type == Wizard) {
  QString tmp = QString("Do you want to execute %1?\n\n").arg(projectRangeTitle());
       int ret = QMessageBox::warning(0,windowTitle (),tmp + message,
                     QMessageBox::Yes | QMessageBox::Default,
                     QMessageBox::No | QMessageBox::Escape);
        if (ret == QMessageBox::No) return false;
  }
return true;
}
void  RangeLimitImpl::FinishOk(){
	message = "";
	texted->insertPlainText(prefixMessage() + projectRangeTitle() + " ***\n\n");
	GetDocumentFromDialog();
	foreach (PropertyValue* val, values) val->SetValueToResetvalue();
	texted->insertPlainText(message);
	texted->insertPlainText(postfixActionMessage() + ": " + projectRangeTitle() + " ***\n\n");
}


bool RangeLimitImpl::applay(){
if (type == Tool) if (!CheckDialogBoxes()) return false;
     QString tmp;
     if (type == Tool){
      MainWindow::self->bottomWindow->OpenMessagesProtocolPage();
      texted->insertPlainText(prefixMessage() + projectRangeTitle() + " ***\n\n");
      }
  message = "";
  GetDocumentFromDialog();
  if (type == Tool || type == Wizard) {
  QString tmp = QString("Do you want to execute %1?\n\n").arg(projectRangeTitle());
       int ret = QMessageBox::warning(0,windowTitle (),tmp + message,
                     QMessageBox::Yes | QMessageBox::Default,
                     QMessageBox::No | QMessageBox::Escape);
        if (ret == QMessageBox::No) return false;
  }
  repaint();
  QApplication::setOverrideCursor(Qt::WaitCursor);
  RECORD record;
  int catSize;
  int numRec = 0;
  numRecErr = 0;
  int numErr = 0;
  QString    name = MainWindow::self->GetOpenBinaryFileName();
  in =  parentWindow->GetFstream();
  in->clear();
  in->seekg(0,ios::beg);
  in->read((char*)&catSize,sizeof(int));
  in->seekg(sizeof(RECORD),ios::beg);

  progressBar->setValue(1);
  progressBar->setRange(1,catSize);
    while(in->read((char*)&record,sizeof(RECORD ))){

	    if(in->fail()){QApplication::restoreOverrideCursor();error(QString("An reading error has occurred"),name);return false;}
            QStringList err = parentWindow->CheckErrorRecord(record,numRec+1);
            if (!err. isEmpty ()){ numErr += err.size();numRecErr++;}
            if ((numRec/100)*100 == numRec ) progressBar->setValue(numRec);
            numRec++;
    }
  in->clear();
  progressBar->setValue(catSize);
  tmp = "";
 if (numRecErr == 0) tmp  += "Records out of range have not been found\n";
  if (numRecErr > 0)
     tmp = QString("%1 values of parameters out of range\n have been found in %2 records. \n")
           .arg(numErr).arg(numRecErr);
  tmp +=   QString("In total %1 records have been checked.\n").arg(numRec);
  textLabel->setText(tmp);
  QApplication::restoreOverrideCursor();
  okButton->setEnabled(TRUE);
  texted->insertPlainText(message);
  tmp += "\n";
  texted->insertPlainText(tmp);
  texted->insertPlainText(postfixActionMessage() + projectRangeTitle() + " ***\n\n");
return true;
}
void RangeLimitImpl::CheckRange(){
if (!applay()) return;
}

void RangeLimitImpl::ProgressBarChanged(int value){
if (value > 1) {
 textLabel->setText(tr("Record: %1").arg(value));
 textLabel->repaint ();
}
}
