#ifndef _RANGE_LIMIT_IMPL_H
#define _RANGE_LIMIT_IMPL_H
#include "ui_rangelimit.h"
#include <fstream>
#include <map>
#include <vector>
using namespace std;
class QWidget;
class QTextEdit;
class FDocument;
class CatTable;
class LineDocProperty;
class PropertyValue;
class SubCatalogImpl;
class HelpWindow;
class RangeLimitImpl : public QDialog, private Ui::DialogLimitsBase
{
    Q_OBJECT
public:
   enum TypeUsing
    {
        Tool,
        Wizard,
        Execute
    };
 
    TypeUsing GetTypeUsing() {return type;}

    RangeLimitImpl(QWidget *parent,FDocument* dc,TypeUsing type); 
    ~RangeLimitImpl();
    bool NextOk();
    void FinishOk();
    bool execute();
    bool applay();
    fstream* in;
protected:
    void closeEvent(QCloseEvent *event); 
public slots:
protected slots:
    void accept();
    void reject();
    void btnHelp();
    void reset();
    void project();
    void defaults();
    void CheckRange();
    void ProgressBarChanged(int value);
private:
    void SetDocumentToDialog();
    void GetDocumentFromDialog();
    bool CheckDialogBoxes();
    FDocument* doc;
    TypeUsing type;
    CatTable* parentWindow;
    QList<LineDocProperty* > propEditLine;
    QList<PropertyValue* > values;
    int numRecErr;
    QTextEdit* texted;
    QString message;
    HelpWindow* help;
friend class SubCatalogImpl;

};
#endif
