#include <QtGui>
#include "mainwindow.h"
#include "repairpro.h" 
#include "profile.h" 
#include "default.h"
RepairPro::RepairPro(QWidget *parent,FDocument* dc,const QString& proFile)
      : QDialog(0),doc(dc)

{ 
    setFont( parent->font() );
	setWindowIcon(QIcon(":/images/icon.png"));
    setupUi(this);
    cancelButton->setFocus ();
    setModal(true);
    setWindowTitle("Repair Project Dialog");
    gridLayout->removeWidget(treeWidget);
    treeWidget->hide();
    prolist = new ProfileList(doc,"No Project",this,ProfileList::Repair);
    //QString proFile = MainWindow::self->GetCurrentProjectName();
    prolist->SetRowList(doc,proFile);
    gridLayout->addWidget(prolist, 0, 0, 1, 1);
    connect(cancelButton, SIGNAL(clicked()), this, SLOT(close()));
    connect(okButton, SIGNAL(clicked()), this, SLOT(accept()));
    connect(helpButton, SIGNAL(clicked()), this, SLOT(btnHelp()));


    resize(MainWindow::self->repairProjectSize);
    move(MainWindow::self->repairProjectPos);

}
//----------------------------------------------------------------------
void RepairPro::closeEvent(QCloseEvent *event)
{
    MainWindow::self->repairProjectPos   =  pos();
    MainWindow::self->repairProjectSize  =  size();
    event->accept();
}
//----------------------------------------------------------------------
void RepairPro::reject()
{
return;
}
//----------------------------------------------------------------------
void RepairPro::btnHelp()
{

}
//----------------------------------------------------------------------
bool RepairPro::CheckExistingCatalogFiles(){
TreeProfileModel* model = prolist->GetListWidget()->GetModel();
QStringList& listRepair = MainWindow::self->GetRepairFileName();
bool findNotExistingCatalog = false;

QString tmp = "Can't find following catalogs:\n";

QString proCatalog = model->GetItemValue(1,0);
  if( listRepair.contains(proCatalog) ) {
    findNotExistingCatalog = true;
    tmp += "Input project catalog:\n     ";
    tmp += proCatalog + "\n";
  }

//QString actions = model->GetItemValue(2);
//tmp += actions + "\n";

QModelIndex indexAct = model->index(2, 0, QModelIndex());
int childCount = model->rowCount(indexAct);
QString mergeAct = projectActionList().split ('@').at(3);
QString substAct = projectActionList().split ('@').at(4);
QString compAct = projectCompareTitle();
  for (int i = 0; i < childCount; ++i){
    QModelIndex indexActChild = model->index(i, 0, indexAct);
    QString actItemValue = model->GetItemValue(2,i);
   // tmp += actItemValue + "\n";
    if (actItemValue == mergeAct ) {
      int fileCount = model->rowCount(indexActChild);
      //QModelIndex indexMerge = model->index(2, i, indexAct);
     // tmp += QString("fileCount %1").arg(fileCount) + "\n";
      QString tmp1 = "";
      for(int j = 0; j < fileCount; ++j){
           QString fileItemValue = model->GetItemValue(2,i,j);
           if( listRepair.contains(fileItemValue) ) 
              tmp1 += "     " + fileItemValue + "\n";
      }
      if (tmp1 != "") {
             findNotExistingCatalog = true;
             tmp += actItemValue +":\n";
             tmp += tmp1;
      }
    }

    if ( actItemValue == substAct ) {
      int fileCount = model->rowCount(indexActChild);
      //QModelIndex indexMerge = model->index(2, i, indexAct);
    //  tmp += QString("fileCount %1").arg(fileCount) + "\n";
      QString tmp1 = "";
      for(int j = 0; j < fileCount; ++j){
           QString fileItemValue = model->GetItemValue(2,i,j);
           if( listRepair.contains(fileItemValue) ) 
              tmp1 += "     " + fileItemValue + "\n";
      }
      if (tmp1 != "") {
             findNotExistingCatalog = true;
             tmp += actItemValue +":\n";
             tmp += tmp1;
      }
    }
    if (actItemValue == compAct  ) {
           QString fileItemValue = model->GetItemValue(2,i,0);
           if( listRepair.contains(fileItemValue) ) {
             findNotExistingCatalog = true;
             tmp += actItemValue +":\n     ";
             tmp += fileItemValue + "\n";
           }
      }
}
if( findNotExistingCatalog ) {
QMessageBox::critical(0,"",tmp);
return false;
}
return true;
}
//----------------------------------------------------------------------
void RepairPro::RepairProjectFile(){
TreeProfileModel* model = prolist->GetListWidget()->GetModel();
QString proCatalog = model->GetItemValue(1,0);
//QMessageBox::critical(0,"",QString("RepairPro::RepairProjectFile\n%1").arg(proCatalog));
doc->GetProjectCatalogName()->SetValue(proCatalog);

QModelIndex indexAct = model->index(2, 0, QModelIndex());
int childCount = model->rowCount(indexAct);
QString mergeAct = projectActionList().split ('@').at(3);
QString substAct = projectActionList().split ('@').at(4);
QString compAct = projectCompareTitle();
  for (int i = 0; i < childCount; ++i){
    QModelIndex indexActChild = model->index(i, 0, indexAct);
    QString actItemValue = model->GetItemValue(2,i);
    if (actItemValue == mergeAct ) {
      int fileCount = model->rowCount(indexActChild);
      QStringList listMergeCatalog;
      for(int j = 0; j < fileCount; ++j){
           QString fileItemValue = model->GetItemValue(2,i,j);
           listMergeCatalog.append(fileItemValue);
      }
       doc->GetListMergeCatalog()->SetListToValue(listMergeCatalog);
    }

    if ( actItemValue == substAct ) {
      int fileCount = model->rowCount(indexActChild);
      QStringList listAddCatalog;
      for(int j = 0; j < fileCount; ++j){
           QString fileItemValue = model->GetItemValue(2,i,j);
           listAddCatalog.append(fileItemValue);
      }
       doc->GetListAddCatalog()->SetListToValue(listAddCatalog);
    }
    if (actItemValue == compAct  ) {
           QString fileItemValue = model->GetItemValue(2,i,0);
           doc->GetSecondCatalogName()->SetValue(fileItemValue);
           }
    }
}

//----------------------------------------------------------------------
void RepairPro::accept(){
prolist->closeOpenedEditor();
if (!CheckExistingCatalogFiles() ) return;
RepairProjectFile();
    MainWindow::self->repairProjectPos   =  pos();
    MainWindow::self->repairProjectSize  =  size();
    done( Accepted );
}
//----------------------------------------------------------------------





