#ifndef _SETTING_PARAMETERS_IMPLEMENTATION_H
#define _SETTING_PARAMETERS_IMPLEMENTATION_H
#include "ui_propertylist.h"
#include <QTreeView>

class QWidget;
class SettingImpl;
class TreePropertyModel;
class TreePropertyDelegate;
class PropertyValue;
class SettingDocument;
class HelpWindow;
class SettingProperty : public QTreeView
{
    Q_OBJECT
public:
    SettingProperty(SettingDocument* doc,int numCol,QWidget* parent = 0, const char *name = 0);
    ~SettingProperty();
    void  GetDataFromTreeView();
    void  PrintValues();
    bool CheckValidValue(QModelIndex &index);
    void  OpenEditor(QModelIndex &index);
    TreePropertyModel* GetModel() {return model;}
    TreePropertyDelegate * GetDelegate(){return delegate;}
public slots:
   void clickedRowCol(QModelIndex  );
protected:
 void drawBranches(QPainter *painter, const QRect &rect, const QModelIndex &index) const;
protected slots:

    void Default();
    void Reset();
    void Initial();

private:
SettingDocument* doc;
SettingImpl* parentWindow;
TreePropertyModel* model;
TreePropertyDelegate *delegate;
QModelIndex edIndex;
QModelIndex indexOpenEditor;
QList<PropertyValue *> ipList;
};
class SettingImpl : public QDialog, private Ui::SettingBase
{
    Q_OBJECT
public:
    SettingImpl(SettingDocument* doc,QWidget* parent = 0);
    ~SettingImpl();
    SettingProperty* list;
    QPushButton *GetButtonHelp()    {return buttonHelp;}
    QPushButton *GetButtonOk()      {return buttonOk;}
    QPushButton *GetButtonCancel()  {return buttonCancel;}
    QToolButton *GetButtonDefault() {return toolButtonDefault;}

    QToolButton *GetButtonReset()   {return toolButtonReset;}
    QToolButton *GetButtonInitial() {return toolButtonInitial;}
    bool modifed;
protected:
    void closeEvent(QCloseEvent *event);
public slots:
protected slots:
    void accept();
    void reject();
    void Help(); 
private:
void RejectCloseImpl();
SettingDocument* doc;
HelpWindow* help;
};

#endif


