#include <QtGui>
#include "mainwindow.h"
#include "subcatalog.h"
#include "viewcatalogimpl.h"
#include "bottomwindow.h"
#include "polygon.h" 
#include "default.h"
#include "editline.h"
#include "helpwindow.h"
SubCatalogImpl::~SubCatalogImpl(){
if(!checkBoxes.empty()) checkBoxes.clear();

if(!comboBoxes.empty()) comboBoxes.clear();

if(!transFunc.empty()) transFunc.clear();

if(!ptrFunct.empty()) ptrFunct.clear();

if(!propDocLine.empty()) {
foreach (LineDocProperty* prop, propDocLine) {delete prop;prop = 0;}
propDocLine.clear();
}

if (polygon != 0) {delete polygon; polygon = 0;}

if(!EditLineValues.empty()) {
for_each(EditLineValues.begin(),EditLineValues.end(),delAndNullify);
EditLineValues.erase(remove(EditLineValues.begin(),EditLineValues.end(),
static_cast<PropertyValue*>(0)),EditLineValues.end());
}

if(!values.empty())  values.clear();
if(help !=0) {delete help; help = 0;}
}

SubCatalogImpl::SubCatalogImpl(QWidget *) : QDialog(0)
{
    setupUi(this);
    polygon = 0;
    help = 0;
}
SubCatalogImpl::SubCatalogImpl(QWidget *parent,FDocument* dc,TypeUsing tp)
    : QDialog(0),doc(dc),type(tp)
{
    setFont( parent->font() );
	setWindowIcon(QIcon(":/images/icon.png"));
    setupUi(this);   
    setModal (true);
    setWindowTitle(projectActionList().split ('@').at(2));
	if (type != Wizard)
    parentWindow = (CatTable*) parent;
	else parentWindow = 0;
    eps = acuracyCompareFloatValue();
    polygon = 0;
    help = 0;
    firstStart = true;
checkBoxes.append(checkBoxRecord);
checkBoxes.append(checkBoxHipocenter);
checkBoxes.append(checkBoxDepth);
checkBoxes.append(checkBoxMagnitude);
checkBoxes.append(checkBoxIntencity);

     comboBoxMagFunction->clear();
     QStringList lst = doc->GetSampleMagFunction()->GetStringList();
     for (int i = 0; i < lst.size(); i++) comboBoxMagFunction->addItem(lst.at(i));

     lst = enumComboBoxMagnitudeList().split ('@');
     comboBoxes.append(comboBoxM1);   comboBoxes.append(comboBoxM2);
     comboBoxes.append(comboBoxM3);   comboBoxes.append(comboBoxM4);
     foreach (QComboBox * box, comboBoxes) box->clear();

     for (int i = 0; i < lst.size(); i++)
     foreach (QComboBox * box, comboBoxes) box->addItem(lst.at(i));
	 


//--------------------------------------------------------------------------------------------------------

values.append(doc->GetSampleRecordIs ());
values.append(doc->GetSampleRecordType ());
values.append(doc->GetSampleRecordDateMin ());
values.append(doc->GetSampleRecordDateMax ());
values.append(doc->GetSampleRecordNumberMin ());
values.append(doc->GetSampleRecordNumberMax ());
values.append(doc->GetSampleHipoIs ());
values.append(doc->GetSampleHipoType ());
values.append(doc->GetSampleHipoRectLatitudeMin ());
values.append(doc->GetSampleHipoRectLatitudeMax ());
values.append(doc->GetSampleHipoRectLongitudeMin ());
values.append(doc->GetSampleHipoRectLongitudeMax ());
values.append(doc->GetSampleHipoRectMinus180 ());
values.append(doc->GetSampleHipoPolygonMinus180 ());
values.append(doc->GetSampleHipoCircleLatitude ());
values.append(doc->GetSampleHipoCircleLongitude ());
values.append(doc->GetSampleHipoCircleRadius ());
values.append(doc->GetSampleHipoPolygonVertice());
values.append(doc->GetSampleListLatitude());
values.append(doc->GetSampleListLongitude());
values.append(doc->GetSampleDepthIs ());
values.append(doc->GetSampleDepthMin ());
values.append(doc->GetSampleDepthMax ());
values.append(doc->GetSampleMbIs ());
values.append(doc->GetSampleMbMin ());
values.append(doc->GetSampleMbMax ());
values.append(doc->GetSampleMsIs ());
values.append(doc->GetSampleMsMin ());
values.append(doc->GetSampleMsMax ());
values.append(doc->GetSampleMlIs ());
values.append(doc->GetSampleMlMin ());
values.append(doc->GetSampleMlMax ());
values.append(doc->GetSampleMpIs ());
values.append(doc->GetSampleMpMin ());
values.append(doc->GetSampleMpMax ());
values.append(doc->GetSampleIntensityIs ());
values.append(doc->GetSampleIntensityMin ());
values.append(doc->GetSampleIntensityMax ());
values.append(doc->GetSampleMagnitudeIs ());
values.append(doc->GetSampleMagnitudeType ());
values.append(doc->GetSampleMagFunctionMin ());
values.append(doc->GetSampleMagFunctionMax ());
values.append(doc->GetSampleMagFunction ());

first  = doc->GetSampleMagFunctionFirstMagnitude();   transFunc.append(first);
second = doc->GetSampleMagFunctionSecondMagnitude();  transFunc.append(second);
third  = doc->GetSampleMagFunctionThirdMagnitude();   transFunc.append(third);
fourth = doc->GetSampleMagFunctionFourthMagnitude();  transFunc.append(fourth);
values.append(first);values.append(second);values.append(third);values.append(fourth);

//--------------------------------------------------------------------------------------------------------
     texted = MainWindow::self->bottomWindow->messageTab;

    if (type == Tool)  toolButtonProject->hide();
    connect(okButton, SIGNAL(clicked()), this, SLOT(accept()));
    connect(cancelButton, SIGNAL(clicked()), this, SLOT(close()));
    connect(toolButtonDefault, SIGNAL(clicked()), this, SLOT(buttonDefault()));
    connect(helpButton, SIGNAL(clicked()), this, SLOT(buttonHelp()));
    connect(pushButtonApplay, SIGNAL(clicked()), this, SLOT(start()));
    connect(toolButtonSetPolygon, SIGNAL(clicked()), this, SLOT(vertices()));
    connect(toolButtonReset,     SIGNAL(clicked()),   this, SLOT(reset()));
    connect(toolButtonProject,   SIGNAL(clicked()),   this, SLOT(project()));
    connect(toolButtonDefault,   SIGNAL(clicked()),   this, SLOT(defaults()));
    connect( progressBar, SIGNAL( valueChanged ( int) ), this, SLOT(ProgressBarChanged(int) ) );
//tabWidget->removeTab(0);

    okButton->setEnabled (FALSE);
    InitLineDocProperty();

    GetDialogFromDocument();

    timer = startTimer( 500 );
    textLabel->setText("");
    DuplicateProgress(0);
    indexCat =  0;
	tabWidget->setCurrentIndex(0);
	if (type == Wizard)  textLabel->hide();
}
void SubCatalogImpl::DuplicateProgress(int progress){
    progressBar->setValue(progress);
}


void SubCatalogImpl::timerEvent(QTimerEvent *)
{
 // if ( e->timerId() != timer) return;
 // if (!checkBoxRecord->isOn()) {
 // groupBoxDateTime->setEnabled (FALSE);
 // groupBoxNumber->setEnabled (FALSE);
 // }  else {
        if (radioButtonRecordDate->isChecked())  {
           groupBoxDateTime->setEnabled (TRUE);
           groupBoxNumber->setEnabled (FALSE);
        }  else {
           groupBoxDateTime->setEnabled (FALSE);
           groupBoxNumber->setEnabled (TRUE);
        }
 // }

//  if (!checkBoxHipocenter->isOn()) {
//  groupBoxRectangle->setEnabled (FALSE);
//  groupBoxCircle->setEnabled (FALSE);
//  labelPolygon->setEnabled (FALSE);
//  spinBoxPolygon->setEnabled (FALSE);
//  toolButtonSetPolygon->setEnabled (FALSE);

 // }  else {
        if (radioButtonRectangle->isChecked())  {
        groupBoxRectangle->setEnabled (TRUE);
        groupBoxCircle->setEnabled (FALSE);
        labelPolygon->setEnabled (FALSE);
        spinBoxPolygon->setEnabled (FALSE);
        toolButtonSetPolygon->setEnabled (FALSE);
        }  
        if (radioButtonCircle->isChecked())  {
        groupBoxRectangle->setEnabled (FALSE);
        groupBoxCircle->setEnabled (TRUE);
        labelPolygon->setEnabled (FALSE);
        spinBoxPolygon->setEnabled (FALSE);
        toolButtonSetPolygon->setEnabled (FALSE);
        }
        if (radioButtonPolygon->isChecked())  {
        groupBoxRectangle->setEnabled (FALSE);
        groupBoxCircle->setEnabled (FALSE);
        labelPolygon->setEnabled (TRUE);
        spinBoxPolygon->setEnabled (TRUE);
        toolButtonSetPolygon->setEnabled (TRUE);
        }
 // }

  if (radioButtonMagInterval->isChecked()) {
    groupBoxMagInterval->setEnabled (TRUE);
    groupBoxMagnitudeFunction->setEnabled (FALSE);
  }  else {
    groupBoxMagInterval->setEnabled (FALSE);
    groupBoxMagnitudeFunction->setEnabled (TRUE);
  }
/*
  if (!checkBoxDepth->isOn()) {
   labelDepth->setEnabled (FALSE);
   lineEditDepthMin->setEnabled (FALSE);
   labelDepthM->setEnabled (FALSE);
   lineEditDepthMax->setEnabled (FALSE);
   labelDepthR->setEnabled (FALSE);
  }  else {
   labelDepth->setEnabled (TRUE);
   lineEditDepthMin->setEnabled (TRUE);
   labelDepthM->setEnabled (TRUE);
   lineEditDepthMax->setEnabled (TRUE);
   labelDepthR->setEnabled (TRUE);
  }

  if (!checkBoxMb->isOn()) {
     labelMb->setEnabled (FALSE);
     lineEditMbMin->setEnabled (FALSE);
     labelMbM->setEnabled (FALSE);
     lineEditMbMax->setEnabled (FALSE);
     labelMbR->setEnabled (FALSE);
  }  else {
     labelMb->setEnabled (TRUE);
     lineEditMbMin->setEnabled (TRUE);
     labelMbM->setEnabled (TRUE);
     lineEditMbMax->setEnabled (TRUE);
     labelMbR->setEnabled (TRUE);
  }
  if (!checkBoxMs->isOn()) {
     labelMs->setEnabled (FALSE);
     lineEditMsMin->setEnabled (FALSE);
     labelMsM->setEnabled (FALSE);
     lineEditMsMax->setEnabled (FALSE);
     labelMsR->setEnabled (FALSE);
  }  else {
     labelMs->setEnabled (TRUE);
     lineEditMsMin->setEnabled (TRUE);
     labelMsM->setEnabled (TRUE);
     lineEditMsMax->setEnabled (TRUE);
     labelMsR->setEnabled (TRUE);
  }
  if (!checkBoxMl->isOn()) {
     labelMl->setEnabled (FALSE);
     lineEditMlMin->setEnabled (FALSE);
     labelMlM->setEnabled (FALSE);
     lineEditMlMax->setEnabled (FALSE);
     labelMlR->setEnabled (FALSE);
  }  else {
     labelMl->setEnabled (TRUE);
     lineEditMlMin->setEnabled (TRUE);
     labelMlM->setEnabled (TRUE);
     lineEditMlMax->setEnabled (TRUE);
     labelMlR->setEnabled (TRUE);
  }

  if (!checkBoxMp->isOn()) {
     labelMp->setEnabled (FALSE);
     lineEditMpMin->setEnabled (FALSE);
     labelMpM->setEnabled (FALSE);
     lineEditMpMax->setEnabled (FALSE);
     labelMpR->setEnabled (FALSE);
  }  else {
     labelMp->setEnabled (TRUE);
     lineEditMpMin->setEnabled (TRUE);
     labelMpM->setEnabled (TRUE);
     lineEditMpMax->setEnabled (TRUE);
     labelMpR->setEnabled (TRUE);
  }
  if (!checkBoxIntencity->isOn()) {
     labelIntencity->setEnabled (FALSE);
     lineEditIntencityMin->setEnabled (FALSE);
     labelIntencityM->setEnabled (FALSE);
     lineEditIntencityMax->setEnabled (FALSE);
     labelIntencityR->setEnabled (FALSE);
  }  else {
     labelIntencity->setEnabled (TRUE);
     lineEditIntencityMin->setEnabled (TRUE);
     labelIntencityM->setEnabled (TRUE);
     lineEditIntencityMax->setEnabled (TRUE);
     labelIntencityR->setEnabled (TRUE);
  }
*/
}

void SubCatalogImpl::buttonDefault(){
   

}
void SubCatalogImpl::buttonHelp(){
    QString home = searchHelpPath() + "/edcat-tool-subcatalog.html";
    if(help !=0) {delete help; help =0;}
    help = new HelpWindow(home,this);
    if ( QApplication::desktop()->width() > 400
         && QApplication::desktop()->height() > 500 )
         help->show();
    else
        help->showMaximized();
}
void SubCatalogImpl::GetDateTimeForWizard(){
   startTime        = sampleWizardRecordDateMin(); 
   endTime          = sampleWizardRecordDateMax();
   SpinBoxNumberMax = sampleWizardRecordNumberMax().toInt();
   SpinBoxNumberMin = sampleWizardRecordNumberMin().toInt();
}
void SubCatalogImpl::GetDateTimeForTool(){
  in =  parentWindow->GetFstream();
   catSize = 0;
   RECORD record;
   Catalog cat;
   in->clear();
   in->seekg(0,ios::beg);
   in->read((char*)&catSize,sizeof(int));
   SpinBoxNumberMax = catSize;
   SpinBoxNumberMin = 1;
   in->seekg(sizeof(RECORD),ios::beg);
   in->read((char*)&record,sizeof(RECORD ));

   startTime =  cat.getQStringISODate(record);

   in->seekg(-((int)sizeof(RECORD)),ios::end);
   in->read((char*)&record,sizeof(RECORD ));

   endTime =  cat.getQStringISODate(record);

   in->clear();
}
void SubCatalogImpl::SetDateTimeNumberRecordsToDialog(){


    QString value = startTime;
    value.replace('-','/'); value.replace('T',' ');
    labelDateBegin->setText(value);
    value = endTime;
    value.replace('-','/'); value.replace('T',' ');
    labelDateEnd->setText(value);

    labelNumberBegin->setText(QString("%1").arg(SpinBoxNumberMin));
    labelNumberEnd->setText(QString("%1").arg(SpinBoxNumberMax));

    spinBoxNumberMin->setRange(SpinBoxNumberMin,SpinBoxNumberMax);
    spinBoxNumberMax->setRange(SpinBoxNumberMin,SpinBoxNumberMax);

    QDate dateStart;
    QString tmp = startTime.section('T',0,0);

    dateStart.setYMD(tmp.section('-',0,0).toInt(),tmp.section('-',1,1).toInt(),
                 tmp.section('-',2,2).toInt());

    QDate dateEnd;
    tmp = endTime.section('T',0,0);
    dateEnd.setYMD(tmp.section('-',0,0).toInt(),tmp.section('-',1,1).toInt(),
               tmp.section('-',2,2).toInt());

    dateTimeEditMin->setDateRange(dateStart,dateEnd);
    dateTimeEditMax->setDateRange(dateStart,dateEnd);

    QTime timeStart;
    tmp = startTime.section('T',1,1);

    timeStart.setHMS(tmp.section(':',0,0).toInt(),tmp.section(':',1,1).toInt(),
                 tmp.section(':',2,2).toInt());
    QTime timeEnd;
    tmp = endTime.section('T',1,1);

    timeEnd.setHMS(tmp.section(':',0,0).toInt(),tmp.section(':',1,1).toInt(),
                 tmp.section(':',2,2).toInt());

    dateTimeEditMin->setTimeRange(timeStart,timeEnd);
    dateTimeEditMax->setTimeRange(timeStart,timeEnd);

}
void SubCatalogImpl::InitLineDocProperty(){

  propDocLine.append(new LineDocProperty(lineEditLatitudeMin,
                             doc->GetSampleHipoRectLatitudeMin ()));
  propDocLine.append(new LineDocProperty(lineEditLatitudeMax,
                             doc->GetSampleHipoRectLatitudeMax ()));

  propDocLine.append(new LineDocProperty(lineEditLongitudeMin,
                             doc->GetSampleHipoRectLongitudeMin ()));
  propDocLine.append(new LineDocProperty(lineEditLongitudeMax,
                             doc->GetSampleHipoRectLongitudeMax ()));

  propDocLine.append(new LineDocProperty(lineEditDepthMin,
                             doc->GetSampleDepthMin ()));
  propDocLine.append(new LineDocProperty(lineEditDepthMax,
                             doc->GetSampleDepthMax ()));

  propDocLine.append(new LineDocProperty(lineEditCircleRad,
                             doc->GetSampleHipoCircleRadius()));
  propDocLine.append(new LineDocProperty(lineEditCircleLon,
                             doc->GetSampleHipoCircleLongitude()));
  propDocLine.append(new LineDocProperty(lineEditCircleLat,
                             doc->GetSampleHipoCircleLatitude()));

  propDocLine.append(new LineDocProperty(lineEditMbMin,
                             doc->GetSampleMbMin ()));
  propDocLine.append(new LineDocProperty(lineEditMbMax,
                             doc->GetSampleMbMax()));

  propDocLine.append(new LineDocProperty(lineEditMsMin,
                             doc->GetSampleMsMin ()));
  propDocLine.append(new LineDocProperty(lineEditMsMax,
                             doc->GetSampleMsMax()));

  propDocLine.append(new LineDocProperty(lineEditMlMin,
                             doc->GetSampleMlMin()));
  propDocLine.append(new LineDocProperty(lineEditMlMax,
                             doc->GetSampleMlMax()));

  propDocLine.append(new LineDocProperty(lineEditMpMin,
                             doc->GetSampleMpMin()));
  propDocLine.append(new LineDocProperty(lineEditMpMax,
                             doc->GetSampleMpMax()));

  propDocLine.append(new LineDocProperty(spinBoxIntensityMin,
                             doc->GetSampleIntensityMin()));
  propDocLine.append(new LineDocProperty(spinBoxIntensityMax,
                             doc->GetSampleIntensityMax()));

  propDocLine.append(new LineDocProperty(spinBoxPolygon,
                             doc->GetSampleHipoPolygonVertice()));

  propDocLine.append(new LineDocProperty(lineEditMFunMin,
                             doc->GetSampleMagFunctionMin()));
  propDocLine.append(new LineDocProperty(lineEditMFunMax,
                             doc->GetSampleMagFunctionMax()));

//---------------------------------------------------------------- 
 PropertyFloatValue* M1_D = new PropertyFloatValue(101,first->valD,"",
 minTransformMagnitudeD(),maxTransformMagnitudeD(),decimalTransformMagnitudeD());
 propDocLine.append(new LineDocProperty(lineEditM1_D,M1_D));
 EditLineValues.push_back(M1_D);

 PropertyFloatValue* M1_A = new PropertyFloatValue(102,first->valA,"",
 minTransformMagnitudeA(),maxTransformMagnitudeA(),decimalTransformMagnitudeA());
 propDocLine.append(new LineDocProperty(lineEditM1_A,M1_A));
 EditLineValues.push_back(M1_A);

 PropertyFloatValue* M1_B = new PropertyFloatValue(103,first->valB,"",
 minTransformMagnitudeB(),maxTransformMagnitudeB(),decimalTransformMagnitudeB());
 propDocLine.append(new LineDocProperty(lineEditM1_B,M1_B));
 EditLineValues.push_back(M1_B);

 PropertyFloatValue* M1_C = new PropertyFloatValue(104,first->valC,"",
 minTransformMagnitudeC(),maxTransformMagnitudeC(),decimalTransformMagnitudeC());
 propDocLine.append(new LineDocProperty(lineEditM1_C,M1_C));
 EditLineValues.push_back(M1_C);

//----------------------------------------------------------------- 

 PropertyFloatValue* M2_D = new PropertyFloatValue(105,second->valD,"",
 minTransformMagnitudeD(),maxTransformMagnitudeD(),decimalTransformMagnitudeD());
 //lineEditM1_D lineEditM1_A lineEditM1_B lineEditM1_C
 propDocLine.append(new LineDocProperty(lineEditM2_D,M2_D));
 EditLineValues.push_back(M2_D);

 PropertyFloatValue* M2_A = new PropertyFloatValue(106,second->valA,"",
 minTransformMagnitudeA(),maxTransformMagnitudeA(),decimalTransformMagnitudeA());
 propDocLine.append(new LineDocProperty(lineEditM2_A,M2_A));
 EditLineValues.push_back(M2_A);

 PropertyFloatValue* M2_B = new PropertyFloatValue(107,second->valB,"",
 minTransformMagnitudeB(),maxTransformMagnitudeB(),decimalTransformMagnitudeB());
 propDocLine.append(new LineDocProperty(lineEditM2_B,M2_B));
 EditLineValues.push_back(M2_B);

 PropertyFloatValue* M2_C = new PropertyFloatValue(108,second->valC,"",
 minTransformMagnitudeC(),maxTransformMagnitudeC(),decimalTransformMagnitudeC());
 propDocLine.append(new LineDocProperty(lineEditM2_C,M2_C));
 EditLineValues.push_back(M2_C);

//-----------------------------------------------------------------

 PropertyFloatValue* M3_D = new PropertyFloatValue(109,third->valD,"",
 minTransformMagnitudeD(),maxTransformMagnitudeD(),decimalTransformMagnitudeD());
 //lineEditM1_D lineEditM1_A lineEditM1_B lineEditM1_C
 propDocLine.append(new LineDocProperty(lineEditM3_D,M3_D));
 EditLineValues.push_back(M3_D);

 PropertyFloatValue* M3_A = new PropertyFloatValue(110,third->valA,"",
 minTransformMagnitudeA(),maxTransformMagnitudeA(),decimalTransformMagnitudeA());
 propDocLine.append(new LineDocProperty(lineEditM3_A,M3_A));
 EditLineValues.push_back(M3_A);

 PropertyFloatValue* M3_B = new PropertyFloatValue(111,third->valB,"",
 minTransformMagnitudeB(),maxTransformMagnitudeB(),decimalTransformMagnitudeB());
 propDocLine.append(new LineDocProperty(lineEditM3_B,M3_B));
 EditLineValues.push_back(M3_B);

 PropertyFloatValue* M3_C = new PropertyFloatValue(112,third->valC,"",
 minTransformMagnitudeC(),maxTransformMagnitudeC(),decimalTransformMagnitudeC());
 propDocLine.append(new LineDocProperty(lineEditM3_C,M3_C));
 EditLineValues.push_back(M3_C);

//-----------------------------------------------------------------
 PropertyFloatValue* M4_D = new PropertyFloatValue(113,fourth->valD,"",
 minTransformMagnitudeD(),maxTransformMagnitudeD(),decimalTransformMagnitudeD());
 //lineEditM1_D lineEditM1_A lineEditM1_B lineEditM1_C
 propDocLine.append(new LineDocProperty(lineEditM4_D,M4_D));
 EditLineValues.push_back(M4_D);

 PropertyFloatValue* M4_A = new PropertyFloatValue(114,fourth->valA,"",
 minTransformMagnitudeA(),maxTransformMagnitudeA(),decimalTransformMagnitudeA());
 propDocLine.append(new LineDocProperty(lineEditM4_A,M4_A));
 EditLineValues.push_back(M4_A);

 PropertyFloatValue* M4_B = new PropertyFloatValue(115,fourth->valB,"",
 minTransformMagnitudeB(),maxTransformMagnitudeB(),decimalTransformMagnitudeB());
 propDocLine.append(new LineDocProperty(lineEditM4_B,M4_B));
 EditLineValues.push_back(M4_B);

 PropertyFloatValue* M4_C = new PropertyFloatValue(116,fourth->valC,"",
 minTransformMagnitudeC(),maxTransformMagnitudeC(),decimalTransformMagnitudeC());
 propDocLine.append(new LineDocProperty(lineEditM4_C,M4_C));
 EditLineValues.push_back(M4_C);


/*
     QFont fnOld = font();
     QFont fn = fnOld;
     fn.setBold(true);
     int width =  fontMetrics().width(fontmetricLineEdit());

     foreach (LineDocProperty *docprop, propDocLine) {
     if (docprop->GetProp()->GetKind()  == PropertyValue::Property_Float){
      QLineEdit * lin = (QLineEdit *) docprop->GetEditor();
      lin->setFixedWidth (width);

 }
*/
   dateTimeEditMin->setDisplayFormat(QApplication::translate("dateTimeEditMin",
                         "yyyy/MM/dd hh:mm:ss"));
   dateTimeEditMax->setDisplayFormat(QApplication::translate("dateTimeEditMax",
                         "yyyy/MM/dd hh:mm:ss"));

	 comboBoxM1->adjustSize();
	 comboBoxM2->adjustSize();
	 comboBoxM3->adjustSize();
	 comboBoxM4->adjustSize();
}
void SubCatalogImpl::GetDialogFromDocument()   {

  if (doc->GetSampleRecordIs()->GetValue() == "1") 
    checkBoxRecord->setChecked (TRUE);
  else checkBoxRecord->setChecked (FALSE);
  if (doc->GetSampleRecordType()->GetValue() == "0") {
    radioButtonRecordDate->setChecked (TRUE);
    radioButtonRecordNumber->setChecked (FALSE);
  }  else {
    radioButtonRecordDate->setChecked (FALSE);
    radioButtonRecordNumber->setChecked (TRUE);
  }

 if (type == Tool)   GetDateTimeForTool();
 if (type == Wizard) GetDateTimeForWizard();

 SetDateTimeNumberRecordsToDialog();

   QDateTime dt;

   QString value = doc->GetSampleRecordDateMin()->GetValue();
   if (value == "auto") value = startTime;
   dateTimeEditMin->setDateTime (dt.fromString(value,Qt::ISODate));

   value = doc->GetSampleRecordDateMax()->GetValue();
   if (value == "auto") value = endTime;
   dateTimeEditMax->setDateTime (dt.fromString(value,Qt::ISODate));

   if (doc->GetSampleRecordNumberMin()->GetValue() == "auto")
    spinBoxNumberMax->QSpinBox::setValue(SpinBoxNumberMin);
   else
    spinBoxNumberMax->QSpinBox::setValue(doc->GetSampleRecordNumberMin()->GetValue().toInt());

   if (doc->GetSampleRecordNumberMax()->GetValue() == "auto")
    spinBoxNumberMax->QSpinBox::setValue(SpinBoxNumberMax);
   else
    spinBoxNumberMax->QSpinBox::setValue(doc->GetSampleRecordNumberMax()->GetValue().toInt());

  if (doc->GetSampleHipoIs()->GetValue() == "1")
    checkBoxHipocenter->setChecked (TRUE);
  else checkBoxHipocenter->setChecked (FALSE);

  if (doc->GetSampleHipoType()->GetValue() == "0") {
    radioButtonRectangle->setChecked (TRUE);
    radioButtonCircle->setChecked (FALSE);
    radioButtonPolygon->setChecked (FALSE);
  }

  if (doc->GetSampleHipoType()->GetValue() == "1") {
    radioButtonRectangle->setChecked (FALSE);
    radioButtonCircle->setChecked (TRUE);
    radioButtonPolygon->setChecked (FALSE);
  }  
  if (doc->GetSampleHipoType()->GetValue() == "2") {
    radioButtonRectangle->setChecked (FALSE);
    radioButtonCircle->setChecked (FALSE);
    radioButtonPolygon->setChecked (TRUE);
  }
  if (doc->GetSampleHipoRectMinus180 ()->GetValue() == "1")
  checkBox180->setChecked (TRUE);
  else checkBox180->setChecked (FALSE);

  if (doc->GetSampleDepthIs()->GetValue() == "1")
    checkBoxDepth->setChecked (TRUE);
  else checkBoxDepth->setChecked (FALSE);

//-------------------------------------------------------------------

  if (doc->GetSampleMagnitudeIs()->GetValue() == "1")
    checkBoxMagnitude->setChecked (TRUE);
  else checkBoxMagnitude->setChecked (FALSE);


  if (doc->GetSampleMagnitudeType()->GetValue() == "0") {
    radioButtonMagInterval->setChecked (TRUE);
    radioButtonMagFunction->setChecked (FALSE);
  }  else {
    radioButtonMagInterval->setChecked (FALSE);
    radioButtonMagFunction->setChecked (TRUE);
  }


  if (doc->GetSampleMbIs()->GetValue() == "1")
    checkBoxMb->setChecked (TRUE);
  else checkBoxMb->setChecked (FALSE);

  if (doc->GetSampleMsIs()->GetValue() == "1")
    checkBoxMs->setChecked (TRUE);
  else checkBoxMs->setChecked (FALSE);

  if (doc->GetSampleMlIs()->GetValue() == "1")
    checkBoxMl->setChecked (TRUE);
  else checkBoxMl->setChecked (FALSE);

  if (doc->GetSampleMpIs()->GetValue() == "1")
    checkBoxMp->setChecked (TRUE);
  else checkBoxMp->setChecked (FALSE);


//----------------------------------------------------------------
 if (first->valIsOn) checkBoxM1->setChecked (TRUE);
 else   checkBoxM1->setChecked (TRUE);
 comboBoxM1->setCurrentIndex(first->valIndexMagnitude);
//----------------------------------------------------------------- 
 if (second->valIsOn) checkBoxM2->setChecked (TRUE);
 else   checkBoxM2->setChecked (TRUE);
 comboBoxM2->setCurrentIndex(second->valIndexMagnitude);
//-----------------------------------------------------------------
 if (third->valIsOn) checkBoxM3->setChecked (TRUE);
 else   checkBoxM3->setChecked (TRUE);
 comboBoxM3->setCurrentIndex(third->valIndexMagnitude);
//-----------------------------------------------------------------
 if (fourth->valIsOn) checkBoxM4->setChecked (TRUE);
 else   checkBoxM4->setChecked (TRUE);
 comboBoxM4->setCurrentIndex(fourth->valIndexMagnitude);
//-----------------------------------------------------------------

//------------------------------ Intencity --------------------------------------

  if (doc->GetSampleIntensityIs()->GetValue() == "1")
    checkBoxIntencity->setChecked (TRUE);
  else checkBoxIntencity->setChecked (FALSE);

     foreach (LineDocProperty *docprop, propDocLine) docprop->SetValueFromDoc();

}
void SubCatalogImpl::GetDocumentFromDialog(){

   if(checkBoxRecord->isChecked()) doc->GetSampleRecordIs()->SetValue("1");
   else doc->GetSampleRecordIs()->SetValue("0");

   if(radioButtonRecordDate->isChecked()) doc->GetSampleRecordType()->SetValue("0");
   else doc->GetSampleRecordType()->SetValue("1");
   
   QDateTime dt = dateTimeEditMin->dateTime () ;
   doc->GetSampleRecordDateMin()->SetValue(dt.toString(Qt::ISODate));
   dt = dateTimeEditMax->dateTime () ;
   doc->GetSampleRecordDateMax()->SetValue(dt.toString(Qt::ISODate));

   doc->GetSampleRecordNumberMin()->SetValue(QString("%1").arg(spinBoxNumberMin->QSpinBox::value ()));
   doc->GetSampleRecordNumberMax()->SetValue(QString("%1").arg(spinBoxNumberMax->QSpinBox::value ()));

   if(checkBoxHipocenter->isChecked()) doc->GetSampleHipoIs()->SetValue("1");
   else doc->GetSampleHipoIs()->SetValue("0");

   if(radioButtonRectangle->isChecked()) doc->GetSampleHipoType()->SetValue("0");
   if(radioButtonCircle->isChecked()) doc->GetSampleHipoType()->SetValue("1");
   if(radioButtonPolygon->isChecked()) doc->GetSampleHipoType()->SetValue("2");

//------------------------------------ Rectangle Hipocenter --------------------------
  doc->GetSampleHipoRectLatitudeMin()->SetValue(lineEditLatitudeMin->text());
  doc->GetSampleHipoRectLatitudeMax()->SetValue(lineEditLatitudeMax->text());
  doc->GetSampleHipoRectLongitudeMin()->SetValue(lineEditLongitudeMin->text());
  doc->GetSampleHipoRectLongitudeMax()->SetValue(lineEditLongitudeMax->text());
  if(checkBox180->isChecked()) doc->GetSampleHipoRectMinus180 ()->SetValue("1");
  else doc->GetSampleHipoRectMinus180 ()->SetValue("0");

//------------------------------------ Circle Hipocenter --------------------------
  doc->GetSampleHipoCircleLatitude()->SetValue(lineEditCircleLat->text());
  doc->GetSampleHipoCircleLongitude()->SetValue(lineEditCircleLon->text());
  doc->GetSampleHipoCircleRadius()->SetValue(lineEditCircleRad->text());

//------------------------------------ Polygon Hipocenter --------------------------
// setValue to Polygon Hipocenter parameters provides by poligon.cpp implementayion
// throw poligon dialog or default values uses
//----------------------------- Depth-----------------------------------------
  doc->GetSampleDepthMin()->SetValue(lineEditDepthMin->text());
  doc->GetSampleDepthMax()->SetValue(lineEditDepthMax->text());
  if(checkBoxDepth->isChecked()) doc->GetSampleDepthIs()->SetValue("1");
  else doc->GetSampleDepthIs()->SetValue("0");

//------------------------------- Magnitude --------------------------
   if(checkBoxMagnitude->isChecked()) doc->GetSampleMagnitudeIs()->SetValue("1");
   else doc->GetSampleMagnitudeIs()->SetValue("0");

   if(radioButtonMagInterval->isChecked()) doc->GetSampleMagnitudeType()->SetValue("0");
   if(radioButtonMagFunction->isChecked()) doc->GetSampleMagnitudeType()->SetValue("1");
 if (doc->GetSampleMagnitudeIs()->GetValue() == "1")
    checkBoxMagnitude->setChecked (TRUE);
  else checkBoxMagnitude->setChecked (FALSE);


  if (doc->GetSampleMagnitudeType()->GetValue() == "0") {
    radioButtonMagInterval->setChecked (TRUE);
    radioButtonMagFunction->setChecked (FALSE);
  }  else {
    radioButtonMagInterval->setChecked (FALSE);
    radioButtonMagFunction->setChecked (TRUE);
  }

//------------------------------ Mb ---------------------------------------
   if(checkBoxMb->isChecked()) doc->GetSampleMbIs()->SetValue("1");
   else doc->GetSampleMbIs()->SetValue("0");
   doc->GetSampleMbMin()->SetValue(lineEditMbMin->text());
   doc->GetSampleMbMax()->SetValue(lineEditMbMax->text());
//------------------------------ Ms ---------------------------------------
   if(checkBoxMs->isChecked()) doc->GetSampleMsIs()->SetValue("1");
   else doc->GetSampleMsIs()->SetValue("0");
   doc->GetSampleMsMin()->SetValue(lineEditMsMin->text());
   doc->GetSampleMsMax()->SetValue(lineEditMsMax->text());
//------------------------------ Ms ---------------------------------------
   if(checkBoxMl->isChecked()) doc->GetSampleMlIs()->SetValue("1");
   else doc->GetSampleMlIs()->SetValue("0");
   doc->GetSampleMlMin()->SetValue(lineEditMlMin->text());
   doc->GetSampleMlMax()->SetValue(lineEditMlMax->text());

//------------------------------ Ms ---------------------------------------
   if(checkBoxMp->isChecked()) doc->GetSampleMpIs()->SetValue("1");
   else doc->GetSampleMpIs()->SetValue("0");
   doc->GetSampleMpMin()->SetValue(lineEditMpMin->text());
   doc->GetSampleMpMax()->SetValue(lineEditMpMax->text());

///------------------------------------------------------------------------
     vector<QString> valFunc;valFunc.resize(4);
     QString tmp;
     if(checkBoxM1->isChecked())
           tmp = QString("1@%1@").arg(comboBoxM1->currentIndex());
     else  tmp = QString("0@%1@").arg(comboBoxM1->currentIndex());
     valFunc[0] = tmp + QString("%1@%2@%3@%4").arg(lineEditM1_D->text())
                                              .arg(lineEditM1_A->text())
                                              .arg(lineEditM1_B->text())
                                              .arg(lineEditM1_C->text());
     if(checkBoxM2->isChecked())
           tmp =  QString("1@%1@").arg(comboBoxM2->currentIndex());
     else  tmp =  QString("0@%1@").arg(comboBoxM2->currentIndex());
     valFunc[1] = tmp + QString("%1@%2@%3@%4").arg(lineEditM2_D->text())
                                              .arg(lineEditM2_A->text())
                                              .arg(lineEditM2_B->text())
                                              .arg(lineEditM2_C->text());

     if(checkBoxM3->isChecked ())
           tmp = QString("1@%1@").arg(comboBoxM3->currentIndex());
     else  tmp = QString("0@%1@").arg(comboBoxM3->currentIndex());
     valFunc[2] = tmp + QString("%1@%2@%3@%4").arg(lineEditM3_D->text())
                                              .arg(lineEditM3_A->text())
                                              .arg(lineEditM3_B->text())
                                              .arg(lineEditM3_C->text());

     if(checkBoxM4->isChecked())
           tmp = QString("1@%1@").arg(comboBoxM4->currentIndex());
     else  tmp = QString("0@%1@").arg(comboBoxM4->currentIndex());
     valFunc[3] = tmp + QString("%1@%2@%3@%4").arg(lineEditM4_D->text())
                                              .arg(lineEditM4_A->text())
                                              .arg(lineEditM4_B->text())
                                              .arg(lineEditM4_C->text());


     doc->GetSampleMagFunctionFirstMagnitude()->SetValue(valFunc[0]);
     doc->GetSampleMagFunctionSecondMagnitude()->SetValue(valFunc[1]);
     doc->GetSampleMagFunctionThirdMagnitude()->SetValue(valFunc[2]);
     doc->GetSampleMagFunctionFourthMagnitude()->SetValue(valFunc[3]);

//------------------------------ Intencity --------------------------------------
   if(checkBoxIntencity->isChecked()) doc->GetSampleIntensityIs()->SetValue("1");
   else doc->GetSampleIntensityIs()->SetValue("0");
   doc->GetSampleIntensityMin()->SetValue(QString("%1").arg(spinBoxIntensityMin->QSpinBox::value ()));
   doc->GetSampleIntensityMax()->SetValue(QString("%1").arg(spinBoxIntensityMax->QSpinBox::value ()));



}
void SubCatalogImpl::FinishOk()
{
	message = "";
	QString tmp = projectActionList().split ('@').at(2);
	texted->insertPlainText(prefixMessage() + tmp + " ***\n\n");
	GetSampleFunc();
    GetDocumentFromDialog();
    foreach (PropertyValue* val, values) val->SetValueToResetvalue();
    texted->insertPlainText(message);
    tmp = projectActionList().split ('@').at(2);
    texted->insertPlainText(postfixActionMessage()  + tmp + " ***\n\n");
}
bool SubCatalogImpl::NextOk() {
message = "";
if ( !GetSampleFunc() ) return false;
  if (type == Tool || type == Wizard) {
  QString tmp = QString("Do you want to execute %1?\n\n").arg(projectActionList().split ('@').at(2));
       int ret = QMessageBox::warning(this,windowTitle (),tmp + message,
                     QMessageBox::Yes | QMessageBox::Default,
                     QMessageBox::No | QMessageBox::Escape);
        if (ret == QMessageBox::No) return false;
  }
return true;
}
bool SubCatalogImpl::execute(){
bool ret = applay();
   killTimer (timer);
   if(indexCat->empty()) parentWindow->RestoreIndex(); else
   if((int)indexCat->size() != parentWindow->GetCatSize()) parentWindow->WriteCatFromIndex();
///-----------------------------------------------------------------

  Catalog cat;
  texted->insertPlainText("\nOutput catalog: " + 
           cat.GetCatalogShortInfoMessage(MainWindow::self->GetOpenBinaryFileName()));
  QString tmp = projectActionList().split ('@').at(2);
  texted->insertPlainText(postfixActionMessage() + ": " + tmp + " ***\n");

//-------------------------------------------------------------------
done( Accepted );
return ret;
}
bool SubCatalogImpl::applay(){
if (firstStart == true) firstStart = false;
else  parentWindow->RestoreIndex();
    if (type == Tool){
      MainWindow::self->bottomWindow->OpenMessagesProtocolPage();
      QString tmp = projectActionList().split ('@').at(2);
      texted->insertPlainText(prefixMessage() + tmp + " ***\n\n");
      }
  message = "";
  in =  parentWindow->GetFstream();
  indexCat =  parentWindow->GetRecordCatalogIndex();
  catSize = indexCat->size();

   SetDateTimeNumberRecordsToDialog();
   if ( !GetSampleFunc() ) {
   ptrFunct.clear();
   position = indexCat->end();
   return false;

   }
  if (type == Tool || type == Wizard) {
  QString tmp = QString("Do you want to execute %1?\n\n").arg(projectActionList().split ('@').at(2));
       int ret = QMessageBox::warning(0,windowTitle (),tmp + message,
                     QMessageBox::Yes | QMessageBox::Default,
                     QMessageBox::No | QMessageBox::Escape);
        if (ret == QMessageBox::No) return false;
  }
  repaint();
  in =  parentWindow->GetFstream();
  indexCat =  parentWindow->GetRecordCatalogIndex();
  catSize = indexCat->size();
  progressBar->setRange(1,catSize);
  DuplicateProgress(0);
  position = indexCat->begin();
  okButton->setEnabled(TRUE);
//--------------------- DateTime or Record Selection --------------------
  int minRecord = 0;
  int maxRecord = 0;
  if (checkBoxRecord->isChecked())  {
  ItrMultiMap pos1,pos2;

  if(radioButtonRecordDate->isChecked()){
    QDateTime min = dateTimeEditMin->dateTime ();
    QDateTime max = dateTimeEditMax->dateTime ();
    short  yr = min.date ().year ();
    short  mo = min.date ().month();
    short  da = min.date ().day();
    short  hr = min.time ().hour();
    short  mn = min.time ().minute();
    short  sc = min.time ().second();
    double dttm = time(yr,mo,da,hr,mn) + (double)sc/ (double)(100);
    pos1 =  indexCat->lower_bound(dttm );
    minRecord = (*pos1).second;

    yr = max.date ().year ();
    mo = max.date ().month();
    da = max.date ().day();
    hr = max.time ().hour();
    mn = max.time ().minute();
    sc = max.time ().second();
    dttm = time(yr,mo,da,hr,mn) + (double)sc/ (double)(100) + eps;
    pos2 =  indexCat->lower_bound(dttm );
    maxRecord = (*pos2).second;

 }
  if (radioButtonRecordNumber->isChecked())  {
   minRecord = spinBoxNumberMin->value () -1;
   pos1 = indexCat->begin(); for(int i = 0; i < minRecord; i++) pos1++;
   maxRecord = spinBoxNumberMax->value ();
   pos2 = indexCat->begin(); for(int i = 0; i < maxRecord; i++) pos2++;
  }
//qWarning("----- rec:   min %d max %d ",minRecord,maxRecord);
//qWarning("xxxxx pos:   min %d max %d ",(*pos1).second,(*pos2).second);
   QString tmp = "";
   if (pos1 != pos2) {
    if (!(pos1 == indexCat->begin() && pos2 == indexCat->end()))  {
     indexCat->erase(pos2, indexCat->end());
     indexCat->erase(indexCat->begin(), pos1);

    }
    tmp = QString("Process completed: %1 records selected.").
                              arg(indexCat->size());
  } else  {
     tmp = QString("Process completed: 0 records selected.");
     
//     DuplicateProgress(catSize);
//     position = indexCat->end();
//    return;
    }

   if (ptrFunct.size() == 0) {
   DuplicateProgress(catSize);
   position = indexCat->end();
   textLabel->setText(tmp);
   message += tmp + "\n";
   texted->insertPlainText(message);
   tmp = projectActionList().split ('@').at(2);
   texted->insertPlainText(postfixActionMessage() + ": " + tmp + " ***\n\n");
   return true;
  }
}
  SubCatalogProccessing();

  texted->insertPlainText(message);
  /*
  Catalog cat;
  texted->insertPlainText("\nOutput catalog:\n" + 
           cat.GetCatalogShortInfoMessage(MainWindow::self->GetOpenBinaryFileName()));

  QString tmp = projectActionList().split ('@').at(2);
  texted->insertPlainText(postfixActionMessage() + ": " + tmp + " ***\n");
*/  
  return true;
}
void SubCatalogImpl::start(){
if (!applay()) return;
}


void SubCatalogImpl::SubCatalogProccessing(){
    int numSel = 0;
    QString tmp = "";
  if(indexCat != 0)
  if(!indexCat->empty())  
    if ( position != indexCat->end()){
 
    RECORD record;
    in->clear();
    position = indexCat->begin();
    while (position != indexCat->end()) {
	    int inpos = position->second +1;
	    in->seekg(inpos*sizeof(RECORD),ios::beg);
	    in->read((char*)&record,sizeof(RECORD ));
      funct.SetRecord(record);
      vector <PDF>::iterator it = ptrFunct.begin();
      bool valueTrue = true;
      while (it != ptrFunct.end()){
         PDF ff =  *it;
         (funct.*ff)();
         if (!funct.Value()) {valueTrue = false; break;  }
         it++;
      } //while
      if(valueTrue) {  position++;  numSel++;  }
      else {
        ItrMultiMap posNew = position;posNew++;
        indexCat->erase(position);
        position = posNew;

      }
 
      if ((inpos/100)*100 == inpos ) DuplicateProgress(inpos);
    }
    DuplicateProgress(catSize);
    if(numSel > 0)
    tmp = QString("Selected %1 records.Process of subcatalog creation is completed.").
                              arg(numSel);
    else
    tmp = QString("Selected 0 records.Process of subcatalog creation is completed.");
    textLabel->setText(tmp);
    message += tmp + "\n";

    }
}
void SubCatalogImpl::vertices()  {
if (polygon != 0) {delete polygon; polygon = 0;}
int rows = spinBoxPolygon->value ();
polygon = new PolygonImpl(this,rows,doc);
polygon->show();
}
void SubCatalogImpl::accept()
{


   killTimer (timer);

   if(indexCat->empty()) parentWindow->RestoreIndex(); else
   if((int)indexCat->size() != parentWindow->GetCatSize()) parentWindow->WriteCatFromIndex();

    GetDocumentFromDialog();
    foreach (PropertyValue* val, values) val->SetValueToResetvalue();
    MainWindow::self->subCatalogPos   =  pos();
    MainWindow::self->subCatalogSize  =  size();
    MainWindow::self->modifiedCatalog = true;
    MainWindow::self->modifiedProtocol = true;


   MainWindow::self->RestoreStatusbarMessage();
///-----------------------------------------------------------------

  Catalog cat;
  texted->insertPlainText("\nOutput catalog: " + 
           cat.GetCatalogShortInfoMessage(MainWindow::self->GetOpenBinaryFileName()));
  QString tmp = projectActionList().split ('@').at(2);
  texted->insertPlainText(postfixActionMessage() + ": " + tmp + " ***\n\n");
 if (type == Tool) {
      texted->ensureCursorVisible ();
  }
//-------------------------------------------------------------------
    done( Accepted );
}
void SubCatalogImpl::closeEvent(QCloseEvent *event)
{
// like as reject
 if(indexCat != 0)
if(!indexCat->empty()){
if ((int)indexCat->size() != parentWindow->GetCatSize()) parentWindow->RestoreIndex();
}
 killTimer (timer);

foreach (PropertyValue* val, values) val->SetResetvalueToValue();
    MainWindow::self->subCatalogPos   =  pos();
    MainWindow::self->subCatalogSize  =  size();
  Catalog cat;
  texted->insertPlainText("\nOutput catalog: " + 
           cat.GetCatalogShortInfoMessage(MainWindow::self->GetOpenBinaryFileName()));	
    texted->insertPlainText(cancelMessage() + "\n");
    MainWindow::self->RestoreStatusbarMessage();
	
    event->accept();

}

void SubCatalogImpl::reject()
{
return;
}

void SubCatalogImpl::reset(){

foreach (PropertyValue* val, values) val->SetResetvalueToValue();
GetDialogFromDocument();
}
void SubCatalogImpl::project(){

foreach (PropertyValue* val, values) val->SetInitial();
GetDialogFromDocument();
}
void SubCatalogImpl::defaults(){

foreach (PropertyValue* val, values) val->SetDefault();
GetDialogFromDocument();
}
void SubCatalogImpl::ProgressBarChanged(int value){
if (value > 1) {
 textLabel->setText(tr("Record: %1").arg(value));
 textLabel->repaint ();
}
}
//----------------------------------------------------------------------------------

