#include <QtGui>
#include "subcatalog.h"
#include "default.h"
#include "subcatalog.h"
#include "bottomwindow.h"
#include <sstream>
#include <iomanip>
#include <math.h>

//double pi=0.0174532925; /* pi devided by 180 degrees */
double rad = 4*atan(1.0)/180.0;
double earthRadius = 6378.16;
//coordinates in degrees
//distanse in kilometers

double distance(double la1, double la2, double lo1, double lo2)
{
double dlo;
double q1,q2,q3,csc1,csc0;
dlo=fabs(lo1-lo2); if (dlo > 180.0) dlo=360.0-dlo;
q2=rad*la1;
q1=cos(q2);
q2=sin(q2);
q3=cos((rad*dlo));
csc0=rad*la2;
csc1=sin(csc0);
csc0=cos(csc0);
return (earthRadius*acos(q2*csc1+q1*q3*csc0));
}
SampleFunc::~SampleFunc(){
  if(!polygon.empty()) polygon.clear();
}
SampleFunc::SampleFunc(){eps = acuracyCompareFloatValue();}
void  SampleFunc::SetRecord(RECORD &rec)
{
record = rec;
Catalog cat;
cat.GetLatLonDepthMagnitude(record,lat,lon,dep,mb,ms,ml,mp);

}
//-----------------------------------------------------------------
void  SampleFunc::SetRectangle (float latmin,float latmax,float lonmin,float lonmax){
  RectLatMin = latmin; 
  RectLatMax = latmax;
  RectLonMin = lonmin;
  RectLonMax = lonmax;
  if ( Lon180 )
   {
    if (RectLonMin > 0) RectLonMin -= 180;
    else RectLonMin += 180;

  }
  if ( Lon180 )
   {
    if (RectLonMax > 0) RectLonMax -= 180;
    else RectLonMax += 180;

  }

}
void  SampleFunc::SetPolygon(QPolygonF &poly) {
    if(!polygon.empty()) polygon.clear();
    for (int i = 0; i < poly.size(); ++i) {
       float lat =   poly.at(i).x();
       float lon =   poly.at(i).y();
       if ( PolygonLon180) {
           if(lon > 0) lon -=  180;
           else   lon +=  180;
       }
        polygon << QPointF(lat, lon);
    }


}
void  SampleFunc::SetDepth(float valmin,float valmax){
    DepthMin = valmin;
    DepthMax = valmax;
}

void  SampleFunc::SetMb(float valmin,float valmax) { 
    MbMin = valmin;
    MbMax = valmax;
}
void  SampleFunc::SetMs(float valmin,float valmax) {
    MsMin = valmin;
    MsMax = valmax;
}


void  SampleFunc::SetMl(float valmin,float valmax) {
    MlMin = valmin;
    MlMax = valmax;
}

void  SampleFunc::SetMp(float valmin,float valmax) {
    MpMin = valmin;
    MpMax = valmax;
}
void  SampleFunc::SetMfunct(float valmin,float valmax) {
    MfunctMin = valmin;
    MfunctMax = valmax;

}
void  SampleFunc::SetIntensity(int valmin,int valmax) {
IntensityMin = valmin;
IntensityMax = valmax;
}
void  SampleFunc::SetValFunctPriority(vector<int> &prior,vector<QString> &valFunc){
if(!priority.empty()) priority.clear();
priority.insert(priority.begin(),prior.begin(),prior.end());
a.resize(4);b.resize(4);c.resize(4);d.resize(4);
  for(int i = 0; i< 4;i++) {
   QStringList param = valFunc[i].split( '@');
   d[i] = param[0].toFloat(); a[i]  = param[1].toFloat(); b[i] = param[2].toFloat(); c[i] = param[3].toFloat();
  }
}
//-----------------------------------------------------------------

void  SampleFunc::Rectangle(){
  
  if (lat < RectLatMin) {value = false; return;}
  if (lat > RectLatMax) {value = false; return;}
  float longitude = lon;
  if ( Lon180 )
   {
    if (longitude > 0) longitude -= 180;
    else longitude += 180;

 }

  if (longitude < RectLonMin) {value = false; return;}
  if (longitude > RectLonMax) {value = false; return;}

  value = true;

}
void  SampleFunc::Circle(){
  if (distance(CircleLat,(double)lat,CircleLon,(double)lon) > CircleRadius)
    value = false;
  else
    value = true;
}
bool SampleFunc::Inside(QPointF irov, const QPolygonF &foliplot)
{
  int size= foliplot.size();
  

  QPointF prev= foliplot.back();
  int intersect_counter= int();
  for (int wat=0; wat<size; ++wat)
  {
    QPointF p= foliplot[wat];
    if ((p.y() > irov.y()) ^ (prev.y() > irov.y()))
    {
      float t= (irov.y() - prev.y())/(p.y() - prev.y());
      float x= prev.x() + t * (p.x() - prev.x());
      if (x>irov.x())
        ++intersect_counter;
    } 
    prev= p;
  }
  return (intersect_counter&1);
}
void  SampleFunc::Polygon(){
   // for (int i = 0; i < polygon.size(); ++i) {
       float longitude = lon;
       if ( PolygonLon180) {
           if(longitude > 0) longitude -=  180*longitudeMagnification();
           else   longitude +=  180*longitudeMagnification();
       }
       if (!Inside(QPointF(lat,longitude), polygon)) {value = false; return;}
    //}
    value = true;
}
void  SampleFunc::Depth(){
  if (dep < DepthMin) {value = false; return;}
  if (dep > DepthMax) {value = false; return;}
  value = true;  
}
void  SampleFunc::Mb(){

  if (mb < MbMin) {value = false; return;}
  if (mb > MbMax) {value = false; return;}
  value = true;
}
void  SampleFunc::Ms(){
 
  if (ms < MsMin) {value = false; return;}
  if (ms > MsMax) {value = false; return;}
  value = true;  
}
void  SampleFunc::Ml(){
  if (ml < MlMin) {value = false; return;}
  if (ml > MlMax) {value = false; return;}
  value = true;
}
void  SampleFunc::Mp(){
  if (mp < MpMin) {value = false; return;}
  if (mp > MpMax) {value = false; return;}
  value = true;
}
void  SampleFunc::Intensity(){
  if (record.inten < IntensityMin) {value = false; return;}
  if (record.inten > IntensityMax) {value = false; return;}
  value = true;
}
void  SampleFunc::MagnitudeValue(){
	if(!priority.empty()) {
		vector<float> &mag = magnitudeRecord;
		mag.resize(4); mag[0] = mb; mag[1] = ms;
		mag[2] = ml; mag[3] = mp;
		bool findNotZeroMagnitude = false;
		int indexNotZeroMagnitude = 0;
		if ((int)priority.size() == 1) findNotZeroMagnitude = true;
		else
			for(int i = 0; i < (int)priority.size();i++)   {
				if( !( fabs(mag[priority[i]]) < eps ))
				{findNotZeroMagnitude = true;indexNotZeroMagnitude = i;break;}
			}
		if (findNotZeroMagnitude) {
			float fm = mFunct(priority[indexNotZeroMagnitude],mag[priority[indexNotZeroMagnitude]]);
			if (fm < MfunctMin) {value = false; return;}
			if (fm > MfunctMax) {value = false; return;} 
			value = true;
		}  else { if(fabs(MfunctMin) < eps) value = true; else value = false;}
	} else value = true;
}
void  SampleFunc::MagnitudeMaximum(){
if(!priority.empty()) {
vector<float> &mag = magnitudeRecord;
mag.resize(4); mag[0] = mb; mag[1] = ms;
               mag[2] = ml; mag[3] = mp;
float fm = mFunct(priority[0],mag[priority[0]]);
 for(int i = 1; i < (int)priority.size();i++)   {
   float   mm = mFunct(priority[i],mag[priority[i]]);
   if( mm > fm ) fm = mm;
   }
    if (fm < MfunctMin) {value = false; return;}
    if (fm > MfunctMax) {value = false; return;}
    value = true;
} else value = true;

}
void  SampleFunc::MagnitudeMinimum(){
if(!priority.empty()) {
vector<float> &mag = magnitudeRecord;
mag.resize(4); mag[0] = mb; mag[1] = ms;
               mag[2] = ml; mag[3] = mp;
float fm = mFunct(priority[0],mag[priority[0]]);
 for(int i = 1; i < (int)priority.size();i++)   {
   float   mm = mFunct(priority[i],mag[priority[i]]);
   if( mm < fm ) fm = mm;
   }
    if (fm < MfunctMin) {value = false; return;}
    if (fm > MfunctMax) {value = false; return;}
    value = true;
} else value = true;

}
void  SampleFunc::MagnitudeAverage(){
if(!priority.empty()) {
vector<float> &mag = magnitudeRecord;
mag.resize(4); mag[0] = mb; mag[1] = ms;
               mag[2] = ml; mag[3] = mp;
float fm = mFunct(priority[0],mag[priority[0]]);
int nn = 0;
if(fabs(fm) > eps) nn++;
 for(int i = 1; i < (int)priority.size();i++){
   float func = mFunct(priority[i],mag[priority[i]]);
   fm += func;
   if(fabs(func) > eps) nn++;
}
    if(nn > 0) fm /= nn;
    if (fm < MfunctMin) {value = false; return;}
    if (fm > MfunctMax) {value = false; return;}
    value = true;
} else value = true;

}
//-------------------------------------------------------------------------------
void SubCatalogImpl::SetTextQLineEdit(QLineEdit* lin,bool bold,QString color){
   QFont fn = font ();
   fn.setBold(bold);
   lin->setFont(fn);
   QPalette pl = lin->palette ();
   pl.setColor (QPalette::Text, QColor(color) );
   lin->setPalette ( pl );
   lin->setText(lin->text());
}
bool SubCatalogImpl::CheckQLineEdit(QLineEdit* linmin,float min,float max,QString name){
  if ( min > max - eps) {
   error( name + QString("minimum value (%1) >= maximum value (%2)").
                        arg(min).arg(max),"");
     SetTextQLineEdit(linmin,true,"red");
     return false;
   } else {
     SetTextQLineEdit(linmin,false,"black");
     return true;
   }

}
bool SubCatalogImpl::CheckQLineEditWithRect180(QLineEdit* linmin,float min,float max,QString name)  {
qWarning("min %8.3f max  %8.3f",min,max);
  if (!(min > 0 && max < 0)) {
   error( name + QString( " [ %1 , %2 ]"
        "\n If rectangle crosses longitude \"180\" then it should not cross longitude \"0\""
                         ).arg(min).arg(max),"");
     SetTextQLineEdit(linmin,true,"red");
     return false;
   } else {
     SetTextQLineEdit(linmin,false,"black");
     return true;
   }

}
void SubCatalogImpl::SetTextQSpinBox(QSpinBox* lin,bool bold,QString color){
   QFont fn = font ();
   fn.setBold(bold);
   lin->setFont(fn);
   QPalette pl = lin->palette ();
   pl.setColor (QPalette::Text, QColor(color) );
   lin->setPalette ( pl );
   lin->QSpinBox::setValue(lin->value());
}
bool SubCatalogImpl::CheckQSpinBox(QSpinBox* linmin,int min,int max,QString name){
  if ( min >= max ) {
   error( name + QString("minimum value (%1) >= maximum value (%2)").
                        arg(min).arg(max),"");
   SetTextQSpinBox(linmin,true,"red");
     return false;
   } else {
     SetTextQSpinBox(linmin,false,"black");
     return true;
   }

}

bool SubCatalogImpl::GetSampleFunc(){

	bool findParam = false;
	foreach (QCheckBox *box, checkBoxes) if (box->isChecked()) findParam = true;
	if (!findParam) {
	 error(QString("Select at least one parameter for sampling"),"");
         return false;
	}
        ptrFunct.clear();
	clearFocus ();

    messageDateTime   = "";
    messageNumber     = "";
    messageRectangle  = "";
    messageCircle     = "";
    messagePoligon    = "";
    messageDepth      = "";
    messageInterval   = "";
    messageFunction   = "";
    messageIntensity  = "";

	float min = 0;
	float max = 0;
  if (checkBoxDepth->isChecked())  {
     min = lineEditDepthMin->text().toFloat();
     max = lineEditDepthMax->text().toFloat();
     if(!CheckQLineEdit(lineEditDepthMin,min,max,"Hypocenter Depth: ")) return false;
     funct.SetDepth(min,max);
     ptrFunct.push_back( &SampleFunc::Depth);
     messageDepth += QString("Hypocenter: Depth  [ %1 , %2 ]").arg(lineEditDepthMin->text()).
                                                              arg(lineEditDepthMax->text());
 }
   if(checkBoxMagnitude->isChecked()){
     if ( radioButtonMagInterval->isChecked() ){
     if (!(checkBoxMb->isChecked() || checkBoxMs->isChecked() ||checkBoxMl->isChecked() ||checkBoxMp->isChecked())){
       error(QString("Select at least one magnitude for \"Magnituds Interval\" sampling"),"");
     return false;}
       messageInterval += "Magnitudes Intervals: ";
       if (checkBoxMb->isChecked())  {
       min = lineEditMbMin->text().toFloat();
       max = lineEditMbMax->text().toFloat();
       if(!CheckQLineEdit(lineEditMbMin,min,max,"Magnitude Mb: ")) return false;
       funct.SetMb(min,max);
       ptrFunct.push_back( &SampleFunc::Mb);
       messageInterval += QString(" M1  [ %1 , %2 ],").arg(lineEditMbMin->text()).
                                                              arg(lineEditMbMax->text());
      }

       if (checkBoxMs->isChecked())  {
       min = lineEditMsMin->text().toFloat();
       max = lineEditMsMax->text().toFloat();
       if(!CheckQLineEdit(lineEditMsMin,min,max,"Magnitude Ms: ")) return false;
	     funct.SetMs(min,max);
       ptrFunct.push_back( &SampleFunc::Ms);
       messageInterval += QString(" M2  [ %1 , %2 ],").arg(lineEditMsMin->text()).
                                                              arg(lineEditMsMax->text());

      }

       if (checkBoxMl->isChecked())  {
       min = lineEditMlMin->text().toFloat();
       max = lineEditMlMax->text().toFloat();
       if(!CheckQLineEdit(lineEditMlMin,min,max,"Magnitude Ml: ")) return false;
       funct.SetMl(min,max);
       ptrFunct.push_back( &SampleFunc::Ml);
       messageInterval += QString(" M3  [ %1 , %2 ],").arg(lineEditMlMin->text()).
                                                              arg(lineEditMlMax->text());
      }

       if (checkBoxMp->isChecked())  {
       min = lineEditMpMin->text().toFloat();
       max = lineEditMpMax->text().toFloat();
       if(!CheckQLineEdit(lineEditMpMin,min,max,"Magnitude Mp: ")) return false;
       funct.SetMp(min,max);
       ptrFunct.push_back( &SampleFunc::Mp);
       messageInterval += QString(" M4  [ %1 , %2 ],").arg(lineEditMpMin->text()).
                                                              arg(lineEditMpMax->text());
      }
       messageInterval.replace(messageInterval.lastIndexOf(','),1,"\n");
  } //radioButtonMagInterval->isOn()
  if (radioButtonMagFunction->isChecked()){
       if (!(checkBoxM1->isChecked() || checkBoxM2->isChecked() ||checkBoxM3->isChecked() ||checkBoxM4->isChecked())){
       error(QString("Select at least one magnitude for \"Magnituds Function\" sampling"),"");
        return false;}
       min = lineEditMFunMin->text().toFloat();
       max = lineEditMFunMax->text().toFloat();
       if(!CheckQLineEdit(lineEditMFunMin,min,max,"Magnitude Function: ")) return false; 
       funct.SetMfunct(min,max);
       vector<int> priorityFind;
       vector<QString> valFunc;valFunc.resize(4);
       if(checkBoxM1->isChecked()) priorityFind.push_back(comboBoxM1->currentIndex ());
       valFunc[0] = QString("%1@%2@%3@%4").arg(lineEditM1_D->text())
                                          .arg(lineEditM1_A->text())
                                          .arg(lineEditM1_B->text())
                                          .arg(lineEditM1_C->text());


     if(checkBoxM2->isChecked ()) priorityFind.push_back(comboBoxM2->currentIndex ());
       valFunc[1] = QString("%1@%2@%3@%4").arg(lineEditM2_D->text())
                                          .arg(lineEditM2_A->text())
                                          .arg(lineEditM2_B->text())
                                          .arg(lineEditM2_C->text());


     if(checkBoxM3->isChecked()) priorityFind.push_back(comboBoxM3->currentIndex ());
       valFunc[2] = QString("%1@%2@%3@%4").arg(lineEditM3_D->text())
                                          .arg(lineEditM3_A->text())
                                          .arg(lineEditM3_B->text())
                                          .arg(lineEditM3_C->text());


     if(checkBoxM4->isChecked ()) priorityFind.push_back(comboBoxM4->currentIndex ());
       valFunc[3] = QString("%1@%2@%3@%4").arg(lineEditM4_D->text())
                                          .arg(lineEditM4_A->text())
                                          .arg(lineEditM4_B->text())
                                          .arg(lineEditM4_C->text());

     funct.SetValFunctPriority(priorityFind,valFunc);
     int indexFunction = comboBoxMagFunction->currentIndex ();
     if (indexFunction == 0 ) ptrFunct.push_back( &SampleFunc::MagnitudeValue); 
     if (indexFunction == 1 ) ptrFunct.push_back( &SampleFunc::MagnitudeMaximum); 
     if (indexFunction == 2 ) ptrFunct.push_back( &SampleFunc::MagnitudeMinimum); 
     if (indexFunction == 3 ) ptrFunct.push_back( &SampleFunc::MagnitudeAverage); 
     QString strmes = "";
     int size = (int) priorityFind.size();
    if(!priorityFind.empty()){
     strmes += QString("Magnitude Function \"F\"  [ %1 , %2 ] \n   F = ").arg(lineEditMFunMin->text()).
                                                              arg(lineEditMFunMax->text());;
     if (indexFunction == 0 ) {
        if (size > 1) strmes += " Priority Value";
        }
     if (indexFunction == 1 )  {
        if (size > 1) strmes += " Maximum";
        }
     if (indexFunction == 2 ) {
        if (size > 1) strmes += " Minimum";
        }
     if (indexFunction == 3 ) {
        if (size > 1) strmes += " Average";
        }

     QString mag = "";
     for(int i = 0; i < size;i++) {
         if(priorityFind[i] == 0)mag += " f(m1),";
         if(priorityFind[i] == 1)mag += " f(m2),";
         if(priorityFind[i] == 2)mag += " f(m3),";
         if(priorityFind[i] == 3)mag += " f(m4),";
     }
     mag.replace(mag.lastIndexOf(','),1," ");
     if (size > 1) strmes += " { " + mag + " }\n";
     else strmes += " " + mag + " \n";
//  prepare message for message page
     for(int i = 0; i < size;i++) {
     QStringList p = valFunc[priorityFind[i]].split ('@');
     QString mag = ""; 
     if(priorityFind[i] == 0)mag = "m1";
     if(priorityFind[i] == 1)mag = "m2";
     if(priorityFind[i] == 2)mag = "m3";
     if(priorityFind[i] == 3)mag = "m4";
     QString fun = "   f(" + mag + ")" + " = " ;
     strmes += fun + p.at(1) + " * " + mag + " + " + p.at(2) +
               " if " + mag + " greater or equal to " + p.at(0);
     strmes += " else " + fun + p.at(3) + "\n";
    }
     messageFunction += strmes;
   }
  } //radioButtonMagFunction->isOn()
}  //checkBoxMagnitude->isOn()
  if (checkBoxIntencity->isChecked())  {
  int min  =  spinBoxIntensityMin->value ();
  int max  =  spinBoxIntensityMax->value ();
  if(!CheckQSpinBox(spinBoxIntensityMin,min,max,"Intensity:  ")) return false;
  funct.SetIntensity(min,max);
  ptrFunct.push_back( &SampleFunc::Intensity);
  messageIntensity += QString("Intensity:  [ %1 , %2 ]").arg(min).arg(max);

  }
  
if (checkBoxHipocenter->isChecked() )  {
   if(radioButtonRectangle->isChecked()) {
   if (checkBox180->isChecked()) funct.GetLon180() = true;
   else  funct.GetLon180() = false;

  float latmin = lineEditLatitudeMin->text().toFloat();
  float latmax = lineEditLatitudeMax->text().toFloat();

 
  if(!CheckQLineEdit(lineEditLatitudeMin,latmin,latmax,"Hypocenter Rectangle Latitude: ")) return false;

  float lonmin = lineEditLongitudeMin->text().toFloat();
  float lonmax = lineEditLongitudeMax->text().toFloat();

  if (!checkBox180->isChecked()) {
  if(!CheckQLineEdit(lineEditLongitudeMin,lonmin,lonmax,"Hypocenter Rectangle Longitude: ")) return false;
  }
  else {
   if(!CheckQLineEditWithRect180(lineEditLongitudeMin,lonmin,lonmax,"Hypocenter Rectangle Longitude: ")) return false;
  } 
  funct.SetRectangle (latmin,latmax,lonmin,lonmax);
  ptrFunct.push_back( &SampleFunc::Rectangle);
  messageRectangle += QString("Hypocenter: Rectangle:\n   Latitude [ %1 , %2 ]\n   Longitude[ %3 , %4 ]").
       arg(lineEditLatitudeMin->text()).arg(lineEditLatitudeMax->text()).
       arg(lineEditLongitudeMin->text()).arg(lineEditLongitudeMax->text());

  }
   if(radioButtonPolygon->isChecked()) {
     if ( doc->GetSampleHipoPolygonMinus180()->GetValue() == "0")
     funct.GetPolygonLon180() = false;
     else  funct.GetPolygonLon180() = true;
     QStringList lat = doc->GetSampleListLatitude()->GetStringList();
     QStringList lon = doc->GetSampleListLongitude()->GetStringList();
     QPolygonF SamplePolygon;
     for (int i = 0; i < lat.size(); ++i) {
     SamplePolygon << QPointF(lat.at(i).toFloat(),lon.at(i).toFloat());
    }
    funct.SetPolygon(SamplePolygon);
//     QPolygonF SamplePolygon << QPointF(0.0, -180.0) << QPointF(90.0, 0.0) << QPointF(0.0, 180.0);
//     SamplePolygon << QPointF(0.0, -180.0) << QPointF(90.0, 0.0) << QPointF(0.0, 180.0);
//     funct.SetPolygon(doc->GetSamplePolygon());
     ptrFunct.push_back( &SampleFunc::Polygon);

         messagePoligon += QString("Hypocenter Polygon: number vertices: %1\n").arg(lat.size());
         messagePoligon += "   List vertices: \"< number [Latitude,Longitude] >\" \n   ";
         ostringstream  os;
         for (int i = 0; i < lat.size(); ++i) {
          string lt = lat.at(i).toAscii().data();
          string ln = lon.at(i).toAscii().data();
          string nn = QString("%1").arg(i+1).toAscii().data();
          os  << std::setw(2) << std::setfill(' ') << nn  << ":  [" << 
                 std::setw(7) << std::showpoint << std::fixed << std::setprecision(3) << lt << " , " <<
                 std::setw(8) << std::showpoint << std::fixed << std::setprecision(3) << ln  << " ]; ";
          if (( (i+1)/2)*2 == (i+1)) os << endl << "   ";
         }

         messagePoligon += QString("%1").arg(os.str().c_str());
   }
   if(radioButtonCircle->isChecked()) {
   double lat    =   lineEditCircleLat->text().toDouble();
   double lon    =   lineEditCircleLon->text().toDouble();
   double radius =   lineEditCircleRad->text().toDouble();
   funct.GetCircleLat()    = lat; 
   funct.GetCircleLon()    = lon; 
   funct.GetCircleRadius() = radius; 
   ptrFunct.push_back( &SampleFunc::Circle);

   messageCircle += 
   QString("Hypocenter: Circle:  Center Latitude %1 , Center Longitude %2 ; Radius: %3").
          arg(lineEditCircleLat->text()).
          arg(lineEditCircleLon->text()).
          arg(lineEditCircleRad->text());
   }
}  // (checkBoxHipocenter->isOn() )

  if (checkBoxRecord->isChecked() && radioButtonRecordDate->isChecked())  {
  QDateTime min = dateTimeEditMin->dateTime ();
  QDateTime max = dateTimeEditMax->dateTime ();

    if (min >= max) {
      QString date1 =  min.toString("yyyy/MM/dd hh:mm:ss");
      QString date2 =  max.toString("yyyy/MM/dd hh:mm:ss");
      error(QString("Records DateTime: minimum value (%1) >= maximum value (%2)").
                        arg(date1).arg(date2),"");
     QFont fn = font ();
     fn.setBold(true);
     dateTimeEditMin->setFont(fn);
     QPalette pl = dateTimeEditMin->palette ();
     pl.setColor (QPalette::Text, QColor("red") );
     dateTimeEditMin->setPalette ( pl );
     dateTimeEditMin->setDateTime(dateTimeEditMin->dateTime());
     return false;
     } else {
     QFont fn = font ();
     fn.setBold(false);
     dateTimeEditMin->setFont(fn);
     QPalette pl = dateTimeEditMin->palette ();
     pl.setColor (QPalette::Text, QColor("black") );
     dateTimeEditMin->setPalette ( pl );
     dateTimeEditMin->setDateTime(dateTimeEditMin->dateTime());

    }

     messageDateTime += QString("Records DateTime:  [ %1 , %2 ]").arg(min.toString("yyyy/MM/dd hh:mm:ss")).
                                                              arg(max.toString("yyyy/MM/dd hh:mm:ss"));


  }
    if (checkBoxRecord->isChecked() && radioButtonRecordNumber->isChecked())  {
       int min  =  spinBoxNumberMin->value ();
       int max  =  spinBoxNumberMax->value ();
       if(!CheckQSpinBox(spinBoxNumberMin,min,max,"Records Number:  ")) return false;
       messageRectangle += QString("Records Number:  [ %1 , %2 ]").arg(min).
                                                                   arg(max);

    }
      QString catmes = "";
      Catalog cat;
      if (type == Tool) catmes += cat.GetCatalogInfoMessage(MainWindow::self->GetCurrentCatalogName());
      if (type == Execute) {
		  catmes += "Current catalog ";
		  catmes += cat.GetCatalogShortInfoMessage(MainWindow::self->GetOpenBinaryFileName());
      }
	  message += catmes;
      message += "Sample conditions:\n";
    if (!messageDateTime.isEmpty())   message += messageDateTime  + "\n";
    if (!messageNumber.isEmpty())     message += messageNumber    + "\n";
    if (!messageRectangle.isEmpty())  message += messageRectangle + "\n";
    if (!messageCircle.isEmpty())     message += messageCircle    + "\n";
    if (!messagePoligon.isEmpty())    message += messagePoligon   + "\n";
    if (!messageDepth.isEmpty())      message += messageDepth     + "\n";
    if (!messageInterval.isEmpty())   message += messageInterval  + "\n";
    if (!messageFunction.isEmpty())   message += messageFunction  + "\n";
    if (!messageIntensity.isEmpty())  message += messageIntensity + "\n";

    message += "\n";

return true;
}
