#ifndef _TRANSFORM_MAGNITUDE_H
#define _TRANSFORM_MAGNITUDE_H
#include "ui_transformmagn.h"
#include "catalog.h"
#include "document.h"
class QWidget;
class QTextEdit;
class FDocument;
class CatTable;
class LineDocProperty;
class HelpWindow;
class TransformFunc {
public:
 TransformFunc(vector<int> &priority,vector<QString> &valFunc,int indexMagnitude);
  ~TransformFunc() {};
 void  Value();
 void  Maximum();
 void  Minimum();
 void  Average();
 void  SetRecord(RECORD rec);
 int indexMagnitude;
 short magnitude;
 protected:
 vector<int> priority;
 RECORD record;
 vector<float> magnitudeRecord;
 vector<float> a,b,c,d;
 float mFunct(int i,float m);
 float eps;

};
//---------------------------------------------------------------------------------
class TransfMagnImpl : public QDialog, private Ui::TransfMagnBase
{
    typedef multimap<double,int> DoubleIntMultiMap;
    typedef DoubleIntMultiMap::iterator ItrMultiMap;
    typedef vector<PropertyValue* > PropValVector;
    typedef vector<PropertyValue* >::iterator PropValIterator;
    typedef void (TransformFunc::*PDF)();
    Q_OBJECT
public:
    enum TypeUsing
    {
        Tool,
        Wizard,
        Execute
    };

    TypeUsing GetTypeUsing() {return type;}

    TransfMagnImpl(QWidget *parent,FDocument* dc,TypeUsing type); 
    ~TransfMagnImpl();
    bool NextOk();
    void FinishOk();
    bool execute();
    bool applay();
public slots:
protected:
    void closeEvent(QCloseEvent *event);
protected slots:
    void accept(); 
    void reject();
    void buttonDefault();
    void buttonReset();
    void buttonProject();
    void helpButton();
    void comboBoxMagnitudeActivate( int index );
    void ProgressBarChanged(int value);
private:
    void GetDialogFromDocument(int indexMagnitude);
    void GetDocumentFromDialog(int indexMagnitude);
    void DefineTransformFunction();
    void GetTransformFunctionFromDocument(int indexMagnitude);
    void InitLineDocProperty();
    bool TransformMagnitude();
    QList<TransformFunc *> transFunc;
    int comboBoxMagnitudeIndex;
    FDocument* doc;
    TypeUsing type;
    QList<QComboBox *> comboBoxes;
    QList<LineDocProperty* > propDocLine;
    PropValVector values;
    QList<TransformFunc *> funct;
    vector <PDF> ptrFunct;
    QTextEdit* texted;
    QString message;
    HelpWindow* help;
};
#endif
 
