#include <QtGui>
#include "mainwindow.h"
#include "viewcatalogimpl.h"
#include "undo.h"
#include "default.h"
#include "tableproperty.h"

//-----------------------------------------------------------------------------------------------------
UndoEdit::UndoEdit(bool Inv,bool Ch,QString Ini,QString Undo,QString Redo):
   Invalid(Inv),Changed(Ch),InitString(Ini),Undo(Undo),Redo(Redo){}
//-----------------------------------------------------------------------------------------------------
UndoRange::~UndoRange() {
if(!UndoEditList.empty()) qDeleteAll(UndoEditList);  UndoEditList.clear();
}
UndoRange::UndoRange(int LeftCol,int TopRow,int BottomRow,int RightCol,
    int NumRows,int NumCols):
    LeftCol(LeftCol),TopRow(TopRow),BottomRow(BottomRow),RightCol(RightCol),
    NumRows(NumRows),NumCols(NumCols)
{}
//-----------------------------------------------------------------------------------------------------
UndoDelete::~UndoDelete()
{
if(!UndoRangList.empty()) qDeleteAll(UndoRangList); UndoRangList.clear();
}
UndoDelete::UndoDelete(){}
UndoDelete::UndoDelete(QList<UndoRange *>& list):
            UndoRangList(list){}
//-----------------------------------------------------------------------------------------------------
UndoChange::~UndoChange()
{
if(undoedit != 0)   delete undoedit;
if(undodelete != 0) delete undodelete;
}
UndoChange::UndoChange()
{
    undoedit = 0;
    undodelete = 0;
}
UndoChange::UndoChange(IProperty* p,QString prev,QString value,int row,int col):Row(row),Column(col)
{
    undodelete = 0;
    undoedit = new UndoEdit(p->GetInvalid(),p->GetChanged(),p->GetInitStr(),prev,value);
    mode = EditMode;
}
UndoChange::UndoChange(UndoDelete* usel,ModeType mod)
{
undoedit = 0;
undodelete =  usel;
mode = mod;
}

/////////////--------------------------------------------------///////////////////////////////
void CatTable::cut(){

    copy();
    del();
}
void CatTable::copy(){
  QItemSelection    isel =  selectModel->selection ();
  if(isel.empty()) return;
  if (selCopy != 0) { delete     selCopy; selCopy = 0; }
  UndoDelete* undoSel = new  UndoDelete();
  selCopy             = new  UndoChange(undoSel,UndoChange::CopyMode);
  GetTableSelection(undoSel,isel,1);
  if(!isel.empty()) isel.clear();

}
void CatTable::paste(){
  QItemSelection    isel =  selectModel->selection ();
  if(isel.empty() || selCopy == 0) return;
  UndoDelete* undoPaste = new  UndoDelete();
  UndoChange* undoChange  = new  UndoChange(undoPaste,UndoChange::PasteMode);

  GetTableSelection(undoPaste,isel,1);
     
  QModelIndex ind;
  QList<UndoRange *> &selCopyList = selCopy->GetUndoDelete()->UndoRangList;
  QList<UndoRange *> &pasteUndoRangeList   = undoChange->GetUndoDelete()->UndoRangList;
  if ( isel.size() != selCopyList.size() ) {
	QMessageBox::information(this,mainWindowCaption(),
				 tr("The information cannot be pasted because the "
				    "copy and paste areas aren't the same size."));
  if (undoPaste != 0) {delete undoPaste; undoPaste = 0;}
	return;
  }

//   int startRowForRepairProperty = 0;
//   bool findRowForRepair = false;
   for(int i = 0; i < selCopyList.size(); ++i) {
      UndoRange * selCopyRange  = selCopyList.at(i);
      QItemSelectionRange pasteRange = isel.at(i);
      int selCopyListLeftCol     = selCopyRange->GetLeftCol();
//      int selCopyListTopRow      = selCopyRange->GetTopRow();
      int selCopyListRightCol    = selCopyRange->GetRightCol();
//      int selCopyListBottomRow   = selCopyRange->GetBottomRow();
      int selCopyListNumRows     = selCopyRange->GetNumRows();
      int selCopyListNumCols     = selCopyRange->GetNumCols();

      int psLeftCol     = pasteRange.left();
      int psTopRow      = pasteRange.top();
      int psRightCol    = pasteRange.right();
//      int psBottomRow   = pasteRange.bottom();
      int psNumRows     = pasteRange.height();
      int psNumCols     = pasteRange.width();
      if (  !(selCopyListLeftCol == psLeftCol &&  selCopyListRightCol == psRightCol &&
             selCopyListNumRows == psNumRows && selCopyListNumCols == psNumCols ) ){
         QMessageBox::information(this,mainWindowCaption(),
         tr("The information cannot be pasted because the "
         "copy and paste areas aren't the same size."));
      if (undoPaste != 0) {delete undoPaste; undoPaste = 0;}
         return;
      }
     if (psTopRow + selCopyListNumRows > ViewBufSize ) {
        QMessageBox::information(this,mainWindowCaption(),
        tr("The information cannot be pasted because the "
        "paste area size is out of veiw buffer table."));
     if (undoPaste != 0) {delete undoPaste; undoPaste = 0;}
        return;
    }
}

   for(int i = 0; i < selCopyList.size(); ++i) {
      UndoRange * selCopyRange  = selCopyList.at(i);
      UndoRange * pasteUndoEditRange  = pasteUndoRangeList.at(i);
      QItemSelectionRange pasteRange = isel.at(i);
//      int selCopyListLeftCol     = selCopyRange->GetLeftCol();
//      int selCopyListTopRow      = selCopyRange->GetTopRow();
//      int selCopyListRightCol    = selCopyRange->GetRightCol();
//      int selCopyListBottomRow   = selCopyRange->GetBottomRow();
      int selCopyListNumRows     = selCopyRange->GetNumRows();
      int selCopyListNumCols     = selCopyRange->GetNumCols();

      int psLeftCol     = pasteRange.left();
      int psTopRow      = pasteRange.top();
//      int psRightCol    = pasteRange.right();
//      int psBottomRow   = pasteRange.bottom();
//      int psNumRows     = pasteRange.height();
//      int psNumCols     = pasteRange.width();
      QList<UndoEdit *> &selCopyUndoEditList = selCopyRange->UndoEditList;
      QList<UndoEdit *> &pasteUndoEditList   = pasteUndoEditRange->UndoEditList;
              int k = 0;
       for (int i = 0; i < selCopyListNumRows; ++i) {
       for (int j = 0; j < selCopyListNumCols; ++j) {
         int row = psTopRow + i;
		 int col = psLeftCol + j;
			//if (selCopyListNumCols == NumCols) col = psLeftCol + j - i - 1;
			

          QModelIndex ind = model->index(row, col, QModelIndex());
          UndoEdit* pasteUndoEditItem   = pasteUndoEditList.at(k);
		  int kj = k;
		  if (selCopyListNumCols == NumCols) kj = k +1 + i;
          UndoEdit* selCopyUndoEditItem = selCopyUndoEditList.at(kj);k++;
          pasteUndoEditItem->GetRedo() =   selCopyUndoEditItem->GetUndo();
     //     if (selCopyListLeftCol == 0 && j == 0) continue;
          model->setData(ind, QVariant(selCopyUndoEditItem->GetUndo()));
	        IProperty * p = model->findProperty(ind);
          p->SetChanged(true);

      }
	   
     }
    }
if (curUndoIndex + 1 == undoList.size()) undoList.append(undoChange);
else  undoList.insert(curUndoIndex+1 ,undoChange);
curUndoIndex++;

if(!isel.empty()) isel.clear();
MainWindow::self->viewBufferModified =  true;
}
//------------------------------------------------------------------------
bool CatTable::GetTableSelection(UndoDelete* undoSel,QItemSelection &isel,int act)
{
  QItemSelectionRange range;
  QModelIndex index;
  int startRowForRepairProperty = 0;
  bool findRowForRepair = false;
  for (int i = 0; i < isel.size(); ++i) {

range = isel.at(i);
int selLeftCol   =   range.left();
int selTopRow    =   range.top();
int selRightCol  =   range.right();
int selNumRows   =   range.height();
int selNumCols   =   range.width();
int selBottomRow =   range.bottom();
//int LeftCol      =   range.left();
//int TopRow       =   range.top();

  UndoRange* rg = new   UndoRange(selLeftCol,selTopRow,selBottomRow,selRightCol,
                selNumRows,selNumCols);

  if (selLeftCol == 0 && selRightCol == NumCols - 1) {

     for(int i = selTopRow; i < selTopRow + selNumRows;i++)  {
      QString  numStr =  model->headerData(i,Qt::Vertical).toString();
      rg->UndoEditList.append(new UndoEdit(false,false,"",numStr,numStr));
      for(int j = 0; j < NumCols;j++)
      {
        QString value   =  model->data(model->index(i, j, QModelIndex())).toString ();
        IProperty * p   =  model->ipList.at(i*(NumCols + 1)  + j + 1);
        rg->UndoEditList.append(new UndoEdit(p->GetInvalid(),p->GetChanged(),p->GetInitStr(),value,value));
      }
    }
     if( !findRowForRepair ) {
        findRowForRepair = true;
        startRowForRepairProperty = selTopRow;
     }
              if (act == 0)  {                 
                  model->removeRows(selTopRow,selNumRows);
                  model->RemoveRowsProperty(selTopRow,selNumRows);
                  model->RepairRowsProperty(selTopRow);
              }
  }
  else {
    for (int i = 0; i < selNumRows; ++i) {
    for (int j = 0; j < selNumCols; ++j) {
         int row = selTopRow + i;
	       int col =  selLeftCol + j;
         QString value   =  model->data(model->index(row, col, QModelIndex())).toString ();
         IProperty * p   =  model->ipList.at(row*(NumCols + 1) + col + 1);
         rg->UndoEditList.append(new UndoEdit(p->GetInvalid(),p->GetChanged(),p->GetInitStr(),value,""));
	     }
    }
             if (act == 0)  {
                  for (int i = 0; i < selNumRows; ++i) {
                     for (int j = 0; j < selNumCols; ++j) {
	                     int col =  selLeftCol + j;
	                     int row = selTopRow + i;
                       index = model->index(row,col, QModelIndex());
                       model->setText(index,"");
	                  }
                 }
              }
   }
  undoSel->UndoRangList.append(rg);
 // if(findRowForRepair) model->RepairRowsProperty(startRowForRepairProperty);
 }
return findRowForRepair;
}
//-----------------------------------------------------------------------------
void CatTable::del()
{
  QItemSelection    isel =  selectModel->selection ();
  if(isel.empty()) return;
  UndoDelete* undoSel = new  UndoDelete();
  UndoChange* undoChange  = new  UndoChange(undoSel,UndoChange::DelMode);
  bool findRowForRepair =
                       GetTableSelection(undoSel,isel,0);
if(findRowForRepair ) {
  if (curUndoIndex + 1 != undoList.size()) {
     if(curUndoIndex < 0 )  {qDeleteAll(undoList); undoList.clear();  }
     else {
        int i = curUndoIndex + 1;
        while( i != undoList.size()){
            delete undoList.at(i);
            undoList.removeAt(i);
        }
     }
  }
  undoList.append(undoChange);
//  SetDatesNumbersToLabels();

} else {
    if (curUndoIndex + 1 == undoList.size())
        undoList.append(undoChange);
    else
        undoList.insert(curUndoIndex+1 ,undoChange);
}
curUndoIndex++;

if(!isel.empty()) isel.clear();
MainWindow::self->viewBufferModified =  true;
ResizeRows();
}
void CatTable::insert(){
QItemSelection    isel =  selectModel->selection ();
QItemSelectionRange range = isel.first () ;
//-------------------------------------------------------------------------
      if (isel.size() != 1){
         QMessageBox::information(this,mainWindowCaption(),
         tr("The information cannot be inserted because the "
         "selected area must contain just one row."));
         return;
      }

//-------------------------------------------------------------------------

int selLeftCol   =   range.left();
int selTopRow    =   range.top();
int selRightCol  =   range.right();
int selNumRows   =   range.height();
int selNumCols   =   range.width();
int selBottomRow =   range.bottom();
//-------------------------------------------------------------------------
      if (  !(selLeftCol == 0 &&  selRightCol == NumCols - 1 &&
             selNumRows == 1 && selNumCols == NumCols ) ){
         QMessageBox::information(this,mainWindowCaption(),
         tr("The information cannot be inserted because the "
         "selected area must contain just one row."));
         return;
      }
//-------------------------------------------------------------------------
  UndoDelete* undoInsert = new  UndoDelete();
  UndoChange* undoChange  = new  UndoChange(undoInsert,UndoChange::InsMode);
  UndoRange* rg = new   UndoRange(selLeftCol,selTopRow,selBottomRow,selRightCol,
                selNumRows,selNumCols);
   for(int i = selTopRow; i < selTopRow + selNumRows;i++)  {
      QString  numStr =  model->headerData(i,Qt::Vertical).toString();
      rg->UndoEditList.append(new UndoEdit(false,false,"",numStr,""));

      for(int j = 0; j < NumCols;j++)
      {
        QString value   =  model->data(model->index(i, j, QModelIndex())).toString ();
        IProperty * p   =  model->ipList.at(i*(NumCols + 1)  + j + 1);
        rg->UndoEditList.append(new UndoEdit(p->GetInvalid(),p->GetChanged(),p->GetInitStr(),value,value));
     }
  }
model->insertRows (selTopRow,1);
model->InsertEmptyValuePropertyRows (selTopRow,1);
model->RepairRowsProperty(selTopRow);
undoInsert->UndoRangList.append(rg);
  if (curUndoIndex + 1 != undoList.size()) {
   if(curUndoIndex < 0 )  {qDeleteAll(undoList); undoList.clear();  }
   else {
        int i = curUndoIndex + 1;
        while( i != undoList.size()){
            delete undoList.at(i);
            undoList.removeAt(i);
        }
     }
  }
  undoList.append(undoChange);
  curUndoIndex++;

MainWindow::self->viewBufferModified =  true;
//SetDatesNumbersToLabels();
if(!isel.empty()) isel.clear();
ResizeRows();
}
//------------------------------------------------------------------------------------------------
void CatTable::undo()
{
    clearSelection ();
    clearFocus ();
  if(undoList.empty() || curUndoIndex == -1) return;
  UndoChange* u = undoList.at(curUndoIndex);
  if(u->GetMode() == UndoChange::EditMode)  {
    QModelIndex ind =  model->index(u->GetRow(), u->GetColumn (), QModelIndex());
    IProperty * p = model->ipList.at(u->GetRow()*(NumCols + 1)  + u->GetColumn () + 1);
    UndoEdit* e = u->GetUndoEdit();
    p->SetIndex(ind);
    p->SetInvalid(e->GetInvalid());
    p->SetChanged(e->GetChanged());
    p->SetInitStr(e->GetInitString());
    model->setText(ind, e->GetUndo());
  }

  if(u->GetMode() == UndoChange::DelMode)  {
  //qWarning("CatTable::undo()  UndoChange::DelMode");
     QList<UndoRange *> &rg = u->GetUndoDelete ()->UndoRangList;
     int startRowForRepairProperty = 0;
     bool findRowForRepair = false;
     for(int i = rg.size() -1; i >= 0; --i) {
      UndoRange * ur  = rg.at(i);
      int rgLeftCol     = ur->GetLeftCol();
      int rgTopRow      = ur->GetTopRow();
      int rgRightCol    = ur->GetRightCol();
      int rgNumRows     = ur->GetNumRows();
      int rgNumCols     = ur->GetNumCols();
      QList<UndoEdit *> &ue = ur->UndoEditList;
     if (rgLeftCol == 0 && rgRightCol == NumCols -1) {
       model->insertRows(rgTopRow,rgNumRows);
        model->InsertValuePropertyRows (rgTopRow,rgNumRows,ue);
 
           if( !findRowForRepair ) {
                findRowForRepair = true;
                startRowForRepairProperty = rgTopRow;
           }
      model->RepairRowsProperty(rgTopRow);
     } else {
       int k = 0;
       for (int i = 0; i < rgNumRows; ++i) {
       for (int j = 0; j < rgNumCols; ++j) {
          int row = rgTopRow + i;
	        int col = rgLeftCol + j;
          QModelIndex ind = model->index(row, col, QModelIndex());    
          UndoEdit* e = ue.at(k);k++;
          model->setData(ind, QVariant(e->GetUndo()));
	        IProperty * p = model->findProperty(ind);
          p->SetInvalid(e->GetInvalid());
          p->SetChanged(e->GetChanged());
	     }
      }
     }
    }
//   if(findRowForRepair) SetDatesNumbersToLabels();//model->RepairRowsProperty(startRowForRepairProperty);     

   }
 if(u->GetMode() == UndoChange::PasteMode)  {
     QList<UndoRange *> &rg = u->GetUndoDelete ()->UndoRangList;
     for(int i = rg.size() -1; i >= 0; --i) {
      UndoRange * ur  = rg.at(i);
      int rgLeftCol     = ur->GetLeftCol();
     // int rgRightCol    = ur->GetRightCol();
      int rgTopRow      = ur->GetTopRow();
      int rgNumRows     = ur->GetNumRows();
      int rgNumCols     = ur->GetNumCols();
      QList<UndoEdit *> &ue = ur->UndoEditList;
       int k = 0;
       //if (rgLeftCol == 0 && rgRightCol == NumCols - 1)  k=1;
       for (int i = 0; i < rgNumRows; ++i) {
       for (int j = 0; j < rgNumCols; ++j) {
        //  if (rgLeftCol == 0 && j == 0){ k++; continue;  }
          int row = rgTopRow + i;
	        int col = rgLeftCol + j;
          QModelIndex ind = model->index(row, col, QModelIndex());
		  int kj = k;
		  if (rgNumCols == NumCols) kj = k +1 + i;
          UndoEdit* e = ue.at(kj); k++;
          model->setData(ind, QVariant(e->GetUndo()));
	        IProperty * p = model->findProperty(ind);
          p->SetInvalid(e->GetInvalid());
          p->SetChanged(e->GetChanged());
	     }
      }
     
    // if(findRowForRepair) model->RepairRowsProperty(startRowForRepairProperty);
    }
   }

 if(u->GetMode() == UndoChange::InsMode)  {
     QList<UndoRange *> &rg = u->GetUndoDelete ()->UndoRangList;
      UndoRange * ur  = rg.at(0);
      int rgTopRow      = ur->GetTopRow();
      int rgNumRows     = ur->GetNumRows();
      int rgLeftCol     = ur->GetLeftCol();
//      int rgRightCol    = ur->GetRightCol();
      int rgNumCols     = ur->GetNumCols();
      model->removeRows(rgTopRow,rgNumRows);
      model->RemoveRowsProperty(rgTopRow,rgNumRows);
      model->RepairRowsProperty(rgTopRow);
      QList<UndoEdit *> &ue = ur->UndoEditList;
       int k = 1;
       for (int i = 0; i < rgNumRows; ++i) {
       for (int j = 0; j < rgNumCols; ++j) {
          int row = rgTopRow + i;
	        int col = rgLeftCol + j;
          QModelIndex ind = model->index(row, col, QModelIndex());
          UndoEdit* e = ue.at(k);k++;
          model->setData(ind, QVariant(e->GetUndo()));
	        IProperty * p = model->findProperty(ind);
          p->SetInvalid(e->GetInvalid());
          p->SetChanged(e->GetChanged());
	     }
      }
  //  SetDatesNumbersToLabels();
 }
 ResizeRows();
 curUndoIndex--;
if (curUndoIndex < 0) MainWindow::self->undoAct->setEnabled (FALSE);
else MainWindow::self->undoAct->setEnabled (true);   

  setFocus ( Qt::MouseFocusReason);
}
void CatTable::redo()
{
    clearSelection ();

 if(undoList.empty() || curUndoIndex  + 1== undoList.size()) return; 
 UndoChange* u = undoList.at(curUndoIndex+1);

  if(u->GetMode() == UndoChange::EditMode)  {
    QModelIndex ind =  model->index(u->GetRow(), u->GetColumn (), QModelIndex());
    IProperty * p = model->ipList.at(u->GetRow()*(NumCols + 1)  + u->GetColumn () + 1);
    UndoEdit* e = u->GetUndoEdit();
    p->SetIndex(ind);
    p->SetInvalid(e->GetInvalid());
    p->SetChanged(true);
    p->SetInitStr(e->GetInitString());
    model->setText(ind, e->GetRedo());
  }
  if(u->GetMode() == UndoChange::DelMode)  {
//qWarning("CatTable::redo()  UndoChange::DelMode");
    QList<UndoRange *> &rg = u->GetUndoDelete ()->UndoRangList;
    int startRowForRepairProperty = 0;
    bool findRowForRepair = false;
    for(int i = 0; i < rg.size(); ++i){
      UndoRange * ur = rg.at(i);
      int rgLeftCol   =   ur->GetLeftCol();
      int rgTopRow    =   ur->GetTopRow();
      int rgRightCol  =   ur->GetRightCol();
      int rgNumRows   =   ur->GetNumRows();
      int rgNumCols   =   ur->GetNumCols();
      QList<UndoEdit *> &ue = ur->UndoEditList;
      if (rgLeftCol == 0 && rgRightCol == NumCols -1) {
        model->removeRows(rgTopRow,rgNumRows);
        model->RemoveRowsProperty(rgTopRow,rgNumRows);
          if( !findRowForRepair ) {
                findRowForRepair = true;
                startRowForRepairProperty = rgTopRow;
           }
       model->RepairRowsProperty(rgTopRow);
     } else {
       int k = 0;
       for (int i = 0; i < rgNumRows; ++i) {
       for (int j = 0; j < rgNumCols; ++j) {
          int row = rgTopRow + i;
	        int col = rgLeftCol + j;
          QModelIndex ind = model->index(row, col, QModelIndex());
          UndoEdit* e = ue.at(k);k++;
          model->setData(ind, QVariant(e->GetRedo())); 
	        IProperty * p = model->findProperty(ind);
          p->SetInvalid(e->GetInvalid());
          p->SetChanged(e->GetChanged());

	     }
      }
     }
    }
    //if(findRowForRepair) SetDatesNumbersToLabels();//model->RepairRowsProperty(startRowForRepairProperty);

   }
if(u->GetMode() == UndoChange::PasteMode)  {
    QList<UndoRange *> &rg = u->GetUndoDelete ()->UndoRangList;
    for(int i = 0; i < rg.size(); ++i){
      UndoRange * ur = rg.at(i);
      int rgLeftCol   =   ur->GetLeftCol();
      int rgTopRow    =   ur->GetTopRow();
     // int rgRightCol  =   ur->GetRightCol();
      int rgNumRows   =   ur->GetNumRows();
      int rgNumCols   =   ur->GetNumCols();
      QList<UndoEdit *> &ue = ur->UndoEditList;
       int k = 0;
     //  if (rgLeftCol == 0 && rgRightCol == NumCols - 1)  k=1;
       for (int i = 0; i < rgNumRows; ++i) {
       for (int j = 0; j < rgNumCols; ++j) {
        //  if (rgLeftCol == 0 && j == 0){ k++; continue;  }
          int row = rgTopRow + i;
	        int col = rgLeftCol + j;
          QModelIndex ind = model->index(row, col, QModelIndex());

          UndoEdit* e = ue.at(k); k++;
          model->setData(ind, QVariant(e->GetRedo()));
	        IProperty * p = model->findProperty(ind);
          p->SetInvalid(e->GetInvalid());
          p->SetChanged(true);

	     }
      }
     
    // if(findRowForRepair) model->RepairRowsProperty(startRowForRepairProperty);
    }
   }
  if(u->GetMode() == UndoChange::InsMode)  {
      QList<UndoRange *> &rg = u->GetUndoDelete ()->UndoRangList;
      UndoRange * ur  = rg.at(0);
      int rgLeftCol     = ur->GetLeftCol();
      int rgTopRow      = ur->GetTopRow();
     // int rgRightCol    = ur->GetRightCol();
      int rgNumRows     = ur->GetNumRows();
      int rgNumCols     = ur->GetNumCols();
      QList<UndoEdit *> &ue = ur->UndoEditList;  
      model->insertRows(rgTopRow,rgNumRows);
      model->InsertValuePropertyRows (rgTopRow,rgNumRows,ue);
      model->RepairRowsProperty(rgTopRow);
      int k = 1;
      for (int i = 0; i < rgNumRows; ++i) {
      for (int j = 0; j < rgNumCols; ++j) {
          int row = rgTopRow + i;
	        int col = rgLeftCol + j; 
          QModelIndex ind = model->index(row, col, QModelIndex());
          //if (rgLeftCol  == 0 && j == 0){ model->setData(ind,"");k++; continue;  }
          
          UndoEdit* e = ue.at(k);k++;
          model->setData(ind, QVariant(e->GetRedo()));
	        IProperty * p = model->findProperty(ind);
          p->SetInvalid(e->GetInvalid());
          p->SetChanged(true);

	     }
      }


     // SetDatesNumbersToLabels();

   }
  ResizeRows();
  curUndoIndex++;
  setFocus ( Qt::MouseFocusReason);
}
