#ifndef UNDO_CHANGES_H
#define UNDO_CHANGES_H
#include <QList>
#include <QString>
class IProperty;
//-----------------------------------------------------------------------------------------------------
class UndoEdit
{
public:
/*
enum ProperyType {
        Int,
        Double,
        String
    };
*/
    UndoEdit(bool Invalid,bool Changed,QString InitString,
             QString Undo,QString Redo);
    ~UndoEdit() {};

bool &GetInvalid(){return Invalid;}
bool &GetChanged(){return Changed;}
QString &GetInitString(){return InitString;}
QString &GetUndo(){return Undo;}
QString &GetRedo(){return Redo;}
//ProperyType &GetType(){return type;}
private:
    bool Invalid;
    bool Changed;
    QString InitString;
    QString Undo;
    QString Redo;
//    ProperyType type;
};
//-----------------------------------------------------------------------------------------------------
class UndoRange
{
public:
    UndoRange(int LeftCol,int TopRow,int BottomRow,int RightCol,
            int NumRows,int NumCols);
    ~UndoRange();

int  &GetLeftCol(){return LeftCol;}
int  &GetTopRow(){return TopRow;}
int  &GetBottomRow(){return BottomRow;}
int  &GetRightCol(){return RightCol;}
int  &GetNumRows(){return NumRows;}
int  &GetNumCols(){return NumCols;}
QList<UndoEdit *> UndoEditList;
private:
int LeftCol;
int TopRow;
int BottomRow;
int RightCol;
int NumRows;
int NumCols;

;
};
//-----------------------------------------------------------------------------------------------------
class UndoDelete
{
public:
    UndoDelete();
    UndoDelete(QList<UndoRange *>& list);
    ~UndoDelete();
    QList<UndoRange *> UndoRangList;
};
//-----------------------------------------------------------------------------------------------------
class UndoChange
{
public:
enum ModeType {
        EditMode,
        CutMode,
        CopyMode,
        PasteMode,
        DelMode,
        InsMode
    };
    UndoChange();
    UndoChange(UndoDelete* usel,ModeType mode);
    UndoChange(IProperty* p,QString prev,QString value,int row,int col);
    ~UndoChange();
    ModeType &GetMode(){return mode;}
    UndoEdit* &GetUndoEdit (){return undoedit;}
    UndoDelete* &GetUndoDelete (){return undodelete;}
    int  &GetRow(){return Row;}
    int  &GetColumn(){return Column;}
private:
    ModeType mode;
    UndoEdit* undoedit;
    UndoDelete*  undodelete;
    int Row;
    int Column;
};
//-----------------------------------------------------------------------------------------------------
#endif
